package com.unis.transaction.api.givebackbail;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.givebackbail.GiveBackVO;
import com.unis.transaction.common.vo.givebackbail.PassBackVO;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * Author lidiaoquan
 *  保证金退款 at 2019-09-21
 */
@RequestMapping("giveback")
public interface GiveBackApi {

    //保证金退款-新增
    @PostMapping("/insertGiveBack")
    public ResponseWrapper insertGiveBack(@RequestBody GiveBackVO vo);

    //保证金退款-修改
    @PostMapping("/updateGiveBack")
    public ResponseWrapper updateGiveBack(@RequestBody  GiveBackVO vo);

    @PostMapping("/updateGiveBackPass")
    public ResponseWrapper updateGiveBackPass(@RequestBody  PassBackVO vo);

 	//保证金退款-分页查询列表
    @PostMapping("/selectGiveBackPageList")
    public ResponseWrapper selectGiveBackPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
        									  @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
       										  @RequestBody GiveBackVO vo);

    @PostMapping("/selectPassBackPageList")
    public ResponseWrapper selectPassBackPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                                  @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                                  @RequestBody PassBackVO vo);

    //保证金退款-查询单个
    @PostMapping("/selectGiveBackDetail")
    public ResponseWrapper selectGiveBackDetail(@RequestBody  GiveBackVO vo);

    @PostMapping("/selectGiveBackPass")
    public ResponseWrapper selectGiveBackPass(@RequestBody PassBackVO vo);
    
    //保证金退款-查询全部数据
    @PostMapping("/selectGiveBackAll")
    public ResponseWrapper selectGiveBackAll(@RequestBody  GiveBackVO vo);


    //保证金退款-查询全部数据
    @PostMapping("/selectGivePassAll")
    public ResponseWrapper selectGivePassAll(@RequestBody  GiveBackVO vo);

    @PostMapping("/selectPassBack")
    public ResponseWrapper selectPassBack(@RequestBody  GiveBackVO vo);
}