package com.unis.transaction.api.signuppay;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.signuppay.TransactionSignUpVO;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * Author lidiaoquan
 * 交易报名 at 2019-09-20
 */
@RequestMapping("transactionsignup")
public interface TransactionSignUpApi {

    @PostMapping(value = "/clickTransactionSignUp/{ccbm}")
    public ResponseWrapper clickTransactionSignUp(@RequestParam("ccbm") String ccbm);

    @PostMapping("/selectClickList")
    public ResponseWrapper selectClickList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                           @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                           @RequestBody SiteVO vo);

    //交易报名-新增
    @PostMapping("/insertTransactionSignUp")
    public ResponseWrapper insertTransactionSignUp(@RequestBody TransactionSignUpVO vo);

    //交易报名-修改
    @PostMapping("/updateTransactionSignUp")
    public ResponseWrapper updateTransactionSignUp(@RequestBody TransactionSignUpVO vo);

    //交易报名-关联信用查询 查看企业是否有资格报名
    @PostMapping("/valiTurn")
    public ResponseWrapper valiTurn(@RequestParam("dwbm") String dwbm);

    //交易报名-分页查询列表
    @PostMapping("/selectTransactionSignUpPageList")
    public ResponseWrapper selectTransactionSignUpPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                                           @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                                           @RequestBody TransactionSignUpVO vo);

    @PostMapping("/selectTransactionSignUp")
    public ResponseWrapper selectTransactionSignUp(@RequestBody TransactionSignUpVO vo);

    @PostMapping("/selectTranPageList")
    public ResponseWrapper selectTranPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                              @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                              @RequestBody TransactionSignUpVO vo);

    //交易报名-查询单个
    @PostMapping("/selectTransactionSignUpDetail")
    public ResponseWrapper selectTransactionSignUpDetail(@RequestBody TransactionSignUpVO vo);

    //交易报名-查询全部数据
    @PostMapping("/selectTransactionSignUpAll")
    public ResponseWrapper selectTransactionSignUpAll(@RequestBody TransactionSignUpVO vo);

    //交易报名--列表---场次---新增
    @PostMapping("/selectSceneList")
    public ResponseWrapper selectSceneList(@RequestBody TransactionSignUpVO vo);

    @PostMapping("/listSignUpByCcbm")
    ResponseWrapper listSignUpByCcbm(@RequestBody TransactionSignUpVO vo);
}
