package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.EntryAndExitOrderDTO;
import com.unis.transaction.common.vo.tradeplan.EntryAndExitOrderVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;

/**
 * Author huyong
 *  出入库委托书 at 2019-09-19
 */
@FeignClient(name = "transaction-service")
@Component
public interface EntryAndExitOrderApi {

    //出入库委托书-新增
    @PostMapping("/entryandexitorder/insert")
    public ResponseWrapper insertEntryAndExitOrder(@RequestBody EntryAndExitOrderVO vo);

    //出入库委托书-修改
    @PostMapping("/entryandexitorder/update")
    public ResponseWrapper updateEntryAndExitOrder(@RequestBody  EntryAndExitOrderVO vo);

 	//出入库委托书-分页查询列表
    @PostMapping("/entryandexitorder/select")
    public ResponseWrapper selectEntryAndExitOrderPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
        									  @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
       										  @RequestBody EntryAndExitOrderVO vo);

    //出入库委托书-查询单个
    @PostMapping("/entryandexitorder/selectDetail")
    public ResponseWrapper selectEntryAndExitOrderInfo(@RequestBody  EntryAndExitOrderVO vo);

    //场次下拉关联
    @PostMapping("/entryandexitorder/selectEntryAndExitOrder")
    public ResponseWrapper selectEntryAndExitOrder();

    //出入库委托书-查看--通过主键
    @GetMapping(value = "/entryandexitorder/selectEntryAndExitOrderBySite/{id}")
    public ResponseWrapper selectEntryAndExitOrderBySite(@RequestParam("id") String id);

     //出入库委托书-查看--通过主键
	@GetMapping(value = "/entryandexitorder/get/{id}")
   public ResponseWrapper selectEntryAndExitOrderDetail(@RequestParam("id") String id);

      //出入库委托书-删除--通过主键
	@DeleteMapping(value = "/entryandexitorder/del/{id}")
    public ResponseWrapper removeEntryAndExitOrder(@RequestParam("id") String id);

    @ApiOperation(value = "出入库委托书--查看--通过主键", notes = "参数：主键")
    @GetMapping(value = "/entryandexitorder/v2/getDTO/{wtbm}")
    ResponseWrapper getEntryAndExitOrderDTO(@PathVariable("wtbm")String wtbm);

    @PostMapping(value = "/entryandexitorder/v2/insert")
    ResponseWrapper insertEntryAndExitOrder2(@RequestBody EntryAndExitOrderDTO entityDTO);

    @PutMapping(value = "/entryandexitorder/v2/update")
    ResponseWrapper updateEntryAndExitOrder2(@RequestBody EntryAndExitOrderDTO entityDTO);

    @DeleteMapping(value = "/entryandexitorder/v2/del/{wtbm}")
    ResponseWrapper deleteEntryAndExitOrder(@PathVariable("wtbm") String wtbm);

    @PutMapping(value = "/entryandexitorder/update2NextNode")
    ResponseWrapper update2NextNode(@RequestBody EntryAndExitOrderVO entity);

    @PutMapping(value = "/entryandexitorder/updatePrice")
    ResponseWrapper updatePrice(@RequestBody EntryAndExitOrderDTO entityDTO);

    @PutMapping(value = "/entryandexitorder/updatePrice2NextNode")
    ResponseWrapper updatePrice2NextNode(@RequestBody EntryAndExitOrderVO entity);

    @PutMapping(value = "/entryandexitorder/updateNotice2NextNode")
    ResponseWrapper updateNotice2NextNode(@RequestBody EntryAndExitOrderVO entity);
}
