package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.RefundLetterVO;
import com.unis.transaction.common.vo.tradeplan.RefundNoticeQueryVO;
import com.unis.transaction.common.vo.tradeplan.RefundNoticeVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@FeignClient(name = "transaction-service")
@Component
public interface RefundNoticeApi {

    @PostMapping(value = "/refundNotice/save")
    public ResponseWrapper save(@RequestBody RefundNoticeVO vo);

    @PostMapping(value = "/refundNotice/update/{type}")
    public ResponseWrapper update(@PathVariable("type") Integer type, @RequestBody RefundNoticeVO vo);

    @PostMapping(value = "/refundNotice/page/{pageNum}/{pageSize}")
    public ResponseWrapper getPage( @PathVariable("pageNum") Integer pageNum,
                                    @PathVariable("pageSize") Integer pageSize,
                                    @RequestBody RefundNoticeQueryVO queryVO);

    @PostMapping(value = "/refundNotice/contractPage/{pageNum}/{pageSize}")
    public ResponseWrapper getContractPage( @PathVariable("pageNum") Integer pageNum,
                                            @PathVariable("pageSize") Integer pageSize,
                                            @RequestBody RefundNoticeQueryVO queryVO);

    @PostMapping(value = "/refundNotice/letter/save")
    public ResponseWrapper saveLetter(@RequestBody RefundLetterVO vo);

    @PostMapping(value = "/refundNotice/letter/update/{type}")
    public ResponseWrapper updateLetter(@PathVariable("type") Integer type, @RequestBody RefundLetterVO vo);

    @GetMapping(value = "/refundNotice/info/{htbm}")
    public ResponseWrapper getInfoByHtbm(@PathVariable("htbm") String htbm);
}
