package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.*;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;
/**
 * Author huyong
 *  交易标的 at 2019-09-21
 */
@FeignClient(name = "transaction-service")
@Component
public interface TradeMarkApi {

    //交易标的-新增
    @PostMapping("/trademark/insert")
    public ResponseWrapper insertTradeMark(@RequestBody TradeMarkBackVO vo);

    //交易标的-修改
    @PostMapping("/trademark/update")
    public ResponseWrapper updateTradeMark(@RequestBody TradeMarkBackVO vo);

    //场次-新增
    @PostMapping("/trademark/insertCC")
    public ResponseWrapper insertCC(@RequestBody SiteVO vo);

    //合同-新增
    @PostMapping("/trademark/insertContract")
    public ResponseWrapper insertContract(@RequestBody ContractVO vo);

    //合同-修改
    @PostMapping("/trademark/updateContract")
    public ResponseWrapper updateContract(@RequestBody ContractVO vo);

    //交易标的-修改成不能修改
    @PostMapping(value = "/trademark/updateContractByisChange")
    public ResponseWrapper updateContractByisChange(@RequestBody  ContractVO vo);

    //场次-查看--通过主键
    @GetMapping(value = "/trademark/selectContractDetail/{id}")
    public ResponseWrapper selectContractDetail(@PathVariable("id") String id);

    @PostMapping(value = "/trademark/selectTradeMarkAll")
    public ResponseWrapper selectTradeMarkAll();

    //场次-查看--通过主键
    @GetMapping(value = "/trademark/selectContract/{id}")
    public ResponseWrapper selectContract(@RequestParam("id") String id);

    //场次-查看--通过主键
    @GetMapping(value = "/trademark/selectContractList/{id}")
    public ResponseWrapper selectContractList(@RequestParam("id") String id);

    @GetMapping(value = "/trademark/selectDWmcList/{id}")
    public ResponseWrapper selectDWmcList(@RequestParam("id") String id);

    @GetMapping(value = "/trademark/selectContractByDwbm/{dwbm}/{ccbm}")
    public ResponseWrapper selectContractByDwbm(@RequestParam("dwbm") String dwbm,@RequestParam("ccbm") String ccbm);

    @GetMapping(value = "/trademark/selectContractPage")
    public ResponseWrapper selectContractPage(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                      @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                      @RequestBody ContractVO vo);

    //场次-修改
    @PostMapping("/trademark/updateCC")
    public ResponseWrapper updateCC(@RequestBody  SiteVO  vo);

    //场次-生成场次数字
    @PostMapping("/trademark/selectCode")
    public ResponseWrapper selectCode();

    //场次-查看--通过主键
    @GetMapping(value = "/trademark/selectCC/{id}")
    public ResponseWrapper selectCC(@RequestParam("id") String id);

    //场次-场次校验
    @PostMapping("/trademark/valiCode")
    public ResponseWrapper valiCode(@RequestParam("ccbm") String ccbm,@RequestParam("cccode") String cccode);


    //交易标的-查询单个
    @PostMapping("/trademark/selectDetail")
    public ResponseWrapper selectTradeMarkInfo(@RequestBody  TradeMarkVO vo);

    @PostMapping("/trademark/selectContracts/{dwbm}/{jylx}")
    public ResponseWrapper selectContracts(@RequestParam("dwbm") String dwbm,@RequestParam("jylx") String jylx);

    @PostMapping("/trademark/selectContractAll")
    public ResponseWrapper selectContractAll();

    @PostMapping("/trademark/selectContractAlls/{jylx}")
    public ResponseWrapper selectContractAlls(@RequestParam("jylx") String jylx);

    @PostMapping(value = "/trademark/selectTradeByCcbm/{ccbm}")
    public ResponseWrapper selectTradeByCcbm(@RequestParam("ccbm") String ccbm);

     //交易标的-查看--通过主键
	@GetMapping(value = "/trademark/get/{id}")
   public ResponseWrapper selectTradeMarkDetail(@RequestParam("id") String id);

    //交易标的-查看--通过主键
    @GetMapping(value = "/trademark/selectTradeMarkByBdh/{bdh}")
    public TradeMarkVO selectTradeMarkByBdh(@RequestParam("bdh") String bdh);

      //交易标的-删除--通过主键
	@DeleteMapping(value = "/trademark/del/{id}")

    public ResponseWrapper deleteTradeMark(@RequestParam("id") String id);

    //交易标的-删除--通过主键
    @DeleteMapping(value = "/trademark/deleteTrade/{id}")

    public ResponseWrapper deleteTrade(@RequestParam("id") String id);

    @DeleteMapping(value = "/trademark/delCC/{id}")

    public ResponseWrapper delCC(@RequestParam("id") String id);

    @GetMapping(value = "/trademark/selectPage")
    public ResponseWrapper selectPage(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                         @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                         @RequestBody WarehousingArrangementVO vo);

    @GetMapping(value = "/trademark/selectList")
	public ResponseWrapper selectByWtfbm(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                         @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                         @RequestBody SiteVO vo);


	@GetMapping(value = "/trademark/export/{apbm}")
	public ResponseWrapper export(@RequestParam("apbm")String apbm);
}