package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.TradeRuleVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
/**
 * Author lidiaoquan
 *  交易细则 at 2019-09-19
 */
@FeignClient(name = "transaction-service")
@Component
public interface TradeRuleApi {

    //交易细则-新增
    @PostMapping("/traderule/insertTradeRule")
    public ResponseWrapper insertTradeRule(@RequestBody TradeRuleVO vo);

    //交易细则-修改
    @PostMapping("/traderule/updateTradeRule")
    public ResponseWrapper updateTradeRule(@RequestBody  TradeRuleVO vo);

 	//交易细则-分页查询列表
    @PostMapping("/traderule/selectTradeRulePageList")
    public ResponseWrapper selectTradeRulePageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
        									  @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
       										  @RequestBody TradeRuleVO vo);

    //交易细则-查询单个
    @PostMapping("/traderule/selectTradeRuleDetail")
    public ResponseWrapper selectTradeRuleDetail(@RequestBody  TradeRuleVO vo);

    //交易细则-查询全部数据
    @PostMapping("/traderule/selectTradeRuleAll")
    public ResponseWrapper selectTradeRuleAll(@RequestBody  TradeRuleVO vo);
}