package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.TyHtlytx;
import com.unis.transaction.common.vo.tradeplan.TyHtlytxVO;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @Classname TyHttxApi
 * @Description 合同提醒Api
 * @Date 2023/8/2 11:13
 * @Created by rising123sun
 */
@FeignClient(name = "transaction-service")
@Component
public interface TyHttxApi {

    // 距离合同完成时间提前提醒时间设置
    // 距离合同完成时间提前提醒时间设置
    @PostMapping("/tyHttx/htsjtxsz")
    @ApiOperation(value = "距离合同完成时间提前提醒时间设置", notes = "距离合同完成时间提前提醒时间设置")
    public ResponseWrapper htsjtxsz(@ApiParam(name = "sj", value = "时间") @RequestParam Integer sj);

    // 距离合同完成时间提前提醒时间查询
    @GetMapping("/tyHttx/htsjtxcx")
    @ApiOperation(value = "距离合同完成时间提前提醒时间查询", notes = "距离合同完成时间提前提醒时间查询")
    public ResponseWrapper htsjtxcx();

    // 添加提醒测试
    @PostMapping("/tyHttx/tjhtlytxTest")
    @ApiOperation(value = "添加提醒测试", notes = "添加提醒测试")
    public ResponseWrapper tjhtlytxTest();

    // 生成敦促履约涵(初次打开)
    @PostMapping("/tyHttx/scdclyh")
    @ApiOperation(value = "生成敦促履约涵(初次打开)", notes = "生成敦促履约涵(初次打开)")
    public ResponseWrapper scdclyh(@ApiParam(name = "hth", value = "合同编号") @RequestParam String hth);

    // 履约提醒分页列表查询
    @PostMapping("/tyHttx/queryPageList")
    @ApiOperation(value = "履约提醒分页列表查询", notes = "履约提醒分页列表查询")
    public ResponseWrapper queryPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                         @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                         @RequestBody TyHtlytxVO tyHtlytx);

    // 回复履约提醒
    @PostMapping("/tyHttx/hfhtlytx")
    @ApiOperation(value = "回复履约提醒", notes = "回复履约提醒")
    public ResponseWrapper hfhtlytx(@RequestBody TyHtlytx tyHtlytx);

    // 修改或保存敦促履约涵
    @PostMapping("/tyHttx/xgbcDclyh")
    @ApiOperation(value = "修改或保存敦促履约涵", notes = "修改或保存敦促履约涵")
    public ResponseWrapper xgbcDclyh(
            @RequestParam(value = "id") String lytxid,
            @RequestParam(value = "dclyhbzr") String dclyhbzr,
            @RequestParam(value = "dclyh") String dclyh,
            @RequestParam(value = "dclyhbzrq") String dclyhbzrq,
            @RequestParam(value = "sclyhzt") String sclyhzt);

    // 根据id查询敦促履约涵
    @GetMapping("/tyHttx/queryDclyhById")
    @ApiOperation(value = "根据id查询敦促履约涵", notes = "根据id查询敦促履约涵")
    public ResponseWrapper queryDclyhById(@ApiParam(name = "id", value = "id") @RequestParam String id);


}
