package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.TyBmkhxxtj;
import com.unis.transaction.common.vo.tradeplan.TyJyccKhxx;
import com.unis.transaction.common.vo.tradeplan.TyJyccKhxxVO;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.util.List;

/**
 * @Classname TyJyccKhxxApi
 * @Description 交易场次_报名客户Api
 * @Date 2023/8/2 09:14
 * @Created by rising123sun
 */
@FeignClient(name = "transaction-service")
@Component
public interface TyJyccKhxxApi {

    // 写下使用easyexcel导入数据并存入到数据库的代码
    @PostMapping(value = "/jyccKhxx/importExcel")
    public ResponseWrapper importExcel(@RequestBody TyJyccKhxxVO tyJyccKhxxVO);

    // 根据wtbh查询所有的客户信息
    @GetMapping(value = "/jyccKhxx/selectKhxxByWtbh")
    public ResponseWrapper selectKhxxByWtbh(@ApiParam(name = "ccId", value = "场次id", required = true) @RequestParam(value = "ccId") String ccId);

    // 根据wtbh查询所有的客户信息
    @GetMapping(value = "/jyccKhxx/selectKhxx")
    public ResponseWrapper selectKhxx(@ApiParam(name = "wtbm", value = "wtbm", required = true) @RequestParam(value = "wtbm") String wtbm);

    // 添加客户信息
    @PostMapping(value = "/jyccKhxx/addKhxx")
    public ResponseWrapper addKhxx(List<TyJyccKhxx> tyJyccKhxxList);

    // 删除客户信息
    @DeleteMapping(value = "/jyccKhxx/deleteKhxx")
    public ResponseWrapper deleteKhxx(List<TyJyccKhxx> tyJyccKhxxList);

    // 报名客户信息统计分页列表查询
    @PostMapping(value = "/jyccKhxx/selectKhxxTj")
    @ApiOperation(value = "报名客户信息统计分页列表查询", notes = "报名客户信息统计分页列表查询")
    public ResponseWrapper selectKhxxTj(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                        @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                        @RequestBody TyBmkhxxtj tyBmkhxxtj);

    // 报名客户信息统计报表导出
    @PostMapping(value = "/jyccKhxx/exportKhxxTj")
    @ApiOperation(value = "报名客户信息统计报表导出", notes = "报名客户信息统计报表导出")
    public ResponseWrapper exportKhxxTj(@RequestBody TyBmkhxxtj tyBmkhxxtj);
}
