package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.*;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;

/**
 * @Classname TyJytjbbApi
 * @Description 交易统计报表Api
 * @Date 2023/8/2 09:14
 * @Created by rising123sun
 */
@FeignClient(name = "transaction-service")
@Component
public interface TyJytjbbApi {

    @ApiOperation(value = "交易统计_成交统计表-分页查询", notes = "交易统计_成交统计表-分页查询")
    @PostMapping(value = "/tyJytjbb/sjcbcjPage")
    public ResponseWrapper insertTradeMark(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                           @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                           @RequestBody TyJytjbb vo);

    // 市级储备成交统计表
    @ApiOperation(value = "交易统计_成交统计表-市级储备成交统计表", notes = "交易统计_成交统计表-市级储备成交统计表")
    @PostMapping(value = "/tyJytjbb/sjcbcj")
    public ResponseWrapper sjcbcj(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc);

    // 市级储备成交统计表报表导出
    @ApiOperation(value = "交易统计_成交统计表-市级储备成交统计表报表导出", notes = "交易统计_成交统计表-市级储备成交统计表报表导出")
    @PostMapping(value = "/tyJytjbb/sjcbcjExport")
    public ResponseWrapper sjcbcjExport(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc);

    // 手续费统计表
    @ApiOperation(value = "交易统计_成交统计表-手续费统计表", notes = "交易统计_成交统计表-手续费统计表")
    @PostMapping(value = "/tyJytjbb/sxfTj")
    public ResponseWrapper sxfTj(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc);

    // 市级储备成交统计表报表导出
    @ApiOperation(value = "交易统计_成交统计表-手续费统计表报表导出", notes = "交易统计_成交统计表-手续费统计表报表导出")
    @PostMapping(value = "/tyJytjbb/sxfExport")
    public ResponseWrapper sxfExport(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc);


    //交易结果汇总表-分页列表
    @ApiOperation(value = "交易结果汇总表-分页列表", notes = "参数：交易日期")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
            @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })
    @PostMapping(value = "/tyJytjbb/selectTurnoverEndPageList")
    public ResponseWrapper jyjghz(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
            , @RequestParam(value = "pageSize", defaultValue = "10") int pageSize
            , @RequestParam(value = "cjrqks", required = false) String cjrqks
            , @RequestParam(value = "cjrqjs", required = false) String cjrqjs);

    // 交易结果汇总表导出为word文件
    @ApiOperation(value = "交易结果汇总表报表导出", notes = "交易结果汇总表报表导出")
    @PostMapping(value = "/tyJytjbb/jyjgExport")
    public ResponseWrapper jyjgExport(@RequestParam(value = "cjrqks", required = false) String cjrqks
            , @RequestParam(value = "cjrqjs", required = false) String cjrqjs);

    // 地储数据记录表分页列表查询
    @ApiOperation(value = "地储数据记录表分页列表查询", notes = "地储数据记录表分页列表查询")
    @PostMapping(value = "/tyJytjbb/selectDcjlPage")
    public ResponseWrapper selectDcjlPage(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                          @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                          @RequestBody TyDcsjjl vo);

    // 地储数据记录表导出
    @ApiOperation(value = "地储数据记录表导出", notes = "地储数据记录表导出")
    @PostMapping(value = "/tyJytjbb/dcjlExport")
    public ResponseWrapper dcjlExport(@RequestBody TyDcsjjl vo);

    // 地储交易汇总表分页列表查询
    @ApiOperation(value = "地储交易汇总表分页列表查询", notes = "地储交易汇总表分页列表查询")
    @PostMapping(value = "/tyJytjbb/selectDcjyhzPage")
    public ResponseWrapper selectDcjyhzPage(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                            @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                            @RequestBody DcJyHzzb vo);

    // 地储交易汇总表导出
    @ApiOperation(value = "地储交易汇总表导出", notes = "地储交易汇总表导出")
    @PostMapping(value = "/tyJytjbb/dcjyhzExport")
    public ResponseWrapper dcjyhzExport(@RequestBody DcJyHzzb vo);

    // 保存或修改地储交易统计备注信息
    @ApiOperation(value = "保存或修改地储交易统计备注信息", notes = "保存或修改地储交易统计备注信息")
    @PostMapping(value = "/tyJytjbb/saveOrUpdateDcjybzxx")
    public ResponseWrapper saveOrUpdateDcjybzxx(@RequestBody Dcjybzxx vo);
}
