package com.unis.transaction.api.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.EntryAndExitOrderInputVO;
import com.unis.transaction.common.vo.tradeplan.WarehousingArrangementVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;

/**
 * Author huyong
 *  出入库安排 at 2019-09-20
 */
@FeignClient(name = "transaction-service")
@Component
public interface WarehousingArrangementApi {

    //出入库安排-新增
    @PostMapping("/warehousingarrangement/insert")
    public ResponseWrapper insertWarehousingArrangement(@RequestBody EntryAndExitOrderInputVO vo);

    //出入库安排-修改
    @PostMapping("/warehousingarrangement/update")
    public ResponseWrapper updateWarehousingArrangement(@RequestBody  EntryAndExitOrderInputVO vo,@RequestParam("sjlx")Integer sjlx);


	  //出入库安排-分页查询列表

	  @PostMapping("/warehousingarrangement/select")
	  public ResponseWrapper selectWarehousingArrangementPageList(@RequestParam(value = "pageNum",
	  defaultValue = "1") int pageNum, @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,@RequestBody WarehousingArrangementVO vo);

    //出入库安排-查询单个
    @PostMapping("/warehousingarrangement/selectDetail")
    public ResponseWrapper selectWarehousingArrangementInfo(@RequestBody  WarehousingArrangementVO vo);

    @PostMapping("/warehousingarrangement/selectWareDetail")
    public ResponseWrapper selectWareDetail(@RequestBody  WarehousingArrangementVO vo);

     //出入库安排-查看--通过主键
	@GetMapping(value = "/warehousingarrangement/get/{id}")
   public ResponseWrapper selectWarehousingArrangementDetail(@RequestParam("id") String id);

    @GetMapping(value = "/warehousingarrangement/selectwarehousingArrangementByWtbm/{wtbm}")
    public ResponseWrapper selectwarehousingArrangementByWtbm(@RequestParam("wtbm") String id);

      //出入库安排-删除--通过主键
	@DeleteMapping(value = "/warehousingarrangement/del/{id}")

    public ResponseWrapper deleteWarehousingArrangement(@RequestParam("id") String id);

    @PostMapping(value = "/warehousingarrangement/singleupdate")
    public ResponseWrapper updateWarehousingArrangement(@RequestBody WarehousingArrangementVO vo);
}