package com.unis.transaction.client;

import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;


@FeignClient(value = "data-dict")
@Component
public interface DictClient {

	@GetMapping({ "/dataDictionary/findById/{id}" })
	public ResponseWrapper findById(@PathVariable("id") Integer id);
	
	@GetMapping({"/dataDictionary/findByGroupId/{groupId}"})
	public ResponseWrapper findByGroupId(@PathVariable("groupId") String groupId);
	
	/**
	 * 通过组Id和对应类型Id获取字典对象
	 * @param groupId
	 * @param dictCode
	 * @return
	 */
	@GetMapping({"/dataDictionary/getDataDictionary/{groupId}/{dictCode}"})
	public ResponseWrapper getDataDictionaryByGroupIdAndDictCode(@PathVariable("groupId") String groupId, @PathVariable("dictCode") String dictCode);
	
	@GetMapping({"/dataDictionaryGroup/findByPid/{pid}"})
	public ResponseWrapper findByPid(@PathVariable("pid") String pid);
	
	@GetMapping({"/dataDictionary/findByPDictCode/{pdictCode}"})
	public ResponseWrapper findByPDictCode(@PathVariable("pdictCode") String pdictCode);
}
