package com.unis.transaction.client;

import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * 
 * @Description: 用户中心接口
 * @author 王帅
 * @date 2019年8月1日
 * @version V1.0
 */
@Component
@FeignClient("myuser")
public interface OrgainzeClient {

	/**
	 * 
	* @Title: findByCode
	* @Description: 根据组织编号获取本单位名字
	* @param @param orgCode
	* @param @return    参数
	* @return ResponseWrapper    返回类型
	* @throws
	 */
	@GetMapping({"/myuser/org/findByCode"})
	public ResponseWrapper findByCode(@RequestParam(name = "orgCode", required = true)String orgCode);
}
