package com.unis.transaction.common.constant;

import io.swagger.annotations.ApiModel;
import lombok.Getter;
import lombok.Setter;

/**
 待提交 91000001  审核驳回 91000102 签章驳回 91000103 受理人已驳回  91000104
 待审核 91000200
 待盖章 91000300

 待受理人审核  91000400 审核人已驳回  91000405
 待审核人审核  91000500
 已确认        91000600
 * 委托书节点状态
 * @author by PIG
 * 2022/8/30 11
 */
@ApiModel("委托书状态")
@Getter
public enum EntryAndExitOrderNodeConstant {

    DTJ("91000001","待提交"),
    DSH("91000200","待审核"),
    SHBH("91000102","审核驳回"),
    DGZ("91000300","待盖章"),
    QZBH("91000103","签章驳回"),

    DSLRSH("91000400","待受理人审核"),
    SLRYBH("91000104","受理人已驳回"),
    DSHRSH("91000500","待审核人审核"),
    SHRBH("91000405","审核人驳回"),
    YQR("91000600","已确认"),

    YFB("91000620","已发布"),
    WFB("91000610","未发布"),
    FBHCH("91000611","发布后撤回")
    ;

    @Setter
    private String name;
    @Setter
    private String value;

    private  EntryAndExitOrderNodeConstant(String value,String name){
        this.value=value;
        this.name=name;
    }
    public boolean eqVal(String val){
        return this.value.equals(val);
    }
}
