package com.unis.transaction.common.utils;

import org.apache.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.List;

public class OrgUtil {

    /**
     * 获取父组织code,无则为空
     * @param code
     * @return
     */
    public static String getParentOrg(String code){
        if(StringUtils.isNotEmpty(code)){
            code=code.trim();
            int len=code.length();
            if(len>5){
                return  code.substring(0,len-3);
            }
            return null;
        }
        return null;
    }

    /**
     * 生成规模计划编号
     * @param year
     * @param orgCode
     * @return
     */
    public static String makeReservePlanCode(String year,String orgCode){
        StringBuffer sb=new StringBuffer();
        if(StringUtils.isNotEmpty(year)&&StringUtils.isNotEmpty(orgCode)){
            sb.append("GM").append(year);
            List<String> list=new ArrayList<>();
            list.add(orgCode);
            String temp=orgCode;
            while((temp=getParentOrg(temp))!=null){
                list.add(temp);
            }
            for(int i=list.size()-1;i>=0;i--){
                sb.append(list.get(i));
            }
        }
        return sb.toString();
    }

    /**
     * 生成收购计划编号
     * @param year
     * @param orgCode
     * @return
     */
    public static String makeReserveBuyPlanCode(String year,String orgCode){
        StringBuffer sb=new StringBuffer();
        if(StringUtils.isNotEmpty(year)&&StringUtils.isNotEmpty(orgCode)){
            sb.append("SG").append(year);
            List<String> list=new ArrayList<>();
            list.add(orgCode);
            String temp=orgCode;
            while((temp=getParentOrg(temp))!=null){
                list.add(temp);
            }
            for(int i=list.size()-1;i>=0;i--){
                sb.append(list.get(i));
            }
        }
        return sb.toString();
    }

    /**
     * 生成轮换计划编号
     * @param year
     * @param orgCode
     * @return
     */
    public static String makeRotatePlanMakeCode(String year,String orgCode){
        StringBuffer sb=new StringBuffer();
        if(StringUtils.isNotEmpty(year)&&StringUtils.isNotEmpty(orgCode)){
            sb.append("JH").append(year);
            List<String> list=new ArrayList<>();
            list.add(orgCode);
            String temp=orgCode;
            while((temp=getParentOrg(temp))!=null){
                list.add(temp);
            }
            for(int i=list.size()-1;i>=0;i--){
                sb.append(list.get(i));
            }
        }
        return sb.toString();
    }

    public static void main(String[] args) {
        System.out.println(makeReservePlanCode("2019","LS001001002"));
    }
}
