package com.unis.transaction.common.utils;

import com.alibaba.fastjson.JSONObject;
import com.unis.common.utils.DateUtil;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class WorkdayUtils {
    private static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    /**
     * @return 返回结果
     */
    public static String request(String httpUrl) {
        BufferedReader reader = null;
        String result = null;
        StringBuffer sbf = new StringBuffer();
        httpUrl = httpUrl;
        try {
            URL url = new URL(httpUrl);
            HttpURLConnection connection = (HttpURLConnection)url.openConnection();
            connection.setRequestMethod("GET");
            connection.connect();
            InputStream is = connection.getInputStream();
            reader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
            String strRead = null;
            while ((strRead = reader.readLine()) != null) {
                sbf.append(strRead);
                sbf.append("\r\n");
            }
            reader.close();
            result = sbf.toString();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }


    //获取计划激活日期
    public static Date getWorkDate(Date news) throws ParseException {
        //String hol = WorkdayUtils.request("http://tool.bitefu.net/jiari?d="+ DateUtil.getYearString());
        String hol = "{\"2021\":{\"0101\":2,\"0102\":1,\"0103\":1,\"0211\":1,\"0212\":2,\"0213\":2,\"0214\":2,\"0215\":1,\"0216\":1,\"0217\":1,\"0403\":1,\"0404\":2,\"0405\":1,\"0501\":2,\"0502\":1,\"0503\":1,\"0504\":1,\"0505\":1,\"0612\":1,\"0613\":1,\"0614\":2,\"0919\":1,\"0920\":1,\"0921\":2,\"1001\":2,\"1002\":2,\"1003\":2,\"1004\":1,\"1005\":1,\"1006\":1,\"1007\":1}}";
        JSONObject jsonObject =JSONObject.parseObject(hol);
        String str = jsonObject.getString(String.valueOf(DateUtil.getYearString()));
        List<String> list = new ArrayList<>();
        String sub = str.substring(1,str.length()-1);
        String[] data  =sub.split(",");
        for(String obj:data){
            String[] val  =obj.replace("\"", "").split(":");
            list.add(String.valueOf(DateUtil.getYearString())+"-"+val[0].substring(0,2)+"-"+val[0].substring(2,4));
        }
        Date today =news;
        Date tomorrow = null;
        int delay = 1;
        int num = 3;//根据需要设置,这个值就是业务需要的n个工作日
        while(delay <= num){
            tomorrow = getTomorrow(today);
            //当前日期+1即tomorrow,判断是否是节假日,同时要判断是否是周末,都不是则将scheduleActiveDate日期+1,直到循环num次即可
            if(!isWeekend(sdf.format(tomorrow)) && !isHoliday(sdf.format(tomorrow),list)){
                delay++;
                today = tomorrow;
            } else if (isWeekend(sdf.format(tomorrow))){
                today = tomorrow;
                System.out.println(sdf.format(tomorrow) + "::是周末");
            } else if (isHoliday(sdf.format(tomorrow),list)){
                today = tomorrow;
                System.out.println(sdf.format(tomorrow) + "::是节假日");
            }
        }
        System.out.println("3个工作日后,即计划激活日期为::" + sdf.format(today));
        return today;
    }

    /**
     * 获取明天的日期
     *
     * @param date
     * @return
     */
    public static Date getTomorrow(Date date){
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.DAY_OF_MONTH, +1);
        date = calendar.getTime();
        return date;
    }

    /**
     * 判断是否是weekend
     *
     * @param sdate
     * @return
     * @throws ParseException
     */
    public static boolean isWeekend(String sdate) throws ParseException {
        Date date = sdf.parse(sdate);
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        if(cal.get(Calendar.DAY_OF_WEEK) == Calendar.SATURDAY || cal.get(Calendar.DAY_OF_WEEK) == Calendar.SUNDAY){
            return true;
        } else{
            return false;
        }

    }

    /**
     * 判断是否是holiday
     *
     * @param sdate
     * @param list
     * @return
     */
    public static boolean isHoliday(String sdate, List<String> list) throws ParseException {
        if(list.size() > 0){
            for(int i = 0; i < list.size(); i++){
                if(sdate.equals(list.get(i))){
                    return true;
                }
            }
        }
        return false;
    }

    public static void main(String[] args) throws Exception{
    }
}

