package com.unis.transaction.common.vo.creditevaluate;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Author lidiaoquan
 * Description 成交数据维护
 * Date  2019-09-26
 */
@ApiModel(value = "成交数据维护导入")
@Data
public class TurnoverDataImpVO implements Serializable {


	@ApiModelProperty(value = "省份名称", notes ="", required = false)
	private String sfmc;	//省份名称

	@ApiModelProperty(value = "合同号", notes ="", required = false)
	private String hth;	//合同号


	@ApiModelProperty(value = "标的号", notes ="", required = false)
	private String bdh;	//标的号


	@ApiModelProperty(value = "卖方承储库名称", notes ="", required = false)
	private String mfcckmc;	//卖方承储库名称


	@ApiModelProperty(value = "交货仓库名称", notes ="", required = false)
	private String jhckmc;	//交货仓库名称


	@ApiModelProperty(value = "仓号名称", notes ="", required = false)
	private String chmc;	//仓号名称


	@ApiModelProperty(value = "生产年份", notes ="", required = false)
	private String scnf;	//生产年份


	@ApiModelProperty(value = "是否露天  0否 1是", notes ="", required = false)
	private String sflt;	//是否露天  0否 1是


	@ApiModelProperty(value = "收购等级名称", notes ="", required = false)
	private String sgdjmc;	//收购等级名称



	@ApiModelProperty(value = "混合扦样等级名称", notes ="", required = false)
	private String hhqydjmc;	//混合扦样等级名称


	@ApiModelProperty(value = "成交数量", notes ="", required = false)
	private Integer cjsl;	//成交数量


	@ApiModelProperty(value = "总成交数量", notes ="", required = false)
	private Integer zcjsl;	//总成交数量


	@ApiModelProperty(value = "粮食性质名称", notes ="", required = false)
	private String lsxzmc;	//粮食性质名称


	@ApiModelProperty(value = "粮食品种名称", notes ="", required = false)
	private String lspzmc;	//粮食品种名称


	@ApiModelProperty(value = "起拍价格", notes ="", required = false)
	private BigDecimal qpjg;	//起拍价格


	@ApiModelProperty(value = "成交单价", notes ="", required = false)
	private BigDecimal cjdj;	//成交单价


	@ApiModelProperty(value = "成交金额", notes ="", required = false)
	private String cjje;	//成交金额


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "成交日期", notes ="", required = false)
	private Date cjrq;	//成交日期


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "付货款截止日期", notes ="", required = false)
	private Date fhkjzrq;	//付货款截止日期


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "出库截止日期", notes ="", required = false)
	private Date ckjzrq;	//出库截止日期


	@ApiModelProperty(value = "成交单位名称", notes ="", required = false)
	private String cjdwmc;	//成交单位名称


	@ApiModelProperty(value = "IP地址及类型", notes ="", required = false)
	private String dzjlx;	//IP地址及类型


	@ApiModelProperty(value = "交易节编号", notes ="", required = false)
	private String jyjbh;	//交易节编号


	@ApiModelProperty(value = "状态名称", notes ="", required = false)
	private String ztmc;	//状态名称


	@ApiModelProperty(value = "横向得分", notes ="", required = false)
	private BigDecimal hxdf;	//横向得分


	@ApiModelProperty(value = "卖方承储库编码", notes ="", required = false)
	private String cc;	//卖方承储库编码


	@ApiModelProperty(value = "委托方", notes ="", required = false)
	private String wtf;	//委托方


}