package com.unis.transaction.common.vo.creditevaluate;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * Author lidiaoquan
 * Description 成交数据维护
 * Date  2019-09-26
 */
@ApiModel(value = "成交数据维护")
@Data
public class TurnoverDataVO extends UrlVO implements Serializable {
	private static final long serialVersionUID = 1L;

	private Integer status;

	@ApiModelProperty(value = "成交编码 CJ+8位顺序号##前端注意：这是修改唯一标识主键", notes ="", required = false)
	private String cjbm;	//成交编码 CJ+8位顺序号>>>前端注意：这是修改唯一标识主键


	@ApiModelProperty(value = "省份编码", notes ="", required = false)
	private String sfbm;	//省份编码


	@ApiModelProperty(value = "省份名称", notes ="", required = false)
	private String sfmc;	//省份名称


	@ApiModelProperty(value = "合同编码", notes ="", required = false)
	private String htbm;	//合同编码


	@ApiModelProperty(value = "合同号", notes ="", required = false)
	private String hth;	//合同号


	@ApiModelProperty(value = "标的编码", notes ="", required = false)
	private String bdbm;	//标的编码


	@ApiModelProperty(value = "标的号", notes ="", required = false)
	private String bdh;	//标的号


	@ApiModelProperty(value = "卖方承储库编码", notes ="", required = false)
	private String mfcckbm;	//卖方承储库编码


	@ApiModelProperty(value = "卖方承储库名称", notes ="", required = false)
	private String mfcckmc;	//卖方承储库名称


	@ApiModelProperty(value = "交货仓库编码", notes ="", required = false)
	private String jhckbm;	//交货仓库编码


	@ApiModelProperty(value = "交货仓库名称", notes ="", required = false)
	private String jhckmc;	//交货仓库名称


	@ApiModelProperty(value = "仓号编码", notes ="", required = false)
	private String chbm;	//仓号编码


	@ApiModelProperty(value = "仓号名称", notes ="", required = false)
	private String chmc;	//仓号名称


	@ApiModelProperty(value = "生产年份", notes ="", required = false)
	private String scnf;	//生产年份


	@ApiModelProperty(value = "是否露天  0否 1是", notes ="", required = false)
	private String sflt;	//是否露天  0否 1是


	@ApiModelProperty(value = "收购等级编码", notes ="", required = false)
	private String sgdjbm;	//收购等级编码


	@ApiModelProperty(value = "收购等级名称", notes ="", required = false)
	private String sgdjmc;	//收购等级名称


	@ApiModelProperty(value = "混合扦样等级编码", notes ="", required = false)
	private String hhqydjbm;	//混合扦样等级编码


	@ApiModelProperty(value = "混合扦样等级名称", notes ="", required = false)
	private String hhqydjmc;	//混合扦样等级名称


	@ApiModelProperty(value = "成交数量", notes ="", required = false)
	private BigDecimal cjsl;	//成交数量


	@ApiModelProperty(value = "总成交数量", notes ="", required = false)
	private BigDecimal zcjsl;	//总成交数量


	@ApiModelProperty(value = "粮食性质编码", notes ="", required = false)
	private String lsxzbm;	//粮食性质编码


	@ApiModelProperty(value = "粮食性质名称", notes ="", required = false)
	private String lsxzmc;	//粮食性质名称


	@ApiModelProperty(value = "粮食品种编码", notes ="", required = false)
	private String lspzbm;	//粮食品种编码


	@ApiModelProperty(value = "粮食品种名称", notes ="", required = false)
	private String lspzmc;	//粮食品种名称


	@ApiModelProperty(value = "起拍价格", notes ="", required = false)
	private BigDecimal qpjg;	//起拍价格


	@ApiModelProperty(value = "成交单价", notes ="", required = false)
	private BigDecimal cjdj;	//成交单价


	@ApiModelProperty(value = "成交金额", notes ="", required = false)
	private BigDecimal cjje;	//成交金额

	@ApiModelProperty(value = "手续费", notes ="", required = false)
	private BigDecimal sxf;	//成交金额


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "成交日期", notes ="", required = false)
	private Date cjrq;	//成交日期


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "付货款截止日期", notes ="", required = false)
	private Date fhkjzrq;	//付货款截止日期


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "出库截止日期", notes ="", required = false)
	private Date ckjzrq;	//出库截止日期


	@ApiModelProperty(value = "成交单位编码", notes ="", required = false)
	private String cjdwbm;	//成交单位编码


	@ApiModelProperty(value = "成交单位名称", notes ="", required = false)
	private String cjdwmc;	//成交单位名称


	@ApiModelProperty(value = "IP地址及类型", notes ="", required = false)
	private String dzjlx;	//IP地址及类型


	@ApiModelProperty(value = "交易节编号", notes ="", required = false)
	private String jyjbh;	//交易节编号


	@ApiModelProperty(value = "状态编码", notes ="", required = false)
	private String ztbm;	//状态编码


	@ApiModelProperty(value = "状态名称", notes ="", required = false)
	private String ztmc;	//状态名称


	@ApiModelProperty(value = "横向得分", notes ="", required = false)
	private BigDecimal hxdf;	//横向得分


	@ApiModelProperty(value = "卖方承储库编码(弃用)", notes ="", required = false)
	private String cc;	//卖方承储库编码


	@ApiModelProperty(value = "委托方", notes ="", required = false)
	private String wtf;	//委托方


	@ApiModelProperty(value = "所属库点编码", notes ="", required = false)
	private String sskd;	//所属库点编码


	@ApiModelProperty(value = "所属库点名称", notes ="", required = false)
	private String sskdmc;	//所属库点名称


	@ApiModelProperty(value = "所属企业编码", notes ="", required = false)
	private String ssqy;	//所属企业编码

	@ApiModelProperty(value = "备注", notes ="", required = false)
	private String remark;	//备注


	@ApiModelProperty(value = "所属库点名称", notes ="", required = false)
	private String ssqymc;	//所属库点名称
	
	@ApiModelProperty(value = "企业分级", notes ="", required = false)
	private String qyfj;	//企业分级
	@ApiModelProperty(value = "纳税等级", notes ="", required = false)
	private String nsdj;	//纳税等级
	@ApiModelProperty(value = "横向得分下限", notes ="", required = false)
	private BigDecimal hxdfStart;	//横向得分下限
	@ApiModelProperty(value = "横向得分上限", notes ="", required = false)
	private BigDecimal hxdfEnd;	//横向得分上限
	@ApiModelProperty(value = "横向得分汇总", notes ="", required = false)
	private BigDecimal hxdfTotal;	//横向得分汇总
	
	@DateTimeFormat(pattern = "状态修改查询入参")
	private List<String> cjbmList;
	
	@DateTimeFormat(pattern = "状态修改入参、违规状态清除入参")
	private List<TurnoverDataStateVO> dataList;
	
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "成交日期开始", notes ="", required = false)
	private Date cjrqStart;
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "成交日期结束", notes ="", required = false)
	private Date cjrqEnd;	
	
	@ApiModelProperty(value = "成交单价下限", notes ="", required = false)
	private BigDecimal cjdjStart;
	@ApiModelProperty(value = "成交单价上限", notes ="", required = false)
	private BigDecimal cjdjEnd;
	
	
	private int operaterType = 0;	//操作类型 默认为0 为1时按成交单位统计 总得分
	@ApiModelProperty(value = "数据类型", notes ="0是系统生成 1是客户自己添加维护的", required = false)
	private String sjlx;	//数据类型  0是系统生成 1是客户自己添加维护的
	@ApiModelProperty(value = "所属场次", notes ="", required = false)
	private String sscc;	//所属场次
	@ApiModelProperty(value = "履约状态编码(弃用)", notes ="", required = false)
	private String lyzt;	//履约状态编码
	@ApiModelProperty(value = "履约状态名称(弃用)", notes ="", required = false)
	private String lyztmc;	//履约状态编码
	@ApiModelProperty(value = "交易性质", notes ="0采购 1销售", required = false)
	private Integer jylx;
	@ApiModelProperty(value = "交易类型", notes ="0竞购1竞销", required = false)
	private String jyxz;
	@ApiModelProperty(value = "产地", notes ="产地", required = false)
	private String cd;
	@ApiModelProperty(value = "投入数量", notes ="产地", required = false)
	private BigDecimal trsl;
	@ApiModelProperty(value = "参加企业数量", notes ="产地", required = false)
	private String qysl;
	@ApiModelProperty(value = "外部企业数量", notes ="产地", required = false)
	private String wbqy;

	@ApiModelProperty(value = "平均价", notes ="产地", required = false)
	private String pjj;
	@ApiModelProperty(value = "履约数量", notes ="产地", required = false)
	private String lysl;
	@ApiModelProperty(value = "履约率", notes ="产地", required = false)
	private String lyl;
	@ApiModelProperty(value = "横向总得分", notes ="横向总得分", required = false)
	private BigDecimal hxzf;

	private float a;

	private float b;

	private float c;

}