package com.unis.transaction.common.vo.creditevaluate;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * Author lgd
 * Description 交易结果及手续费实体
 */
@ApiModel(value = "交易结果及手续费实体")
@Data
public class TurnoverEndVO implements Serializable {
	private static final long serialVersionUID = 1L;

	private String jgbm;	//结果编码 CJ+8位顺序号

	@ApiModelProperty(value = "场次名称", notes ="", required = false)
	private String apcc;

	private String ccbm;

	@ApiModelProperty(value = "委托方", notes ="", required = false)
	private String wtfmc;


	@ApiModelProperty(value = "交易性质", notes ="", required = false)
	private Integer jyxz;


	@ApiModelProperty(value = "品种", notes ="", required = false)
	private String pzmc;

	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "交割日期", notes ="", required = false)
	private Date jgrq;

	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "交易日期", notes ="", required = false)
	private Date jyrq;


	@ApiModelProperty(value = "发布状态 0待发布 1已发布 2清单已撤回", notes ="", required = false)
	private String fbzt;


	@ApiModelProperty(value = "发布状态名称", notes ="", required = false)
	private String fbztmc;


	@ApiModelProperty(value = "公告标题", notes ="", required = false)
	private String title;

	@ApiModelProperty(value = "发布人", notes ="", required = false)
	private String fbr;


	@ApiModelProperty(value = "底价", notes ="", required = false)
	private String dj;	//仓号编码


	@ApiModelProperty(value = "交易数量", notes ="", required = false)
	private String jysl;	//仓号名称


	@ApiModelProperty(value = "成交数量", notes ="", required = false)
	private String scnf;	//生产年份


	@ApiModelProperty(value = "最低成交价", notes ="", required = false)
	private String sflt;


	@ApiModelProperty(value = "最高成交价", notes ="", required = false)
	private String sgdjbm;


	@ApiModelProperty(value = "均价", notes ="", required = false)
	private String sgdjmc;


	@ApiModelProperty(value = "成交率", notes ="", required = false)
	private String hhqydjbm;


	@ApiModelProperty(value = "发布时间", notes ="", required = false)
	private String fbsj;


	@ApiModelProperty(value = "交易类型", notes ="", required = false)
	private Integer jylx;


	@ApiModelProperty(value = "手续费类型", notes ="", required = false)
	private String sxflx;


	@ApiModelProperty(value = "手续费", notes ="", required = false)
	private String sxfl;

	@ApiModelProperty(value = "富文本", notes ="", required = false)
	private String fwb;

	@ApiModelProperty(value = "粮食性质", notes ="", required = false)
	private String lsxzbm;

	@ApiModelProperty(value = "粮食性质", notes ="", required = false)
	private String lsxzmc;

	private String jyxzmc;

	private String jylxmc;

	@ApiModelProperty(value = "品种", notes ="", required = false)
	private String pzbm;

}