package com.unis.transaction.common.vo.flowable.base;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@ApiModel(value = "分页入参")
public class BaseVO {

	@ApiModelProperty(value = "页码")
	public int pageNum;
	
	@ApiModelProperty(value = "展示记录数")
	public int pageSize;
	
	private Integer status; // 状态，1：正常，0：已作废
	
	private String creator; // 创建人
	
	private String creatorCode;// 创建人编码

	@DateTimeFormat( pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	private Date createDate; // 创建时间
	
	private String refresher; // 更新人
	
	private String refresherCode; // 更新人编码

	@DateTimeFormat( pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	private Date refreshTime;// 更新时间
	
	private String remark; // 备注
}
