/*
* GiveBackBailLetterShowVO.java
* 版权所有 © 2011-2017 北京神舟良实信息技术有限公司
* Copyright © 2011-2017 All Rights Reserved    京ICP备13013562号
* 2019-09-20 21:04:21 created by lipenghe with LAPTOP-IJQ2SDFV
*/
package com.unis.transaction.common.vo.givebackbail;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.constant.BaseStatusConstant;
import com.unis.transaction.common.groups.InsertGroup;
import com.unis.transaction.common.groups.UpdateGroup;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.util.Date;

/**
 * TY_JYTKWTH-退保证金委托函
 * @author lipenghe at 2019-09-20 21:04:21
 */
@ApiModel(value = "TY_JYTKWTH:退保证金委托函-GiveBackBailLetterShowVO")
@Data
@Table(name="TY_JYTKWTH")
public class GiveBackBailLetterShowVO implements Serializable{

    @NotBlank(message = "委托函编码不能为空",groups ={UpdateGroup.class})
    @Length(max=32,message="委托函编码最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "委托函编码#<主键><非空>", notes ="委托函编码")
    @Id
    @Column(name="WTHBM",length=32)
    private String wthbm;

    @Length(max=128,message="通知标题最大为128字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "通知标题", notes ="通知标题", hidden = true)
    @Column(name="TZBT",length=128)
    private String tzbt;

    @Length(max=32,message="委托函编号最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "委托函编号", notes ="委托函编号", hidden = true)
    @Column(name="WTHBH",length=32)
    private String wthbh;

    @ApiModelProperty(value = "0销售#<默认值:0>1采购", notes ="0销售", hidden = true)
    @Column(name="WTLX",length=10,precision=10,scale=0)
    private Integer wtlx;

    @Length(max=128,message="类型名称最大为128字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "类型名称", notes ="类型名称", hidden = true)
    @Column(name="WTLXMC",length=128)
    private String wtlxmc;

    @Length(max=128,message="接收单位最大为128字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "接收单位", notes ="接收单位", hidden = true)
    @Column(name="JSDW",length=128)
    private String jsdw;

    @Length(max=32,message="接收正文最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "接收正文", notes ="接收正文", hidden = true)
    @Column(name="JSZW",length=32)
    private String jszw;

    @NotBlank(message="场次不能为空",groups ={ InsertGroup.class})
    @Length(max=32,message="场次最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "场次", notes ="场次", hidden = true)
    @Column(name="APCC",length=32)
    private String apcc;

    @Length(max=32,message="编制人最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "编制人", notes ="编制人", hidden = true)
    @Column(name="BZR",length=32)
    private String bzr;

    @ApiModelProperty(value = "编制时间", notes ="编制时间", hidden = true)
    @Column(name="BZSJ")
    @DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    private Date bzsj;

    @Length(max=32,message="状态值最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "状态值", notes ="状态值", hidden = true)
    @Column(name="ZT",length=32)
    private String zt;

    @Length(max=32,message="状态名称最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "状态名称", notes ="状态名称", hidden = true)
    @Column(name="ZTMC",length=32)
    private String ztmc;

    @ApiModelProperty(value = "状态#<默认值:1>1：正常，0：已作废(用做是否删除)", notes ="状态", hidden = true)
    @Column(name="STATUS",length=10,precision=10,scale=0)
    private Integer status;

    @Length(max=32,message="创建人最大为32字符",groups ={UpdateGroup.class, InsertGroup.class})
    @ApiModelProperty(value = "创建人", notes ="创建人", hidden = true)
    @Column(name="CREATOR",length=32)
    private String creator;

    @ApiModelProperty(value = "创建时间#<默认值:current>", notes ="创建时间", hidden = true)
    @Column(name="CREATE_DATE")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date createDate;

    @ApiModelProperty(value = "合同编号", notes ="场次")
    @Column(name="HTBH")
    private String htbh;

    @ApiModelProperty(value = "合同编码", notes ="场次")
    @Column(name="HTBM")
    private String htbm;

    public GiveBackBailLetterShowVO(){
        this.status= BaseStatusConstant.STATUS_NORMAL;
    }
}