package com.unis.transaction.common.vo.givebackbail;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * Author lidiaoquan
 * Description 保证金退款
 * Date  2019-09-21
 */
@ApiModel(value = "保证金退款")
@Data
public class GiveBackVO extends UrlVO implements Serializable {
	private static final long serialVersionUID = 1L;


	@ApiModelProperty(value = "退款编码 TK + 8位", notes ="", required = false)
	private String tkbm;

	@ApiModelProperty(value = "交易编码 JY+8位顺序号", notes ="", required = false)
	private String jybm;

	@ApiModelProperty(value = "退保证金委托函编码", notes ="", required = false)
	private String wthbm;

	private String wtfbm;

/*	@ApiModelProperty(value = "退款金额", notes ="", required = false)
	private String tkje;

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "退款时间", notes ="", required = false)
	private Date tksj;

	@ApiModelProperty(value = "操作人", notes ="", required = false)
	private String czr;

	@ApiModelProperty(value = "退款凭证", notes ="", required = false)
	private String tkpz;*/

	@ApiModelProperty(value = "退款状态", notes ="", required = false)
	private String tkzt;

	@ApiModelProperty(value = "退款状态", notes ="", required = false)
	private String tkztmc;

/*	@ApiModelProperty(value = "x新退款状态 ", notes ="", required = false)
	private String xtkzt;

	@ApiModelProperty(value = "新退款状态 ", notes ="", required = false)
	private String xtkztmc;*/
/*
	@ApiModelProperty(value = "备注", notes ="", required = false)
	private String remark;

	@ApiModelProperty(value = "财务操作人", notes ="", required = false)
	private String cwczr;

	@ApiModelProperty(value = "财务操作人", notes ="", required = false)
	private String tksm;*/
	
	@ApiModelProperty(value = "状态 0删除 1正常", notes ="", required = false)
	private Integer status;

	@ApiModelProperty(value = "退款分类 0成交 1未成交", notes ="", required = false)
	private Integer tkfl;

	@ApiModelProperty(value = "场次", notes ="", required = false)
	private String apcc;
	private String sjlx;	//0 待处理数据
	
	@ApiModelProperty(value = "报名单位名称", notes ="", required = false)
	private String dwmc;
	private String dwbm;
	@ApiModelProperty(value = "联系电话", notes ="", required = false)
	private String lxdh;
	@ApiModelProperty(value = "粮食品种名称", notes ="", required = false)
	private String lspzmc;
	@ApiModelProperty(value = "手续费率", notes ="", required = false)
	private String sxfl;
	@ApiModelProperty(value = "数量", notes ="", required = false)
	private BigDecimal sl;
	@ApiModelProperty(value = "金额", notes ="", required = false)
	private String je;
/*	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	@ApiModelProperty(value = "汇款时间", notes ="", required = false)
	private Date hksj;
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "汇款时间查询开始", notes ="", required = false)
	private Date hksjQuerystart;
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "汇款时间查询结束", notes ="", required = false)
	private Date hksjQueryEnd;*/
	
	
	@ApiModelProperty(value = "页面模块 1交易部经办人 2交易部负责人 3财务审批 4结算部负责人 5分管副总裁", notes ="", required = false)
	private Integer pageType = 1;
	@ApiModelProperty(value = "查询退款状态集合", notes ="", required = false)
	private List<String> tkztList;

	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "交易日期", notes ="", required = false)
	private Date jyrq;
	@ApiModelProperty(value = "交易类型", notes ="", required = false)
	private Integer jylx;
	@ApiModelProperty(value = "退款类型", notes ="", required = false)
	private Integer tklx;
	@ApiModelProperty(value = "保证金", notes ="", required = false)
	private BigDecimal bzj;
	@ApiModelProperty(value = "委托编码", notes ="", required = false)
	private String wtbm;
	@ApiModelProperty(value = "场次编码", notes ="", required = false)
	private String ccbm;
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "报名时间", notes ="", required = false)
	private Date bmrq;

	@ApiModelProperty(value = "合同编号", notes ="场次")
	private String htbh;

	@ApiModelProperty(value = "合同编码", notes ="场次")
	private String htbm;

	@ApiModelProperty(value = "0销售#<默认值:0>1采购", notes ="0销售")
	private Integer wtlx;

	@ApiModelProperty(value = "退款单位", notes ="退款单位")
	private String jsdw;
	@ApiModelProperty(value = "代办用户集合", notes ="", required = false)
	private List<ReceiverCollectionVO> userList;
	//-------------------add lgd------------------------
	@ApiModelProperty(value = "手续费", notes ="", required = false)
	private String sxf;
	@ApiModelProperty(value = "交易部经办人", notes ="交易部经办人")
	private String jyjbr;
	@ApiModelProperty(value = "交易部经办时间", notes ="退款单位")
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyjbsj;
	@ApiModelProperty(value = "交易部负责人", notes ="交易部负责人")
	private String jyfzr;
	@ApiModelProperty(value = "交易部负责时间", notes ="交易部负责时间")
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyfzsj;
	@ApiModelProperty(value = "交易部负责结果", notes ="交易部负责结果")
	private Integer jyfz;
	@ApiModelProperty(value = "交易部负责意见", notes ="交易部负责意见")
	private String jyfzyj;
	@ApiModelProperty(value = "财务审批人", notes ="财务审批人")
	private String jycwr;
	@ApiModelProperty(value = "财务审批时间", notes ="财务审批时间")
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jycwsj;
	@ApiModelProperty(value = "财务审批结果", notes ="财务审批结果")
	private Integer jycw;
	@ApiModelProperty(value = "财务审批意见", notes ="财务审批意见")
	private String jycwyj;
	@ApiModelProperty(value = "结算部负责人", notes ="结算部负责人")
	private String jyjsr;
	@ApiModelProperty(value = "结算部负责时间", notes ="结算部负责时间")
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyjssj;
	@ApiModelProperty(value = "结算部负责结果", notes ="结算部负责结果")
	private Integer jyjs;
	@ApiModelProperty(value = "结算部负责意见", notes ="结算部负责意见")
	private String jyjsyj;
	@ApiModelProperty(value = "分管副总裁", notes ="分管副总裁")
	private String jyzcr;
	@ApiModelProperty(value = "分管副总裁时间", notes ="分管副总裁时间")
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyzcsj;
	@ApiModelProperty(value = "分管副总裁结果", notes ="分管副总裁结果")
	private Integer jyzc;
	@ApiModelProperty(value = "分管副总裁意见", notes ="分管副总裁意见")
	private String jyzcyj;
	//-------------------end lgd------------------------
	private String bz;
}