package com.unis.transaction.common.vo.givebackbail;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Author lgd
 * Description 交易通知
 */
@ApiModel(value = "交易通知")
@Data
public class NoticeVO extends UrlVO implements Serializable {
    private static final long serialVersionUID = 1L;
    @ApiModelProperty(value = "交易通知 Tz + 8位", notes ="", required = false)
    private String tzbm;
    @ApiModelProperty(value = "交易通知标题", notes ="", required = false)
    private String title;
    @ApiModelProperty(value = "交易通知类型，0：粮食数量，1：粮食质量，2：提货时间，3：其他", notes ="", required = false)
    private Integer tzlx;
    @ApiModelProperty(value = "交易通知类型名称", notes ="", required = false)
    private String tzlxmc;
    @ApiModelProperty(value = "场次", notes ="", required = false)
    private String apcc;
    @ApiModelProperty(value = "场次编码", notes ="", required = false)
    private String ccbm;
    @ApiModelProperty(value = "合同编码", notes ="", required = false)
    private String htbm;
    @ApiModelProperty(value = "合同号", notes ="", required = false)
    private String htbh;
    @ApiModelProperty(value = "粮食性质", notes ="", required = false)
    private String lsxz;
    @ApiModelProperty(value = "品种", notes ="", required = false)
    private String pz;
    @ApiModelProperty(value = "买方", notes ="", required = false)
    private String ccmc;
    @ApiModelProperty(value = "卖方", notes ="", required = false)
    private String sgmc;
    @ApiModelProperty(value = "买方编码", notes ="", required = false)
    private String ccdw;
    private String ccdws;
    @ApiModelProperty(value = "卖方编码", notes ="", required = false)
    private String sgdw;
    private String sgdws;
    @ApiModelProperty(value = "通知内容", notes ="", required = false)
    private String reason;
    @ApiModelProperty(value = "通知附件", notes ="", required = false)
    private String tzfj;
    @DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")    @ApiModelProperty(value = "通知日期", notes ="", required = false)
    private Date tzsj;
    @ApiModelProperty(value = "通知状态 0草稿，1已提交，2已反馈", notes ="", required = false)
    private String tzzt;
    @ApiModelProperty(value = "通知状态名称", notes ="", required = false)
    private String tzztmc;
    @ApiModelProperty(value = "通知人", notes ="", required = false)
    private String tzr;
    @ApiModelProperty(value = "通知发送类型 0仅委托方 1交易双方 2客户", notes ="", required = false)
    private Integer fslx;
    @ApiModelProperty(value = "委托方答复", notes ="", required = false)
    private String wtdf;
    @ApiModelProperty(value = "委托方附件", notes ="", required = false)
    private String wtfj;
    @ApiModelProperty(value = "委托方人", notes ="", required = false)
    private String wtr;
    @ApiModelProperty(value = "委托方状态", notes ="", required = false)
    private String wtzt;
    @DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    @ApiModelProperty(value = "委托回复日期", notes ="", required = false)
    private Date wtsj;
    @ApiModelProperty(value = "客户答复", notes ="", required = false)
    private String khdf;
    @ApiModelProperty(value = "客户附件", notes ="", required = false)
    private String khfj;
    @ApiModelProperty(value = "客户方人", notes ="", required = false)
    private String khr;
    @ApiModelProperty(value = "客户方状态", notes ="", required = false)
    private String khzt;
    @DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    @ApiModelProperty(value = "客户回复日期", notes ="", required = false)
    private Date khsj;
    @ApiModelProperty(value = "列表类型 0 通知提起和处理 1 申述通知", notes ="", required = false)
    private String pageType;
    private List<String> ztList;
    @ApiModelProperty(value = "代办用户集合", notes ="", required = false)
    private Map<String,List<ReceiverCollectionVO>> userMap;

    @ApiModelProperty(value = "查看状态 0待提交1已提交2双方已查看4委托方查看5 客户已查看", notes ="", required = false)
    private String ckzt;
    @ApiModelProperty(value = "查看状态名称", notes ="", required = false)
    private String ckztmc;
}
