package com.unis.transaction.common.vo.givebackbail;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * Author lidiaoquan
 * Description 保证金退款
 * Date  2019-09-21
 */
@ApiModel(value = "未成交退款")
@Data
public class PassBackVO extends UrlVO implements Serializable {
	private static final long serialVersionUID = 1L;
	private String tkbm;	//退款编码 TK + 8位>>>前端注意：这是修改唯一标识主键

	private String wtfbm;

	private String wtbm;	//退保证金委托函编码

	private String apcc;	//场次
	private Integer bdsl;
	private Integer jylx;
	private String jybzj;
	private String lybzj;
	private String jsdw;
	@ApiModelProperty(value = "通知日期", notes ="", required = false)
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date tksj;	//退款时间

	private String tkzt;	//财务退款状态 0 待确认 1已确认

	private String tkztmc;	//财务退款状态 0 待确认 1已确认

	private BigDecimal sl;
	private String je;
	private String dwbm;
	private String ccbm;
	private String pzmc;
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	private Date jyrq;
	@ApiModelProperty(value = "页面模块 1交易部经办人 2交易部负责人 3财务审批 4结算部负责人 5分管副总裁", notes ="", required = false)
	private Integer pageType = 1;
	@ApiModelProperty(value = "查询退款状态集合", notes ="", required = false)
	private List<String> tkztList;
	private String jyjbr;
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyjbsj;
	private String jyfzr;
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyfzsj;
	private Integer jyfz;
	private String jyfzyj;
	private String jycwr;
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jycwsj;
	private Integer jycw;
	private String jycwyj;
	private String jyjsr;
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyjssj;
	private Integer jyjs;
	private String jyjsyj;
	private String jyzcr;
	@DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
	private Date jyzcsj;
	private Integer jyzc;
	private String jyzcyj;
	private String childs;
	List<GiveBackChildVO> childVOS;
	@ApiModelProperty(value = "代办用户集合", notes ="", required = false)
	private List<ReceiverCollectionVO> userList;
}