package com.unis.transaction.common.vo.signuppay;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * Author lidiaoquan
 * Description 交易报名
 * Date  2019-09-20
 */
@ApiModel(value = "交易报名")
@Data
@EqualsAndHashCode(callSuper = true)
public class TransactionSignUpVO extends UrlVO implements Serializable {
	private static final long serialVersionUID = 1L;


	@ApiModelProperty(value = "交易报名", notes ="")
	private String jybm;

	private String ccbm;

	private String wtbm;
	private String wtfbm;
	private String wtfmc;

	@ApiModelProperty(value = "标的编码  BD +8位顺序号", notes ="")
	private String bdbm;

	@ApiModelProperty(value = "标的号", notes ="")
	private String bdh;

	@ApiModelProperty(value = "场次", notes ="")
	private String apcc;

	@ApiModelProperty(value = "数量", notes ="")
	private BigDecimal sl;

	@ApiModelProperty(value = "金额", notes ="")
	private String je;

	@ApiModelProperty(value = "粮食品种编码", notes ="")
	private String lspzbm;

	@ApiModelProperty(value = "粮食品种名称", notes ="")
	private String lspzmc;

	@ApiModelProperty(value = "粮食性质", notes ="")
	private String lsxz;

	@ApiModelProperty(value = "粮食性质名称", notes ="")
	private String lsxzmc;

	@ApiModelProperty(value = "粮食类别", notes ="")
	private String lslb;

	@ApiModelProperty(value = "粮食类别名称", notes ="")
	private String lslbmc;

	@ApiModelProperty(value = "报名单位编码", notes ="")
	private String dwbm;

	@ApiModelProperty(value = "报名单位名称", notes ="")
	private String dwmc;

	@ApiModelProperty(value = "联系电话", notes ="")
	private String lxdh;

	@ApiModelProperty(value = "交易保证金", notes ="")
	private String jybzj;

	@ApiModelProperty(value = "履约保证金", notes ="")
	private String lybzj;

	@ApiModelProperty(value = "手续费率 根据粮食性质编码带出", notes ="")
	private String sxfl;

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "报名日期", notes ="")
	private Date bmrq;

	@ApiModelProperty(value = "附件id", notes ="")
	private String fjid;

	@ApiModelProperty(value = "审核人", notes ="")
	private String spr;

    /**
     * @Description  审核状态
     * 91000001-待提交
     * 91000002-待审核
     * 91000008-审核不通过
     * 91000013-审核通过
     * 91000003付款通过
     * 91000007付款未通过
     */
	@ApiModelProperty(value = "审核状态91000001-待提交、91000002-待审核、91000008-审核不通过、91000013-审核通过 91000003付款通过 91000007付款未通过", notes ="")
	private String shzt;

	@ApiModelProperty(value = "审核状态名称91000001-待提交、91000002-待审核、91000008-已驳回、91000013-已通过", notes ="")
	private String shztmc;

	@ApiModelProperty(value = "审核意见", notes ="")
	private String shyj;

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "审核时间", notes ="")
	private Date shsj;

	@ApiModelProperty(value = "汇款金额", notes ="")
	private BigDecimal hkje;

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "汇款时间", notes ="")
	private Date hksj;

	@ApiModelProperty(value = "汇款单位编码", notes ="")
	private String hkdwbm;

	@ApiModelProperty(value = "汇款单位名称", notes ="")
	private String hkdwmc;

	@ApiModelProperty(value = "汇款凭证", notes ="")
	private String hkpz;

	@ApiModelProperty(value = "收款状态 0否 1是", notes ="")
	private Integer skzt;

	private Integer zt;

	@ApiModelProperty(value = "收款状态名称0否 1是", notes ="")
	private String skztmc;

	@ApiModelProperty(value = "退款状态", notes ="")
	private String tkzt;

	@ApiModelProperty(value = "汇款意见", notes ="")
	private String hkyj;	//收款状态 0否 1是

	@ApiModelProperty(value = "退款状态名称", notes ="")
	private String tkztmc;

	@ApiModelProperty(value = "备注", notes ="")
	private String remark;

	@ApiModelProperty(value = "0作废 1正常", notes ="")
	private Integer status;

	private Integer skyj;	//收款状态 0否 1是
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date sksj;	//收款状态 0否 1是


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "报名日期查询开始", notes ="")
	private Date bmrqStart;

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "报名日期查询结束", notes ="")
	private Date bmrqEnd;

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "审核时间查询开始", notes ="")
	private Date shsjStart;

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "审核时间查询结束", notes ="")
	private Date shsjEnd;

	@ApiModelProperty(value = "1客户 2交易部 3财务处 4保证金退款函新增", notes ="")
	private Integer pageType = 1;

	@ApiModelProperty(value = "审核状态集合", notes ="")
	private List<String> shztList;

	@ApiModelProperty(value = "合同集合", notes ="")
	private List<String> htList;

	@ApiModelProperty(value = "交易编码集合>>批量提交", notes ="")
	private List<String> jybmList;

	@ApiModelProperty(value = "代办用户集合", notes ="")
	private List<ReceiverCollectionVO> userList;
	@ApiModelProperty(value = "缴款金额", notes ="")
	private String jkje;

	@ApiModelProperty(value = "意向标的", notes ="")
	private String yxbd;

    @Column(name = "lxr")
    @ApiModelProperty("联系人")
    private String lxr;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "交易日期", notes ="")
    private Date jyrq;

    @ApiModelProperty(value = "交易时间", notes ="")
    @Column(name = "jysj")
    private String jysj;

    @ApiModelProperty(value = "交易方向<br/> 0采购 1销售 0,1购销双向", example = "0,1")
    private String jyfx;

    @ApiModelProperty(value = "交易方向名称", notes = "")
    private String jyfxmc;

    @ApiModelProperty(value = "交易方式<br/> 0竞价  1挂牌 2购销双向", notes = "")
    private String jyfs;

    @ApiModelProperty(value = "交易方式<br/> 名称", notes = "")
    private String jyfsmc;

    @ApiModelProperty(value = "意向数量（吨）")
    @Column(name = "yxsl")
    private BigDecimal yxsl;

    @ApiModelProperty(value = "汇款审核结果")
    private Integer hkshjg;
    @ApiModelProperty(value = "汇款审核时间")
    private Date hkshsj;
    @ApiModelProperty(value = "汇款审核意见")
    private String hkshyj;
    @ApiModelProperty(value = "汇款审核人")
    private String hkshr;

    @ApiModelProperty(value = "交易审核结果")
    private Integer jyshjg;
    @ApiModelProperty(value = "交易审核时间")
    private Date jyshsj;
    @ApiModelProperty(value = "交易审核意见")
    private String jyshyj;
    @ApiModelProperty(value = "交易审核人")
    private String jyshr;

    @ApiModelProperty(value = "委托编号")
    private String wtbh;

}
