package com.unis.transaction.common.vo.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * Description 合同
 * Date  2019-09-21
 */
@ApiModel(value = "合同")
@Data
@EqualsAndHashCode(callSuper = true)
public class ContractVO extends UrlVO implements Serializable {
    @ApiModelProperty(value = "合同编码  HT +8位顺序号", required = true)
    private String htbm;

    @ApiModelProperty(value = "合同编号", required = true)
    private String htbh;

    @ApiModelProperty(value = "商户编号")
    private String shbh;

    @ApiModelProperty(value = "卖方", required = true)
    private String cmmc;

    @ApiModelProperty(value = "卖方单位编码", required = true)
    private String cmdw;

    @ApiModelProperty(value = "买方", required = true)
    private String sgmc;

    @ApiModelProperty(value = "买方单位编码", required = true)
    private String sgdw;

    @ApiModelProperty(value = "委托单位       ",notes = "储备粮---发送单位", required = true)
    private String fsdw;

//    @ApiModelProperty(value = "签订地点")
//    private String qddd;

    @ApiModelProperty(value = "地址")
    private String adress;

    @ApiModelProperty(value = "粮食等级")
    private String lsdj;

    @ApiModelProperty(value = "标的号", required = true)
    private String bdh;

    @ApiModelProperty(value = "标的编码", required = true)
    private String bdbm;

    @ApiModelProperty(value = "品种名称", required = true)
    private String pzmc;

    @ApiModelProperty(value = "粮食性质")
    private String lsxz;

    @ApiModelProperty(value = "粮食数量", required = true)
    private BigDecimal lssl;

    /**
     * 1, '销售', 0, '采购'
     */
    @ApiModelProperty(value = "交易类型", required = true)
    private Integer jylx;

    @ApiModelProperty(value = "单价")
    private BigDecimal dj;

    @ApiModelProperty(value = "成交额(元)", required = true)
    private String je;

    @ApiModelProperty(value = "实际交款额(元)")
    private String sjjke;

    @ApiModelProperty(value = "承贷库名称")
    private String cdkmc;

    @ApiModelProperty(value = "承储单位， 标的中的单位", notes = "实际存储库名称", required = true)
    private String cckmc;
    private String cckdm;

//    @ApiModelProperty(value = "法定代表人")
//    private String fddbr;

//    @ApiModelProperty(value = "卖方电话")
//    private String mtel;

//    @ApiModelProperty(value = "买方电话")
//    private String sgtel;

//    @ApiModelProperty(value = "委托代理人")
//    private String wtdlr;

//    @ApiModelProperty(value = "开户银行")
//    private String khyh;

//    @ApiModelProperty(value = "银行开户帐号")
//    private String khzh;

//    @ApiModelProperty(value = "帐号")
//    private String zh;

//    @ApiModelProperty(value = "卖方邮政编码")
//    private String yzbm;

    @ApiModelProperty(value = "买方邮政编码")
    private String sgbm;

    @ApiModelProperty(value = "合同状态")
    private String status;

    //@JsonFormat(pattern ="yyyy-MM-dd")
    @ApiModelProperty(value = "成交日期")
    private String cjrq;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "开始日期")
    private Date startDate;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "结束日期")
    private Date endDate;

    @ApiModelProperty(value = "品种集合")
    private List<String> pzList;
    @ApiModelProperty(value = "合同pdf文件")
    private String pdfs;

    private float a;

    private Integer b;

    private Integer c;

    @ApiModelProperty(value = "交货仓库")
    private String njhck;
    @ApiModelProperty(value = "卖方承储库")
    private String nmfcck;
    @ApiModelProperty(value = "仓号", required = true)
    private String nch;
    @ApiModelProperty(value = "生产年份", required = true)
    private String nnf;
    @ApiModelProperty(value = "是否露天")
    private String nsflt;
    @ApiModelProperty(value = "扦样等级")
    private String nqydj;
    @ApiModelProperty(value = "总成交数量")
    private String nzcjl;
    @ApiModelProperty(value = "出库截止日期")
    private String nckjzrq;
    @ApiModelProperty(value = "仓房编码", required = true)
    private String ncfbm;
    @ApiModelProperty(value = "卖方编码")
    private String nmfbm;
    @ApiModelProperty(value = "备注")
    private String nbz;
    @ApiModelProperty(value = "起拍价")
    private String nqpj;


//    @ApiModelProperty(value = "产地")
//    private String cd;

    @ApiModelProperty(value = "生产年份")
    private String shcnf;

    @ApiModelProperty(value = "完成时间 交割日期", required = true)
    private String promptDate;

    @ApiModelProperty(value = "联系人", required = true)
    private String lxr;
    @ApiModelProperty(value = "联系方式", required = true)
    private String lxfs;

    @ApiModelProperty(value = "交易类型<br/> 0采购 1销售 0,1购销双向", required = true)
    private String jyfx;

    @ApiModelProperty(value = "交易方式<br/>  0竞价 1挂牌 2购销双向", required = true)
    private String jyfs;

    @ApiModelProperty(value = "品种编码", required = true)
    private String pzbm;

    @ApiModelProperty(value = "起拍单价", required = true)
    private BigDecimal qpdj;
    @ApiModelProperty(value = "成交单价", required = true)
    private BigDecimal cjdj;

    @ApiModelProperty(value = "场次编码", required = true)
    private String ccbm;
    @ApiModelProperty(value = "场次", required = true)
    private String apcc;

    @ApiModelProperty(value = "交易方向名称")
    private String jyfxmc;
    @ApiModelProperty(value = "交易方式<br/> 名称")
    private String jyfsmc;

    @ApiModelProperty(value = "数据版本 0 老数据 1 新数据", example = "1")
    private Integer dataVer;

    @ApiModelProperty(value = "退款状态 0 未退款 1 已退款", example = "0")
    private String refund_status;

    @ApiModelProperty(value = "交易保证金")
    private String jybzj;

    @ApiModelProperty(value = "履约保证金")
    private String lybzj;

    @ApiModelProperty(value = "手续费")
    private String sxf;

    @ApiModelProperty(value = "合同下发结果")
    private String sendresult;

    // 是否可更改
    @ApiModelProperty(value = "是否可更改,0否，1是")
    private String isChange;

}
