package com.unis.transaction.common.vo.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname Dcjybzxx
 * @Description 地储交易统计备注信息
 * @Date 2023/9/4 15:45
 * @Created by rising123sun
 */
@Data
@ApiModel(value = "Dcjybzxx", description = "地储交易统计备注信息")
@Table(name = "ty_dcjybzxx")
public class Dcjybzxx {

    // 主键
    @ApiModelProperty(value = "主键")
    @Id
    private String id;

    // 标的号
    @ApiModelProperty(value = "标的号")
    @Column(name = "bdh")
    private String bdh;

    // 合同编号
    @ApiModelProperty(value = "合同编号")
    @Column(name = "htbh")
    private String htbh;

    @ApiModelProperty(value = "特殊备注")
    @Column(name = "tsbz")
    private String tsbz;

    @ApiModelProperty(value = "原因")
    @Column(name = "yy")
    private String yy;

    // 编辑人
    @ApiModelProperty(value = "编辑人")
    @Column(name = "bjr")
    private String bjr;

    // 编辑日期
    @ApiModelProperty(value = "编辑日期")
    @Column(name = "bjrq")
    @DateTimeFormat(pattern = "yyyy年MM月dd日")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date bjrq;

}
