package com.unis.transaction.common.vo.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.BaseVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "保证金退款说明函")
public class RefundLetterVO extends BaseVO {

    @ApiModelProperty(value = "ID", notes = "")
    private String id;

    @ApiModelProperty(value = "合同编码", notes = "")
    private String htbm;

    //状态
    @ApiModelProperty(value = "状态")
    private String zt;

    @ApiModelProperty(value = "状态name")
    private String ztName;

    //盖章
    @ApiModelProperty(value = "盖章")
    private String gz;

    //签章日期
    @ApiModelProperty(value = "盖章日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date gzrq;

    //盖章人
    @ApiModelProperty(value = "盖章人")
    private String gzr;

    //盖章人编码
    @ApiModelProperty(value = "盖章人编码")
    private String gzrbh;

    //是否接收
    @ApiModelProperty(value = "是否接收 0:否 1:是")
    private Integer sfjs;

    //接收意见
    @ApiModelProperty(value = "接收意见")
    private String jsyj;

    //接收人
    @ApiModelProperty(value = "接收人")
    private String jsr;

    //接收人编号
    @ApiModelProperty(value = "接收人编号")
    private String jsrbh;

    //接收日期
    @ApiModelProperty(value = "接收日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jsrq;

    @ApiModelProperty(value = "正文")
    private String tzzw;
}
