package com.unis.transaction.common.vo.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Description 合同
 * Date  2019-09-21
 */
@ApiModel(value = "保证金退款-合同VO")
@Data
public class RefundNoticeContractVO implements Serializable {

    @ApiModelProperty(value = "合同编码  HT +8位顺序号", required = true)
    private String htbm;

    @ApiModelProperty(value = "合同编号", required = true)
    private String htbh;

    @ApiModelProperty(value = "合同类型", required = true)
    private String htlx;

    @ApiModelProperty(value = "买方", required = true)
    private String sgmc;

    @ApiModelProperty(value = "买方单位编码", required = true)
    private String sgdw;

    @ApiModelProperty(value = "品种名称", required = true)
    private String pzmc;

    @ApiModelProperty(value = "品种编码")
    private String pzbm;

    @ApiModelProperty(value = "粮食数量", required = true)
    private BigDecimal cjsl;

    @ApiModelProperty(value = "承储单位， 标的中的单位", notes = "实际存储库名称", required = true)
    private String cckmc;
    private String cckdm;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "成交日期")
    private String cjrq;

    @ApiModelProperty(value = "场次编码")
    private String ccbm;

    @ApiModelProperty(value = "场次")
    private String apcc;

    @ApiModelProperty(value = "交易保证金")
    private BigDecimal jybzj;

    @ApiModelProperty(value = "履约保证金")
    private BigDecimal lybzj;

    //签章日期
    @ApiModelProperty(value = "履约截止日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date lyjzrq;

    @ApiModelProperty(value = "交易单价")
    private BigDecimal jydj;

    @ApiModelProperty(value = "交易金额")
    private BigDecimal jyje;
}
