package com.unis.transaction.common.vo.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.BaseVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "保证金退款通知查询VO")
public class RefundNoticeQueryVO {

    @ApiModelProperty(value = "查询端 1:企业端 2:管理端", required = true)
    private Integer type;

    @ApiModelProperty(value = "合同编号", notes = "")
    private String htbm;

    @ApiModelProperty(value = "合同类型")
    private Integer htlx;

    @ApiModelProperty(value = "成交单位")
    private String sgmc;

    @ApiModelProperty(value = "承储库名称")
    private String cckmc;

    private String orgCode;

    @ApiModelProperty(value = "开始日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date kssj;

    @ApiModelProperty(value = "结束日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jssj;

    @ApiModelProperty(value = "品种")
    private String pzmc;

    @ApiModelProperty(value = "品种编码")
    private String pzbm;

    //状态
    @ApiModelProperty(value = "状态")
    private String zt;

    @ApiModelProperty(value = "履约类型 0:全部 1:部分",required = true)
    private Integer lylx;

    @ApiModelProperty(value = "开始日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date cjkssj;

    @ApiModelProperty(value = "结束日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date cjjssj;

    @ApiModelProperty(value = "场次")
    private String apcc;

}
