package com.unis.transaction.common.vo.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.BaseVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "保证金退款通知单表")
public class RefundNoticeVO extends BaseVO {

    @ApiModelProperty(value = "ID", notes = "")
    private String id;

    @ApiModelProperty(value = "合同编号", notes = "")
    private String htbm;

    @ApiModelProperty(value = "合同编号", notes = "")
    private String htbh;

    @ApiModelProperty(value = "合同类型", notes = "")
    private String htlx;

    @ApiModelProperty(value = "场次")
    private String apcc;

    @ApiModelProperty(value = "场次编码")
    private String ccbm;

    @ApiModelProperty(value = "成交单位")
    private String sgmc;

    @ApiModelProperty(value = "买方单位编码")
    private String sgdw;

    @ApiModelProperty(value = "承储库名称")
    private String cckmc;

    @ApiModelProperty(value = "承储库代码")
    private String cckdm;

    @ApiModelProperty(value = "签订日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date cjrq;

    @ApiModelProperty(value = "品种")
    private String pzmc;

    @ApiModelProperty(value = "品种编码")
    private String pzbm;

    @ApiModelProperty(value = "成交数量")
    private BigDecimal cjsl;

    @ApiModelProperty(value = "履约数量")
    private BigDecimal lysl;

    @ApiModelProperty(value = "违约数量")
    @Column(name = "wysl")
    private BigDecimal wysl;

    @ApiModelProperty(value = "交易保证金")
    private BigDecimal jybzj;

    @ApiModelProperty(value = "履约保证金")
    private BigDecimal lybzj;

    //签章日期
    @ApiModelProperty(value = "履约截止日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date lyjzrq;

    @ApiModelProperty(value = "交易单价")
    private BigDecimal jydj;

    @ApiModelProperty(value = "交易金额")
    private BigDecimal jyje;

    //状态
    @ApiModelProperty(value = "状态")
    private String zt;

    @ApiModelProperty(value = "状态name")
    private String ztName;

    //盖章
    @ApiModelProperty(value = "盖章")
    private String gz;

    //签章日期
    @ApiModelProperty(value = "盖章日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date gzrq;

    //盖章人
    @ApiModelProperty(value = "盖章人")
    private String gzr;

    //盖章人编码
    @ApiModelProperty(value = "盖章人编码")
    private String gzrbh;

    //是否接收
    @ApiModelProperty(value = "是否接收 0:否 1:是")
    private Integer sfjs;

    //接收意见
    @ApiModelProperty(value = "接收意见")
    private String jsyj;

    //接收人
    @ApiModelProperty(value = "接收人")
    private String jsr;

    //接收人编号
    @ApiModelProperty(value = "接收人编号")
    private String jsrbh;

    //接收日期
    @ApiModelProperty(value = "接收日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jsrq;

    @ApiModelProperty(value = "履约类型 0:全部 1:部分")
    private Integer lylx;

    @ApiModelProperty(value = "正文")
    private String tzzw;

    private RefundLetterVO refundLetterVO;
}
