package com.unis.transaction.common.vo.tradeplan;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * Author LGD
 * Description 场次信息
 * Date  2019-09-21
 */
//ty_jycc表
@ApiModel(value = "场次信息")
@Data
@EqualsAndHashCode(callSuper = true)
public class SiteVO extends UrlVO implements Serializable{
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "CC+8位顺序号  编码", notes ="")
    private String ccbm;
    @ApiModelProperty(value = "wt+8位顺序号  编码", notes ="")
    private String wtbm;
    @ApiModelProperty(value = "场次code", notes ="")
    private String cccode;
    @ApiModelProperty(value = "场次", notes ="")
    private String apcc;
    @ApiModelProperty(value = "场次状态", notes ="")
    private String cczt;	// 场次状态 0 未发布 1 已发布

    @ApiModelProperty(value = "手续费", notes ="")
    private String sxf;

    @ApiModelProperty(value = "场次编号", notes ="")
    private String ccbh;

    @ApiModelProperty(value = "手续费率", notes ="")
    private String sxfl;

    @ApiModelProperty(value = "交易保证金", notes ="")
    private String jybzj;

    @ApiModelProperty(value = "履约保证金", notes ="")
    private String lybzj;

    @ApiModelProperty(value = "手续费类型", notes ="")
    private String sxfType;

    private Integer zt;

    @ApiModelProperty(value = "保证金", notes ="")
    private String bzj;

    @ApiModelProperty(value = "委托编号", notes ="")
    private String wtbh;

    @ApiModelProperty(value = "交易类型", notes ="")
    private String jylx;

    @ApiModelProperty(value = "交易性质")
    private String jyxz;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "交割日期", notes ="")
    private Date jgrq;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "交易日期", notes ="")
    private Date jyrq;

    @ApiModelProperty(value = "品种", notes ="")
    private String pz;

    @ApiModelProperty(value = "完成状态", notes ="")
    private String wczt;
    @ApiModelProperty(value = "过期时间", notes ="")
    private String gqsj;

    @ApiModelProperty(value = "数量", notes ="")
    private String sl;
    private String dwbm;
    private List<String> htList;
    private List<String> dwList;
    private String marks;
    private EntryAndExitOrderVO orderVO;

    private List<WarehousingArrangementVO> warehousingArrangementList;

    @ApiModelProperty(value = "交易类型<br/> 0采购 1销售 0,1购销双向")
    private String jyfx;

    @ApiModelProperty("交易方式<br/>  0竞价 1挂牌 2购销双向")
    private String jyfs;

    @ApiModelProperty(value = "交易时间", notes ="")
    private String jysj;

    @ApiModelProperty("委托方编码")
    private String wtfbm;

    @ApiModelProperty("委托方名称")
    private String wtfmc;

    @ApiModelProperty("发布状态 0 未发布 1已发布 发布后撤回")
    private Integer fbzt;

    @ApiModelProperty("发布状态名称 0未发布 1已发布 发布后撤回")
    private String fbztmc;

    @ApiModelProperty(value = "交易方向名称<br/> 0采购<br/> 1销售<br/> 0,1采购,销售")
    @Column(name = "jyfxmc")
    private String jyfxmc;

    @ApiModelProperty("交易方式名称")
    private String jyfsmc;

    @ApiModelProperty(value = "安排状态 <br/> 待提交 91000001  签章驳回 91000103 <br/> 待盖章 91000300<br/> 已确认        91000600")
    private String apzt;

    @ApiModelProperty("安排状态名称")
    private String apztmc;

    @ApiModelProperty("请求页面 1-场次安排 2-底价 3-公告")
    private Integer pageType;

    @ApiModelProperty(value = "委托书粮食性质")
    private String lsxz;
}
