package com.unis.transaction.common.vo.tradeplan;

import com.unis.transaction.common.vo.UrlVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * Author huyong
 * Description 交易标的
 * Date  2019-09-21
 */
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "交易标的")
@Data
public class TradeMarkVO extends UrlVO implements Serializable {
	private static final long serialVersionUID = 1L;


	@ApiModelProperty(value = "标的编码  BD +8位顺序号", notes ="")
	private String bdbm;

	@ApiModelProperty(value = "AP+8位顺序号  编码", notes ="")
	private String apbm;

	@ApiModelProperty(value = "wt+8位顺序号  编码", notes ="")
	private String wtbm;

	@ApiModelProperty(value = "标的号", notes ="")
	private String bdh;

	@ApiModelProperty(value = "场次编码", notes ="")
	private String ccbm;

	@ApiModelProperty(value = "起报价", notes ="")
	private BigDecimal qbj;

	@ApiModelProperty(value = "备注", notes ="")
	private String bz;

	@ApiModelProperty(value = "备注", notes ="")
	private String remark;

	@ApiModelProperty(value = "数量", notes ="")
	private BigDecimal sl;	//数量

	//lgd新增start
	@ApiModelProperty(value = "委托收购库点编码", notes ="")
	private String sgkdbm;	//委托收购库点编码
	@ApiModelProperty(value = "委托收购库点", notes ="")
	private String sgkdmc;	//委托收购库点
	@ApiModelProperty(value = "实际存储库点编码", notes ="")
	private String cckdbm;	//实际存储库点编码
	@ApiModelProperty(value = "实际存储库点", notes ="")
	private String cckdmc;	//实际存储库点
	@ApiModelProperty(value = "所在货位混合扦样等级", notes ="")
	private String qydj;	//所在货位混合扦样等级


	private String ccdw;
	private String cfbm;
	private String pz;
	private String cd;
	private String scnd;
	//lgd新增end

}
