package com.unis.transaction.common.vo.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.UrlVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * Author lidiaoquan
 * Description 交易细则
 * Date  2019-09-19
 */
@ApiModel(value = "交易细则")
@Data
public class TradeRuleVO extends UrlVO implements Serializable {
	private static final long serialVersionUID = 1L;


	@ApiModelProperty(value = "XZ+8位顺序号  编码", notes ="", required = false)
	private String xzbm;

	@ApiModelProperty(value = "细则标题", notes ="", required = false)
	private String xzbt;

	@ApiModelProperty(value = "细则正文", notes ="", required = false)
	private String xzzw;

	@DateTimeFormat( pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "编制时间", notes ="", required = false)
	private Date bzsj;

	@ApiModelProperty(value = "附件", notes ="", required = false)
	private String fjid;

	@ApiModelProperty(value = "编制人员", notes ="", required = false)
	private String bzr;

	@ApiModelProperty(value = "发布状态 0 暂存 1已发布", notes ="", required = false)
	private Integer fbzt;
	
	@ApiModelProperty(value = " 0 作废 1正常", notes ="", required = false)
	private Integer status;

	@ApiModelProperty(value = "发布状态名称 0 暂存 1已发布", notes ="", required = false)
	private String fbztmc;

	@ApiModelProperty(value = "备注", notes ="", required = false)
	private String remark;

	@ApiModelProperty(value = "粮食性质编码", notes ="", required = false)
	private String lsxzbm;

	@ApiModelProperty(value = "粮食性质名称", notes ="", required = false)
	private String lsxzmc;
	
	
	
	
	@DateTimeFormat( pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "编制时间开始", notes ="", required = false)
	private Date startDate;
	
	@DateTimeFormat( pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "编制时间结束", notes ="", required = false)
	private Date endDate;
	
	
	
}