package com.unis.transaction.common.vo.tradeplan;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname TyJyccKhxx
 * @Description 交易场次_报名客户
 * @Date 2023/7/27 15:08
 * @Created by rising123sun
 */
@Table(name = "ty_jycc_khxx")
@Data
@ApiModel(description = "交易场次_报名客户")
public class TyJyccKhxx {

    @Id
    @Column(name = "id", nullable = false)
    @ExcelProperty(value = "主键ID")
    @ApiModelProperty(value = "主键ID")
    private String id;

    @Column(name = "wtbh")
    @ExcelProperty(value = "委托编号")
    @ApiModelProperty(value = "委托编号")
    private String wtbh;

    // 专场名称
    @Column(name = "zcmc")
    @ExcelProperty(value = "专场名称")
    @ApiModelProperty(value = "专场名称")
    private String zcmc;

    // 会员代码
    @Column(name = "hydm")
    @ExcelProperty(value = "会员代码")
    @ApiModelProperty(value = "会员代码")
    private String hydm;

    @Column(name = "khmc")
    @ExcelProperty(value = "会员名称")
    @ApiModelProperty(value = "会员名称")
    private String khmc;

    // 营业执照编号
    @Column(name = "yyzzbh")
    @ExcelProperty(value = "营业执照编号")
    @ApiModelProperty(value = "营业执照编号")
    private String yyzzbh;

    // 交易前保证金
    @Column(name = "jyqbzj")
    @ExcelProperty(value = "交易前保证金")
    @ApiModelProperty(value = "交易前保证金")
    private String jyqbzj;

    // 报名时间
    @Column(name = "bmsj")
    @ExcelProperty(value = "报名时间")
    @ApiModelProperty(value = "报名时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    private Date bmsj;


}
