package com.unis.transaction.common.vo.tradeplan;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ContentStyle;
import com.alibaba.excel.enums.poi.HorizontalAlignmentEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @Classname TyJytjbbScbcj
 * @Description 交易统计报表_市级储备成交统计表
 * @Date 2023/7/27 18:28
 * @Created by rising123sun
 */
@Data
@ContentStyle(horizontalAlignment = HorizontalAlignmentEnum.CENTER)
public class TyJytjbbScbcj {

    @ApiModelProperty(value = "合同编号")
    @ExcelProperty("合同编号")
    private String htbh;

    @ApiModelProperty(value = "承储单位， 标的中的单位", notes = "实际存储库名称")
    @ExcelProperty("承储单位")
    private String cckmc;

    @ApiModelProperty(value = "仓号")
    @ExcelProperty("仓号")
    private String nch;

    @ApiModelProperty(value = "品种")
    @ExcelProperty("品种")
    private String pzmc;

    @ApiModelProperty(value = "品种编码")
    @ExcelIgnore
    private String pzbm;

    @ApiModelProperty(value = "生产年份")
    @ExcelProperty("生产年份")
    private String nnf;

    @ApiModelProperty(value = "成交数量（吨）")
    @ExcelProperty("成交数量（吨）")
    private String cjsl;

    @ApiModelProperty(value = "起拍单价（元/吨）")
    @ExcelProperty("起拍单价（元/吨）")
    private String qpdj;

    @ApiModelProperty(value = "成交单价（元/吨）")
    @ExcelProperty("成交单价（元/吨）")
    private BigDecimal cjdj;

//    @ApiModelProperty(value = "卖方")
//    private String cmmc;
//
//    @ApiModelProperty(value = "卖方单位编码")
//    private String cmdw;
//
//    @ApiModelProperty(value = "买方")
//    private String sgmc;
//
//    @ApiModelProperty(value = "买方单位编码")
//    private String sgdw;

    @ApiModelProperty(value = "成交单位")
    @ExcelProperty("成交单位")
    private String cjdw;

    @ApiModelProperty(value = "成交额(元)", required = true)
    @ExcelProperty("成交额(元)")
    private String je;

    @ApiModelProperty(value = "交易日期")
    @ExcelProperty("完成时间")
    private String cjrq;

}
