package com.unis.transaction.common.vo.tradeplan;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ContentStyle;
import com.alibaba.excel.enums.poi.HorizontalAlignmentEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @Classname TyJytjbbSxftj
 * @Description 交易统计报表_手续费统计表
 * @Date 2023/7/27 18:28
 * @Created by rising123sun
 */
@Data
@ContentStyle(horizontalAlignment = HorizontalAlignmentEnum.CENTER)
public class TyJytjbbSxftj {

    @ApiModelProperty(value = "合同编号")
    @ExcelProperty("合同编号")
    private String htbh;

    @ApiModelProperty(value = "成交单位")
    @ExcelProperty("成交单位")
    private String cjdw;

    @ApiModelProperty(value = "成交单价（元/吨）")
    @ExcelProperty("成交单价")
    private BigDecimal cjdj;

    @ApiModelProperty(value = "成交数量（吨）")
    @ExcelProperty("成交数量")
    private String cjsl;

    @ApiModelProperty(value = "手续费率")
    @ExcelIgnore
    private String sxfl;

    @ApiModelProperty(value = "交易保证金")
    @ExcelIgnore
    private String jybzj;

    @ApiModelProperty(value = "履约保证金")
    @ExcelIgnore
    private String lybzj;

    @ApiModelProperty(value = "交易方向<br/> 0采购 1销售 0,1购销双向")
    @ExcelIgnore
    private String jyfx;

    @ApiModelProperty(value = "交易方式<br/>  0竞价  1挂牌 2购销双向")
    @ExcelIgnore
    private String jyfs;

    @ApiModelProperty(value = "手续费类型")
    @ExcelIgnore
    private String sxfType;

    @ApiModelProperty(value = "成交额(元)")
    @ExcelProperty("成交额(元)")
    private String je;

    @ApiModelProperty(value = "手续费（元）")
    @ExcelProperty("手续费（元）")
    private String sxf;

    @ApiModelProperty(value = "冻结交易保证金（元）")
    @ExcelProperty("冻结交易保证金（元）")
    private String djjybzj;

    @ApiModelProperty(value = "冻结履约保证金（元）")
    @ExcelProperty("冻结履约保证金（元）")
    private String djlybzj;

    @ApiModelProperty(value = "实际交款额（元）")
    @ExcelProperty("实际交款额（元）")
    private String sjjke;

    @ApiModelProperty(value = "可清退金额（元）")
    @ExcelProperty("可清退金额（元）")
    private String kqtje;

    @ApiModelProperty(value = "实际交款额（元）合并")
    @ExcelIgnore
    private String sjjkehb;

    @ApiModelProperty(value = "可清退金额（元）合并")
    @ExcelIgnore
    private String kqtjehb;

    @ApiModelProperty(value = "委托单位")
    @ExcelIgnore
    private String wtfmc;

    @ApiModelProperty(value = "交易类型")
    @ExcelIgnore
    private String jylx;

    @ApiModelProperty(value = "粮食性质编码")
    @ExcelIgnore
    private String lsxzbm;

    @ApiModelProperty(value = "交易日期")
    @ExcelProperty("完成时间")
    private String cjrq;


}
