package com.unis.transaction.common.vo.tradeplan;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * Author huyong
 * Description 出入库安排
 * Date  2019-09-20
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "安排、 货源")
public class WarehousingArrangementVO extends TradeMarkVO implements Serializable {
    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "AP+8位顺序号  编码", notes = "")
    private String apbm;

    @ApiModelProperty(value = "wt+8位顺序号  编码", notes = "")
    private String wtbm;

    @ApiModelProperty(value = "单位编码", notes = "")
    private String dwbm;

    @ApiModelProperty(value = "单位名称", notes = "")
    private String dwmc;

    @ApiModelProperty(value = "品种编码", notes = "")
    private String pzbm;

    @ApiModelProperty(value = "品种名称", notes = "")
    private String pzmc;


    @ApiModelProperty(value = "粮食数量", notes = "")
    private BigDecimal lssl;

    @ApiModelProperty(value = "生产年度", notes = "")
    private String scnd;

    @ApiModelProperty(value = "0是 1否", notes = "")
    private Integer sfbg;

    @ApiModelProperty(value = "储存地点", notes = "")
    private String ccdd;




//    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
//    @ApiModelProperty(value = "提货期限", notes = "")
//    private Date thqx;

//	@ApiModelProperty(value = "1确认 2驳回", notes ="")
//	private Integer sfjs;
//
//	@ApiModelProperty(value = "意见", notes ="")
//	private String yj;

    //	@ApiModelProperty(value = "状态值", notes ="")
    private String zt;

//	@ApiModelProperty(value = "状态值", notes ="")
//	private Integer status;
//
//	@ApiModelProperty(value = "状态名称", notes ="")
//	private String ztmc;

//	@ApiModelProperty(value = "细则标题", notes ="")
//	private String xzbt;
//
//	@ApiModelProperty(value = "细则正文", notes ="")
//	private String xzzw;

//    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
//    @ApiModelProperty(value = "编制时间", notes = "")
//    private Date bzsj;
//
//    @ApiModelProperty(value = "编制人员", notes = "")
//    private String bzr;

//	@ApiModelProperty(value = "发布状态 0 暂存 1已发布", notes ="")
//	private Integer fbzt;
//
//	@ApiModelProperty(value = "发布状态名称 0 暂存 1已发布", notes ="")
//	private String fbztmc;
//
//	@ApiModelProperty(value = "常用出库方式  0铁路 1公路  2水路", notes ="")
//	private String cyckfs;

    @ApiModelProperty(value = "正常出库能力", notes = "")
    private String cknl;

//	@ApiModelProperty(value = "是否具备40吨计量能力  0是 1否", notes ="")
//	private Integer sfjbnl;
//
//	@ApiModelProperty(value = "有无铁路专线    0是 1否", notes ="")
//	private Integer ywtl;
//
//	@ApiModelProperty(value = "是否露天", notes ="")
//	private Integer sflt;
//
//	@ApiModelProperty(value = "距离最近距离", notes ="")
//	private String jl;

//	@ApiModelProperty(value = "储粮方式", notes ="")
//	private Integer clxs;

//	@ApiModelProperty(value = "储粮方式名称", notes ="")
//	private String clxsmc;

    @ApiModelProperty(value = "备注", notes = "")
    private String remark;

    @ApiModelProperty(value = "数据类型<br/> 0-采购=安排 1-销售=货源", notes = "")
    private Integer sjlx;

    @ApiModelProperty(value = "安排数据类型 0-安排数据 1-货源保存", notes = "")
    private Integer aplx;

    @ApiModelProperty(value = "交易类型 0采购 1销售", notes = "")
    private Integer jylx;

    @ApiModelProperty(value = "委托方名称")
    private String wtfmc;

    @ApiModelProperty(value = "委托方编码")
    private String wtfbm;

    @ApiModelProperty(value = "收购等级")
    private String sgdj;

    @ApiModelProperty(value = "标的号", notes = "")
    private String bdh;

    @ApiModelProperty(value = "委托编号", notes = "")
    private String wtbh;

//	@ApiModelProperty(value = "产地", notes ="")
//	private String cd;

    @ApiModelProperty(value = "代办用户集合", notes = "")
    private List<ReceiverCollectionVO> userList;

    // 指标 start =======================================================
    @ApiModelProperty(value = "容重", notes = "")
    private String rz;

    @ApiModelProperty(value = "水份", notes = "")
    private String sf;

    @ApiModelProperty(value = "杂质", notes = "")
    private String zhaz;

    @ApiModelProperty(value = "不完善粒", notes = "")
    private String bwsl;

    @ApiModelProperty(value = "色泽气味", notes = "")
    private String szqw;

    @ApiModelProperty(value = "出糙率", notes = "")
    private String ccl;
    //lgd新加字段start

//    @ApiModelProperty(value = "酸值", notes = "")
//    private String sz;
//    @ApiModelProperty(value = "过氧化值", notes = "")
//    private String gyhz;
//    @ApiModelProperty(value = "溶剂残留量", notes = "")
//    private String rjcll;
//    @ApiModelProperty(value = "霉变", notes = "")
//    private String mb;
//    @ApiModelProperty(value = "脂肪酸值", notes = "")
//    private String zfsz;
//    @ApiModelProperty(value = "品尝评分值", notes = "")
//    private String pcpfz;
//    @ApiModelProperty(value = "黄粒米", notes = "")
//    private String hlm;
//    @ApiModelProperty(value = "互混", notes = "")
//    private String hh;
    //lgd新加字段end

    @ApiModelProperty(value = "碎米", notes = "")
    @Column(name = "sm")
    private String sm;

    @ApiModelProperty(value = "加工精度", notes = "")
    @Column(name = "jgjd")
    private String jgjd;

    @ApiModelProperty(value = "灰分", notes = "")
    @Column(name = "hf")
    private String hf;
    // 指标 end =======================================================


    @ApiModelProperty(value = "仓房编码", notes = "仓房编码")
    private String cfbm;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "完成时间", notes = "")
    @Column(name = "wcsj")
    private Date wcsj;

    @ApiModelProperty(value = "入库能力", notes = "")
    @Column(name = "rknl")
    private String rknl;

    @ApiModelProperty(value = "是否空仓<br/> 否  是", notes = "")
    @Column(name = "sfkc")
    private String sfkc;

    @ApiModelProperty(value = "标的分组序号", notes = "")
    @Column(name = "bd_group")
    private String bdGroup;

    @ApiModelProperty("标的编码  BD +8位顺序号")
    @Column(name = "bdbm")
    private String bdbm;

    @ApiModelProperty("交易底价")
    @Column(name = "jydj")
    private BigDecimal jydj;
}
