package com.unis.transaction.server;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.scheduling.annotation.EnableScheduling;
import tk.mybatis.spring.annotation.MapperScan;


/**
 * 天津
 * 字典服务
 */
@SpringBootApplication
@ComponentScan("com.unis")
@MapperScan("com.unis.transaction.server.dao")
@EnableEurekaClient
@EnableScheduling
@EnableFeignClients(basePackages = "com.unis.transaction")
public class TransactionApplication {
	public static void main(String[] args) {
		SpringApplication.run(TransactionApplication.class, args);
		System.out.println("==================启动成功==================");
	}
}