package com.unis.transaction.server.config;

import com.alibaba.excel.metadata.Head;
import com.alibaba.excel.metadata.data.WriteCellData;
import com.alibaba.excel.write.handler.WriteHandler;
import com.alibaba.excel.write.handler.context.CellWriteHandlerContext;
import com.alibaba.excel.write.merge.AbstractMergeStrategy;
import com.alibaba.excel.write.metadata.holder.WriteSheetHolder;
import com.alibaba.excel.write.metadata.holder.WriteTableHolder;
import com.unis.transaction.server.entity.tradeplan.TyJytjbbSxftj;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.util.CellRangeAddress;

import java.util.List;

import static cn.afterturn.easypoi.util.PoiMergeCellUtil.mergeCells;

// 合并策略实现类
public class MergeStrategy extends AbstractMergeStrategy {

    private static final int SJJKE_COLUMN_INDEX = 8;
    private static final int KQTJE_COLUMN_INDEX = 9;

    private List<TyJytjbbSxftj> tyJytjbbSxftjs;
    private List<Integer> integerList;

    private Sheet sheet;

    public MergeStrategy(List<TyJytjbbSxftj> tyJytjbbSxftjs, List<Integer> integerList) {
        this.tyJytjbbSxftjs = tyJytjbbSxftjs;
        this.integerList = integerList;
    }

    @Override
    public void beforeCellCreate(CellWriteHandlerContext context) {
        super.beforeCellCreate(context);
    }

    @Override
    public void beforeCellCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Row row, Head head, Integer columnIndex, Integer relativeRowIndex, Boolean isHead) {
        super.beforeCellCreate(writeSheetHolder, writeTableHolder, row, head, columnIndex, relativeRowIndex, isHead);
    }

    @Override
    public void afterCellCreate(CellWriteHandlerContext context) {
        super.afterCellCreate(context);
    }

    @Override
    public void afterCellCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Cell cell, Head head, Integer relativeRowIndex, Boolean isHead) {
        super.afterCellCreate(writeSheetHolder, writeTableHolder, cell, head, relativeRowIndex, isHead);
    }

    @Override
    public void afterCellDataConverted(CellWriteHandlerContext context) {
        super.afterCellDataConverted(context);
    }

    @Override
    public void afterCellDataConverted(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, WriteCellData<?> cellData, Cell cell, Head head, Integer relativeRowIndex, Boolean isHead) {
        super.afterCellDataConverted(writeSheetHolder, writeTableHolder, cellData, cell, head, relativeRowIndex, isHead);
    }

    @Override
    public void afterCellDispose(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, List<WriteCellData<?>> cellDataList, Cell cell, Head head, Integer relativeRowIndex, Boolean isHead) {
        super.afterCellDispose(writeSheetHolder, writeTableHolder, cellDataList, cell, head, relativeRowIndex, isHead);
    }

    // 按照分组将各种类别分别合并成一个单元格
    private void mergeGroupColumn(Integer index) {
        Integer rowCnt = 2;
        for (Integer count : integerList) {
            CellRangeAddress cellRangeAddress = new CellRangeAddress(rowCnt, rowCnt + count - 1, index, index);
            // 设置值

            sheet.addMergedRegionUnsafe(cellRangeAddress);
            rowCnt += count;
        }
    }

    @Override
    protected void merge(Sheet sheet, Cell cell, Head head, Integer integer) {
        this.sheet = sheet;
        // 第二行和最后一行不合并
        if (cell.getRowIndex() == 0 || cell.getRowIndex() == 1 || cell.getRowIndex() == tyJytjbbSxftjs.size() + 1) {
            return;
        }

        switch (cell.getColumnIndex()) {
            case SJJKE_COLUMN_INDEX:
                mergeGroupColumn(SJJKE_COLUMN_INDEX);
                // 合并单元格后设置新值
                cell.setCellValue(tyJytjbbSxftjs.get(0).getSjjke());
                break;
            case KQTJE_COLUMN_INDEX:
                mergeGroupColumn(KQTJE_COLUMN_INDEX);
                // 合并单元格后设置新值
                cell.setCellValue(tyJytjbbSxftjs.get(0).getKqtje());
                break;
        }


    }
}
