package com.unis.transaction.server.config;

import com.alibaba.fastjson.JSON;
import com.unis.transaction.common.vo.backlog.BacklogAddVO;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import com.unis.transaction.server.service.BacklogMQService;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.PostConstruct;
import java.util.List;

public class ThreadUtil {

    private static BacklogMQService mqService;
    @Autowired
    private  BacklogMQService backlogMQService;

    @PostConstruct
    private void beforeInit() {
        mqService = this.backlogMQService;
    }

    public static void startThread(BacklogAddVO record,List<ReceiverCollectionVO> list){
        if(list!=null&&list.size()>0){
            new Thread(new Runnable() {
                @Override
                public void run() {
                    for (ReceiverCollectionVO userVO : list) {
                        System.out.println("********************接收人*******************");
                        System.out.println("-----" + userVO.getUserName() + "-------" + userVO.getUserId());
                        System.out.println("********************************************");
                        record.setReceiver(userVO.getUserName());
                        record.setReceiverId(userVO.getUserId());
                        // 需要将对象序列化成JSONObject
                        mqService.sendMsg(JSON.parseObject(com.unis.transaction.common.utils.JsonUtils.serialize(record)), "insert");
                    }
                }
            }).start();
        }
    }

}
