package com.unis.transaction.server.controller.creditevaluate;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.creditevaluate.EnterPriseClassSetVO;
import com.unis.transaction.common.vo.creditevaluate.EnterPriseClassVO;
import com.unis.transaction.server.service.EnterPriseClassSetService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * Author lidiaoquan
 *  企业分级设置 at 2019-09-26
 */
@RestController
@RequestMapping(value = "/enterpriseclassset")
@Api(value = "企业分级设置", tags = "企业分级设置")
public class EnterPriseClassSetController {
   
    @Autowired
    private EnterPriseClassSetService enterpriseclasssetService;

 	//企业分级设置-新增
 	@ApiOperation(value = "企业分级设置-新增", notes = "参数：EnterPriseClassSetVO")
    @PostMapping(value = "/insertEnterPriseClassSet")
    public ResponseWrapper insertEnterPriseClassSet(@RequestBody  EnterPriseClassVO vo) {
		try {
			return enterpriseclasssetService.insertEnterPriseClassSet(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//企业分级设置-修改
 	@ApiOperation(value = "企业分级设置-修改", notes = "参数：EnterPriseClassSetVO")
    @PostMapping(value = "/updateEnterPriseClassSet")
    public ResponseWrapper updateEnterPriseClassSet(@RequestBody EnterPriseClassSetVO vo) {
		try {
			return enterpriseclasssetService.updateEnterPriseClassSet(vo,null);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}


	//企业分级设置-查看--返回单条
	@ApiOperation(value = "企业分级设置--查看--返回单条", notes = "参数：EnterPriseClassSetVO")
	@PostMapping(value = "/selectEnterPriseClassSetDetail")	
    public ResponseWrapper selectEnterPriseClassSetDetail(@RequestBody EnterPriseClassSetVO vo) {
       	try {
			return enterpriseclasssetService.selectEnterPriseClassSetDetail(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }
}
