package com.unis.transaction.server.controller.creditevaluate;

import com.unis.common.utils.POI4Util;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.creditevaluate.TurnoverDataVO;
import com.unis.transaction.server.service.TurnoverDataService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Author lidiaoquan
 *  成交数据维护 at 2019-09-26
 */
@RestController
@RequestMapping(value = "/turnoverdata")
@Api(value = "成交数据维护", tags = "成交数据维护")
public class TurnoverDataController {
   
    @Autowired
    private TurnoverDataService turnoverdataService;


 	//成交数据维护-新增
 	@ApiOperation(value = "成交数据维护-新增", notes = "参数：TurnoverDataVO")
    @PostMapping(value = "/insertTurnoverData")
    public ResponseWrapper insertTurnoverData(@RequestBody  TurnoverDataVO vo) {
		try {
			return turnoverdataService.insertTurnoverData(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}
	//成交数据维护-批量导入新增
	@ApiOperation(value = "成交数据维护-新增", notes = "参数：TurnoverDataVO")
	@PostMapping(value = "/insertTurnoverDataImp")
	public ResponseWrapper insertTurnoverDataImp(@RequestBody  TurnoverDataVO vo) {
		try {
			return turnoverdataService.insertTurnoverDataImp(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//成交数据维护-修改
 	@ApiOperation(value = "成交数据维护-修改", notes = "参数：TurnoverDataVO")
    @PostMapping(value = "/updateTurnoverData")
    public ResponseWrapper updateTurnoverData(@RequestBody TurnoverDataVO vo) {
		try {
			return turnoverdataService.updateTurnoverData(vo,null);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//成交数据维护-分页列表
	@ApiOperation(value = "成交数据维护-分页列表", notes = "参数：TurnoverDataVO")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
        @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })	
    @PostMapping(value = "/selectTurnoverDataPageList")
    public ResponseWrapper selectTurnoverDataPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
        ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
        ,@RequestBody TurnoverDataVO vo) {
       	try {
			return turnoverdataService.selectTurnoverDataPageList(pageNum,pageSize,vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	@ApiOperation(value = "成交数据维护-分页列表", notes = "参数：TurnoverDataVO")
	@PostMapping(value = "/selectTurnoverDataImport")
	public ResponseWrapper selectTurnoverDataImport(@RequestBody TurnoverDataVO vo) {
		try {
			return turnoverdataService.selectTurnoverDataImport(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}
    
    //成交数据维护-列表全部数据
    @ApiOperation(value = "成交数据维护-列表全部数据", notes = "参数：TurnoverDataVO")
    @PostMapping(value = "/selectTurnoverDataAll")
    public ResponseWrapper selectTurnoverDataAll(@RequestBody TurnoverDataVO vo) {
       	try {
			return turnoverdataService.selectTurnoverDataAll(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	//成交数据维护-查看--返回单条
	@ApiOperation(value = "成交数据维护--查看--返回单条", notes = "参数：TurnoverDataVO")
	@PostMapping(value = "/selectTurnoverDataDetail")	
    public ResponseWrapper selectTurnoverDataDetail(@RequestBody TurnoverDataVO vo) {
       	try {
			return turnoverdataService.selectTurnoverDataDetail(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }
	
	
	// 成交数据维护--导入--下载模板
	@ApiOperation(value = "成交数据维护--导入--下载模板", notes = "参数：TurnoverDataVO")
    @PostMapping(value = "/impData")	
	public ResponseWrapper impData(@RequestPart(value = "file")MultipartFile file) {
		List<String> columns = new ArrayList<String>();
		columns.add("1");
		columns.add("2");
		columns.add("3");
		columns.add("4");
		columns.add("5");
		columns.add("6");
		columns.add("7");
		columns.add("8");
		columns.add("9");
		columns.add("10");
		columns.add("11");
		columns.add("12");
		columns.add("13");
		columns.add("14");
		columns.add("15");
		columns.add("16");
		columns.add("17");
		columns.add("18");
		columns.add("19");
		columns.add("20");
		columns.add("21");
		columns.add("22");
		columns.add("23");
		columns.add("24");
		columns.add("25");
		columns.add("26");
		columns.add("27");
		columns.add("28");
		Map<String, Object> map = POI4Util.uploadExcel(file, columns);
		Integer state = Integer.valueOf(map.get("state")+"");
//		if(state == 1) {
//			@SuppressWarnings("unchecked")
//			List<Line> lines = (List<Line>) map.get("lines");
//			for (Line line : lines) {
//				List<Column> columns2 = line.getColumns();
//				for (Column line2 : columns2) {
//					
//					TurnoverDataVO vo = new TurnoverDataVO();
//					turnoverdataService.insertTurnoverData(vo );
//					System.out.println(line2.getName()+"***"+line2.getValue());
//				}
//			}
//		}
		return ResponseWrapper.success();
	}
}
