package com.unis.transaction.server.controller.creditevaluate;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.creditevaluate.TurnoverEndVO;
import com.unis.transaction.server.service.TurnoverEndService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Author lgd
 */
@RestController
@RequestMapping(value = "/turnoverend")
@Api(value = "交易结果及手续费维护", tags = "交易结果及手续费维护")
public class TurnoverEndController {
   
    @Autowired
    private TurnoverEndService TurnoverEndService;


	//成交数据维护-修改
 	@ApiOperation(value = "交易结果-修改", notes = "参数：TurnoverEndVO")
    @PostMapping(value = "/updateTurnoverEnd")
    public ResponseWrapper updateTurnoverEnd(@RequestBody TurnoverEndVO vo) {
		try {
			return TurnoverEndService.updateTurnoverEnd(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//成交数据维护-分页列表
	@ApiOperation(value = "交易结果-分页列表", notes = "参数：TurnoverEndVO")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
        @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })	
    @PostMapping(value = "/selectTurnoverEndPageList")
    public ResponseWrapper selectTurnoverEndPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
        ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
        ,@RequestBody TurnoverEndVO vo) {
       	try {
			return TurnoverEndService.selectTurnoverEndPageList(pageNum,pageSize,vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	//成交数据维护-查看--返回单条
	@ApiOperation(value = "交易结果--查看--返回单条", notes = "参数：TurnoverEndVO")
	@PostMapping(value = "/selectTurnoverEndDetail")	
    public ResponseWrapper selectTurnoverEndDetail(@RequestBody TurnoverEndVO vo) {
       	try {
			return TurnoverEndService.selectTurnoverEndDetail(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	@ApiOperation(value = "手续费-分页列表", notes = "参数：TurnoverEndVO")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
			@ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
	})
	@PostMapping(value = "/selectTurnoverSxfPageList")
	public ResponseWrapper selectTurnoverSxfPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
			,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
			,@RequestBody TurnoverEndVO vo) {
		try {
			return TurnoverEndService.selectTurnoverSxfPageList(pageNum,pageSize,vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//成交数据维护-查看--返回单条
	@ApiOperation(value = "手续费--查看--返回单条", notes = "参数：TurnoverEndVO")
	@PostMapping(value = "/selectTurnoverSxfDetail")
	public ResponseWrapper selectTurnoverSxfDetail(@RequestBody TurnoverEndVO vo) {
		try {
			return TurnoverEndService.selectTurnoverSxfDetail(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

}
