package com.unis.transaction.server.controller.givebackbail;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.givebackbail.ComplainVO;
import com.unis.transaction.server.service.ComplainService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Author lgd
 */
@RestController
@RequestMapping(value = "/complain")
@Api(value = "交易申诉", tags = "交易申诉")
public class ComplainController {

    @Autowired
    ComplainService complainService;

    //交易申诉-新增
    @ApiOperation(value = "交易申诉-新增", notes = "参数：ComplainVO")
    @PostMapping(value = "/insertComplain")
    public ResponseWrapper insertComplain(@RequestBody ComplainVO vo) {
        try {
            return complainService.insertComplain(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    //交易申诉-修改
    @ApiOperation(value = "交易申诉-修改", notes = "参数：ComplainVO")
    @PostMapping(value = "/updateComplain")
    public ResponseWrapper updateComplain(@RequestBody ComplainVO vo) {
        try {
            return complainService.updateComplain(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    //交易申诉-修改
    @ApiOperation(value = "交易申诉-删除", notes = "参数：ComplainVO")
    @PostMapping(value = "/deleteComplain")
    public ResponseWrapper deleteComplain(@RequestBody ComplainVO vo) {
        try {
            return complainService.deleteComplain(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    //交易申诉-分页列表
    @ApiOperation(value = "交易申诉-分页列表", notes = "参数：ComplainVO")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
            @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })
    @PostMapping(value = "/selectComplainPageList")
    public ResponseWrapper selectComplainPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
            ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
            ,@RequestBody ComplainVO vo) {
        try {
            return complainService.selectComplainPageList(pageNum,pageSize,vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }


    //交易申诉-查看--返回单条
    @ApiOperation(value = "交易申诉--查看--返回单条", notes = "参数：ComplainVO")
    @PostMapping(value = "/selectComplainDetail")
    public ResponseWrapper selectComplainDetail(@RequestBody ComplainVO vo) {
        try {
            return complainService.selectComplainDetail(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    //交易申诉-查看--返回单条
    @ApiOperation(value = "交易申诉--查询登录单位全部未退款数据", notes = "参数：ComplainVO")
    @PostMapping(value = "/selectSiteAll")
    public ResponseWrapper selectSiteAll() {
        try {
            return complainService.selectSiteAll();
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    @ApiOperation(value = "交易申诉--查询合同", notes = "参数：主键")
    @GetMapping(value = "/selectContracts/{ccbm}")
    public ResponseWrapper selectContracts(@PathVariable("ccbm") String ccbm) {
        try {
            return complainService.selectContracts(ccbm);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }
}
