/*
 * GiveBackBailLetterController.java
 * 版权所有 © 2011-2017 北京神舟良实信息技术有限公司
 * Copyright © 2011-2017 All Rights Reserved    京ICP备13013562号
 * 2019-09-20 created by lipenghe with LAPTOP-IJQ2SDFV
 */
package com.unis.transaction.server.controller.givebackbail;

import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.constant.BaseStatusConstant;
import com.unis.transaction.common.constant.GiveBackBailConstant;
import com.unis.transaction.common.vo.givebackbail.GiveBackBailLetterVO;
import com.unis.transaction.server.service.GiveBackBailLetterService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * TY_JYTKWTH-退保证金委托函
 * @author lipenghe at 2019-09-20 21:04:21
 */
@RestController
@RequestMapping("/manager/givebackbail")
@Api(value = "保证金退款", tags = "退保证金委托函")
public class GiveBackBailLetterController {

    @Autowired
    private GiveBackBailLetterService giveBackBailLetterService;

    @ApiOperation(value = "保证金退款---退保证金委托函---新增", notes = "保证金退款")
    @PostMapping("/giveBackBailLetter/insertEntitySelective")
    public ResponseWrapper insertEntitySelective(@RequestBody GiveBackBailLetterVO
                                                             bailLetterVO) {
        //@Validated({InsertGroup.class})
     /*   if(bindingResult.hasErrors()){
            return ResponseWrapper.validateFail(bindingResult.getAllErrors());
        }else{*/
            return giveBackBailLetterService.insertEntitySelectiveResult(bailLetterVO);
      //  }
    }

    @ApiOperation(value = "保证金退款---退保证金委托函---修改", notes = "保证金退款")
    @PostMapping("/giveBackBailLetter/updateByEntitySelective")
    public ResponseWrapper updateByEntitySelective(@RequestBody GiveBackBailLetterVO bailLetterVO
        ) {
        //@Validated({InsertGroup.class})
   /*     if(bindingResult.hasErrors()){
            return ResponseWrapper.validateFail(bindingResult.getAllErrors());
        }else{*/
            return giveBackBailLetterService.updateByEntitySelectiveResult(bailLetterVO,null);
       // }
    }

    @ApiOperation(value = "保证金退款---退保证金委托函---更新状态", notes = "保证金退款")
    @PostMapping("/giveBackBailLetter/updateStatusByEntity")
    public ResponseWrapper updateStatusByEntity(@RequestBody GiveBackBailLetterVO bailLetterVO) {
        if(bailLetterVO!=null){
            return giveBackBailLetterService.updateStatusByEntityResult(bailLetterVO,null);
        }else{
            return ResponseWrapper.invalid();
        }
    }

    @ApiOperation(value = "保证金退款---退保证金委托函---删除", notes = "保证金退款")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "wthbm", value = "委托函编码#<主键><非空>", dataType = "String", paramType = "body")
    })
    @PostMapping("/giveBackBailLetter/deleteByEntity")
    public ResponseWrapper deleteByEntity(@RequestBody GiveBackBailLetterVO bailLetterVO){
        if(bailLetterVO!=null){
            bailLetterVO.setStatus(BaseStatusConstant.STATUS_DELETED);
            return giveBackBailLetterService.deleteByEntityResult(bailLetterVO,null);
        }else{
            return ResponseWrapper.invalid();
        }
    }

    @ApiOperation(value = "保证金退款---退保证金委托函---编制人分页查询列表,pageSize,pageNum从url传", notes = "保证金退款")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query")
        ,@ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
        ,@ApiImplicitParam(name = "wthbm", value = "委托函编码#<主键><非空>", dataType = "String", paramType = "body")
        ,@ApiImplicitParam(name = "wtlx", value = "0销售#<默认值:0>1采购", dataType = "Integer", paramType = "body")
    })
    @PostMapping("/giveBackBailLetter/selectOwnerPageByEntity")
    public ResponseWrapper selectOwnerPageByEntity(
        @RequestParam(value = "pageNum", defaultValue = "1") int pageNum
        ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
        ,@RequestBody GiveBackBailLetterVO bailLetterVO) {
        bailLetterVO.setCreator(CurrentUtil.getUserAccount());
        return giveBackBailLetterService.selectPageByEntityResult(pageNum,pageSize
        , bailLetterVO,"WTHBM DESC");
    }

    @ApiOperation(value = "保证金退款---退保证金委托函---接收组织分页查询列表,pageSize,pageNum从url传", notes = "保证金退款")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query")
        ,@ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
        ,@ApiImplicitParam(name = "wthbm", value = "委托函编码#<主键><非空>", dataType = "String", paramType = "body")
        ,@ApiImplicitParam(name = "wtlx", value = "0销售#<默认值:0>1采购", dataType = "Integer", paramType = "body")
    })
    @PostMapping("/giveBackBailLetter/selectReceivePageByEntity")
    public ResponseWrapper selectReceivePageByEntity(
        @RequestParam(value = "pageNum", defaultValue = "1") int pageNum
        ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
        ,@RequestBody GiveBackBailLetterVO bailLetterVO) {
        bailLetterVO.setJsdw(CurrentUtil.getOrgId());
        bailLetterVO.setZt(GiveBackBailConstant.YFS.getValue());
        return giveBackBailLetterService.selectPageByEntityResult(pageNum,pageSize
            , bailLetterVO,"WTHBM DESC");
    }

    @ApiOperation(value = "保证金退款---退保证金委托函---查询详情", notes = "保证金退款")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "wthbm", value = "委托函编码#<主键><非空>", dataType = "String", paramType = "body")
    })
    @PostMapping("/giveBackBailLetter/selectById")
    public ResponseWrapper selectById(@RequestBody GiveBackBailLetterVO bailLetterVO){
        if(bailLetterVO!=null){
            return giveBackBailLetterService.selectByIdResult(bailLetterVO);
        }else{
            return ResponseWrapper.invalid();
        }
    }

    @ApiOperation(value = "保证金退款---查询场次对应的单位下拉列表", notes = "保证金退款")
    @PostMapping("/giveBackBailLetter/selectTkdwList")
    public ResponseWrapper selectTkdwList(){
        return giveBackBailLetterService.selectTkdwList();
    }

    @ApiOperation(value = "查询单位下拉合同列表", notes = "参数：主键")
    @PostMapping(value = "/giveBackBailLetter/selectTkdwHtList/{dwbm}")
    public ResponseWrapper selectTkdwHtList(@PathVariable("dwbm") String dwbm) {
        try {
            return giveBackBailLetterService.selectTkdwHtList(dwbm);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }




    @ApiOperation(value = "保证金退款---退保证金委托函---初始化数据", notes = "保证金退款")
    @PostMapping("/giveBackBailLetter/selectInitData")
    public ResponseWrapper selectInitData(@RequestBody GiveBackBailLetterVO bailLetterVO){
        if(bailLetterVO!=null){
            return giveBackBailLetterService.selectInitDataResult(bailLetterVO);
        }else{
            return ResponseWrapper.invalid();
        }
    }
}
