package com.unis.transaction.server.controller.givebackbail;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.givebackbail.GiveBackVO;
import com.unis.transaction.common.vo.givebackbail.PassBackVO;
import com.unis.transaction.server.service.GiveBackService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Author lidiaoquan
 *  保证金退款 at 2019-09-21
 */
@RestController
@RequestMapping(value = "/giveback")
@Api(value = "保证金退款", tags = "保证金退款")
public class GiveBackController {
   
    @Autowired
    private GiveBackService givebackService;

 	//保证金退款-新增
 	@ApiOperation(value = "保证金退款-新增", notes = "参数：GiveBackVO")
    @PostMapping(value = "/insertGiveBack")
    public ResponseWrapper insertGiveBack(@RequestBody  GiveBackVO vo) {
		try {
			return givebackService.insertGiveBack(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//保证金退款-修改
 	@ApiOperation(value = "保证金退款-修改", notes = "参数：GiveBackVO")
	@PostMapping(value = "/updateGiveBack")
	public ResponseWrapper updateGiveBack(@RequestBody GiveBackVO vo) {
		try {
			return givebackService.updateGiveBack(vo,null);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	@ApiOperation(value = "保证金退款-未成交修改", notes = "参数：GiveBackVO")
	@PostMapping(value = "/updateGiveBackPass")
	public ResponseWrapper updateGiveBackPass(@RequestBody PassBackVO vo) {
		try {
			return givebackService.updateGiveBackPass(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//保证金退款-分页列表
	@ApiOperation(value = "保证金退款-分页列表", notes = "参数：GiveBackVO")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
        @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })	
    @PostMapping(value = "/selectGiveBackPageList")
    public ResponseWrapper selectGiveBackPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
        ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
        ,@RequestBody GiveBackVO vo) {
       	try {
			return givebackService.selectGiveBackPageList(pageNum,pageSize,vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	@ApiOperation(value = "保证金退款-未成交分页列表", notes = "参数：GiveBackVO")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
			@ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
	})
	@PostMapping(value = "/selectPassBackPageList")
	public ResponseWrapper selectPassBackPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
			,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
			,@RequestBody PassBackVO vo) {
		try {
			return givebackService.selectPassBackPageList(pageNum,pageSize,vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}
    
    //保证金退款-列表全部数据
    @ApiOperation(value = "保证金退款-列表全部数据", notes = "参数：GiveBackVO")
    @PostMapping(value = "/selectGiveBackAll")
    public ResponseWrapper selectGiveBackAll(@RequestBody GiveBackVO vo) {
       	try {
			return givebackService.selectGiveBackAll(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	@ApiOperation(value = "保证金退款-列表全部数据", notes = "参数：GiveBackVO")
	@PostMapping(value = "/selectGivePassAll")
	public ResponseWrapper selectGivePassAll(@RequestBody GiveBackVO vo) {
		try {
			return givebackService.selectGivePassAll(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	@ApiOperation(value = "保证金退款-列表全部数据", notes = "参数：GiveBackVO")
	@PostMapping(value = "/selectPassBack")
	public ResponseWrapper selectPassBack(@RequestBody GiveBackVO vo) {
		try {
			return givebackService.selectPassBack(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//保证金退款-查看--返回单条
	@ApiOperation(value = "保证金退款--查看--返回单条", notes = "参数：GiveBackVO")
	@PostMapping(value = "/selectGiveBackDetail")
	public ResponseWrapper selectGiveBackDetail(@RequestBody GiveBackVO vo) {
		try {
			return givebackService.selectGiveBackDetail(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	@ApiOperation(value = "保证金退款--未成交查看--返回单条", notes = "参数：GiveBackVO")
	@PostMapping(value = "/selectGiveBackPass")
	public ResponseWrapper selectGiveBackPass(@RequestBody PassBackVO vo) {
		try {
			return givebackService.selectGiveBackPass(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}
}
