package com.unis.transaction.server.controller.givebackbail;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.givebackbail.NoticeVO;
import com.unis.transaction.server.service.NoticeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Author lgd
 */
@RestController
@RequestMapping(value = "/notice")
@Api(value = "交易通知", tags = "交易通知")
public class NoticeController {

    @Autowired
    NoticeService noticeService;

    //交易通知-新增
    @ApiOperation(value = "交易通知-新增", notes = "参数：NoticeVO")
    @PostMapping(value = "/insertNotice")
    public ResponseWrapper insertNotice(@RequestBody NoticeVO vo) {
        try {
            return noticeService.insertNotice(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    //交易通知-修改
    @ApiOperation(value = "交易通知-修改", notes = "参数：NoticeVO")
    @PostMapping(value = "/updateNotice")
    public ResponseWrapper updateNotice(@RequestBody NoticeVO vo) {
        try {
            return noticeService.updateNotice(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    @ApiOperation(value = "交易通知-查询委托方", notes = "参数：NoticeVO")
    @PostMapping(value = "/getWtf")
    public ResponseWrapper getWtf(@RequestBody NoticeVO vo) {
        try {
            return noticeService.getWtf(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    //交易通知-修改
    @ApiOperation(value = "交易通知-删除", notes = "参数：NoticeVO")
    @PostMapping(value = "/deleteNotice")
    public ResponseWrapper deleteNotice(@RequestBody NoticeVO vo) {
        try {
            return noticeService.deleteNotice(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    //交易通知-分页列表
    @ApiOperation(value = "交易通知-分页列表", notes = "参数：NoticeVO")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
            @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })
    @PostMapping(value = "/selectNoticePageList")
    public ResponseWrapper selectNoticePageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
            ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
            ,@RequestBody NoticeVO vo) {
        try {
            return noticeService.selectNoticePageList(pageNum,pageSize,vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }


    //交易通知-查看--返回单条
    @ApiOperation(value = "交易通知--查看--返回单条", notes = "参数：NoticeVO")
    @PostMapping(value = "/selectNoticeDetail")
    public ResponseWrapper selectNoticeDetail(@RequestBody NoticeVO vo) {
        try {
            return noticeService.selectNoticeDetail(vo);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }


    //交易申诉-查看--返回单条
    @ApiOperation(value = "交易申诉--查询登录单位全部未退款数据", notes = "参数：ComplainVO")
    @PostMapping(value = "/selectSiteAllNotice")
    public ResponseWrapper selectSiteAllNotice() {
        try {
            return noticeService.selectSiteAllNotice();
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

    @ApiOperation(value = "交易申诉--查询合同", notes = "参数：主键")
    @GetMapping(value = "/selectContractNotice/{ccbm}")
    public ResponseWrapper selectContractNotice(@PathVariable("ccbm") String ccbm) {
        try {
            return noticeService.selectContractNotice(ccbm);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error();
        }
    }

}
