package com.unis.transaction.server.controller.signuppay;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.signuppay.FeeRateVO;
import com.unis.transaction.server.service.FeeRateService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Author lidiaoquan
 *  手续费率维护 at 2019-09-19
 */
@RestController
@RequestMapping(value = "/feerate")
@Api(value = "手续费率维护", tags = "手续费率维护")
public class FeeRateController {
   
    @Autowired
    private FeeRateService feerateService;

 	//手续费率维护-新增
 	@ApiOperation(value = "手续费率维护-新增", notes = "参数：FeeRateVO")
    @PostMapping(value = "/insertFeeRate")
    public ResponseWrapper insertFeeRate(@RequestBody  FeeRateVO vo) {
		try {
			return feerateService.insertFeeRate(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//手续费率维护-修改
 	@ApiOperation(value = "手续费率维护-修改", notes = "参数：FeeRateVO")
    @PostMapping(value = "/updateFeeRate")
    public ResponseWrapper updateFeeRate(@RequestBody FeeRateVO vo) {
		try {
			return feerateService.updateFeeRate(vo,null);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//手续费率维护-分页列表
	@ApiOperation(value = "手续费率维护-分页列表", notes = "参数：FeeRateVO")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
        @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })	
    @PostMapping(value = "/selectFeeRatePageList")
    public ResponseWrapper selectFeeRatePageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
        ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
        ,@RequestBody FeeRateVO vo) {
       	try {
			return feerateService.selectFeeRatePageList(pageNum,pageSize,vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }
    
    //手续费率维护-列表全部数据
    @ApiOperation(value = "手续费率维护-列表全部数据", notes = "参数：FeeRateVO")
    @PostMapping(value = "/selectFeeRateAll")
    public ResponseWrapper selectFeeRateAll(@RequestBody FeeRateVO vo) {
       	try {
			return feerateService.selectFeeRateAll(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	//手续费率维护-查看--返回单条
	@ApiOperation(value = "手续费率维护--查看--返回单条", notes = "参数：FeeRateVO")
	@PostMapping(value = "/selectFeeRateDetail")	
    public ResponseWrapper selectFeeRateDetail(@RequestBody FeeRateVO vo) {
       	try {
			return feerateService.selectFeeRateDetail(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }
}
