package com.unis.transaction.server.controller.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.tradeplan.TradeRuleVO;
import com.unis.transaction.server.service.TradeRuleService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Author lidiaoquan
 *  交易细则 at 2019-09-19
 */
@RestController
@RequestMapping(value = "/traderule")
@Api(value = "交易细则", tags = "交易细则")
public class TradeRuleController {
   
    @Autowired
    private TradeRuleService traderuleService;

 	//交易细则-新增
 	@ApiOperation(value = "交易细则-新增", notes = "参数：TradeRuleVO")
    @PostMapping(value = "/insertTradeRule")
    public ResponseWrapper insertTradeRule(@RequestBody  TradeRuleVO vo) {
		try {
			return traderuleService.insertTradeRule(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//交易细则-修改
 	@ApiOperation(value = "交易细则-修改", notes = "参数：TradeRuleVO")
    @PostMapping(value = "/updateTradeRule")
    public ResponseWrapper updateTradeRule(@RequestBody TradeRuleVO vo) {
		try {
			return traderuleService.updateTradeRule(vo,null);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
	}

	//交易细则-分页列表
	@ApiOperation(value = "交易细则-分页列表", notes = "参数：TradeRuleVO")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
        @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })	
    @PostMapping(value = "/selectTradeRulePageList")
    public ResponseWrapper selectTradeRulePageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
        ,@RequestParam(value = "pageSize", defaultValue = "10") int pageSize
        ,@RequestBody TradeRuleVO vo) {
       	try {
			return traderuleService.selectTradeRulePageList(pageNum,pageSize,vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }
    
    //交易细则-列表全部数据
    @ApiOperation(value = "交易细则-列表全部数据", notes = "参数：TradeRuleVO")
    @PostMapping(value = "/selectTradeRuleAll")
    public ResponseWrapper selectTradeRuleAll(@RequestBody TradeRuleVO vo) {
       	try {
			return traderuleService.selectTradeRuleAll(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }

	//交易细则-查看--返回单条
	@ApiOperation(value = "交易细则--查看--返回单条", notes = "参数：TradeRuleVO")
	@PostMapping(value = "/selectTradeRuleDetail")	
    public ResponseWrapper selectTradeRuleDetail(@RequestBody TradeRuleVO vo) {
       	try {
			return traderuleService.selectTradeRuleDetail(vo);
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseWrapper.error();
		}
    }
}
