package com.unis.transaction.server.controller.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.server.entity.tradeplan.TyHtlytx;
import com.unis.transaction.server.entity.tradeplan.TyHtlytxVO;
import com.unis.transaction.server.service.TyHttxsjService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * @Classname TyHttxController
 * @Description 合同提醒Controller
 * @Date 2023/8/2 10:17
 * @Created by rising123sun
 */
@RestController
@RequestMapping("/tyHttx")
@Api(value = "合同提醒", tags = "合同提醒")
public class TyHttxController {
    @Resource
    private TyHttxsjService tyHttxsjService;

    // 距离合同完成时间提前提醒时间设置
    @PostMapping("/htsjtxsz")
    @ApiOperation(value = "距离合同完成时间提前提醒时间设置", notes = "距离合同完成时间提前提醒时间设置")
    public ResponseWrapper htsjtxsz(@ApiParam(name = "sj", value = "时间") @RequestParam Integer sj) {
        try {
            return ResponseWrapper.success(tyHttxsjService.htsjtxsz(sj));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }
    // 距离合同完成时间提前提醒时间查询
    @GetMapping("/htsjtxcx")
    @ApiOperation(value = "距离合同完成时间提前提醒时间查询", notes = "距离合同完成时间提前提醒时间查询")
    public ResponseWrapper htsjtxcx() {
        try {
            return ResponseWrapper.success(tyHttxsjService.htsjtxcx());
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 添加提醒测试
    @PostMapping("/tjhtlytxTest")
    @ApiOperation(value = "添加提醒测试", notes = "添加提醒测试")
    public ResponseWrapper tjhtlytxTest() {
        try {
            return ResponseWrapper.success(tyHttxsjService.tjhtlytx());
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 生成敦促履约涵(初次打开)
    @PostMapping("/scdclyh")
    @ApiOperation(value = "生成敦促履约涵(初次打开)", notes = "生成敦促履约涵(初次打开)")
    public ResponseWrapper scdclyh(@ApiParam(name = "hth", value = "合同编号") @RequestParam String hth) {
        try {
            return ResponseWrapper.success(tyHttxsjService.sccsdclyh(hth));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 根据id查询敦促履约涵
    @GetMapping("/queryDclyhById")
    @ApiOperation(value = "根据id查询敦促履约涵", notes = "根据id查询敦促履约涵")
    public ResponseWrapper queryDclyhById(@ApiParam(name = "id", value = "id") @RequestParam String id) {
        try {
            return ResponseWrapper.success(tyHttxsjService.queryDclyhById(id));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 履约提醒分页列表查询
    @PostMapping("/queryPageList")
    @ApiOperation(value = "履约提醒分页列表查询", notes = "履约提醒分页列表查询")
    public ResponseWrapper queryPageList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                         @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                         @RequestBody TyHtlytxVO tyHtlytx) {
        try {
            return ResponseWrapper.success(tyHttxsjService.queryPageList(pageNum, pageSize, tyHtlytx));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 回复履约提醒
    @PostMapping("/hfhtlytx")
    @ApiOperation(value = "回复履约提醒", notes = "回复履约提醒")
    public ResponseWrapper hfhtlytx(@RequestBody TyHtlytx tyHtlytx) {
        try {
            return ResponseWrapper.success(tyHttxsjService.hfhtlytx(tyHtlytx));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 修改或保存敦促履约涵
    @PostMapping("/xgbcDclyh")
    @ApiOperation(value = "修改或保存敦促履约涵", notes = "修改或保存敦促履约涵")
    public ResponseWrapper xgbcDclyh(
            @RequestParam(value = "id") String lytxid,
            @RequestParam(value = "dclyhbzr") String dclyhbzr,
            @RequestParam(value = "dclyh") String dclyh,
            @RequestParam(value = "dclyhbzrq") String dclyhbzrq,
            @RequestParam(value = "sclyhzt") String sclyhzt) {
        try {
            return ResponseWrapper.success(tyHttxsjService.xgbcDclyh(lytxid, dclyhbzr, dclyh, dclyhbzrq, sclyhzt));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }
}
