package com.unis.transaction.server.controller.tradeplan;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.server.entity.tradeplan.DcJyHzzb;
import com.unis.transaction.server.entity.tradeplan.Dcjybzxx;
import com.unis.transaction.server.entity.tradeplan.TyDcsjjl;
import com.unis.transaction.server.entity.tradeplan.TyJytjbb;
import com.unis.transaction.server.service.TyJytjbbService;
import io.swagger.annotations.*;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

/**
 * @Classname TyJytjbbService
 * @Description 交易统计报表
 * @Date 2023/7/27 18:28
 * @Created by rising123sun
 */
@RestController
@RequestMapping("/tyJytjbb")
@Api(value = "交易统计表", tags = "交易统计表")
public class TyJytjbbController {

    @Resource
    private TyJytjbbService tyJytjbbService;

    @ApiOperation(value = "交易统计_成交统计表-分页查询", notes = "交易统计_成交统计表-分页查询")
    @PostMapping(value = "/sjcbcjPage")
    public ResponseWrapper insertTradeMark(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                           @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                           @RequestBody TyJytjbb vo) {
        try {
            return ResponseWrapper.success(tyJytjbbService.selectContractPage(pageNum, pageSize, vo));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 市级储备成交统计表
    @ApiOperation(value = "交易统计_成交统计表-市级储备成交统计表", notes = "交易统计_成交统计表-市级储备成交统计表")
    @PostMapping(value = "/sjcbcj")
    public ResponseWrapper sjcbcj(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc) {
        try {
            return ResponseWrapper.success(tyJytjbbService.sjcbcj(apcc));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 市级储备成交统计表报表导出
    @ApiOperation(value = "交易统计_成交统计表-市级储备成交统计表报表导出", notes = "交易统计_成交统计表-市级储备成交统计表报表导出")
    @PostMapping(value = "/sjcbcjExport")
    public ResponseWrapper sjcbcjExport(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc) {
        try {
            return tyJytjbbService.sjcbcjExport(apcc);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 手续费统计表
    @ApiOperation(value = "交易统计_成交统计表-手续费统计表", notes = "交易统计_成交统计表-手续费统计表")
    @PostMapping(value = "/sxfTj")
    public ResponseWrapper sxfTj(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc) {
        try {
            return ResponseWrapper.success(tyJytjbbService.sxfTj(apcc));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 市级储备成交统计表报表导出
    @ApiOperation(value = "交易统计_成交统计表-手续费统计表报表导出", notes = "交易统计_成交统计表-手续费统计表报表导出")
    @PostMapping(value = "/sxfExport")
    public ResponseWrapper sxfExport(@ApiParam(name = "apcc", value = "场次", required = true) @RequestParam(value = "apcc") String apcc) {
        try {
            return ResponseWrapper.success(tyJytjbbService.sxfExport(apcc));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    //交易结果汇总表-分页列表
    @ApiOperation(value = "交易结果汇总表-分页列表", notes = "参数：交易日期")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageSize", value = "分页大小", dataType = "int", paramType = "query"),
            @ApiImplicitParam(name = "pageNum", value = "当前页", dataType = "int", paramType = "query")
    })
    @PostMapping(value = "/selectTurnoverEndPageList")
    public ResponseWrapper jyjghz(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum
            , @RequestParam(value = "pageSize", defaultValue = "10") int pageSize
            , @RequestParam(value = "cjrqks", required = false) String cjrqks
            , @RequestParam(value = "cjrqjs", required = false) String cjrqjs
    ) {
        try {
            return ResponseWrapper.success(tyJytjbbService.jyjghz(pageNum, pageSize, cjrqks, cjrqjs));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 交易结果汇总表导出为word文件
    @ApiOperation(value = "交易结果汇总表报表导出", notes = "交易结果汇总表报表导出")
    @PostMapping(value = "/jyjgExport")
    public ResponseWrapper jyjgExport(@RequestParam(value = "cjrqks", required = false) String cjrqks
            , @RequestParam(value = "cjrqjs", required = false) String cjrqjs) {
        try {
            return ResponseWrapper.success(tyJytjbbService.jyjgExport(cjrqks, cjrqjs));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 地储数据记录表分页列表查询
    @ApiOperation(value = "地储数据记录表分页列表查询", notes = "地储数据记录表分页列表查询")
    @PostMapping(value = "/selectDcjlPage")
    public ResponseWrapper selectDcjlPage(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                          @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                          @RequestBody TyDcsjjl vo) {
        try {
            return ResponseWrapper.success(tyJytjbbService.selectDcjlPage(pageNum, pageSize, vo));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 地储数据记录表导出
    @ApiOperation(value = "地储数据记录表导出", notes = "地储数据记录表导出")
    @PostMapping(value = "/dcjlExport")
    public ResponseWrapper dcjlExport(@RequestBody TyDcsjjl vo) {
        try {
            return ResponseWrapper.success(tyJytjbbService.dcjlExport(vo));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 地储交易汇总表分页列表查询
    @ApiOperation(value = "地储交易汇总表分页列表查询", notes = "地储交易汇总表分页列表查询")
    @PostMapping(value = "/selectDcjyhzPage")
    public ResponseWrapper selectDcjyhzPage(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                            @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                            @RequestBody DcJyHzzb vo) {
        try {
            return ResponseWrapper.success(tyJytjbbService.selectDcjyhzPage(pageNum, pageSize, vo));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 地储交易汇总表导出
    @ApiOperation(value = "地储交易汇总表导出", notes = "地储交易汇总表导出")
    @PostMapping(value = "/dcjyhzExport")
    public ResponseWrapper dcjyhzExport(@RequestBody DcJyHzzb vo) {
        try {
            return ResponseWrapper.success(tyJytjbbService.dcjyhzExport(vo));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

    // 保存或修改地储交易统计备注信息
    @ApiOperation(value = "保存或修改地储交易统计备注信息", notes = "保存或修改地储交易统计备注信息")
    @PostMapping(value = "/saveOrUpdateDcjybzxx")
    public ResponseWrapper saveOrUpdateDcjybzxx(@RequestBody Dcjybzxx vo) {
        try {
            return ResponseWrapper.success(tyJytjbbService.saveOrUpdateDcjybzxx(vo));
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseWrapper.error(e.getMessage());
        }
    }

}
