package com.unis.transaction.server.dao;

import com.unis.transaction.common.vo.tradeplan.EntryAndExitOrderGoodsDO;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import tk.mybatis.mapper.common.Mapper;

import java.util.List;

/**
 * @author by PIG
 * 2022/8/22 16
 */
public interface EntryAndExitOrderGoodsDao extends Mapper<EntryAndExitOrderGoodsDO> {

    @Delete("delete from ty_jycrkwt_hw where wtbm = #{wtbm}")
    int deleteByWtbm(@Param("wtbm") String wtbm);

    @Select("<script>" +
            "select wtbm, pzmc from ty_jycrkwt_hw where wtbm in " +
            "<foreach collection='wtbmList'  item='item' open='(' close=')' separator=','>" +
            "  #{item,jdbcType=VARCHAR}" +
            "</foreach>" +
            "group by wtbm, pzmc" +
            "</script>")
    List<EntryAndExitOrderGoodsDO> listGroupPzmcByWtbm(@Param("wtbmList") List<String> wtbmList);
}
