/*
 * GiveBackBailLetterDao.java
 * 版权所有 © 2011-2017 北京神舟良实信息技术有限公司
 * Copyright © 2011-2017 All Rights Reserved    京ICP备13013562号
 * 2019-09-20 21:04:21 created by lipenghe with LAPTOP-IJQ2SDFV
 */
package com.unis.transaction.server.dao;

import com.github.pagehelper.Page;
import com.unis.transaction.common.vo.givebackbail.GiveBackBailLetterVO;
import com.unis.transaction.server.entity.givebackbail.GiveBackBailLetterDO;
import tk.mybatis.mapper.common.Mapper;

import java.util.List;

/**
 * TY_JYTKWTH-退保证金委托函
 * @author lipenghe at 2019-09-20 21:04:21
 */
public interface GiveBackBailLetterDao extends Mapper<GiveBackBailLetterDO> {
    /**
     * <TY_JYTKWTH-退保证金委托函>插入全部字段(会覆盖数据库默认值)
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int insertEntity(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>选择性插入字段,只插入非空的属性对应的字段
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int insertEntitySelective(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>更改数据状态
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int updateStatusByEntity(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体更新单条或者多条数据(会覆盖数据库默认值)
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int updateByEntity(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体更新单条或者多条数据,只更新非空的属性对应的字段
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int updateByEntitySelective(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体单条或者批量删除
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int deleteByEntity(GiveBackBailLetterVO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体单条或者批量删除
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int deleteByEntity(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体假删除,根据实体属性单条
     *      或批量删除只是改变了状态不在页面显示,数据仍存在
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int deleteShamByEntity(GiveBackBailLetterVO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体查询数量
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    int selectCountByEntity(GiveBackBailLetterVO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体(唯一标示)查询一条数据
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    GiveBackBailLetterVO selectById(GiveBackBailLetterVO entity);

    /**
    * <TY_JYTKWTH-退保证金委托函>根据实体(唯一标示)查询一条数据
    * @param entity    <退保证金委托函>对象
    * @author lipenghe with LAPTOP-IJQ2SDFV
    */
    GiveBackBailLetterVO selectById(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体查询分页列表
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    Page<GiveBackBailLetterVO> selectPageByEntity(GiveBackBailLetterVO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体查询列表
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    List<GiveBackBailLetterVO> selectByEntity(GiveBackBailLetterVO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>根据实体查询列表
     * @param entity     <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    List<GiveBackBailLetterVO> selectByEntity(GiveBackBailLetterDO entity);

    List<GiveBackBailLetterVO> selectHt( GiveBackBailLetterVO giveBackBailLettervo);

    List<GiveBackBailLetterVO> selectYfsHt(GiveBackBailLetterVO giveBackBailLetterDO);
}