package com.unis.transaction.server.dao;

import com.github.pagehelper.Page;
import com.unis.transaction.common.vo.signuppay.SceneVO;
import com.unis.transaction.common.vo.signuppay.TransactionSignUpVO;
import com.unis.transaction.server.entity.signuppay.TransactionSignUpDO;
import org.apache.ibatis.annotations.Param;
import tk.mybatis.mapper.common.Mapper;

import java.util.List;

/**
 * 交易报名
 * @author lidiaoquan at 2019-09-20
 */
public interface TransactionSignUpDao extends Mapper<TransactionSignUpDO>{

    public List<TransactionSignUpDO> selectList(TransactionSignUpVO vo);

    public Page<TransactionSignUpVO> selectPageList(TransactionSignUpVO vo);

    public TransactionSignUpVO selectDetail(TransactionSignUpVO vo);

    public int insert(TransactionSignUpDO transactionsignup);


    public int delete(TransactionSignUpDO transactionsignup);

    //获取场次列表
    public List<SceneVO> selectSceneList(TransactionSignUpDO transactionsignup);

	public List<TransactionSignUpDO> selectListNotInGiveBackBail(TransactionSignUpVO vo);

	//根据apcc修改退款状态
	public void updateSignUpTkzt(TransactionSignUpDO transactionsignup);

    TransactionSignUpDO selectTransByCcbm(@Param("ccbm") String ccbm, @Param("userId")String userId);

    Page<TransactionSignUpVO> selectPageLists(TransactionSignUpVO vo);

    Page<TransactionSignUpVO> selectTransactionSignPageList(TransactionSignUpVO vo);

    List<TransactionSignUpVO> selectTransactionSignUpList();

    List<TransactionSignUpDO> selectListByCC(String ccbm);

    List<TransactionSignUpDO> selectLists(TransactionSignUpVO vo);

    /**
     *
     * @param dwmc 报名单位
     * @param ccbm 场次编码
     * @return
     */
    TransactionSignUpDO selectByDwbmAndCcbm(@Param("dwmc")String dwmc, @Param("ccbm")String ccbm);

    List<TransactionSignUpVO> selectDwbmList(@Param("ccbm")String ccbm, @Param("shzt")String shzt);

    List<TransactionSignUpDO> selectSiteAll(TransactionSignUpVO vo);

    Page<TransactionSignUpVO> selectTranPageList(TransactionSignUpVO vo);

    List<TransactionSignUpDO> selectSiteAllNotice(TransactionSignUpVO vo);

    List<TransactionSignUpVO> selectSkztList(@Param("ccbm")String ccbm, @Param("skzt")String skzt);

    List<TransactionSignUpVO> selectSkztListNew(TransactionSignUpVO transaction);

    String getGqsj(String ccbm);

    TransactionSignUpVO getSignUpBeforeDataCcbm(String ccbm);

    String selectdwbmByTyshxydm(String tyshxydm);
}
