package com.unis.transaction.server.domain.creditevaluate;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.utils.EntityUtil;
import com.unis.transaction.common.utils.JsonUtils;
import com.unis.transaction.common.vo.creditevaluate.EnterPriseClassVariableVO;
import com.unis.transaction.server.dao.EnterPriseClassVariableDao;
import com.unis.transaction.server.entity.creditevaluate.EnterPriseClassVariableDO;
import com.unis.transaction.server.service.impl.BaseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 企业分级变量维护业务
 * @author lidiaoquan at 2019-09-26
 */
@Component
public class EnterPriseClassVariableDomain{

    @Autowired
    EnterPriseClassVariableDao enterpriseclassvariableDao;
    
    @Autowired
    BaseRepository baseMapper;
        
	/**
   	  * 通用的插入处理Calendar.getInstance().get(Calendar.YEAR)
     * @param entity <企业分级变量维护>
     */
    private void buildInsertData(EnterPriseClassVariableDO entity){
        entity.buildInsertData();
        String pk= baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(EnterPriseClassVariableDO.class)
        ,"blbm", "BL", 8);
        entity.setBlbm(pk);
    }
    
   /**
       * 通用的更新处理
    * @param entity
    */
    private void buildUpdateData(EnterPriseClassVariableDO entity){
        entity.buildUpdateData();
    }
    
    /**
     * <企业分级变量维护>插入全部字段
     * @author lidiaoquan
     */
    public int insertEntity(EnterPriseClassVariableDO entity) {
        buildInsertData(entity);
        return enterpriseclassvariableDao.insertSelective(entity);
    }
    
    /**
     * <企业分级变量维护>非null的修改
     * @author lidiaoquan
     */
    public int updateEntity(EnterPriseClassVariableDO entity) {
        buildUpdateData(entity);
        return enterpriseclassvariableDao.updateByPrimaryKeySelective(entity);
    }
    
	//企业分级变量维护-新增
    public ResponseWrapper insertEnterPriseClassVariable(EnterPriseClassVariableVO vo){
        EnterPriseClassVariableDO entity=JsonUtils.parse(
            JsonUtils.serialize(vo),EnterPriseClassVariableDO.class);
        int num= insertEntity(entity);
        return ResponseWrapper.choose(num);		 
    }

	//企业分级变量维护-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateEnterPriseClassVariable(EnterPriseClassVariableVO vo,java.lang.Integer updateType){
        EnterPriseClassVariableDO entity=JsonUtils.parse(
            JsonUtils.serialize(vo),EnterPriseClassVariableDO.class);
   		int num = updateEntity(entity);
        return ResponseWrapper.choose(num);
	}
	
	//企业分级变量维护-分页列表
    public Page<EnterPriseClassVariableVO> selectEnterPriseClassVariablePageList(int pageNum, int pageSize, EnterPriseClassVariableVO vo){
 		PageHelper.startPage(pageNum,pageSize);
  		Page<EnterPriseClassVariableVO> selectPageList = enterpriseclassvariableDao.selectPageList(vo);
        return selectPageList;		
    }

	//企业分级变量维护-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectEnterPriseClassVariableAll(EnterPriseClassVariableVO vo){
		List<EnterPriseClassVariableDO> enterpriseclassvariableDOList=enterpriseclassvariableDao.selectList(vo);
        List<EnterPriseClassVariableVO> voList=JsonUtils.parse(
            JsonUtils.serialize(enterpriseclassvariableDOList),List.class);
        return ResponseWrapper.success(voList);
    }

	//企业分级变量维护--查看--返回单条
    public ResponseWrapper selectEnterPriseClassVariableDetail(EnterPriseClassVariableVO vo){
		EnterPriseClassVariableVO selectById = enterpriseclassvariableDao.selectDetail(vo);
        return ResponseWrapper.success(selectById);   
    }

}
