package com.unis.transaction.server.domain.creditevaluate;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.constant.RotatePlanStatusConstant;
import com.unis.transaction.common.utils.EntityUtil;
import com.unis.transaction.common.utils.JsonUtils;
import com.unis.transaction.common.utils.LocalDateUtils;
import com.unis.transaction.common.vo.creditevaluate.TurnoverDataVO;
import com.unis.transaction.server.dao.SiteDao;
import com.unis.transaction.server.dao.TradeMarkDao;
import com.unis.transaction.server.dao.TurnoverDataDao;
import com.unis.transaction.server.entity.creditevaluate.TurnoverDataDO;
import com.unis.transaction.server.entity.tradeplan.SiteDO;
import com.unis.transaction.server.service.impl.BaseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * 成交数据维护业务
 * @author lidiaoquan at 2019-09-26
 */
@Component
public class TurnoverDataDomain{

    @Autowired
    TurnoverDataDao turnoverdataDao;
    @Autowired
    TradeMarkDao tradeMarkDao;
    @Autowired
    SiteDao siteDao;
    @Autowired
    BaseRepository baseMapper;


        
	/**
   	  * 通用的插入处理Calendar.getInstance().get(Calendar.YEAR)
     * @param entity <成交数据维护>
     */
    private void buildInsertData(TurnoverDataDO entity){
        //entity.buildInsertData();
        String pk= baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(TurnoverDataDO.class)
        ,"cjbm", "CJ", 8);
        entity.setCjbm(pk);
    }
    
   /**
       * 通用的更新处理
    * @param entity
    */
    private void buildUpdateData(TurnoverDataDO entity){
        entity.buildUpdateData();
    }
    
    /**
     * <成交数据维护>插入全部字段
     * @author lidiaoquan
     */
    public int insertEntity(TurnoverDataDO entity) {
        buildInsertData(entity);
        return turnoverdataDao.insertSelective(entity);
    }
    
    /**
     * <成交数据维护>非null的修改
     * @author lidiaoquan
     */
    public int updateEntity(TurnoverDataDO entity) {
        buildUpdateData(entity);
        return turnoverdataDao.updateByPrimaryKeySelective(entity);
    }
    
	//成交数据维护-新增
    public ResponseWrapper insertTurnoverData(TurnoverDataVO vo){
        TurnoverDataDO entity=JsonUtils.parse(
            JsonUtils.serialize(vo),TurnoverDataDO.class);
        entity.setSjlx("1");
        if(RotatePlanStatusConstant.WG.equals(vo.getZtbm())){
            turnoverdataDao.updateHxdfByDwbm(vo.getCjdwbm(),null);
            entity.setHxzf(new BigDecimal("0"));
        }else if(RotatePlanStatusConstant.WY.equals(vo.getZtbm())){
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Calendar c = Calendar.getInstance();
            c.setTime(new Date());
            c.add(Calendar.YEAR, -1);
            Date y = c.getTime();
            String year = format.format(y);
            c.set(Calendar.YEAR, Integer.valueOf(year));
            Date date = c.getTime();
            turnoverdataDao.updateHxdfByDwbm(vo.getCjdwbm(),date);
            entity.setHxzf(new BigDecimal("0"));
        }else{
            TurnoverDataVO turnoverDataVO = new TurnoverDataVO();
            turnoverDataVO.setCjdwbm(vo.getCjdwbm());
            List<TurnoverDataVO> turnoverDataVOS = turnoverdataDao.selectZtbmByDwbm(turnoverDataVO);
            if(turnoverDataVOS!=null&&turnoverDataVOS.size()>0){
                entity.setHxzf(turnoverDataVOS.get(0).getHxzf().add(vo.getHxdf()));
                turnoverdataDao.updateHxzfByDwbm(entity);
            }else{
                String je = vo.getCjje().toString();
                BigDecimal hxzf = new BigDecimal(vo.getA()+vo.getB()*(Float.valueOf(je))/vo.getC()).add(new
                        BigDecimal("2"));
                /*BigDecimal hxzf =vo.getCjje().divide(new BigDecimal("7500"),2, BigDecimal.ROUND_HALF_UP).multiply(new
                        BigDecimal("2")).add(new
                        BigDecimal("0.02")).add(new
                        BigDecimal("2"));*/
                entity.setHxzf(hxzf);
                turnoverdataDao.updateHxzfByDwbm(entity);
            }
        }
        int num= insertEntity(entity);


        return ResponseWrapper.choose(num);		 
    }
    public ResponseWrapper insertTurnoverDataImp(TurnoverDataVO vo) {
        TurnoverDataDO entity=JsonUtils.parse(
                JsonUtils.serialize(vo),TurnoverDataDO.class);
        entity.setSjlx("1");
        TurnoverDataVO turnoverDataVO = new TurnoverDataVO();
        turnoverDataVO.setCjdwbm(vo.getCjdwbm());
        List<TurnoverDataVO> turnoverDataVOS = turnoverdataDao.selectZtbmByDwbm(turnoverDataVO);
        if(turnoverDataVOS!=null&&turnoverDataVOS.size()>0){
            entity.setHxzf(turnoverDataVOS.get(0).getHxzf().add(vo.getHxdf()));
            turnoverdataDao.updateHxzfByDwbm(entity);
        }else{
           /* BigDecimal hxzf = new BigDecimal(vo.getA()).add(new BigDecimal(vo.getB()).multiply(vo.getCjje()).divide
                    (new BigDecimal(vo.getC()))).add(new
                    BigDecimal("2"));*/
            String je = vo.getCjje().toString();
            BigDecimal hxzf = new BigDecimal(vo.getA()+vo.getB()*(Float.valueOf(je))/vo.getC()).add(new
                    BigDecimal("2"));
           /* BigDecimal hxzf =vo.getCjje().divide(new BigDecimal("7500"),2, BigDecimal.ROUND_HALF_UP).multiply(new
                    BigDecimal("2")).add(new
                    BigDecimal("0.02")).add(new
                    BigDecimal("2"));*/
            entity.setHxzf(hxzf);
        }
        int num= insertEntity(entity);
        return ResponseWrapper.choose(num);
    }

	//成交数据维护-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateTurnoverData(TurnoverDataVO vo,java.lang.Integer updateType){
    	int num = 0;
    	//List<TurnoverDataStateVO> dataList = vo.getDataList();
    /*	//批量修改状态
		if(vo.getOperaterType() == 1 && dataList != null && dataList.size() > 0) {
    		for (TurnoverDataStateVO turnoverDataVO : dataList) {
    			TurnoverDataDO entity=JsonUtils.parse(JsonUtils.serialize(turnoverDataVO),TurnoverDataDO.class);
    			num = updateEntity(entity);
			}
    	}else {*/
    		TurnoverDataDO entity=JsonUtils.parse(JsonUtils.serialize(vo),TurnoverDataDO.class);
    		num = updateEntity(entity);
    	//}
    	if(RotatePlanStatusConstant.WG.equals(vo.getZtbm())){
            turnoverdataDao.updateHxdfByDwbm(vo.getCjdwbm(),null);
            entity.setHxzf(new BigDecimal("0"));
        }else if(RotatePlanStatusConstant.WY.equals(vo.getZtbm())){
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Calendar c = Calendar.getInstance();
            c.setTime(new Date());
            c.add(Calendar.YEAR, -1);
            Date y = c.getTime();
            String year = format.format(y);
            c.set(Calendar.YEAR, Integer.valueOf(year));
            Date date = c.getTime();
            entity.setHxzf(new BigDecimal("0"));
            turnoverdataDao.updateHxdfByDwbm(vo.getCjdwbm(),date);
        }
        return ResponseWrapper.choose(num);
	}


    //成交数据维护-分页列表
    public Page<TurnoverDataVO> selectTurnoverDataPageList(int pageNum, int pageSize, TurnoverDataVO vo){
 		PageHelper.startPage(pageNum,pageSize);
 		Page<TurnoverDataVO> selectPageList = null;
 		if(vo.getCjrqEnd()!=null){
            vo.setCjrqEnd(LocalDateUtils.localDateTime2Date(LocalDateUtils.getEndTime(vo.getCjrqEnd())));
        }
 		if(vo.getOperaterType() == 1) {
 			selectPageList = turnoverdataDao.selectCjdwSummayPageList(vo);
 		}else if(vo.getOperaterType() == 2) {
            selectPageList = turnoverdataDao.selectPageLists(vo);
        }else {
 			selectPageList = turnoverdataDao.selectPageList(vo);
 			if(selectPageList!=null&&selectPageList.size()>0){
                for(TurnoverDataVO dataVO:selectPageList){
                    SiteDO siteDO = siteDao.selectByPrimaryKey(dataVO.getCc());
                    dataVO.setTrsl(new BigDecimal(siteDO.getSl()));
                    dataVO.setLyl(dataVO.getCjsl().multiply(new BigDecimal("100")).divide(new BigDecimal(siteDO.getSl()),2,BigDecimal.ROUND_HALF_UP).toString());
                }
            }
 		}
        return selectPageList;		
    }

    public List<TurnoverDataVO> selectZtbmByDwbm(TurnoverDataVO turnoverDataVO) {
        return turnoverdataDao.selectZtbmByDwbm(turnoverDataVO);
    }

    //成交数据维护-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectTurnoverDataAll(TurnoverDataVO vo){
		List<TurnoverDataDO> turnoverdataDOList=turnoverdataDao.selectList(vo);
        List<TurnoverDataVO> voList=JsonUtils.parse(
            JsonUtils.serialize(turnoverdataDOList),List.class);
        return ResponseWrapper.success(voList);
    }

	//成交数据维护--查看--返回单条
    public ResponseWrapper selectTurnoverDataDetail(TurnoverDataVO vo){
    	TurnoverDataVO selectById = null;
    	if(vo.getOperaterType() == 1) {
    		selectById = turnoverdataDao.selectCjdwSummayDetail(vo);
    	}else {
    		selectById = turnoverdataDao.selectDetail(vo);
    	}
		return ResponseWrapper.success(selectById);   
    }

    public void updateHxzfByDwbm(TurnoverDataDO turnoverDataDO) {
        turnoverdataDao.updateHxzfByDwbm(turnoverDataDO);
    }

    public ResponseWrapper selectTurnoverDataImport(TurnoverDataVO vo) {
        if(vo.getCjrqEnd()!=null){
            vo.setCjrqEnd(LocalDateUtils.localDateTime2Date(LocalDateUtils.getEndTime(vo.getCjrqEnd())));
        }
        List<TurnoverDataVO> selectPageList = turnoverdataDao.selectPageList(vo);
        return ResponseWrapper.success(selectPageList);
    }


//    public  void excelModel(HttpServletResponse response, String bblxId) {
//        List<ReportTypeIndicatorVO> reportTypeIndicatorVOList = JSONArray.parseArray(JSONArray.toJSONString(res.get("list")),ReportTypeIndicatorVO.class);
//        if(reportTypeIndicatorVOList != null && reportTypeIndicatorVOList.size() > 0){
//            String nameFile = "Model";
//            //1.创建工作簿
//            XSSFWorkbook workbook = new XSSFWorkbook();
//            //2.创建工作表
//            XSSFSheet Sheet1 = workbook.createSheet("Sheet1");
//            //2.1加载合并单元格对象
//            //3.创建行
//            //3.1创建头标题行;并且设置头标题
//            XSSFRow row = Sheet1.createRow(0);
//
//            //3.2创建列标题;并且设置列标题
//
//            String[] titles = new String[reportTypeIndicatorVOList.size() + 1];
//            titles[0] = "时间";
//            for (int i = 0; i < reportTypeIndicatorVOList.size(); i++) {
//                if(reportTypeIndicatorVOList.get(i).getJlbz() != null){
//                    titles[i + 1] = reportTypeIndicatorVOList.get(i).getPzmc() + "(" + reportTypeIndicatorVOList.get(i).getJlbz() + ")";
//                }else{
//                    titles[i + 1] = reportTypeIndicatorVOList.get(i).getPzmc();
//                }
//            }
//            for(int i=0;i<titles.length;i++) {
//                XSSFCell cell2 = row.createCell(i);
//                //加载单元格样式
//                cell2.setCellValue(titles[i]);
//            }
//            //设置第一列格式为文本
//            XSSFCellStyle style1 = workbook.createCellStyle();
//            DataFormat format = workbook.createDataFormat();style1.setDataFormat(format.getFormat("@"));
//            row.getCell(0).setCellStyle(style1);
//            try {
//                export(nameFile,workbook,response);
//            } catch (IOException e) {
//                e.printStackTrace();
//            }
//        }
//
//    }
//
//    
//    //导出excel
//    public static void export(String fileName, XSSFWorkbook workbook, HttpServletResponse response) throws IOException {
//        OutputStream os = null;
//        try {
//            fileName = new String(fileName.getBytes(), "iso8859-1")  + ".xlsx";
//            os = response.getOutputStream();// 取得输出流
//            response.reset();// 清空输出流   +
//            response.setContentType("application/x-download");
//            response.addHeader("Content-Disposition", "attachment;filename=" + fileName );
//            response.setCharacterEncoding("UTF-8");
//            workbook.write(os);
//            os.flush();
//            os.close();
//        } catch (FileNotFoundException e) {
//            e.printStackTrace();
//        }
//    }
//    
//    //导入
//    public ResponseWrapper excelInput(MultipartFile file, String bblxId) {
//        try {
//            Integer total = 0;
//            Integer success = 0;
//            Integer fail = 0;
//            FileInputStream fis = (FileInputStream) file.getInputStream();
//            LinkedHashMap<String, String> alias = new LinkedHashMap<>();
//            alias.put("时间", "month");
//
//            List<ReportTypeIndicatorVO> reportTypeIndicatorVOList = JSONArray.parseArray(JSONArray.toJSONString(res.get("list")),ReportTypeIndicatorVO.class);
//            //获取价格类型对应月报表的价格类型
//            ResponseWrapper wrapper1 = feign.monthPriceType(bblxId);
//            System.out.println(JSONArray.toJSONString(wrapper1));
//            String priceType = (String) JSONObject.parseObject(JSONArray.toJSONString(wrapper1)).get("data");
//            for (int i = 0; i < reportTypeIndicatorVOList.size(); i++) {
//                if(reportTypeIndicatorVOList.get(i).getJlbz() != null){
//                    alias.put(reportTypeIndicatorVOList.get(i).getPzmc() + "(" + reportTypeIndicatorVOList.get(i).getJlbz() + ")",reportTypeIndicatorVOList.get(i).getZbbm() + reportTypeIndicatorVOList.get(i).getJlbzbm());
//                }else{
//                    alias.put(reportTypeIndicatorVOList.get(i).getPzmc(),reportTypeIndicatorVOList.get(i).getZbbm());
//                }
//
//            }
//            List<Map<String, Object>> ls = null;
//            try {
//                ls = ExcelUtil.excel2Pojo(fis, alias);
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//            // 转换成json
//            String compJson = JSONArray.toJSONString(ls);
//            List<Map> reportList = (List<Map>)JSONArray.parseArray(compJson,Map.class);
//            if(reportList != null && reportList.size() > 0){
//                for (int i = 0; i < reportList.size(); i++) {
//                    ++total;
//                    String time = (String)reportList.get(i).get("month");
//                    SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
//                    if(count != null && count > 0){
//                        //失败数加1
//                        ++fail;
//                    }else {
//                        //3.不存在 则执行新增操作
//                        ++success;
//                        ReportRecordInfoVO reportRecordInfoVO = new ReportRecordInfoVO();
//                        feign.saveOne(reportRecordInfoVO);
//                    }
//                }
//            }
//            Map<String,Object> resultMap= new HashMap<>();
//            resultMap.put("total",total);
//            resultMap.put("fail",fail);
//            resultMap.put("success",success);
//            return ResponseWrapper.success(HttpStatus.OK.value(), HttpStatus.OK.getReasonPhrase(), resultMap);
//        } catch (Exception e) {
//            e.printStackTrace();
//            return ResponseWrapper.error(HttpStatus.INTERNAL_SERVER_ERROR.value(),HttpStatus.INTERNAL_SERVER_ERROR.getReasonPhrase(),"导入失败");
//
//        }
//    }

}
