package com.unis.transaction.server.domain.creditevaluate;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.utils.JsonUtils;
import com.unis.transaction.common.vo.creditevaluate.TurnoverEndVO;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import com.unis.transaction.common.vo.tradeplan.SxfVO;
import com.unis.transaction.server.dao.*;
import com.unis.transaction.server.entity.creditevaluate.TurnoverEndDO;
import com.unis.transaction.server.entity.signuppay.TransactionSignUpDO;
import com.unis.transaction.server.entity.tradeplan.*;
import com.unis.transaction.server.service.impl.BaseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.*;

@Component
public class TurnoverEndDomain {
    @Autowired
    TurnoverEndDao turnoverEndDao;
    @Autowired
    BaseRepository baseMapper;
    @Autowired
    TradeMarkDao tradeMarkDao;
    @Autowired
    SiteDao siteDao;
    @Autowired
    EntryAndExitOrderDao entryAndExitOrderDao;
    @Autowired
    TransactionSignUpDao transactionSignUpDao;

    @Resource
    TyJyccKhxxDao tyJyccKhxxDao;

    public TurnoverEndDO selectTurnoverEndByCcbm(String ccbm) {
        return turnoverEndDao.selectTurnoverEndByCcbm(ccbm);
    }

    public int insert(TurnoverEndDO turnoverEndDO) {
        int num = turnoverEndDao.insertSelective(turnoverEndDO);
        return num;
    }

    public ResponseWrapper updateTurnoverEnd(TurnoverEndVO vo) {
        TurnoverEndDO entity= JsonUtils.parse(
                JsonUtils.serialize(vo),TurnoverEndDO.class);
        int num = turnoverEndDao.updateByPrimaryKeySelective(entity);
        return ResponseWrapper.choose(num);
    }

    public Page<TurnoverEndVO> selectTurnoverEndPageList(int pageNum, int pageSize, TurnoverEndVO vo) {
        PageHelper.startPage(pageNum,pageSize);
        Page<TurnoverEndVO> selectPageList = turnoverEndDao.selectTurnoverEndPageList(vo);
        return selectPageList;
    }

    public ResponseWrapper selectTurnoverEndDetail(TurnoverEndVO vo) {
        TurnoverEndDO endDO = turnoverEndDao.selectByPrimaryKey(vo.getJgbm());
        return ResponseWrapper.success(endDO);
    }

    public Page<TurnoverEndVO> selectTurnoverSxfPageList(int pageNum, int pageSize, TurnoverEndVO vo) {
        PageHelper.startPage(pageNum,pageSize);
        Page<TurnoverEndVO> selectPageList = turnoverEndDao.selectTurnoverSxfPageList(vo);
        return selectPageList;
    }

    public ResponseWrapper selectTurnoverSxfDetail(TurnoverEndVO vo) {
        TurnoverEndDO endDO = turnoverEndDao.selectByPrimaryKey(vo.getJgbm());
        SiteDO siteDO = siteDao.selectByPrimaryKey(endDO.getCcbm());
        LinkedList<SxfVO> linkedList = null;
        List<TradeMarkDO> tradeMarkDOS = tradeMarkDao.selectListByCcbm(siteDO.getCcbm());
        List<String> bdjh = new ArrayList<>();
        for(TradeMarkDO tradeMarkDO:tradeMarkDOS){
            bdjh.add(tradeMarkDO.getBdbm());
        }
        //最低和最高成交价 合同里面的价格
        SiteVO siteVO = new SiteVO();
        siteVO.setHtList(bdjh);
        String cjsl = tradeMarkDao.getCjsl(siteVO);
        String cjje = tradeMarkDao.getCjje(siteVO);
        if("0".equals(endDO.getSxflx())){//双边0
            linkedList = getData(endDO,siteDO,siteVO);
            SxfVO sxfVO = new SxfVO();
            sxfVO.setSxf(new BigDecimal(siteDO.getSxfl()).multiply(new BigDecimal(cjsl)).toString());
            sxfVO.setSl(cjsl);
            sxfVO.setCjje(cjje);
            sxfVO.setCjdw(endDO.getWtfmc());
            sxfVO.setHtbh("委托方");
            linkedList.add(sxfVO);
        }else if("1".equals(endDO.getSxflx())){//委托方1
            linkedList = new LinkedList<>();
            SxfVO sxfVO = new SxfVO();
            sxfVO.setSxf(new BigDecimal(siteDO.getSxfl()).multiply(new BigDecimal(cjsl)).toString());
            sxfVO.setSl(cjsl);
            sxfVO.setCjje(cjje);
            sxfVO.setCjdw(endDO.getWtfmc());
            sxfVO.setHtbh("委托方");
            linkedList.add(sxfVO);
        }else{
            linkedList = getData(endDO,siteDO,siteVO);
        }
        return ResponseWrapper.success(linkedList);
    }

    private LinkedList<SxfVO> getData(TurnoverEndDO endDO,SiteDO siteDO,SiteVO siteVO) {
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteDO.getWtbm());
        List<ContractDO> list = null;
        if("0".equals(endDO.getJylx())){ //cmmc,cmdw
            list = tradeMarkDao.selectContractByCmmc(siteVO);
        }else{
            list = tradeMarkDao.selectContractBySgmc(siteVO);
        }
        LinkedList<SxfVO> linkedList = new LinkedList<>();
        for(ContractDO contractDO:list){
            SxfVO sxfVO = new SxfVO();
            TransactionSignUpDO transactionSignUpDO = null;
            List<TyJyccKhxx> khxxList = tyJyccKhxxDao.selectKhxxByWtbh(siteDO.getWtbm());
            TyJyccKhxx tyJyccKhxx = new TyJyccKhxx();
            if("0".equals(endDO.getJylx())){
                sxfVO.setCjdw(contractDO.getCmmc());
                tyJyccKhxx = khxxList.stream().filter(tyJyccKhxx1 -> contractDO.getCmmc().equals(tyJyccKhxx1.getKhmc())).findFirst().get();
                transactionSignUpDO = transactionSignUpDao.selectByDwbmAndCcbm(contractDO.getCmmc(),endDO.getCcbm());
            }else{
                sxfVO.setCjdw(contractDO.getSgmc());
                tyJyccKhxx = khxxList.stream().filter(tyJyccKhxx1 -> contractDO.getSgmc().equals(tyJyccKhxx1.getKhmc())).findFirst().get();
                transactionSignUpDO = transactionSignUpDao.selectByDwbmAndCcbm(contractDO.getSgmc(),endDO.getCcbm());
            }
            sxfVO.setCjje(contractDO.getJe().toString());
            sxfVO.setDj(contractDO.getDj().toString());
            sxfVO.setSl(contractDO.getLssl().toString());
            sxfVO.setHtbh(contractDO.getHtbh());
            sxfVO.setJgrq(exitOrderDO.getJgrq());
            //sxfVO.setKqtbzj(transactionSignUpDO.getJkje()); //缴款额-总的冻结资金
            sxfVO.setSxf(new BigDecimal(siteDO.getSxfl()).multiply(contractDO.getLssl()).toString());  //场次的手续费率乘以合同的数量
            sxfVO.setDjzj(new BigDecimal(siteDO.getLybzj()).add(new BigDecimal(siteDO.getJybzj())).divide(new
                    BigDecimal(siteDO.getSl()),2, BigDecimal.ROUND_HALF_UP).multiply(contractDO.getLssl()).toString());
            //场次两个保证金相加除以场次数量在乘以合同数量
            if(tyJyccKhxx.getJyqbzj()!=null){
                sxfVO.setYjbzj(tyJyccKhxx.getJyqbzj()); //报名时候的缴款额
            }else{
                sxfVO.setYjbzj(0+""); //报名时候的缴款额
            }

            linkedList.add(sxfVO);
        }
        //冻结资金集合
        Map<String,String> map = new HashMap<>();
        for(SxfVO sxfVO:linkedList){
             if(map.get(sxfVO.getCjdw())!=null){
                 map.put(sxfVO.getCjdw(),new BigDecimal(map.get(sxfVO.getCjdw())).add(new BigDecimal(sxfVO.getDjzj())).toString());
             }else{
                 map.put(sxfVO.getCjdw(),sxfVO.getDjzj());
             }
        }
        for(SxfVO sxfVO:linkedList){
            sxfVO.setKqtbzj(new BigDecimal(sxfVO.getYjbzj()).subtract(new BigDecimal(map.get(sxfVO.getCjdw()))).toString());
        }
        return  linkedList;
    }
}
