package com.unis.transaction.server.domain.givebackbail;

import com.alibaba.fastjson.JSON;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.JsonUtils;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.constant.GiveBackBailConstant;
import com.unis.transaction.common.constant.PlanStatusConstant;
import com.unis.transaction.common.utils.EntityUtil;
import com.unis.transaction.common.vo.backlog.BacklogAddVO;
import com.unis.transaction.common.vo.backlog.BacklogUpdateVO;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import com.unis.transaction.common.vo.givebackbail.NoticeVO;
import com.unis.transaction.common.vo.signuppay.TransactionSignUpVO;
import com.unis.transaction.common.vo.tradeplan.ContractVO;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import com.unis.transaction.server.dao.*;
import com.unis.transaction.server.entity.givebackbail.NoticeDO;
import com.unis.transaction.server.entity.signuppay.TransactionSignUpDO;
import com.unis.transaction.server.entity.tradeplan.EntryAndExitOrderDO;
import com.unis.transaction.server.entity.tradeplan.SiteDO;
import com.unis.transaction.server.service.BacklogMQService;
import com.unis.transaction.server.service.impl.BaseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 交易申诉业务
 * @author lgd
 */
@Component
public class NoticeDomain {


    @Autowired
    NoticeDao noticeDao;

    @Autowired
    BaseRepository baseMapper;
    @Autowired
    BacklogMQService mqService;
    @Autowired
    TradeMarkDao tradeMarkDao;
    @Autowired
    SiteDao siteDao;
    @Autowired
    EntryAndExitOrderDao entryAndExitOrderDao;
    @Autowired
    TransactionSignUpDao transactionsignupDao;
    /**
     * 通用的插入处理Calendar.getInstance().get(Calendar.YEAR)
     */
    private void buildInsertData(NoticeDO entity){
        entity.buildInsertData();
        String pk= baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(NoticeDO.class)
                ,"tzbm", "TZ", 8);
        entity.setTzbm(pk);
    }

    /**
     * 通用的更新处理
     * @param entity
     */
    private void buildUpdateData(NoticeDO entity){
        entity.buildUpdateData();
    }

    /**
     * <交易申诉>插入全部字段
     * @author lgd
     */
    public int insertEntity(NoticeDO entity) {
        buildInsertData(entity);
        return noticeDao.insertSelective(entity);
    }

    /**
     * <交易申诉>非null的修改
     * @author lgd
     */
    public int updateEntity(NoticeDO entity) {
        buildUpdateData(entity);
        return noticeDao.updateByPrimaryKeySelective(entity);
    }
    public ResponseWrapper insertNotice(NoticeVO vo) {
        NoticeDO entity= JsonUtils.parse(
                JsonUtils.serialize(vo),NoticeDO.class);
        SiteDO siteDO = siteDao.selectByPrimaryKey(vo.getCcbm());
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteDO.getWtbm());
        String wtf = exitOrderDO.getWtfbm();
        String khf = "";
        if(wtf.equals(vo.getSgdw())){
            khf = vo.getCcdw();
        }else{
            khf = vo.getSgdw();
        }
        switch (vo.getFslx()) {
            case 0:
                entity.setCcdws(wtf);//
                entity.setWtzt("0");
                break;
            case 1:
                entity.setCcdws(wtf);
                entity.setWtzt("0");
                entity.setKhzt("0");
                entity.setSgdws(khf);
                break;
            case 2:
                entity.setSgdws(khf);
                entity.setKhzt("0");
                break;
            default:
                break;
        }
        entity.setCkzt(entity.getTzzt());
        entity.setCkztmc(entity.getTzztmc());
        int num= insertEntity(entity);
        if(num>0&&PlanStatusConstant.ISSUED.getValue().equals(vo.getTzzt())){
            BacklogAddVO record = new BacklogAddVO();
            record.buildAddVO(record);
            record.setItemQuery(vo.getItemQuery());
            record.setItemQueryHaveDone(vo.getItemQueryHaveDone());
            record.setItemUrlHaveDone(vo.getItemUrlHaveDone());
            record.setItemName("交易中心下发"+entity.getApcc() + "的交易通知待查收");
            record.setItemStatus(Integer.valueOf(vo.getTzzt()));
            record.setItemStatusName(vo.getTzztmc());
            record.setItemUrl(vo.getUrl());
            new Thread(new Runnable() {
                @Override
                public void run() {
                    if(vo.getUserMap()!=null&&vo.getUserMap().size()>0){
                        for (Map.Entry<String, List<ReceiverCollectionVO>> m : vo.getUserMap().entrySet()) {
                            for (ReceiverCollectionVO userVO : m.getValue()) {
                                System.out.println("********************接收人*******************");
                                System.out.println("-----" + userVO.getUserName() + "-------" + userVO.getUserId());
                                System.out.println("********************************************");
                                record.setItemId(entity.getTzbm()+"-"+m.getKey());
                                record.setReceiver(userVO.getUserName());
                                record.setReceiverId(userVO.getUserId());
                                mqService.sendMsg(JSON.parseObject(com.unis.transaction.common.utils.JsonUtils.serialize(record)), "insert");
                            }
                        }
                    }
                }
            }).start();
        }
        return ResponseWrapper.choose(num);
    }

    public ResponseWrapper updateNotice(NoticeVO vo) {
        NoticeDO entity=JsonUtils.parse(
                JsonUtils.serialize(vo),NoticeDO.class);
        SiteDO siteDO = siteDao.selectByPrimaryKey(vo.getCcbm());
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteDO.getWtbm());
        String wtf = exitOrderDO.getWtfbm();
        String khf = "";
        if(wtf.equals(vo.getSgdw())){
            khf = vo.getCcdw();
        }else{
            khf = vo.getSgdw();
        }
        if(PlanStatusConstant.ISSUED.getValue().equals(vo.getTzzt())){
            switch (vo.getFslx()) {
                case 0:
                    entity.setCcdws(wtf);//
                    entity.setWtzt(PlanStatusConstant.TO_BE_ISSUE.getValue());
                    break;
                case 1:
                    entity.setCcdws(wtf);
                    entity.setWtzt(PlanStatusConstant.TO_BE_ISSUE.getValue());
                    entity.setKhzt(PlanStatusConstant.TO_BE_ISSUE.getValue());
                    entity.setSgdws(khf);
                    break;
                case 2:
                    entity.setSgdws(khf);
                    entity.setKhzt(PlanStatusConstant.TO_BE_ISSUE.getValue());
                    break;
                default:
                    break;
            }
            entity.setCkzt(entity.getTzzt());
            entity.setCkztmc(entity.getTzztmc());
        }
        NoticeDO noticeDO = noticeDao.selectByPrimaryKey(vo.getTzbm());
        if(PlanStatusConstant.WBack.getValue().equals(vo.getTzzt())){
            entity.setWtzt(PlanStatusConstant.ISSUED.getValue());
           if(PlanStatusConstant.KBack.getValue().equals(noticeDO.getTzzt())){
               entity.setKhzt(PlanStatusConstant.ISSUED.getValue());
               entity.setTzzt(PlanStatusConstant.FINISHED.getValue());
               entity.setTzztmc("双方已反馈");
           }
        }
        if(PlanStatusConstant.KBack.getValue().equals(vo.getTzzt())){
            entity.setKhzt(PlanStatusConstant.ISSUED.getValue());
            if(PlanStatusConstant.WBack.getValue().equals(noticeDO.getTzzt())){
                entity.setWtzt(PlanStatusConstant.ISSUED.getValue());
                entity.setTzzt(PlanStatusConstant.FINISHED.getValue());
                entity.setTzztmc("双方已反馈");
            }
        }
        //修改查看状态
  /*      if(vo.getKhzt()!=null){
            if(PlanStatusConstant.ISSUED.getValue().equals(noticeDO.getCkzt())){
                entity.setCkzt(PlanStatusConstant.KBack.getValue());
                entity.setCkztmc("客户已查看");
            }else if(PlanStatusConstant.WBack.getValue().equals(noticeDO.getCkzt())){
                entity.setCkzt(PlanStatusConstant.FINISHED.getValue());
                entity.setCkztmc("双方已查看");
            }
        }
        if(vo.getWtzt()!=null){
            if(PlanStatusConstant.ISSUED.getValue().equals(noticeDO.getCkzt())){
                entity.setCkzt(PlanStatusConstant.WBack.getValue());
                entity.setCkztmc("委托方已查看");
            }else if(PlanStatusConstant.KBack.getValue().equals(noticeDO.getCkzt())){
                entity.setCkzt(PlanStatusConstant.FINISHED.getValue());
                entity.setCkztmc("双方已查看");
            }
        }*/
        int num = updateEntity(entity);
        //待办
        if(num>0) {
            if (PlanStatusConstant.ISSUED.getValue().equals(vo.getTzzt())) {
                BacklogAddVO record = new BacklogAddVO();
                record.buildAddVO(record);
                record.setItemQuery(vo.getItemQuery());
                record.setItemQueryHaveDone(vo.getItemQueryHaveDone());
                record.setItemUrlHaveDone(vo.getItemUrlHaveDone());
                record.setItemName("交易中心下发" + entity.getApcc() + "的交易通知待查收");
                record.setItemStatus(Integer.valueOf(vo.getTzzt()));
                record.setItemStatusName(vo.getTzztmc());
                record.setItemUrl(vo.getUrl());
                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        if (vo.getUserMap() != null && vo.getUserMap().size() > 0) {
                            for (Map.Entry<String, List<ReceiverCollectionVO>> m : vo.getUserMap().entrySet()) {
                                for (ReceiverCollectionVO userVO : m.getValue()) {
                                    System.out.println("********************接收人*******************");
                                    System.out.println("-----" + userVO.getUserName() + "-------" + userVO.getUserId());
                                    System.out.println("********************************************");
                                    record.setItemId(entity.getTzbm() + "-" + m.getKey());
                                    record.setReceiver(userVO.getUserName());
                                    record.setReceiverId(userVO.getUserId());
                                    mqService.sendMsg(JSON.parseObject(com.unis.transaction.common.utils.JsonUtils.serialize(record)), "insert");
                                }
                            }
                        }
                    }
                }).start();
            }

        //已办
        if(PlanStatusConstant.WBack.getValue().equals(vo.getTzzt())||PlanStatusConstant.KBack.getValue().equals(vo
                .getTzzt())){
            BacklogUpdateVO updateVO = new BacklogUpdateVO();
            updateVO.buildUpdateVO(updateVO);
            if(PlanStatusConstant.WBack.getValue().equals(vo.getTzzt())){
                updateVO.setItemId(vo.getTzbm()+"-"+wtf);
                updateVO.setItemName(entity.getApcc() + "的交易通知已反馈");
            }else if(PlanStatusConstant.KBack.getValue().equals(vo.getTzzt())){
                updateVO.setItemId(vo.getTzbm()+"-"+khf);
                updateVO.setItemName(entity.getApcc() + "的交易通知已反馈");
            }
            updateVO.setItemStatus(Integer.valueOf(vo.getTzzt()));
            updateVO.setItemStatusName(vo.getTzztmc());
            mqService.sendMsg(JSON.parseObject(com.unis.transaction.common.utils.JsonUtils.serialize(updateVO)), "update");
        }
        }
        return ResponseWrapper.choose(num);
    }

    public ResponseWrapper deleteNotice(NoticeVO vo) {
        int num = noticeDao.deleteByPrimaryKey(vo.getTzbm());
        return ResponseWrapper.choose(num);
    }

    public ResponseWrapper selectNoticeDetail(NoticeVO vo) {
        NoticeDO selectById = noticeDao.selectByPrimaryKey(vo.getTzbm());
        //修改查看状态
        if(vo.getKhzt()!=null){
            if(PlanStatusConstant.ISSUED.getValue().equals(selectById.getCkzt())){
                selectById.setCkzt(PlanStatusConstant.KBack.getValue());
                selectById.setCkztmc("客户已查看");
            }else if(PlanStatusConstant.WBack.getValue().equals(selectById.getCkzt())){
                selectById.setCkzt(PlanStatusConstant.FINISHED.getValue());
                selectById.setCkztmc("双方已查看");
            }
        }
        if(vo.getWtzt()!=null){
            if(PlanStatusConstant.ISSUED.getValue().equals(selectById.getCkzt())){
                selectById.setCkzt(PlanStatusConstant.WBack.getValue());
                selectById.setCkztmc("委托方已查看");
            }else if(PlanStatusConstant.KBack.getValue().equals(selectById.getCkzt())){
                selectById.setCkzt(PlanStatusConstant.FINISHED.getValue());
                selectById.setCkztmc("双方已查看");
            }
        }
        noticeDao.updateByPrimaryKeySelective(selectById);
        return ResponseWrapper.success(selectById);
    }

    public Page<NoticeVO> selectNoticePageList(int pageNum, int pageSize, NoticeVO vo) {
        PageHelper.startPage(pageNum,pageSize);
        List<String> ztList = new ArrayList<>();
        if(PlanStatusConstant.TO_BE_ISSUE.getValue().equals(vo.getPageType())){
            if(vo.getTzzt()==null){
                    ztList.add(PlanStatusConstant.FINISHED.getValue());
                    ztList.add(PlanStatusConstant.ISSUED.getValue());
                    ztList.add(PlanStatusConstant.WBack.getValue());
                    ztList.add(PlanStatusConstant.KBack.getValue());
                    ztList.add(PlanStatusConstant.TO_BE_ISSUE.getValue());
            }
        }else{
            if(vo.getTzzt()==null){
            ztList.add(PlanStatusConstant.FINISHED.getValue());
            ztList.add(PlanStatusConstant.WBack.getValue());
            ztList.add(PlanStatusConstant.KBack.getValue());
            ztList.add(PlanStatusConstant.ISSUED.getValue());
            }
        }
        if(ztList.size()>0){
            vo.setZtList(ztList);
        }
        Page<NoticeVO> selectPageList = null;
        if(PlanStatusConstant.TO_BE_ISSUE.getValue().equals(vo.getPageType())){
            selectPageList = noticeDao.selectPageList(vo);
        }else{
            vo.setCcdw(CurrentUtil.getOrgId());
            selectPageList = noticeDao.selectPageLists(vo);
        }
        return selectPageList;
    }

    public ResponseWrapper selectSiteAllNotice() {
        TransactionSignUpVO vo = new TransactionSignUpVO();
        vo.setZt(Integer.valueOf(GiveBackBailConstant.ZC.getValue()));
        List<TransactionSignUpDO> transactionsignupDOList=transactionsignupDao.selectSiteAllNotice(vo);
        return ResponseWrapper.success(transactionsignupDOList);
    }

    public ResponseWrapper selectContractNotice(String ccbm) {
        TransactionSignUpVO vo = new TransactionSignUpVO();
        vo.setDwbm(CurrentUtil.getOrgId());
        vo.setZt(Integer.valueOf(GiveBackBailConstant.ZC.getValue()));
        SiteVO siteVO = new SiteVO();
        siteVO.setCcbm(ccbm);
        siteVO.setZt(Integer.valueOf(GiveBackBailConstant.ZC.getValue()));
        List<ContractVO> list = tradeMarkDao.selectContractNotice(siteVO);
        return ResponseWrapper.success(list);
    }

    public ResponseWrapper getWtf(NoticeVO vo) {
        SiteDO siteDO = siteDao.selectByPrimaryKey(vo.getCcbm());
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteDO.getWtbm());
        String wtf = exitOrderDO.getWtfbm();
        return ResponseWrapper.success(200,"成功",wtf);
    }
}
