package com.unis.transaction.server.domain.signuppay;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.utils.EntityUtil;
import com.unis.transaction.common.utils.JsonUtils;
import com.unis.transaction.common.vo.signuppay.FeeRateVO;
import com.unis.transaction.server.dao.FeeRateDao;
import com.unis.transaction.server.entity.signuppay.FeeRateDO;
import com.unis.transaction.server.service.impl.BaseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 手续费率维护业务
 * @author lidiaoquan at 2019-09-19
 */
@Component
public class FeeRateDomain{

    @Autowired
    FeeRateDao feerateDao;
    
    @Autowired
    BaseRepository baseMapper;
        
	/**
   	  * 通用的插入处理Calendar.getInstance().get(Calendar.YEAR)
     * @param entity <手续费率维护>
     */
    private void buildInsertData(FeeRateDO entity){
        entity.buildInsertData();
        String pk= baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(FeeRateDO.class)
        ,"flbm", "FL", 8);
        entity.setFlbm(pk);
    }
    
   /**
       * 通用的更新处理
    * @param entity
    */
    private void buildUpdateData(FeeRateDO entity){
        entity.buildUpdateData();
    }
    
    /**
     * <手续费率维护>插入全部字段
     * @author lidiaoquan
     */
    public int insertEntity(FeeRateDO entity) {
        buildInsertData(entity);
        buildUpdateData(entity);
        return feerateDao.insertSelective(entity);
    }
    
    /**
     * <手续费率维护>非null的修改
     * @author lidiaoquan
     */
    public int updateEntity(FeeRateDO entity) {
        buildUpdateData(entity);
        return feerateDao.updateByPrimaryKeySelective(entity);
    }
    
	//手续费率维护-新增
    public ResponseWrapper insertFeeRate(FeeRateVO vo){
    	FeeRateVO param = new FeeRateVO();
    	param.setClxzbm(vo.getClxzbm());
    	param.setFbzt(1);
    	//FeeRateVO detail = feerateDao.selectDetail(param);
    	//默认新增的启用 其他的禁用
        FeeRateVO feeRateVO = new FeeRateVO();
        feeRateVO.setClxzbm(vo.getClxzbm());
        feeRateVO.setFbzt(0);
        feeRateVO.setFbztmc("禁用中");
        feerateDao.updateFeeRateStatus(feeRateVO);
    	/*if(detail != null) {
    		return ResponseWrapper.error(detail.getClxzmc() + "已启用，请先禁用！");
    	}*/
        FeeRateDO entity=JsonUtils.parse(
            JsonUtils.serialize(vo),FeeRateDO.class);
        int num= insertEntity(entity);
        return ResponseWrapper.choose(num);		 
    }

	//手续费率维护-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateFeeRate(FeeRateVO vo,java.lang.Integer updateType){

        //默认新增的启用 其他的禁用
        FeeRateVO feeRateVO = new FeeRateVO();
        feeRateVO.setClxzbm(vo.getClxzbm());
        feeRateVO.setFlbm(vo.getFlbm());
        if(vo.getFbzt()==1){
            feeRateVO.setFbzt(0);
            feeRateVO.setFbztmc("禁用中");
            feerateDao.updateFeeRateStatus(feeRateVO);
        }
        FeeRateDO entity=JsonUtils.parse(
                JsonUtils.serialize(vo),FeeRateDO.class);
   		int num = updateEntity(entity);
        return ResponseWrapper.choose(num);
	}
	
	//手续费率维护-分页列表
    public Page<FeeRateVO> selectFeeRatePageList(int pageNum, int pageSize, FeeRateVO vo){
 		PageHelper.startPage(pageNum,pageSize);
  		Page<FeeRateVO> selectPageList = feerateDao.selectPageList(vo);
        return selectPageList;		
    }

	//手续费率维护-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectFeeRateAll(FeeRateVO vo){
		List<FeeRateDO> feerateDOList=feerateDao.selectList(vo);
        List<FeeRateVO> voList=JsonUtils.parse(
            JsonUtils.serialize(feerateDOList),List.class);
        return ResponseWrapper.success(voList);
    }

	//手续费率维护--查看--返回单条
    public ResponseWrapper selectFeeRateDetail(FeeRateVO vo){
		FeeRateVO selectById = feerateDao.selectDetail(vo);
        return ResponseWrapper.success(selectById);   
    }

}
