package com.unis.transaction.server.domain.signuppay;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.constant.GiveBackBailConstant;
import com.unis.transaction.common.constant.RotatePlanStatusConstant;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.utils.EntityUtil;
import com.unis.transaction.common.vo.givebackbail.GiveBackVO;
import com.unis.transaction.common.vo.givebackbail.PassBackVO;
import com.unis.transaction.common.vo.tradeplan.ContractVO;
import com.unis.transaction.common.vo.tradeplan.EntryAndExitOrderVO;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import com.unis.transaction.server.dao.PassBackDao;
import com.unis.transaction.server.dao.SiteDao;
import com.unis.transaction.server.dao.TradeMarkDao;
import com.unis.transaction.server.dao.TransactionSignUpDao;
import com.unis.transaction.server.entity.creditevaluate.TurnoverEndDO;
import com.unis.transaction.server.entity.givebackbail.PassBackDO;
import com.unis.transaction.server.entity.signuppay.TransactionSignUpDO;
import com.unis.transaction.server.entity.tradeplan.SiteDO;
import com.unis.transaction.server.entity.tradeplan.TradeMarkDO;
import com.unis.transaction.server.service.EntryAndExitOrderService;
import com.unis.transaction.server.service.GiveBackService;
import com.unis.transaction.server.service.TradeMarkService;
import com.unis.transaction.server.service.TurnoverEndService;
import com.unis.transaction.server.service.impl.BaseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Component
public class SetDomain {
    @Autowired
    private TransactionSignUpDao transactionSignUpDao;
    @Autowired
    private TradeMarkDao tradeMarkDao;
    @Autowired
    private PassBackDao passBackDao;
    @Autowired
    private SiteDao siteDao;
    @Autowired
    BaseRepository baseMapper;
    @Autowired
    TurnoverEndService turnoverEndService;
    @Autowired
    private TradeMarkService tradeMarkService;
    @Autowired
    private GiveBackService giveBackService;

    @Autowired
    private EntryAndExitOrderService entryAndExitOrderService;

    public ResponseWrapper clickTransactionSignUp(String ccbm) {
        SiteDO up = siteDao.selectByPrimaryKey(ccbm);
        up.setWczt("已完成");
        siteDao.updateByPrimaryKey(up);
        List<GiveBackVO> list = giveBackService.selectGiveBackByCcbm(ccbm);
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        for (GiveBackVO giveBackVO : list) {
            EntryAndExitOrderVO exitOrderDO = entryAndExitOrderService.getEntryAndExitOrderDetail(giveBackVO.getWtbm());
            TransactionSignUpDO transactionSignUpDO = transactionSignUpDao.selectByPrimaryKey(giveBackVO.getJybm());
            //String dt1 = df.format(transactionSignUpDO.getGqsj());
            //String dt2 = df.format(new Date());
            // if (dt1.equals(dt2)) {
            // 判断合同中是否存在该记录
            List<ContractVO> contractVOList = null;
            if ("0".equals(exitOrderDO.getJyfx())) {
                contractVOList = tradeMarkDao.selectContractLists(transactionSignUpDO.getCcbm(), transactionSignUpDO.getDwbm());
            } else {
                contractVOList = tradeMarkDao.selectContractList(transactionSignUpDO.getCcbm(), transactionSignUpDO.getDwbm());
            }
            if (contractVOList != null && contractVOList.size() > 0) {
                transactionSignUpDO.setShztmc(RotatePlanStatusConstant.YCJ.getName());
                transactionSignUpDO.setShzt(RotatePlanStatusConstant.YCJ.getValue());
                transactionSignUpDao.updateByPrimaryKeySelective(transactionSignUpDO);
                //判断是否是部分成交
                String sum = "";
                if ("0".equals(exitOrderDO.getJyfx())) {
                    sum = tradeMarkDao.getTotalSum(transactionSignUpDO.getCcbm(), transactionSignUpDO.getDwbm());
                } else {
                    sum = tradeMarkDao.getTotalSums(transactionSignUpDO.getCcbm(), transactionSignUpDO.getDwbm());
                }
                if (new BigDecimal(up.getSl()).compareTo(new BigDecimal(sum)) == 0) {
                } else {
                    PassBackVO PassBackVO = new PassBackVO();
                    PassBackVO.setCcbm(transactionSignUpDO.getCcbm());
                    PassBackDO pass = passBackDao.selectDetail(PassBackVO);
                    if (pass != null) {
                    } else {
                        SiteDO vo = siteDao.selectByPrimaryKey(transactionSignUpDO.getCcbm());
                        PassBackDO passBackDO = new PassBackDO();
                        passBackDO.setApcc(vo.getApcc());
                        List<TradeMarkDO> lists = tradeMarkDao.selectListByCcbm(vo.getCcbm());
                        passBackDO.setBdsl(lists.size());
                        passBackDO.setCcbm(vo.getCcbm());
                        passBackDO.setJylx(giveBackVO.getJylx());
//                        passBackDO.setPzmc(exitOrderDO.getPzmc());
                        passBackDO.setJyrq(vo.getJyrq());
                        passBackDO.setJybzj(vo.getJybzj());
                        passBackDO.setLybzj(vo.getLybzj());
                        passBackDO.setSl(new BigDecimal(vo.getSl()));
                        passBackDO.setTkbm(giveBackVO.getTkbm());
                        passBackDO.setTksj(new Date());
                        passBackDO.setTkzt(GiveBackBailConstant.JYJB.getValue());
                        passBackDO.setTkztmc(GiveBackBailConstant.JYJB.getName());
                        passBackDO.setWtbm(transactionSignUpDO.getWtbm());
                        passBackDO.setWtfbm(transactionSignUpDO.getWtfbm());
                        passBackDao.insertSelective(passBackDO);
                    }
                }
            } else {
                giveBackVO.setTkzt(GiveBackBailConstant.JYJB.getValue());
                giveBackVO.setTkztmc(GiveBackBailConstant.JYJB.getName());
                giveBackVO.setTkfl(1);
                transactionSignUpDO.setShztmc(RotatePlanStatusConstant.WCJ.getName());
                transactionSignUpDO.setShzt(RotatePlanStatusConstant.WCJ.getValue());
                giveBackService.updateGiveEntity(giveBackVO);
                transactionSignUpDao.updateByPrimaryKeySelective(transactionSignUpDO);
                PassBackVO PassBackVO = new PassBackVO();
                PassBackVO.setCcbm(transactionSignUpDO.getCcbm());
                PassBackDO pass = passBackDao.selectDetail(PassBackVO);
                if (pass != null) {

                } else {
                    SiteDO vo = siteDao.selectByPrimaryKey(transactionSignUpDO.getCcbm());
                    PassBackDO passBackDO = new PassBackDO();
                    passBackDO.setApcc(vo.getApcc());
                    List<TradeMarkDO> lists = tradeMarkDao.selectListByCcbm(vo.getCcbm());
                    passBackDO.setBdsl(lists.size());
                    passBackDO.setCcbm(vo.getCcbm());
                    passBackDO.setJylx(giveBackVO.getJylx());
//                    passBackDO.setPzmc(exitOrderDO.getPzmc());
                    passBackDO.setJyrq(vo.getJyrq());
                    passBackDO.setJybzj(vo.getJybzj());
                    passBackDO.setLybzj(vo.getLybzj());
                    passBackDO.setSl(new BigDecimal(vo.getSl()));
                    passBackDO.setTkbm(giveBackVO.getTkbm());
                    passBackDO.setTksj(new Date());
                    passBackDO.setTkzt(GiveBackBailConstant.JYJB.getValue());
                    passBackDO.setTkztmc(GiveBackBailConstant.JYJB.getName());
                    passBackDO.setWtbm(transactionSignUpDO.getWtbm());
                    passBackDO.setWtfbm(transactionSignUpDO.getWtfbm());
                    passBackDao.insertSelective(passBackDO);
                }
            }
            // }
        }
        //添加交易结果
        //判断交易结果中是否存在
        List<GiveBackVO> cjList = giveBackService.selectGiveBackCjLists(ccbm);
        for (GiveBackVO giveBackVO : cjList) {
            EntryAndExitOrderVO exitOrderDO = entryAndExitOrderService.getEntryAndExitOrderDetail(giveBackVO.getWtbm());
            TransactionSignUpDO transactionSignUp = transactionSignUpDao.selectByPrimaryKey(giveBackVO.getJybm());
            TurnoverEndDO is = turnoverEndService.selectTurnoverEndByCcbm(transactionSignUp.getCcbm());
            if (is != null) {
            } else {
                TurnoverEndDO turnoverEndDO = new TurnoverEndDO();
                String pk = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(TurnoverEndDO.class) , "jgbm", "JG", 8);
                turnoverEndDO.setJgbm(pk);
                SiteDO siteDO = siteDao.selectByPrimaryKey(transactionSignUp.getCcbm());
                turnoverEndDO.setApcc(transactionSignUp.getApcc());
                turnoverEndDO.setCcbm(transactionSignUp.getCcbm());
                turnoverEndDO.setWtfmc(exitOrderDO.getWtfmc());
                turnoverEndDO.setJylx(exitOrderDO.getJyfx());
                turnoverEndDO.setJylxmc(exitOrderDO.getJyfxmc());
                if (siteDO.getJyxz() != null) {
                    turnoverEndDO.setJyxz(Integer.valueOf(siteDO.getJyxz()));
                }
                turnoverEndDO.setJyrq(exitOrderDO.getJyrq());
                turnoverEndDO.setJgrq(exitOrderDO.getJgrq());
//                turnoverEndDO.setPzmc(exitOrderDO.getPzmc());
//                turnoverEndDO.setPzbm(exitOrderDO.getPzbm());
//                turnoverEndDO.setLsxzbm(exitOrderDO.getLsxzbm());
//                turnoverEndDO.setLsxzmc(exitOrderDO.getLsxzmc());
                turnoverEndDO.setFbzt("0");
                turnoverEndDO.setFbztmc("待发布");
                //底价  每个标的的起报价 取最低的
                Double dj = tradeMarkService.getDj(siteDO.getCcbm());
                turnoverEndDO.setDj(String.valueOf(dj));
                //交易数量
                turnoverEndDO.setJysl(siteDO.getSl());
                //成交数量  所有合同的成交数量
                List<TradeMarkDO> tradeMarkDOS = tradeMarkDao.selectListByCcbm(siteDO.getCcbm());
                List<String> bdjh = new ArrayList<>();
                for (TradeMarkDO tradeMarkDO : tradeMarkDOS) {
                    bdjh.add(tradeMarkDO.getBdbm());
                }
                //最低和最高成交价 合同里面的价格
                SiteVO siteVO = new SiteVO();
                siteVO.setHtList(bdjh);
                String cjsl = tradeMarkDao.getCjsl(siteVO);
                turnoverEndDO.setCjsl(cjsl);
                String zdcjj = tradeMarkDao.getZdcjj(siteVO);
                turnoverEndDO.setZdcjj(zdcjj);
                String zgcjj = tradeMarkDao.getZgcjj(siteVO);
                turnoverEndDO.setZgcjj(zgcjj);
                String cjje = tradeMarkDao.getCjje(siteVO);
                turnoverEndDO.setJj(new BigDecimal(cjje).divide(new BigDecimal(cjsl), 2, BigDecimal.ROUND_HALF_UP).toString());
                turnoverEndDO.setSxfl(siteDO.getSxfl());
                turnoverEndDO.setSxflx(siteDO.getSxfType());
                turnoverEndDO.setCjl(new BigDecimal(cjsl).divide(new BigDecimal(siteDO.getSl()), 2, BigDecimal
                        .ROUND_HALF_UP).multiply(new BigDecimal("100")).toString());
                int num = turnoverEndService.insert(turnoverEndDO);
            }
        }
        return null;
    }

    public PageResult<SiteVO> selectClickList(int pageNum, int pageSize, SiteVO vo) {
        PageHelper.startPage(pageNum, pageSize);
        Page<SiteVO> selectPageList = tradeMarkDao.selectPageList(vo);
        List<SiteVO> result = selectPageList.getResult();
        //返回类型转换
        if (result != null && result.size() > 0) {
            for (SiteVO siteVO : result) {
                String gqsj = transactionSignUpDao.getGqsj(siteVO.getCcbm());
                siteVO.setGqsj(gqsj);
            }
            return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, result);
        }
        return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, new ArrayList<>());
    }
}
