package com.unis.transaction.server.domain.tradeplan;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.trs.web2frame.domain.DocumentMgr;
import com.trs.web2frame.entity.WDocument;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.DateUtil;
import com.unis.common.utils.RequestUtils;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.constant.*;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.utils.EntityUtil;
import com.unis.transaction.common.utils.HttpRequestUtil;
import com.unis.transaction.common.utils.JsonUtils;
import com.unis.transaction.common.vo.backlog.BacklogAddVO;
import com.unis.transaction.common.vo.backlog.BacklogUpdateVO;
import com.unis.transaction.common.vo.backlog.ReceiverCollectionVO;
import com.unis.transaction.common.vo.givebackbail.GiveBackBailLetterVO;
import com.unis.transaction.common.vo.givebackbail.GiveBackVO;
import com.unis.transaction.common.vo.signuppay.TransactionSignUpVO;
import com.unis.transaction.common.vo.tradeplan.*;
import com.unis.transaction.server.dao.*;
import com.unis.transaction.server.domain.creditevaluate.TurnoverDataDomain;
import com.unis.transaction.server.entity.base.WcmDocumentObj;
import com.unis.transaction.server.entity.givebackbail.GiveBackDO;
import com.unis.transaction.server.entity.tradeplan.*;
import com.unis.transaction.server.entity.tradeplan.TyJyccKhxx;
import com.unis.transaction.server.service.BacklogMQService;
import com.unis.transaction.server.service.impl.BaseRepository;
import lombok.extern.log4j.Log4j2;
import lombok.var;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;
import tk.mybatis.mapper.entity.Example.Criteria;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.net.InetAddress;
import java.net.URLEncoder;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 出入库委托书业务
 *
 * @author huyong at 2019-09-19
 */
@Log4j2
@Component
@Transactional
public class EntryAndExitOrderDomain {
    @Autowired
    EntryAndExitOrderDao entryAndExitOrderDao;

    @Autowired
    WarehousingArrangementDao warehousingArrangementDao;

    @Autowired
    TurnoverDataDomain turnoverdataDomain;

    @Autowired
    TransactionSignUpDao transactionSignUpDao;

    @Autowired
    GiveBackBailLetterDao giveBackBailLetterDao;
    @Autowired
    BaseRepository baseMapper;

    @Autowired
    TradeMarkDao trademarkMapper;

    @Autowired
    GiveBackDao giveBackDao;

    @Autowired
    SiteDao siteDao;

    @Autowired
    ContractDao contractDao;
    @Autowired
    BacklogMQService mqService;

    @Autowired
    EntryAndExitOrderSeeSampleDao seeSampleDao;
    @Autowired
    EntryAndExitOrderGoodsDao goodsDao;

    @Resource
    TyJyccKhxxDao tyJyccKhxxDao;


    //出入库委托书-新增
    public void insertEntryAndExitOrder(EntryAndExitOrderVO vo) {
        EntryAndExitOrderDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), EntryAndExitOrderDO.class);
        String pk = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(EntryAndExitOrderDO.class), "wtbm", "wt", 8);
        entity.setWtbm(pk);
        String jyfx = vo.getJyfx();
        //注入申请编码
        Example example = new Example(EntryAndExitOrderDO.class);
        example.orderBy("createDate").desc();
        Criteria createCriteria = example.createCriteria();

        SimpleDateFormat sf = new SimpleDateFormat("yyyy");
        String format = sf.format(new Date());
        String last = "";
        if (jyfx.equals("0")) {
            last = "CG";
            createCriteria.andLike("wtbh", format + "%CG");
        } else {
            last = "XS";
            createCriteria.andLike("wtbh", format + "%XS");
        }
        List<EntryAndExitOrderDO> selectByExample = entryAndExitOrderDao.selectByExample(example);
        int sxh = 1;
        if (selectByExample != null && selectByExample.size() > 0) {
            EntryAndExitOrderDO entryAndExitOrderDO = selectByExample.get(0);
            String wtbh = entryAndExitOrderDO.getWtbh();
            String substring = wtbh.substring(4, wtbh.length() - 2);
            int parseInt = Integer.parseInt(substring);
            sxh = parseInt + 1;
        }
        NumberFormat nf = NumberFormat.getInstance();
        nf.setGroupingUsed(false);
        nf.setMaximumIntegerDigits(5);
        nf.setMinimumIntegerDigits(5);
        String sxhStr = nf.format(sxh);
        entity.setWtbh(format + sxhStr + last);
        entity.buildInsertData();

        int insert = entryAndExitOrderDao.insertSelective(entity);
        if (insert <= 0) {
            throw new RuntimeException("新增失败");
        }
        if (RotatePlanStatusConstant.YTJ.getValue().equals(vo.getZt())) {
            System.out.println("*************进入创建待办************");
            BacklogAddVO record = new BacklogAddVO();
            record.buildAddVO(record);
            record.setItemQuery(vo.getItemQuery());
            record.setItemQueryHaveDone(vo.getItemQueryHaveDone());
            record.setItemUrlHaveDone(vo.getItemUrlHaveDone());
            record.setItemId(entity.getWtbm() + "-01");
            record.setItemName("委托编号为（" + entity.getWtbh() + "）的数据在交易中心待确认");
            record.setItemStatus(Integer.valueOf(vo.getZt()));
            record.setItemStatusName(vo.getZtmc());
            record.setItemUrl(vo.getUrl());
            // 另起线程执行待办
            //List<ReceiverCollectionVO> userList =
            new Thread(new Runnable() {
                @Override
                public void run() {
                    if (vo.getUserList() != null && vo.getUserList().size() > 0) {
                        for (ReceiverCollectionVO userVO : vo.getUserList()) {
                            System.out.println("********************接收人*******************");
                            System.out.println("-----" + userVO.getUserName() + "-------" + userVO.getUserId());
                            System.out.println("********************************************");
                            record.setReceiver(userVO.getUserName());
                            record.setReceiverId(userVO.getUserId());
                            // 需要将对象序列化成JSONObject
                            System.out.println("*************进入创建待办10************");
                            mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(record)), "insert");
                        }
                    }
                }
            }).start();
        }
    }


    //出入库委托书-修改
    public void updateEntryAndExitOrder(EntryAndExitOrderVO vo) {
        EntryAndExitOrderDO entity = JsonUtils.parse(JsonUtils.serialize(vo), EntryAndExitOrderDO.class);
        entity.buildUpdateData();
        int update = entryAndExitOrderDao.updateByPrimaryKeySelective(entity);
        if (update <= 0) {
            throw new RuntimeException("修改失败");
        }
        if (update > 0 && (RotatePlanStatusConstant.YQR.getValue().equals(vo.getZt())
                || RotatePlanStatusConstant.YTJ.getValue().equals(vo.getZt()))) {
            System.out.println("*************进入创建待办************");
            BacklogAddVO record = new BacklogAddVO();
            record.buildAddVO(record);
            if (RotatePlanStatusConstant.YTJ.getValue().equals(vo.getZt())) {
                record.setItemId(entity.getWtbm() + "-01");
            } else {
                record.setItemId(entity.getWtbm() + "-03");
            }

            record.setItemQuery(vo.getItemQuery());
            record.setItemQueryHaveDone(vo.getItemQueryHaveDone());
            record.setItemUrlHaveDone(vo.getItemUrlHaveDone());
            if (RotatePlanStatusConstant.YQR.getValue().equals(vo.getZt())) {
                record.setItemName("委托编号为（" + entity.getWtbh() + "）的数据在委托方待安排");
            } else {
                record.setItemName("委托编号为（" + entity.getWtbh() + "）的数据在交易中心待确认");
            }
            record.setItemStatus(Integer.valueOf(vo.getZt()));
            record.setItemStatusName(vo.getZtmc());
            record.setItemUrl(vo.getUrl());
            // 另起线程执行待办
            //List<ReceiverCollectionVO> userList =
            new Thread(new Runnable() {
                @Override
                public void run() {
                    for (ReceiverCollectionVO userVO : vo.getUserList()) {
                        System.out.println("********************接收人*******************");
                        System.out.println("-----" + userVO.getUserName() + "-------" + userVO.getUserId());
                        System.out.println("********************************************");
                        record.setReceiver(userVO.getUserName());
                        record.setReceiverId(userVO.getUserId());
                        // 需要将对象序列化成JSONObject
                        mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(record)), "insert");
                    }
                }
            }).start();
        }
        //委托方提交出入库委托书后-已办
        if (update > 0 && (RotatePlanStatusConstant.YQR.getValue().equals(vo.getZt()))) {
            BacklogUpdateVO updateVO = new BacklogUpdateVO();
            updateVO.buildUpdateVO(updateVO);
            updateVO.setItemId(vo.getWtbm() + "-01");
            updateVO.setItemName("委托编号为（" + vo.getWtbh() + "）的数据在交易中心已确认");
            updateVO.setItemStatus(Integer.valueOf(RotatePlanStatusConstant.YQR.getValue()));
            updateVO.setItemStatusName(RotatePlanStatusConstant.YQR.getName());
            new Thread(new Runnable() {
                @Override
                public void run() {
                    mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(updateVO)), "update");
                }
            }).start();
        }
    }

    /**
     * 2022年8月29日 重构
     *
     * @param pageNum
     * @param pageSize
     * @param vo
     * @return
     */
    public PageResult<EntryAndExitOrderVO> selectEntryAndExitOrderPageList(int pageNum, int pageSize, EntryAndExitOrderVO vo) {
        Example example = new Example(EntryAndExitOrderDO.class, false, false).excludeProperties(EntryAndExitOrderDO.getExcludeField());
        //组装查询条件
        Criteria createCriteria = example.createCriteria();
        createCriteria.andEqualTo("status", 1);
        String lsxzbm = vo.getLsxzbm();
        if (lsxzbm != null && !lsxzbm.isEmpty()) {
            createCriteria.andEqualTo("lsxzbm", lsxzbm);
        }
        String wtfmc = vo.getWtfmc();
        if (wtfmc != null && !wtfmc.isEmpty()) {
            createCriteria.andLike("wtfmc", "%" + wtfmc + "%");
        }
        String wtbh = vo.getWtbh();
        if (StringUtils.isNotEmpty(wtbh)) {
            createCriteria.andLike("wtbh", "%" + wtbh + "%");
        }
        Date jyrq = vo.getJyrq();
        if (null != jyrq) {
            createCriteria.andEqualTo("jyrq", jyrq);
        }
        String jyfx = vo.getJyfx();
        String jyfs = vo.getJyfs();
        createCriteria.andEqualTo("pzbm", vo.getPzbm())
                .andEqualTo("jyfx", jyfx)
                .andEqualTo("jyfs", jyfs);

        String headerToken = RequestUtils.getHeaderToken();
        if (StringUtils.isEmpty(headerToken)) {

        } else {
            String zt = vo.getZt();
            if ("LS001020".equals(CurrentUtil.getOrgId())) {
                // 交易中心
                if (StringUtils.isEmpty(zt)) {
                    List<String> clientZt = Arrays.asList("91000400", "91000405", "91000500", "91000600");
                    createCriteria.andIn("zt", clientZt);
                } else {
                    createCriteria.andEqualTo("zt", zt);
                }
            } else {
                if (StringUtils.isNotEmpty(zt)) {
                    createCriteria.andEqualTo("zt", zt);
                }
                String orgId = CurrentUtil.getOrgId();
                createCriteria.andEqualTo("wtfbm", orgId);
            }
        }

        //根据页面不同获取不同的状态值做查询条件
        Integer page = vo.getPage();
        if (null != page) {
            String paramName = "";
            String zt = "";
            if (page == 0) {
                paramName = "zt";
                zt = vo.getZt();
            } else if (page == 1) {
                paramName = "apzt";
                zt = vo.getApzt();
            } else if (page == 2) {
                paramName = "hybzt";
                zt = vo.getHybzt();
            }
            createCriteria.andNotEqualTo(paramName, "");
            if (!"".equals(paramName)) {
                createCriteria.andEqualTo(paramName, zt);
            }
            List<String> zts = vo.getZts();
            if (zts != null && !zts.isEmpty()) {
                createCriteria.andIn(paramName, zts);
            }
        }

        //开始分页
        PageHelper.startPage(pageNum, pageSize);
        PageHelper.orderBy("refresh_time desc");
        Page<EntryAndExitOrderDO> pageInfo = (Page<EntryAndExitOrderDO>) entryAndExitOrderDao.selectByExample(example);
        List<EntryAndExitOrderDO> result = pageInfo.getResult();
        //返回类型转换
        if (result != null && result.size() > 0) {
            List<EntryAndExitOrderVO> entryAndExitOrderVOList = JSONObject.parseArray(JSONObject.toJSONString(result), EntryAndExitOrderVO.class);
            List<String> wtbmList = entryAndExitOrderVOList.stream().map(EntryAndExitOrderVO::getWtbm).collect(Collectors.toList());
            List<EntryAndExitOrderGoodsDO> goodsDOList = goodsDao.listGroupPzmcByWtbm(wtbmList);
            Map<String, String> pzmcCollect = goodsDOList.stream().collect(Collectors.toMap(EntryAndExitOrderGoodsDO::getWtbm, EntryAndExitOrderGoodsDO::getPzmc, (s, a) -> s + "、" + a));

            for (EntryAndExitOrderVO entryAndExitOrderVO : entryAndExitOrderVOList) {
                entryAndExitOrderVO.setPzmc(pzmcCollect.get(entryAndExitOrderVO.getWtbm()));
            }

            return new PageResult<>(pageInfo.getTotal(), pageInfo.getPages(), pageNum, entryAndExitOrderVOList);
        }
        return new PageResult<>(pageInfo.getTotal(), pageInfo.getPages(), pageNum, new ArrayList<>());
    }

    //出入库委托书--查看--返回单条
    public EntryAndExitOrderVO selectEntryAndExitOrderInfo(EntryAndExitOrderVO vo) {
        EntryAndExitOrderDO entity = JsonUtils.parse(JsonUtils.serialize(vo), EntryAndExitOrderDO.class);
        EntryAndExitOrderDO select = entryAndExitOrderDao.selectOne(entity);
        EntryAndExitOrderVO parse = JsonUtils.parse(JsonUtils.serialize(select), EntryAndExitOrderVO.class);
        return parse;
    }

    //出入库委托书--查看--通过主键
    public EntryAndExitOrderVO getInfoEntryAndExitOrderDetail(String id) {
        EntryAndExitOrderDO entity = entryAndExitOrderDao.selectByPrimaryKey(id);
        EntryAndExitOrderVO entryandexitorderVO = JsonUtils.parse(JsonUtils.serialize(entity), EntryAndExitOrderVO.class);
        return entryandexitorderVO;
    }

    //出入库委托书--删除
    public void removeEntryAndExitOrder(String wtbm) {
        EntryAndExitOrderDO entity = entryAndExitOrderDao.selectByPrimaryKey(wtbm);
        entity.setStatus(0);
        entity.buildUpdateData();
        int del = entryAndExitOrderDao.updateByPrimaryKeySelective(entity);
        if (del <= 0) {
            throw new RuntimeException("删除失败");
        }
    }

    //出入库安排-批量新增
    public void insertWarehousingArrangement(EntryAndExitOrderInputVO inputVo) {
        EntryAndExitOrderVO entryAndExitOrderVO = inputVo.getEntryAndExitOrderVO();
        EntryAndExitOrderDO entryAndExitOrderDO = JSONObject.parseObject(JSONObject.toJSONString(entryAndExitOrderVO), EntryAndExitOrderDO.class);
        int update = entryAndExitOrderDao.updateByPrimaryKeySelective(entryAndExitOrderDO);
        List<WarehousingArrangementVO> vos = inputVo.getDetails();
        for (WarehousingArrangementVO vo : vos) {
            WarehousingArrangementDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), WarehousingArrangementDO.class);
            String pk = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(WarehousingArrangementDO.class), "apbm", "AP", 8);
            //查询发送单位的orgcode
            String dwdms = "";
            if (entity.getDwbm().endsWith("001")) {
                dwdms = entity.getDwbm().substring(0, entity.getDwbm().length() - 3);
            }
            String dwdm = trademarkMapper.selectOrgCode(dwdms);
            entity.setDwdm(dwdm);
            entity.setApbm(pk);
            entity.setAplx(inputVo.getAplx());
            entity.buildInsertData();
            entity.setCfbm(vo.getCfbm());

            int insert = warehousingArrangementDao.insertSelective(entity);
            if (insert <= 0) {
                throw new RuntimeException("新增失败");
            }
        }
        EntryAndExitOrderDO entryAndExit = entryAndExitOrderDao.selectByPrimaryKey(entryAndExitOrderDO.getWtbm());
        if (update > 0 && (RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getApzt
                ()) || RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt()))) {
            System.out.println("*************进入创建待办************");
            BacklogAddVO record = new BacklogAddVO();
            record.buildAddVO(record);
            record.setItemQueryHaveDone(inputVo.getEntryAndExitOrderVO().getItemQueryHaveDone());
            record.setItemUrlHaveDone(inputVo.getEntryAndExitOrderVO().getItemUrlHaveDone());
            record.setItemQuery(inputVo.getEntryAndExitOrderVO().getItemQuery());

            if (RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getApzt())) {
                record.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-04");
                record.setItemName("委托编号为（" + entryAndExit.getWtbh() + "）的数据在货源表中待安排");
                record.setItemStatus(Integer.valueOf(inputVo.getEntryAndExitOrderVO().getApzt()));
                record.setItemStatusName(inputVo.getEntryAndExitOrderVO().getApztmc());
            } else {
                record.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-02");
                record.setItemName("委托编号为（" + entryAndExit.getWtbh() + "）的数据在交易中心货源表中待确认");
                record.setItemStatus(Integer.valueOf(inputVo.getEntryAndExitOrderVO().getHybzt()));
                record.setItemStatusName(inputVo.getEntryAndExitOrderVO().getHybztmc());
            }
            record.setItemUrl(inputVo.getEntryAndExitOrderVO().getUrl());
            // 另起线程执行待办
            //List<ReceiverCollectionVO> userList =
            new Thread(new Runnable() {
                @Override
                public void run() {
                    for (ReceiverCollectionVO userVO : inputVo.getEntryAndExitOrderVO().getUserList()) {
                        System.out.println("********************接收人*******************");
                        System.out.println("-----" + userVO.getUserName() + "-------" + userVO.getUserId());
                        System.out.println("********************************************");
                        record.setReceiver(userVO.getUserName());
                        record.setReceiverId(userVO.getUserId());
                        // 需要将对象序列化成JSONObject
                        mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(record)), "insert");
                    }
                }
            }).start();
        }
        //交易中心在出入库委托书确认后-已办   委托方在出入库安排完成-已办
        if (update > 0 && (RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getApzt
                ()) || RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt()))) {
            BacklogUpdateVO updateVO = new BacklogUpdateVO();
            updateVO.buildUpdateVO(updateVO);
            if (RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getApzt())) {
                updateVO.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-03");
                updateVO.setItemName("委托编号为（" + entryAndExit.getWtbh() + "03）的数据在交易安排中已提交");
            } else {
                updateVO.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-04");
                updateVO.setItemName("委托编号为（" + entryAndExit.getWtbh() + "04）的数据在货源表中已提交");
            }
            updateVO.setItemStatus(Integer.valueOf(RotatePlanStatusConstant.YTJ.getValue()));
            updateVO.setItemStatusName(RotatePlanStatusConstant.YTJ.getName());
            new Thread(new Runnable() {
                @Override
                public void run() {
                    mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(updateVO)), "update");
                }
            }).start();
            //mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(updateVO)), "update");
        }
    }


    //出入库安排-批量修改
    public void updateWarehousingArrangement(EntryAndExitOrderInputVO inputVo, Integer sjlx) {
        String wtbm = inputVo.getEntryAndExitOrderVO().getWtbm();
        Example example = new Example(WarehousingArrangementDO.class);
        Criteria criteria = example.createCriteria();
        criteria.andEqualTo("sjlx", sjlx);
        criteria.andEqualTo("aplx", inputVo.getAplx());
        criteria.andEqualTo("wtbm", wtbm);
        /*if(RotatePlanStatusConstant.YBH.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt())){*/
        if (RotatePlanStatusConstant.YBH.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt())
                || RotatePlanStatusConstant.YFB.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt())
                || RotatePlanStatusConstant.QDCH.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt())) {
        } else {
            warehousingArrangementDao.deleteByExample(example);
        }
        EntryAndExitOrderVO entryAndExitOrderVO = inputVo.getEntryAndExitOrderVO();
        EntryAndExitOrderDO entryAndExitOrderDO = JSONObject.parseObject(JSONObject.toJSONString(entryAndExitOrderVO), EntryAndExitOrderDO.class);
        int update = entryAndExitOrderDao.updateByPrimaryKeySelective(entryAndExitOrderDO);
        List<WarehousingArrangementVO> vos = inputVo.getDetails();
        EntryAndExitOrderDO orderDO = entryAndExitOrderDao.selectByPrimaryKey(wtbm);
        if (update <= 0) {
            throw new RuntimeException("操作失败");
        } else {
            if (RotatePlanStatusConstant.YBH.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt())) {
            } else {
                for (WarehousingArrangementVO vo : vos) {

                    WarehousingArrangementDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), WarehousingArrangementDO.class);
                    String pk = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(WarehousingArrangementDO.class)
                            , "apbm", "AP", 8);
                    entity.setApbm(pk);
                    //查询发送单位的orgcode
                    String dwdms = "";
                    if (entity.getDwbm().endsWith("001")) {
                        dwdms = entity.getDwbm().substring(0, entity.getDwbm().length() - 3);
                    }
                    String dwdm = trademarkMapper.selectOrgCode(dwdms);
                    entity.setDwdm(dwdm);
                    entity.setAplx(inputVo.getAplx());
                    entity.buildInsertData();
                    entity.setCfbm(vo.getCfbm());
                    int insert = warehousingArrangementDao.insertSelective(entity);

                    if (insert <= 0) {
                        throw new RuntimeException("新增失败");
                    }
                    if (RotatePlanStatusConstant.YQR.getValue().equals(entryAndExitOrderVO.getHybzt())) {
                        // 发布的时候生成标的号等数据
                        TradeMarkDO tradeMarkDO = new TradeMarkDO();
                        String pkbd = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(TradeMarkDO.class), "bdbm", "BD", 8);
                        tradeMarkDO.setBdbm(pkbd);
                        tradeMarkDO.setWtbm(entryAndExitOrderDO.getWtbm());
                        tradeMarkDO.setApbm(entity.getApbm());
                        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(entryAndExitOrderDO.getWtbm());
                        tradeMarkDO.setBdh(createBdh(exitOrderDO.getLsxzmc(), exitOrderDO.getWtfmc()));
                        tradeMarkDO.buildInsertData();
                        int intTrade = trademarkMapper.insertSelective(tradeMarkDO);
                        if (intTrade <= 0) {
                            throw new RuntimeException("标的号生成失败");
                        }
                    }
                }
            }

            if (update > 0 && (RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getApzt
                    ()) || RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt()))
                    || RotatePlanStatusConstant.YQR.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt())) {
                System.out.println("*************进入创建待办************");
                BacklogAddVO record = new BacklogAddVO();
                record.buildAddVO(record);
                record.setItemQuery(inputVo.getEntryAndExitOrderVO().getItemQuery());
                record.setItemQueryHaveDone(inputVo.getEntryAndExitOrderVO().getItemQueryHaveDone());
                record.setItemUrlHaveDone(inputVo.getEntryAndExitOrderVO().getItemUrlHaveDone());
                //record.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm());
                if (RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getEntryAndExitOrderVO().getApzt())) {
                    record.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-04");
                    record.setItemName("委托编号为（" + orderDO.getWtbh() + "）的数据在货源表中待安排");
                    record.setItemStatus(Integer.valueOf(inputVo.getEntryAndExitOrderVO().getApzt()));
                    record.setItemStatusName(inputVo.getEntryAndExitOrderVO().getApztmc());
                    /// record.setItemUrl(inputVo.getUrl());
                } else if (inputVo.getEntryAndExitOrderVO().getHybzt().equals(RotatePlanStatusConstant.YQR.getValue())) {
                    record.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-05");
                    record.setItemName("委托编号为（" + orderDO.getWtbh() + "）的数据在交易标的中待提交");
                    record.setItemStatus(Integer.valueOf(inputVo.getEntryAndExitOrderVO().getHybzt()));
                    record.setItemStatusName(inputVo.getEntryAndExitOrderVO().getHybztmc());
                    // record.setItemUrl(inputVo.getEntryAndExitOrderVO().getUrl());
                } else {
                    record.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-02");
                    record.setItemName("委托编号为（" + orderDO.getWtbh() + "）的数据在交易中心中待确认");
                    record.setItemStatus(Integer.valueOf(inputVo.getEntryAndExitOrderVO().getHybzt()));
                    record.setItemStatusName(inputVo.getEntryAndExitOrderVO().getHybztmc());
                    //record.setItemUrl(inputVo.getUrl());
                }
                record.setItemStatus(Integer.valueOf(RotatePlanStatusConstant.YTJ.getValue()));
                record.setItemStatusName("已提交");
                record.setItemUrl(inputVo.getEntryAndExitOrderVO().getUrl());
                // 另起线程执行待办
                //List<ReceiverCollectionVO> userList =
                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        for (ReceiverCollectionVO userVO : inputVo.getEntryAndExitOrderVO().getUserList()) {
                            System.out.println("-----" + userVO.getUserName() + "-------" + userVO.getUserId());
                            record.setReceiver(userVO.getUserName());
                            record.setReceiverId(userVO.getUserId());
                            // 需要将对象序列化成JSONObject
                            mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(record)), "insert");
                        }
                    }
                }).start();
            }
        }
        //委托方提交货源表后-已办
        if (RotatePlanStatusConstant.YQR.getValue().equals(inputVo.getEntryAndExitOrderVO().getHybzt())) {
            BacklogUpdateVO updateVO = new BacklogUpdateVO();
            updateVO.buildUpdateVO(updateVO);
            updateVO.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-02");
            updateVO.setItemName("委托编号为（" + orderDO.getWtbh() + "-02）的数据在委托方货源表中已提交");
            updateVO.setItemStatus(Integer.valueOf(RotatePlanStatusConstant.YQR.getValue()));
            updateVO.setItemStatusName(RotatePlanStatusConstant.YQR.getName());
            new Thread(new Runnable() {
                @Override
                public void run() {
                    mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(updateVO)), "update");
                }
            }).start();
            // mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(updateVO)), "update");
        }
        //insertWarehousingArrangement(inputVo);
    }


    private String createBdh(String lsxzbm, String wtfmc) {
        //String name = CurrentUtil.getCompanyName();
        String head = CompanyConstant.MAP.get(wtfmc);
        if (lsxzbm.equals("区级储备粮")) {
            head = head + "Q";
        } else if (lsxzbm.equals("贸易粮")) {
            head = head + "M";
        }
        head = head + DateUtil.DateToStr(new Date(), "yyyyMMdd") + "-";
        //获取数据库中编号
        List<TradeMarkDO> list = trademarkMapper.findByBdh(head);
        String nums = "";
        if (String.valueOf(list.size() + 1).length() == 1) {
            nums = "00" + String.valueOf(list.size() + 1);
        } else if (String.valueOf(list.size() + 1).length() == 2) {
            nums = "0" + String.valueOf(list.size() + 1);
        } else {
            nums = String.valueOf(list.size() + 1);
        }
        head = head + nums;
        return head;
    }

    //出入库安排-分页列表 public PageResult<WarehousingArrangementVO>
    public PageResult<WarehousingArrangementVO> selectWarehousingArrangementPageList(int pageNum, int pageSize, WarehousingArrangementVO vo) {
        Example example = new Example(WarehousingArrangementDO.class);
        Criteria criteria = example.createCriteria();
        criteria.andNotEqualTo("zt", "");
        String wtfmc = vo.getWtfmc();
        if (wtfmc != null && !wtfmc.isEmpty()) {
            criteria.andLike("wtfmc", "%" + wtfmc + "%");
        }
        String dwmc = vo.getDwmc();
        if (dwmc != null && !dwmc.isEmpty()) {
            criteria.andLike("dwmc", "%" + dwmc + "%");
        }
        String wtbm = vo.getWtbm();
        if (wtbm != null && !wtbm.isEmpty()) {
            //criteria.andLike("wtbm", "%"+wtbm+"%");
            criteria.andEqualTo("wtbm", wtbm);
        }
        String pzmc = vo.getPzmc();
        if (pzmc != null && !pzmc.isEmpty()) {
            criteria.andLike("pzmc", "%" + pzmc + "%");
        }
        criteria.andEqualTo("pzbm", vo.getPzbm()).andEqualTo("jylx", vo.getJylx()).andEqualTo("zt", vo.getZt());
        PageHelper.startPage(pageNum, pageSize);
        PageHelper.orderBy("refresh_time desc");
        Page<WarehousingArrangementDO> pageInfo = (Page<WarehousingArrangementDO>) warehousingArrangementDao.selectByExample(example);
        List<WarehousingArrangementDO> result = pageInfo.getResult();
        if (result != null && !result.isEmpty()) {
            List<WarehousingArrangementVO> parseArray = JSONObject.parseArray(JSONObject.toJSONString(result), WarehousingArrangementVO.class);
            for (WarehousingArrangementVO warehousingArrangementVO : parseArray) {
                TradeMarkVO tradeMarkVO = trademarkMapper.findByApbm(warehousingArrangementVO.getApbm());
                if (tradeMarkVO != null) {
                    warehousingArrangementVO.setBdh(tradeMarkVO.getBdh());
                    warehousingArrangementVO.setBdbm(tradeMarkVO.getBdbm());
                }
                EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(warehousingArrangementVO.getWtbm());
                if (exitOrderDO != null) {
                    warehousingArrangementVO.setWtbh(exitOrderDO.getWtbh());
                }
            }
            return new PageResult<>(pageInfo.getTotal(), pageInfo.getPages(), pageNum, parseArray);
        }
        return new PageResult<>(pageInfo.getTotal(), pageInfo.getPages(), pageNum, new ArrayList<>());
    }

    //出入库安排--查看--返回多条
    public EntryAndExitOrderInputVO selectWarehousingArrangementInfo(WarehousingArrangementVO vo) {
        EntryAndExitOrderInputVO orderInputVO = new EntryAndExitOrderInputVO();
        EntryAndExitOrderDO exitOrderVO = entryAndExitOrderDao.selectByPrimaryKey(vo.getWtbm());
        EntryAndExitOrderVO enty = JsonUtils.parse(JsonUtils.serialize(exitOrderVO), EntryAndExitOrderVO.class);
        orderInputVO.setEntryAndExitOrderVO(enty);
        WarehousingArrangementDO entity = JsonUtils.parse(JsonUtils.serialize(vo), WarehousingArrangementDO.class);

        List<WarehousingArrangementDO> select = warehousingArrangementDao.select(entity);
        List<WarehousingArrangementVO> array = JSONObject.parseArray(JSONObject.toJSONString(select), WarehousingArrangementVO.class);
        if (array != null && array.size() > 0) {
            for (WarehousingArrangementVO warehousingArrangementVO : array) {
                TradeMarkDO tradeMarkDO = trademarkMapper.selectByPrimaryKey(warehousingArrangementVO.getApbm());
                if (tradeMarkDO != null) {
                    warehousingArrangementVO.setBdbm(tradeMarkDO.getBdbm());
                    warehousingArrangementVO.setBdh(tradeMarkDO.getBdh());
                }
            }
        }
        orderInputVO.setDetails(array);
        return orderInputVO;
    }

    public List<WarehousingArrangementVO> selectWareDetail(WarehousingArrangementVO vo) {
        WarehousingArrangementDO entity = JsonUtils.parse(JsonUtils.serialize(vo), WarehousingArrangementDO.class);
        List<WarehousingArrangementDO> select = warehousingArrangementDao.select(entity);
        List<WarehousingArrangementVO> array = JSONObject.parseArray(JSONObject.toJSONString(select), WarehousingArrangementVO.class);
        if (array != null && array.size() > 0) {
            for (WarehousingArrangementVO warehousingArrangementVO : array) {
                TradeMarkDO tradeMarkDO = trademarkMapper.selectByPrimaryKey(warehousingArrangementVO.getApbm());
                if (tradeMarkDO != null) {
                    warehousingArrangementVO.setBdbm(tradeMarkDO.getBdbm());
                    warehousingArrangementVO.setBdh(tradeMarkDO.getBdh());
                }
            }
        }
        return array;
    }

    //出入库安排--查看--通过主键
    public WarehousingArrangementVO getInfoWarehousingArrangementDetail(String id) {
        WarehousingArrangementDO entity = warehousingArrangementDao.selectByPrimaryKey(id);
        WarehousingArrangementVO warehousingarrangementVO = JsonUtils.parse(JsonUtils.serialize(entity), WarehousingArrangementVO.class);
        TradeMarkVO tradeMarkVO = trademarkMapper.findByApbm(warehousingarrangementVO.getApbm());
        warehousingarrangementVO.setBdh(tradeMarkVO.getBdh());
        return warehousingarrangementVO;
    }

    //出入库安排--删除
    public void deleteWarehousingArrangement(String id) {
        WarehousingArrangementDO entity = warehousingArrangementDao.selectByPrimaryKey(id);
        entity.setStatus(0);
        entity.buildUpdateData();
        int del = warehousingArrangementDao.updateByPrimaryKeySelective(entity);
        if (del <= 0) {
            throw new RuntimeException("删除失败");
        }
    }


    //交易标的-新增
    public void insertTradeMark(TradeMarkBackVO inputVo) {
        WarehousingArrangementVO warehousingArrangementVO = inputVo.getWarehousingArrangementVO();
        WarehousingArrangementDO arrangementDO = JSONObject.parseObject(JSONObject.toJSONString(warehousingArrangementVO), WarehousingArrangementDO.class);

        arrangementDO.buildUpdateData();

        int updatewar = warehousingArrangementDao.updateByPrimaryKeySelective(arrangementDO);
        if (updatewar <= 0) {
            throw new RuntimeException("更新失败");
        }
        TradeMarkVO deatils = inputVo.getTradeMarkVO();

        TradeMarkDO entity = JSONObject.parseObject(JSONObject.toJSONString(deatils), TradeMarkDO.class);
        entity.buildUpdateData();
        int result = trademarkMapper.updateBytrade(entity);
        if (result <= 0) {
            throw new RuntimeException("更新失败");
        } else {
            //交易中心确认货源表后
            if (RotatePlanStatusConstant.YTJ.getValue().equals(inputVo.getWarehousingArrangementVO().getZt())) {
                BacklogUpdateVO updateVO = new BacklogUpdateVO();
                updateVO.buildUpdateVO(updateVO);
                updateVO.setItemId(inputVo.getEntryAndExitOrderVO().getWtbm() + "-05");
                updateVO.setItemName("委托编号为（" + inputVo.getEntryAndExitOrderVO().getWtbh() + "-05）的数据在交易标的中已提交");
                updateVO.setItemStatus(Integer.valueOf(RotatePlanStatusConstant.YTJ.getValue()));
                updateVO.setItemStatusName(RotatePlanStatusConstant.YTJ.getName());
                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(updateVO)), "update");
                    }
                }).start();
                //mqService.sendMsg(JSON.parseObject(JsonUtils.serialize(updateVO)), "update");
            }
        }
    }
    //}

    //交易标的-修改
    public void updateTradeMark(TradeMarkBackVO inputVO) {
        insertTradeMark(inputVO);
    }


    //交易标的--查看--返回多条
    public List<TradeMarkVO> selectTradeMarkInfo(TradeMarkVO vo) {
        TradeMarkDO entity = JsonUtils.parse(JsonUtils.serialize(vo), TradeMarkDO.class);
        List<TradeMarkDO> select = trademarkMapper.select(entity);
        List<TradeMarkVO> parseArray = JSONObject.parseArray(JSONObject.toJSONString(select), TradeMarkVO.class);
        return parseArray;
    }

    //交易标的--查看--通过主键
    public TradeMarkBackVO getInfoTradeMarkDetail(String id) {
        TradeMarkBackVO tradeMarkBackVO = new TradeMarkBackVO();
        TradeMarkDO entity = trademarkMapper.selectByPrimaryKey(id);
        TradeMarkVO trademarkVO = JsonUtils.parse(JsonUtils.serialize(entity), TradeMarkVO.class);
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(entity.getWtbm());
        EntryAndExitOrderVO exitOrderVO = JsonUtils.parse(JsonUtils.serialize(exitOrderDO), EntryAndExitOrderVO.class);
        tradeMarkBackVO.setEntryAndExitOrderVO(exitOrderVO);
        WarehousingArrangementDO warehousingArrangementDO = warehousingArrangementDao.selectByPrimaryKey(entity.getApbm());
        WarehousingArrangementVO warehousingArrangementVO = JsonUtils.parse(JsonUtils.serialize(warehousingArrangementDO), WarehousingArrangementVO.class);
        tradeMarkBackVO.setWarehousingArrangementVO(warehousingArrangementVO);
        trademarkVO.setSl(warehousingArrangementVO.getLssl());
        tradeMarkBackVO.setTradeMarkVO(trademarkVO);
        return tradeMarkBackVO;
    }

    //交易标的--删除
    public void deleteTradeMark(String id) {
        TradeMarkDO entity = trademarkMapper.selectByPrimaryKey(id);
        int del = trademarkMapper.deleteByPrimaryKey(id);
        if (del <= 0) {
            throw new RuntimeException("删除失败");
        }
    }


    /**
     * 场次分页
     *
     * @param pageNum
     * @param pageSize
     * @param vo
     * @return
     */
    public PageResult<SiteVO> selectByWtfbm(int pageNum, int pageSize, SiteVO vo) {
        PageHelper.startPage(pageNum, pageSize);

        String headerToken = RequestUtils.getHeaderToken();
        if (StringUtils.isEmpty(headerToken)) {
        } else {
            String orgId = CurrentUtil.getOrgId();
            vo.setWtfbm(orgId);
            if ("LS001020".equals(CurrentUtil.getOrgId())) {
                // 交易中心
            } else {
            }
        }
        Page<SiteVO> selectPageList = trademarkMapper.selectPageList(vo);
        List<SiteVO> result = selectPageList.getResult();
        //返回类型转换
        if (result != null && result.size() > 0) {
            List<SiteVO> siteVOList = JSONObject.parseArray(JSONObject.toJSONString(result), SiteVO.class);

            List<String> wtbmList = siteVOList.stream().map(SiteVO::getWtbm).collect(Collectors.toList());
            List<EntryAndExitOrderGoodsDO> goodsDOList = goodsDao.listGroupPzmcByWtbm(wtbmList);
            Map<String, String> pzmcCollect = goodsDOList.stream().collect(Collectors.toMap(EntryAndExitOrderGoodsDO::getWtbm, EntryAndExitOrderGoodsDO::getPzmc, (s, a) -> s + "、" + a));
            for (SiteVO item : siteVOList) {
                item.setPz(pzmcCollect.get(item.getWtbm()));
            }
            return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, siteVOList);
        }
        return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, new ArrayList<>());
    }


    public List<WarehousingArrangementVO> exportTradeMark(String apbm) {
        WarehousingArrangementVO infoWarehousingArrangementDetail = getInfoWarehousingArrangementDetail(apbm);
        TradeMarkVO tradeMarktVO = new TradeMarkVO();
        tradeMarktVO.setApbm(apbm);
        List<TradeMarkVO> tradeMarkInfo = selectTradeMarkInfo(tradeMarktVO);
        List<WarehousingArrangementVO> exportVOs2 = new ArrayList<>();
        for (TradeMarkVO data : tradeMarkInfo) {
            WarehousingArrangementVO vo = new WarehousingArrangementVO();
            vo = infoWarehousingArrangementDetail;
            vo.setBdh(data.getBdh());
            //vo.setApcc(data.getApcc());
            vo.setQbj(data.getQbj());
            vo.setSl(data.getSl());
            vo.setApbm(data.getApbm());
            vo.setBdbm(data.getBdbm());
            vo.setBdh(data.getBdh());
            exportVOs2.add(vo);
        }
        return exportVOs2;
    }

    /**
     * @param vo
     * @return Integer 返回类型
     * @Title: updateWarehousingArrangement
     * @Description: 修改货源表信息
     */
    public Integer updateWarehousingArrangement(WarehousingArrangementVO vo) {
        WarehousingArrangementDO arrangementDO = JSONObject.parseObject(JSONObject.toJSONString(vo), WarehousingArrangementDO.class);
        arrangementDO.buildUpdateData();
        return warehousingArrangementDao.updateByPrimaryKeySelective(arrangementDO);
    }

    /**
     * 新增场次
     *
     * @param vo
     */
    public void insertCC(SiteVO vo) {
        SiteDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), SiteDO.class);
        String pkbd = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(SiteDO.class), "ccbm", "CC", 8);
        entity.setCcbm(pkbd);
        entity.buildInsertData();
        entity.setZt(1);
        String wtbm = entity.getWtbm();
        if (RotatePlanStatusConstant.YFB.getName().equals(vo.getCczt())) {
            entity.setWczt("未成交");
        }
        int insert = siteDao.insertSelective(entity);
        if (insert <= 0) {
            throw new RuntimeException("新增失败");
        }

        WarehousingArrangementDO query = WarehousingArrangementDO.builder().wtbm(wtbm).build();
        var warehousingArrangementDOList = warehousingArrangementDao.select(query);
        Date jyrq = entity.getJyrq();
        String prefix = DateFormatUtils.format(jyrq, "yyyyMMdd-");
        for (WarehousingArrangementDO item : warehousingArrangementDOList) {
            Integer jylx = item.getJylx();
            if (jylx == TradeType.type.CG.getValue()) {
                String bdh = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(WarehousingArrangementDO.class), "bdh", "CG" + prefix, 3);
                item.setBdh(bdh);
            } else if (jylx == TradeType.type.XS.getValue()) {
                String bdh = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(WarehousingArrangementDO.class), "bdh", "XS" + prefix, 3);
                item.setBdh(bdh);
            }
            warehousingArrangementDao.updateBdh(item);
        }

        if (RotatePlanStatusConstant.YFB.getName().equals(vo.getCczt())) {
            EntryAndExitOrderDO entryAndExitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(vo.getWtbm());
            entryAndExitOrderDO.setJyrq(vo.getJgrq());
            entryAndExitOrderDao.updateByPrimaryKeySelective(entryAndExitOrderDO);
            List<TradeMarkVO> list = JSONArray.parseArray(vo.getMarks(), TradeMarkVO.class);
            for (TradeMarkVO tradeMarkVO : list) {
                TradeMarkDO tradeMarkDO = trademarkMapper.selectByPrimaryKey(tradeMarkVO.getBdbm());
                tradeMarkDO.setCcbm(entity.getCcbm());
                trademarkMapper.updateByPrimaryKey(tradeMarkDO);
            }
            trademarkMapper.deleteTradeMarkSite(vo.getWtbm());
        }
    }

    public void updateCC(SiteVO vo) {
        SiteDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), SiteDO.class);
        entity.buildUpdateData();
        if (RotatePlanStatusConstant.YFB.getName().equals(vo.getCczt())) {
            entity.setWczt("未成交");
        }
        int update = siteDao.updateByPrimaryKey(entity);
        if (update <= 0) {
            throw new RuntimeException("修改失败");
        }
        if (RotatePlanStatusConstant.YFB.getName().equals(vo.getCczt())) {
            EntryAndExitOrderDO entryAndExitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(vo.getWtbm());
            entryAndExitOrderDO.setJyrq(vo.getJgrq());
            entryAndExitOrderDao.updateByPrimaryKeySelective(entryAndExitOrderDO);
            List<TradeMarkVO> list = JSONArray.parseArray(vo.getMarks(), TradeMarkVO.class);
            for (TradeMarkVO tradeMarkVO : list) {
                TradeMarkDO tradeMarkDO = trademarkMapper.selectByPrimaryKey(tradeMarkVO.getBdbm());
                tradeMarkDO.setCcbm(entity.getCcbm());
                trademarkMapper.updateByPrimaryKey(tradeMarkDO);
            }
            trademarkMapper.deleteTradeMarkSite(vo.getWtbm());
        }

    }


    public int selectCode() {
        List<SiteDO> list = siteDao.selectAll();
        int re = 0;
        if (list != null && list.size() > 0) {
            int code = trademarkMapper.selectCode();
            re = code + 1;
        } else {
            re = 1;
        }
        return re;
    }

    public Boolean valiCode(String ccbm, String cccode) {
        SiteVO siteVO = trademarkMapper.valiCode(ccbm, cccode);
        boolean result = true;
        if (siteVO != null) {
            result = false;
        }
        return result;
    }

    public List<EntryAndExitOrderVO> selectEntryAndExitOrder() {
        //后期修改为一张表
        List<EntryAndExitOrderDO> list = trademarkMapper.selectListBySite();
        List<EntryAndExitOrderVO> parseArray = JSONObject.parseArray(JSONObject.toJSONString(list), EntryAndExitOrderVO.class);
        return parseArray;
    }

    public SiteBacktVO selectEntryAndExitOrderBySite(String id) {
        SiteBacktVO siteBacktVO = new SiteBacktVO();
        EntryAndExitOrderDO exitOrderVO = entryAndExitOrderDao.selectByPrimaryKey(id);
        EntryAndExitOrderVO entity = JSONObject.parseObject(JSONObject.toJSONString(exitOrderVO), EntryAndExitOrderVO.class);
        siteBacktVO.setEntryAndExitOrderVO(entity);

        Example example = new Example(EntryAndExitOrderDO.class);
        example.orderBy("createDate").desc();
        Criteria createCriteria = example.createCriteria();
        createCriteria.andEqualTo("wtbm", id);

        var warehousingArrangementQuery = WarehousingArrangementDO.builder().wtbm(entity.getWtbm()).build();
        List<WarehousingArrangementDO> warehousingArrangementDOList = warehousingArrangementDao.select(warehousingArrangementQuery);
        var warehousingArrangementVOList = JSONArray.parseArray(JSON.toJSONString(warehousingArrangementDOList), WarehousingArrangementVO.class);
        siteBacktVO.setDeatils(warehousingArrangementVOList);
        return siteBacktVO;
    }

    public SiteBacktVO selectCC(String ccbm) {
        SiteBacktVO siteBacktVO = new SiteBacktVO();
        SiteDO siteDO = siteDao.selectByPrimaryKey(ccbm);
        SiteVO siteVO = JSONObject.parseObject(JSONObject.toJSONString(siteDO), SiteVO.class);
        siteBacktVO.setSiteVO(siteVO);
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteDO.getWtbm());
        EntryAndExitOrderVO exitOrderVO = JSONObject.parseObject(JSONObject.toJSONString(exitOrderDO), EntryAndExitOrderVO.class);
        siteBacktVO.setEntryAndExitOrderVO(exitOrderVO);

        var warehousingArrangementQuery = WarehousingArrangementDO.builder().wtbm(siteVO.getWtbm()).build();
        List<WarehousingArrangementDO> warehousingArrangementDOList = warehousingArrangementDao.select(warehousingArrangementQuery);
        var warehousingArrangementVOList = JSONArray.parseArray(JSON.toJSONString(warehousingArrangementDOList), WarehousingArrangementVO.class);
        siteBacktVO.setDeatils(warehousingArrangementVOList);
        return siteBacktVO;
    }

    public void delCC(String id) {
        int del = siteDao.deleteByPrimaryKey(id);
        if (del <= 0) {
            throw new RuntimeException("删除失败");
        }
    }

    public PageResult<WarehousingArrangementVO> selectPage(int pageNum, int pageSize, WarehousingArrangementVO vo) {
        PageHelper.startPage(pageNum, pageSize);
        String token = RequestUtils.getHeaderToken();
        if (token != null && !"".equals(token)) {
            vo.setWtfbm(CurrentUtil.getOrgId());
        }
        Page<WarehousingArrangementVO> selectPageList = trademarkMapper.selectPage(vo);
        List<WarehousingArrangementVO> result = selectPageList.getResult();
        //返回类型转换
        if (result != null && result.size() > 0) {
            List<WarehousingArrangementVO> array = JSONObject.parseArray(JSONObject.toJSONString(result), WarehousingArrangementVO.class);
            for (WarehousingArrangementVO warehousingArrangementVO : array) {
                EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(warehousingArrangementVO.getWtbm());
                warehousingArrangementVO.setWtbh(exitOrderDO.getWtbh());
            }
            return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, array);
        }
        return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, new ArrayList<>());
    }

    public void insertContract(ContractVO vo) {
        ContractDO contractDO = JSONObject.parseObject(JSONObject.toJSONString(vo), ContractDO.class);
        String pkbd = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(ContractDO.class), "htbm", "HT", 8);
        contractDO.setHtbm(pkbd);
        contractDO.setIsChange("1");
        contractDO.setRefund_status("0");
        EntryAndExitOrderDO entryAndExitOrderDO = entryAndExitOrderDao.getEntryAndExitOrderBySiteId(vo.getCcbm());
        contractDO.setLsxz(entryAndExitOrderDO.getLsxzbm());
        contractDO.setShcnf(contractDO.getNnf());
        contractDO.buildInsertData();
        int insert = contractDao.insertSelective(contractDO);
        if (insert <= 0) {
            throw new RuntimeException("新增失败");
        }
        //修改保证金退款的状态
        WarehousingArrangementDO wo = warehousingArrangementDao.selectOne(WarehousingArrangementDO.builder().bdbm(contractDO.getBdbm()).build());
        SiteDO siteDO = siteDao.selectByPrimaryKey(contractDO.getCcbm());
        //List<TradeMarkDO> trlist = trademarkMapper.selectListByCcbm(to.getCcbm());
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(wo.getWtbm());
//        TransactionSignUpDO signUpDO = null;
        List<TyJyccKhxx> khxxList = tyJyccKhxxDao.selectKhxxByWtbh(siteDO.getWtbm());
        TyJyccKhxx khxx = new TyJyccKhxx();
        Integer jylx = vo.getJylx();
        if (TradeType.type.CG.getValue() == jylx) {
            if (khxxList != null && khxxList.size() > 0) {
                khxx = khxxList.stream().filter(item -> item.getKhmc().equals(vo.getCmmc())).findFirst().orElse(null);
            }
//            signUpDO = transactionSignUpDao.selectByDwbmAndCcbm(vo.getCmdw(), contractDO.getCcbm());
        } else {
            if (khxxList != null && khxxList.size() > 0) {
                khxx = khxxList.stream().filter(item -> item.getKhmc().equals(vo.getSgmc())).findFirst().orElse(null);
            }
//            signUpDO = transactionSignUpDao.selectByDwbmAndCcbm(vo.getSgdw(), contractDO.getCcbm());
        }
//        signUpDO.setShzt(RotatePlanStatusConstant.YCJ.getValue());
//        signUpDO.setShztmc(RotatePlanStatusConstant.YCJ.getName());
//        transactionSignUpDao.updateByPrimaryKeySelective(signUpDO);
        //添加数据到退保证金
        GiveBackVO giveBackVO = new GiveBackVO();
        giveBackVO.setJybm(khxx.getId());
        giveBackVO.setSjlx("0");
        List<GiveBackDO> selectDetails = giveBackDao.selectDetails(giveBackVO);
        if (selectDetails != null && selectDetails.size() == 1 && selectDetails.get(0).getHtbm() == null) {
            GiveBackDO giveBackDO = selectDetails.get(0);
            giveBackDO.setTkfl(0);
            giveBackDO.setSl(contractDO.getLssl());
            if (contractDO.getDj() != null) {
                giveBackDO.setJe(contractDO.getDj().toString());
            }
            giveBackDO.setSxf(contractDO.getLssl().multiply(new BigDecimal(siteDO.getSxfl())).toString());
            giveBackDO.setHtbh(contractDO.getHtbh());
            giveBackDO.setHtbm(contractDO.getHtbm());
            if ("0".equals(exitOrderDO.getJyfx())) {
                giveBackDO.setJsdw(contractDO.getCmmc());
            } else {
                giveBackDO.setJsdw(contractDO.getSgmc());
            }
            //判断成交类型 //0 未成交 1部分成交 2 全部成交
            giveBackDO.setSjlx("1");
            giveBackDao.updateByPrimaryKeySelective(giveBackDO);
        } else {
            GiveBackDO giveBackDOs = new GiveBackDO();
            giveBackDOs.setJybm(khxx.getId());
            giveBackDOs.setApcc(siteDO.getApcc());
            giveBackDOs.setCcbm(siteDO.getCcbm());
            if (khxx.getJyqbzj() != null) {
                giveBackDOs.setJkje(new BigDecimal(khxx.getJyqbzj()));
            }
            giveBackDOs.setGqsj(khxx.getBmsj());
            giveBackDOs.setDwbm(khxx.getHydm());
            giveBackDOs.setDwmc(khxx.getKhmc());
            List<TradeMarkDO> list = trademarkMapper.selectListByCcbm(siteDO.getCcbm());
            giveBackDOs.setBdsl(list.size());
            giveBackDOs.setJyfx(exitOrderDO.getJyfx());
            giveBackDOs.setWtbm(exitOrderDO.getWtbm());
            giveBackDOs.setWtfbm(exitOrderDO.getWtfbm());
            giveBackDOs.buildInsertData();
            String pk = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(GiveBackDO.class), "tkbm", "TK", 8);
            giveBackDOs.setTkbm(pk);
            giveBackDOs.setTkfl(0);
            giveBackDOs.setSl(contractDO.getLssl());
            if (contractDO.getDj() != null) {
                giveBackDOs.setJe(contractDO.getDj().toString());
            }
            giveBackDOs.setSxf(contractDO.getLssl().multiply(new BigDecimal(siteDO.getSxfl())).toString());
            giveBackDOs.setHtbh(contractDO.getHtbh());
            giveBackDOs.setHtbm(contractDO.getHtbm());
            if ("0".equals(exitOrderDO.getJyfx())) {
                giveBackDOs.setJsdw(contractDO.getCmmc());
            } else {
                giveBackDOs.setJsdw(contractDO.getSgmc());
            }
            //判断成交类型 //0 未成交 1部分成交 2 全部成交
            giveBackDOs.setSjlx("1");
            giveBackDao.insertSelective(giveBackDOs);
        }
        //在提交的时候 添加数据到成交数据维护vo
        //if("0".equals(vo.getStatus())){
//        TurnoverDataDO turnoverDataDO = new TurnoverDataDO();
//        turnoverDataDO.setBdbm(vo.getBdbm());
//        turnoverDataDO.setHtbm(contractDO.getHtbm());
//        turnoverDataDO.setHth(contractDO.getHtbh());
//        turnoverDataDO.setBdh(vo.getBdh());
//        turnoverDataDO.setMfcckbm(vo.getCckmc());
//        turnoverDataDO.setMfcckmc(vo.getCmmc());
//        turnoverDataDO.setSjlx("0");
//        turnoverDataDO.setCjsl(vo.getLssl());
//        turnoverDataDO.setZcjsl(vo.getLssl());
//        turnoverDataDO.setLspzmc(vo.getPzmc());
//        turnoverDataDO.setCjdj(vo.getDj());
//        turnoverDataDO.setCjje(new BigDecimal(vo.getJe()));
//        turnoverDataDO.setJhckbm(vo.getSgbm());
//        turnoverDataDO.setJhckmc(vo.getSgmc());
//        turnoverDataDO.setCd(wo.getCd());
//
//        turnoverDataDO.setLspzbm(wo.getPzbm());
//        turnoverDataDO.setChbm(wo.getCcdd());
//        turnoverDataDO.setChmc(wo.getCcdd());
//        turnoverDataDO.setCjrq(exitOrderDO.getJyrq());
//        turnoverDataDO.setScnf(wo.getScnd());
//        turnoverDataDO.setSflt(String.valueOf(wo.getSflt()));
//        turnoverDataDO.setSgdjbm(wo.getSgdj());
//        turnoverDataDO.setSgdjmc(wo.getSgdj());
//        turnoverDataDO.setHhqydjbm(tradeMarkDO.getQydj());
//        turnoverDataDO.setLsxzbm(exitOrderDO.getLsxzbm());
//        turnoverDataDO.setLsxzmc(exitOrderDO.getLsxzmc());
//        turnoverDataDO.setQpjg(contractDO.getQpdj());
//        turnoverDataDO.setWtf(exitOrderDO.getWtfmc());
//        turnoverDataDO.setSscc(siteDO.getApcc());
//        turnoverDataDO.setCc(siteDO.getCcbm());
//        turnoverDataDO.setCjdwbm(vo.getSgdw());
//        turnoverDataDO.setCjdwmc(vo.getSgmc());
//        turnoverDataDO.setZtbm(RotatePlanStatusConstant.YLY.getValue());
//        turnoverDataDO.setZtmc(RotatePlanStatusConstant.YLY.getName());
//        turnoverDataDO.setJylx(exitOrderDO.getJyfx());
//        turnoverDataDO.setJyxz(siteDO.getJyxz());
//        turnoverDataDO.setTrsl(contractDO.getLssl());
//        turnoverDataDO.setSxf(new BigDecimal(siteDO.getSxfl()));
//        turnoverDataDO.setCd(wo.getCd());
//        TransactionSignUpVO transactionSignUpVO = new TransactionSignUpVO();
//        List<TransactionSignUpDO> doList = transactionMapper.selectListByCC(siteDO.getCcbm());
//        turnoverDataDO.setQysl(String.valueOf(doList.size()));
//        int i = 0;
//        for (TransactionSignUpDO transactionSignUpDO : doList) {
//            if (CompanyConstant.MAP.get(transactionSignUpDO.getDwmc()) == null) {
//                i++;
//            }
//        }
        //  信用完事后查询
//        turnoverDataDO.setHxdf(BigDecimal.valueOf(vo.getA() + vo.getB() * (Float.parseFloat(vo.getJe())) / vo.getC()));
//        TurnoverDataVO turnoverDataVO = new TurnoverDataVO();
//        turnoverDataVO.setCjdwbm(vo.getSgdw());
//        List<TurnoverDataVO> turnoverDataVOS = turnoverdataDomain.selectZtbmByDwbm(turnoverDataVO);
//        if (turnoverDataVOS != null && turnoverDataVOS.size() > 0) {
//            turnoverDataDO.setHxzf(new BigDecimal(vo.getA() + vo.getB() * (Float.valueOf(vo.getJe())) / vo.getC()).add(turnoverDataVOS.get(0).getHxzf()));
//            turnoverdataDomain.updateHxzfByDwbm(turnoverDataDO);
//        } else {
//            turnoverDataDO.setHxzf(new BigDecimal(vo.getA() + vo.getB() * (Float.valueOf(vo.getJe())) / vo.getC()).add(new BigDecimal("2")));
//        }
//        turnoverDataDO.setWbqy(String.valueOf(i));
//        turnoverdataDomain.insertEntity(turnoverDataDO);
        //}
        // 往库级系统推送合同
        String str = null;
        try {
            //库区编码，合同编号，合同类型，合同数量，单价，总价，货位编码，粮食品种，明细品种，等级，粮食性质,生产年份，产地，客户名称，客户证件号
            String cckdm = contractDO.getCckdm();
            if (StringUtils.isNotBlank(cckdm)) {
                List<String> kqdmByQyjgdm = trademarkMapper.getKqdmByQyjgdm(cckdm);
                if (kqdmByQyjgdm != null && kqdmByQyjgdm.size() > 0) {
                    cckdm = kqdmByQyjgdm.get(0);
                }
            }
            JSONObject sendObj = new JSONObject();
            sendObj.put("htbm", contractDO.getHtbm());                //合同htbm
            sendObj.put("kqdm", cckdm);                //库区编码
            sendObj.put("htbh", contractDO.getHtbh());            //合同编号
            sendObj.put("htlx", contractDO.getJylx());                //合同类型
            sendObj.put("htsl", contractDO.getLssl());                //合同数量
            sendObj.put("dj", contractDO.getCjdj());                //单价
            sendObj.put("zj", contractDO.getJe());                //总价
            sendObj.put("hwbm", contractDO.getNcfbm());            //货位编码
            String pzbm = contractDO.getPzbm();
            if (StringUtils.isNotBlank(pzbm)) {
                String[] split = pzbm.split(",");
                StringBuilder sb = new StringBuilder();
                StringBuilder mxsb = new StringBuilder();
                for (int i = 0; i < split.length; i++) {
                    if (i == split.length - 1) {
                        // 粮食品种取pz前三位，后面补零
                        String pz = split[i].substring(0, 3) + "0000";
                        String mxpz = split[i];
                        sb.append(pz);
                        mxsb.append(mxpz);
                    } else {
                        // 粮食品种取pz前三位，后面补零
                        String pz = split[i].substring(0, 3) + "0000";
                        String mxpz = split[i];
                        sb.append(pz).append(",");
                        mxsb.append(mxpz).append(",");
                    }
                }
                sendObj.put("pz", sb.toString());            //粮食品种
                sendObj.put("mxpz", mxsb.toString());            //明细品种
            }
            sendObj.put("lsdj", contractDO.getLsdj());            //等级
            sendObj.put("lsxz", contractDO.getLsxz());            //粮食性质
            sendObj.put("scnf", contractDO.getNnf());            //生产年份
//				sendObj.put("cd", contract.getCd());			//产地
            if (contractDO.getJylx() != null) {
                if (0 == contractDO.getJylx()) {
                    sendObj.put("khmc", contractDO.getCmmc());            //客户名称
//                    sendObj.put("khzjh", contractDO.getCmdw());			//客户证件号
                } else {
                    sendObj.put("khmc", contractDO.getSgmc());            //客户名称
//                    sendObj.put("khzjh", contractDO.getSgdw());			//客户证件号
                }
            }
            System.out.println(sendObj);
            log.info("往库级系统推送合同 | sendObj=" + sendObj);
            str = URLEncoder.encode(com.unis.common.utils.JsonUtils.serialize(sendObj), "UTF-8");
            log.info("往库级系统推送合同 | URLEncoder | str=" + str);
        } catch (Exception e) {
            e.printStackTrace();
        }
        Map<String, Object> noticeMap = new HashMap<String, Object>();
        noticeMap.put("notice", str);
        //String depot =env.getProperty("depotApi");
        //System.out.println(depotApi);
        InetAddress ip = null;
        try {
            ip = InetAddress.getLocalHost();
        } catch (Exception e) {
            e.printStackTrace();
        }
        String ips = ip.toString();
        log.info("===============================" + ips + "===================================");
        String url = "";
        if (ips.split("/")[1].contains("172")) {
            url = "http://172.16.0.16:9002/businessContractReceiveController/saveContract";
        } else {
            url = "http://10.223.3.62:9002/businessContractReceiveController/saveContract";
        }
        log.info("===============================" + url + "===================================");
        String res = HttpRequestUtil.doFormPost(url, noticeMap);
        //String result = HttpRequestUtil.sendJSON(depotApi,str);
        //String res=HttpRequestUtil.sendGet(depotApi,"notice="+str);
        System.out.println(res);
        log.info("往库级系统推送合同 |  返回结果 | res=" + res);
        if (res != null) {
            contractDO.setSendresult(res);
            try {
                contractDao.updateByPrimaryKeySelective(contractDO);
            } catch (Exception e) {
                log.error("合同新增成功但是往库级系统推送合同失败", e.getMessage());
            }
        }
    }

    public void updateContract(ContractVO vo) {
        ContractDO entity = JsonUtils.parse(JsonUtils.serialize(vo), ContractDO.class);
        entity.setShcnf(entity.getNnf());
        entity.buildUpdateData();
        int update = contractDao.updateByPrimaryKeySelective(entity);
        if (update <= 0) {
            throw new RuntimeException("修改失败");
        }
        if (!"1".equals(vo.getIsChange())) {
            // 往库级系统推送合同
            String str = null;
            try {
                //库区编码，合同编号，合同类型，合同数量，单价，总价，货位编码，粮食品种，明细品种，等级，粮食性质,生产年份，产地，客户名称，客户证件号
                String cckdm = entity.getCckdm();
                if (StringUtils.isNotBlank(cckdm)) {
                    List<String> kqdmByQyjgdm = trademarkMapper.getKqdmByQyjgdm(cckdm);
                    if (kqdmByQyjgdm != null && kqdmByQyjgdm.size() > 0) {
                        cckdm = kqdmByQyjgdm.get(0);
                    }
                }
                JSONObject sendObj = new JSONObject();
                sendObj.put("htbm", entity.getHtbm());                //合同htbm
                sendObj.put("kqdm", cckdm);                //库区编码
                sendObj.put("htbh", entity.getHtbh());            //合同编号
                sendObj.put("htlx", entity.getJylx());                //合同类型
                sendObj.put("htsl", entity.getLssl());                //合同数量
                sendObj.put("dj", entity.getCjdj());                //单价
                sendObj.put("zj", entity.getJe());                //总价
                sendObj.put("hwbm", entity.getNcfbm());            //货位编码
                String pzbm = entity.getPzbm();
                if (StringUtils.isNotBlank(pzbm)) {
                    String[] split = pzbm.split(",");
                    StringBuilder sb = new StringBuilder();
                    StringBuilder mxsb = new StringBuilder();
                    for (int i = 0; i < split.length; i++) {
                        if (i == split.length - 1) {
                            // 粮食品种取pz前三位，后面补零
                            String pz = split[i].substring(0, 3) + "0000";
                            String mxpz = split[i];
                            sb.append(pz);
                            mxsb.append(mxpz);
                        } else {
                            // 粮食品种取pz前三位，后面补零
                            String pz = split[i].substring(0, 3) + "0000";
                            String mxpz = split[i];
                            sb.append(pz).append(",");
                            mxsb.append(mxpz).append(",");
                        }
                    }
                    sendObj.put("pz", sb.toString());            //粮食品种
                    sendObj.put("mxpz", mxsb.toString());            //明细品种
                }
                sendObj.put("lsdj", entity.getLsdj());            //等级
                sendObj.put("lsxz", entity.getLsxz());            //粮食性质
                sendObj.put("scnf", entity.getNnf());            //生产年份
//				sendObj.put("cd", contract.getCd());			//产地
                if (entity.getJylx() != null) {
                    if (0 == entity.getJylx()) {
                        sendObj.put("khmc", entity.getCmmc());            //客户名称
//                    sendObj.put("khzjh", entity.getCmdw());			//客户证件号
                    } else {
                        sendObj.put("khmc", entity.getSgmc());            //客户名称
//                    sendObj.put("khzjh", entity.getSgdw());			//客户证件号
                    }
                }
                System.out.println(sendObj);
                log.info("往库级系统推送合同 | sendObj=" + sendObj);
                str = URLEncoder.encode(com.unis.common.utils.JsonUtils.serialize(sendObj), "UTF-8");
                log.info("往库级系统推送合同 | URLEncoder | str=" + str);
            } catch (Exception e) {
                e.printStackTrace();
            }
            Map<String, Object> noticeMap = new HashMap<String, Object>();
            noticeMap.put("notice", str);
            //String depot =env.getProperty("depotApi");
            //System.out.println(depotApi);
            InetAddress ip = null;
            try {
                ip = InetAddress.getLocalHost();
            } catch (Exception e) {
                e.printStackTrace();
            }
            String ips = ip.toString();
            log.info("===============================" + ips + "===================================");
            String url = "";
            if (ips.split("/")[1].contains("172")) {
                url = "http://172.16.0.16:9002/businessContractReceiveController/saveContract";
            } else {
                url = "http://10.223.3.62:9002/businessContractReceiveController/saveContract";
            }
            log.info("===============================" + url + "===================================");
            String res = HttpRequestUtil.doFormPost(url, noticeMap);
            //String result = HttpRequestUtil.sendJSON(depotApi,str);
            //String res=HttpRequestUtil.sendGet(depotApi,"notice="+str);
            System.out.println(res);
            log.info("往库级系统推送合同 |  返回结果 | res=" + res);
            if (res != null) {
                entity.setSendresult(res);
                try {
                    contractDao.updateByPrimaryKeySelective(entity);
                } catch (Exception e) {
                    log.error("合同修改成功但是往库级系统推送合同失败", e.getMessage());
                }
            }
        }
    }

    public ResponseWrapper selectContractDetail(String id) {
        ContractDO contractDO = contractDao.selectByPrimaryKey(id);
        ContractVO entity = JsonUtils.parse(JsonUtils.serialize(contractDO), ContractVO.class);
        TradeMarkDO tradeMarkDO = trademarkMapper.selectByPrimaryKey(contractDO.getBdbm());
        // todo 现在没标的会导致报错
        if (null != tradeMarkDO) {
            EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(tradeMarkDO.getWtbm());
            entity.setLsxz(exitOrderDO.getLsxzbm());
        }
        // 保证金
        SiteDO siteDO = siteDao.selectByPrimaryKey(entity.getCcbm());
        if (null != siteDO) {
            if (StringUtils.isNotBlank(siteDO.getJybzj())) {
                BigDecimal bzj = new BigDecimal(siteDO.getJybzj()).setScale(2, RoundingMode.HALF_UP);
                BigDecimal cjsl = new BigDecimal(String.valueOf(entity.getLssl())).setScale(2, RoundingMode.HALF_UP);
                // 交易保证金(元/吨)*成交数量
                BigDecimal bigDecimal = formatNumber(bzj.multiply(cjsl));
                entity.setJybzj(bigDecimal.toString());

            }
            // 履约保证金(元/吨)*成交数
            if (StringUtils.isNotBlank(siteDO.getLybzj())) {
                // 如果是整数不保留小数，小数才保留两位
                BigDecimal lybzj = new BigDecimal(siteDO.getLybzj()).setScale(2, RoundingMode.HALF_UP);
                BigDecimal cjsl = new BigDecimal(String.valueOf(entity.getLssl())).setScale(2, RoundingMode.HALF_UP);
                BigDecimal multiply = formatNumber(lybzj.multiply(cjsl));
                entity.setLybzj(multiply.toString());
            }

            // 手续费率/100*成交额(元)
            if (StringUtils.isNotBlank(siteDO.getSxfl())) {
                // sxfl除以一百
                BigDecimal sxfl = new BigDecimal(siteDO.getSxfl()).divide(new BigDecimal("100"), 4, RoundingMode.HALF_UP);
                BigDecimal cje = new BigDecimal(entity.getJe()).setScale(2, RoundingMode.HALF_UP);
                BigDecimal multiply = formatNumber(sxfl.multiply(cje));
                entity.setSxf(multiply.toString());
            }
        }
        return ResponseWrapper.success(entity);
    }

    public static BigDecimal formatNumber(BigDecimal number) {
        if (number.scale() > 0 && number.stripTrailingZeros().scale() > 0) {
            return number.setScale(2, RoundingMode.HALF_UP);
        } else {
            return number.setScale(0, RoundingMode.HALF_UP);
        }
    }

    public PageResult<ContractVO> selectContractPage(int pageNum, int pageSize, ContractVO vo) {
        PageHelper.startPage(pageNum, pageSize);
        if (vo.getPzmc() != null && !"".equals(vo.getPzmc())) {
            List<String> pzList = new ArrayList<>(Arrays.asList(vo.getPzmc().split(",")));
            vo.setPzList(pzList);
        }

        Page<ContractVO> selectPageList = trademarkMapper.selectContractPage(vo);
        List<ContractVO> result = selectPageList.getResult();
        // 返回类型转换
        if (result != null && result.size() > 0) {
            List<ContractVO> array = JSONObject.parseArray(JSONObject.toJSONString(result), ContractVO.class);
            array.forEach(i -> {
                String je = i.getJe();
                if (je.endsWith(".00")) {
                    i.setJe(je.replace(".00", ""));
                }
            });
            return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, array);
        }

        return new PageResult<>(selectPageList.getTotal(), selectPageList.getPages(), pageNum, new ArrayList<>());
    }

    public ResponseWrapper selectContract(String id) {
        TradeMarkBackVO tradeMarkBackVO = new TradeMarkBackVO();
        TradeMarkDO tradeMarkDO = trademarkMapper.selectByPrimaryKey(id);
        TradeMarkVO tradeMarkVO = JsonUtils.parse(JsonUtils.serialize(tradeMarkDO), TradeMarkVO.class);
        WarehousingArrangementDO warehousingArrangementDO = warehousingArrangementDao.selectByPrimaryKey(tradeMarkDO.getApbm());
        WarehousingArrangementVO warehousingArrangementVO = JsonUtils.parse(JsonUtils.serialize(warehousingArrangementDO), WarehousingArrangementVO.class);
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(tradeMarkDO.getWtbm());
        EntryAndExitOrderVO exitOrderVO = JsonUtils.parse(JsonUtils.serialize(exitOrderDO), EntryAndExitOrderVO.class);
        tradeMarkBackVO.setWarehousingArrangementVO(warehousingArrangementVO);
        tradeMarkBackVO.setEntryAndExitOrderVO(exitOrderVO);
        tradeMarkBackVO.setTradeMarkVO(tradeMarkVO);
        SiteDO siteDO = trademarkMapper.selectSiteByBdbm(id);
        TransactionSignUpVO transaction = new TransactionSignUpVO();
        transaction.setSkzt(1);
        transaction.setCcbm(siteDO.getCcbm());
        transaction.setBdh(tradeMarkDO.getBdh());
        List<TransactionSignUpVO> list = transactionSignUpDao.selectSkztListNew(transaction);
        tradeMarkBackVO.setTransactionSignUpVOS(list);
        return ResponseWrapper.success(tradeMarkBackVO);
    }

    public ResponseWrapper selectTradeMarkAll() {
        List<SiteVO> siteDOList = trademarkMapper.selectTradeMarkAll();
        if (siteDOList.size() != 0) {
            // 只要近半年的场次
            siteDOList = siteDOList.stream().filter(i -> {
                Date jyrq = i.getJyrq();
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(jyrq);
                calendar.add(Calendar.MONTH, 6);
                Date time = calendar.getTime();
                return time.after(new Date());
            }).collect(Collectors.toList());
            if (siteDOList.size() > 0) {
                List<String> wtbmList = siteDOList.stream().map(SiteVO::getWtbm).collect(Collectors.toList());
                String[] coulmn = {"wtbm", "apbm", "dwbm", "dwdm", "dwmc", "pzbm", "pzmc", "lssl", "scnd", "cfbm", "ccdd", "wcsj", "bdh", "bdbm", "jylx"};
                Example entryAndExitOrderExample = new Example(WarehousingArrangementDO.class, false, false).selectProperties(coulmn);
                Criteria entryAndExitOrderCriteria = entryAndExitOrderExample.createCriteria();
                entryAndExitOrderCriteria.andIn("wtbm", wtbmList);
                List<WarehousingArrangementDO> warehousingArrangementList = warehousingArrangementDao.selectByExample(entryAndExitOrderExample);
                List<WarehousingArrangementVO> warehousingArrangementVOList = JSONObject.parseArray(JSONObject.toJSONString(warehousingArrangementList), WarehousingArrangementVO.class);
                // 获取所有合同信息
                List<ContractVO> contractVOList = trademarkMapper.selectContractList(null, null);
                if (contractVOList.size() > 0) {
                    List<String> bdbmList = contractVOList.stream().map(ContractVO::getBdbm).collect(Collectors.toList());
                    // 过滤掉warehousingArrangementVOList的bdbm在bdbmList当中的数据
                    warehousingArrangementVOList = warehousingArrangementVOList.stream()
                            .filter(i -> !bdbmList.contains(i.getBdbm())).collect(Collectors.toList());
                }

                LinkedHashMap<String, List<WarehousingArrangementVO>> map = warehousingArrangementVOList.stream().collect(Collectors.groupingBy(WarehousingArrangementVO::getWtbm, LinkedHashMap::new, Collectors.toList()));
                for (SiteVO siteDO : siteDOList) {
                    String wtbm = siteDO.getWtbm();
                    siteDO.setWarehousingArrangementList(map.get(wtbm));
                }
            }

        }
        return ResponseWrapper.success(siteDOList);
    }

    public ResponseWrapper selectContractList(String id) {
        List<ContractVO> list = trademarkMapper.selectContractList(id, null);
        return ResponseWrapper.success(list);
    }

    public SiteVO selectDetailCC(String ccbm) {
        SiteVO siteVO = JsonUtils.parse(JsonUtils.serialize(siteDao.selectByPrimaryKey(ccbm)), SiteVO.class);
        return siteVO;
    }

    public void updateStatusCC(SiteVO siteVO) {
        SiteDO entity = JSONObject.parseObject(JSONObject.toJSONString(siteVO), SiteDO.class);
        int update = siteDao.updateByPrimaryKey(entity);
        if (update <= 0) {
            throw new RuntimeException("修改失败");
        }
    }

    public ResponseWrapper selectwarehousingArrangementByWtbm(String id) {
        List<WarehousingArrangementVO> list = trademarkMapper.selectwarehousingArrangementByWtbm(id);
        return ResponseWrapper.success(list);
    }

    public TradeMarkVO selectTradeMarkByBdh(String bdh) {
        TradeMarkDO tradeMarkDO = trademarkMapper.selectTradeMarkByBdh(bdh);
        TradeMarkVO tradeMarkVO = JsonUtils.parse(JsonUtils.serialize(tradeMarkDO), TradeMarkVO.class);
        return tradeMarkVO;
    }

    public void deleteTrade(String ids) {
        String[] arr = ids.split(",");
        for (String id : arr) {
            trademarkMapper.deleteByPrimaryKey(id);
        }
    }

    public ResponseWrapper selectDWmcList(String id) {
        SiteDO siteDO = siteDao.selectByPrimaryKey(id);
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteDO.getWtbm());
        List<ContractVO> list = null;
        //查询出所有已发送的合同
        List<String> htList = new ArrayList<>();
        GiveBackBailLetterVO giveBackBailLettervo = new GiveBackBailLetterVO();
        giveBackBailLettervo.setZt(GiveBackBailConstant.ZC.getValue());
        giveBackBailLettervo.setWtfbm(CurrentUtil.getOrgId());
        List<GiveBackBailLetterVO> lists = giveBackBailLetterDao.selectHt(giveBackBailLettervo);
        if (!lists.isEmpty()) {
            for (GiveBackBailLetterVO giveBackBailLetterDO : lists) {
                String[] strings = giveBackBailLetterDO.getHtbm().split(",");
                htList.addAll(Arrays.asList(strings));
            }
        }
        SiteVO siteVO = new SiteVO();
        if (htList.size() > 0) {
            siteVO.setHtList(htList);
        }
        siteVO.setCcbm(id);
        if ("0".equals(exitOrderDO.getJyfx())) {
            list = trademarkMapper.selectDwbmList(siteVO);
        } else {
            list = trademarkMapper.selectDwbmLists(siteVO);
        }
        return ResponseWrapper.success(list);
    }

    public ResponseWrapper selectContractByDwbm(String dwbm, String ccbm) {
        SiteDO siteDO = siteDao.selectByPrimaryKey(ccbm);
        EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteDO.getWtbm());
        List<ContractVO> list = null;
        //查询出所有已发送的合同
        List<String> htList = new ArrayList<>();
        GiveBackBailLetterVO giveBackBailLettervo = new GiveBackBailLetterVO();
        giveBackBailLettervo.setZt(GiveBackBailConstant.ZC.getValue());
        giveBackBailLettervo.setWtfbm(CurrentUtil.getOrgId());
        List<GiveBackBailLetterVO> lists = giveBackBailLetterDao.selectHt(giveBackBailLettervo);
        if (!lists.isEmpty()) {
            for (GiveBackBailLetterVO giveBackBailLetterDO : lists) {
                String[] strings = giveBackBailLetterDO.getHtbm().split(",");
                Collections.addAll(htList, strings);
            }
        }
        SiteVO siteVO = new SiteVO();
        if (htList.size() > 0) {
            siteVO.setHtList(htList);
        }
        siteVO.setCcbm(ccbm);
        siteVO.setDwbm(dwbm);
        if ("0".equals(exitOrderDO.getJyfx())) {
            list = trademarkMapper.selectContractByDwbm(siteVO);
        } else {
            list = trademarkMapper.selectContractByDwbms(siteVO);
        }
        return ResponseWrapper.success(list);
    }

    public ResponseWrapper selectContracts(String dwbm, String jylx) {
        //查询出所有已发送的合同
        List<String> htList = new ArrayList<>();
        GiveBackBailLetterVO giveBackBailLettervo = new GiveBackBailLetterVO();
        giveBackBailLettervo.setZt(GiveBackBailConstant.ZC.getValue());
        giveBackBailLettervo.setWtfbm(dwbm);
        List<GiveBackBailLetterVO> lists = giveBackBailLetterDao.selectHt(giveBackBailLettervo);
        if (!lists.isEmpty()) {
            for (GiveBackBailLetterVO giveBackBailLetterDO : lists) {
                String[] strings = giveBackBailLetterDO.getHtbm().split(",");
                htList.addAll(Arrays.asList(strings));
            }
        }
        SiteVO siteVO = new SiteVO();
        siteVO.setJylx(jylx);
        if (htList.size() > 0) {
            siteVO.setHtList(htList);
        }
        if ("10180008".equals(CurrentUtil.getOrgLevel())) {
            List<String> dwList = trademarkMapper.selectGxgsList(dwbm);
            siteVO.setDwList(dwList);
        } else {
            siteVO.setDwbm(dwbm);
        }

        //if(Integer.valueOf(jylx)==0){
        List<ContractVO> list = trademarkMapper.selectContractHtByDwbm(siteVO);
        //}else{
        //list = trademarkMapper.selectContractByDwbms(siteVO);
        //}
        return ResponseWrapper.success(list);
    }

    public ResponseWrapper selectTradeByCcbm(String ccbm) {
        List<TradeMarkDO> list = trademarkMapper.selectListByCcbm(ccbm);
        return ResponseWrapper.success(list);
    }

    public ResponseWrapper selectContractAll() {
        List<ContractVO> list;
        //查询出所有已发送的合同
        List<String> htList = new ArrayList<>();
        GiveBackBailLetterVO giveBackBailLettervo = new GiveBackBailLetterVO();
        giveBackBailLettervo.setZt(GiveBackBailConstant.ZC.getValue());
        List<GiveBackBailLetterVO> lists = giveBackBailLetterDao.selectHt(giveBackBailLettervo);
        if (!lists.isEmpty()) {
            htList = lists.stream().flatMap(i -> Arrays.stream(i.getHtbm().split(";"))).collect(Collectors.toList());
        }
        SiteVO siteVO = new SiteVO();
        if (htList.size() > 0) {
            siteVO.setHtList(htList);
        }
        list = trademarkMapper.selectContractByDwbm(siteVO);

        return ResponseWrapper.success(list);
    }

    public Double getDj(String ccbm) {
        return trademarkMapper.getDj(ccbm);
    }

    public List<SiteVO> selectContractByZt(String wczt) {
        return trademarkMapper.selectContractByZt(wczt);
    }


    public ResponseWrapper selectContractAlls(String jylx) {
        List<ContractVO> list;
        // 查询出所有已发送的合同
        GiveBackBailLetterVO giveBackBailLettervo = new GiveBackBailLetterVO();
        giveBackBailLettervo.setZt(GiveBackBailConstant.ZC.getValue());
        List<GiveBackBailLetterVO> lists = giveBackBailLetterDao.selectHt(giveBackBailLettervo);
        SiteVO siteVO = new SiteVO();
        if (!lists.isEmpty()) {
            List<String> htList = lists.stream()
                    .flatMap(i -> Arrays.stream(i.getHtbm().split(",")))
                    .collect(Collectors.toList());
            if (htList.size() > 0) {
                siteVO.setHtList(htList);
            }
        }
        siteVO.setJylx(jylx);
        list = trademarkMapper.selectContractByDwbm(siteVO);
        return ResponseWrapper.success(list);
    }

    public EntryAndExitOrderDTO getEntryAndExitOrderDTO(String wtbm) {
        EntryAndExitOrderDTO dto = new EntryAndExitOrderDTO();

        var goodsQuery = new EntryAndExitOrderGoodsDO();
        goodsQuery.setWtbm(wtbm);
        var goodsList = goodsDao.select(goodsQuery);

        EntryAndExitOrderVO entryAndExitOrderVO = getInfoEntryAndExitOrderDetail(wtbm);
        SiteDO siteDO = siteDao.selectOne(SiteDO.builder().wtbm(wtbm).build());
        if (null != siteDO) {
            String jysj = siteDO.getJysj();
            LocalTime localTime = LocalTime.parse(jysj);
            String cnTime = localTime.format(DateTimeFormatter.ofPattern("ah:mm", Locale.SIMPLIFIED_CHINESE));
            entryAndExitOrderVO.setJysj(cnTime);
        }
        entryAndExitOrderVO.setGoodsDOList(goodsList);

        dto.setEntryAndExitOrderVO(entryAndExitOrderVO);
        String jyfx = entryAndExitOrderVO.getJyfx();
        if (jyfx.contains(TradeType.CG)) {
            Example example = new Example(WarehousingArrangementDO.class)
                    .excludeProperties(WarehousingArrangementDO.getExcludeField());
            Criteria criteria = example.createCriteria();
            criteria.andEqualTo("status", 1)
                    .andEqualTo("sjlx", TradeType.type.CG.getValue())
                    .andEqualTo("wtbm", wtbm);
            dto.setApList(getWarehousingList(example));
        }
        if (jyfx.contains(TradeType.XS)) {
            Example example = new Example(WarehousingArrangementDO.class)
                    .excludeProperties(WarehousingArrangementDO.getExcludeField());
            var seeSampleQuery = new EntryAndExitOrderSeeSampleDO();
            seeSampleQuery.setWtbm(wtbm);
            var seeSampleDOList = seeSampleDao.select(seeSampleQuery);
            entryAndExitOrderVO.setSeeSampleDOList(seeSampleDOList);

            Criteria criteria = example.createCriteria();
            criteria.andEqualTo("status", 1)
                    .andEqualTo("sjlx", TradeType.type.XS.getValue())
                    .andEqualTo("wtbm", wtbm);
            dto.setHyList(getWarehousingList(example));
        }
        return dto;
    }

    private List<WarehousingArrangementDTO> getWarehousingList(Example example) {
        var apDoList = warehousingArrangementDao.selectByExample(example);
        if (apDoList == null) {
            return new ArrayList<>();
        }
        var apVoList = JSONObject.parseArray(JSONObject.toJSONString(apDoList), WarehousingArrangementVO.class);
        var collect = apVoList.stream().collect(Collectors.groupingBy(i -> (i.getDwbm() + "@" + i.getDwmc()), LinkedHashMap::new, Collectors.toList()));
        return collect.entrySet().stream().map(i -> {
            var dw = i.getKey().split("@");
            BigDecimal count = i.getValue().stream().map(WarehousingArrangementVO::getLssl).filter(Objects::nonNull).reduce(BigDecimal.ZERO, BigDecimal::add);
            return WarehousingArrangementDTO.builder().detailList(i.getValue()).count(count).dwmc(dw[1]).dwbm(dw[0]).build();
        }).collect(Collectors.toList());
    }

    public int insertEntryAndExitOrder2(EntryAndExitOrderDTO entityDTO) {
        EntryAndExitOrderVO entryAndExitOrderVO = entityDTO.getEntryAndExitOrderVO();
        var jyfx = entryAndExitOrderVO.getJyfx();
        String tableName = EntityUtil.getTableName(EntryAndExitOrderDO.class);
        String wtbm = baseMapper.selectByTableNameAndAttr(tableName, "wtbm", "wt", 8);

        EntryAndExitOrderDO mainEntity = JSONObject.parseObject(JSONObject.toJSONString(entryAndExitOrderVO), EntryAndExitOrderDO.class);
        mainEntity.setWtbm(wtbm);
        String orgId = CurrentUtil.getOrgId();
        mainEntity.setWtfbm(orgId);
        mainEntity.setWtfmc(CurrentUtil.getOrgName());
        String preStr = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMMdd"));
        if (TradeType.CG.equals(jyfx)) {
            preStr = "CG" + preStr;
        } else if (TradeType.XS.equals(jyfx)) {
            preStr = "XS" + preStr;
        } else {
            preStr = "SX" + preStr;
        }

        if ("".equals(orgId)) {
            mainEntity.setZt("");
        }
        String wtbh = baseMapper.selectByTableNameAndAttr(tableName, "wtbh", preStr, 3);
        mainEntity.setWtbh(wtbh);
        mainEntity.buildInsertData();
        mainEntity.setFbzt(null);
        mainEntity.setFbztmc(null);
        int wtRes = entryAndExitOrderDao.insertSelective(mainEntity);

        var goodsDOList = entryAndExitOrderVO.getGoodsDOList();
        saveGoodsList(wtbm, goodsDOList);

        if (jyfx.contains(TradeType.CG)) {
            saveWarehousingArrangementList(entityDTO.getApList(), wtbm, TradeType.type.CG.getValue());
        }
        if (jyfx.contains(TradeType.XS)) {
            var seeSampleDOList = entryAndExitOrderVO.getSeeSampleDOList();
            saveSeeSampleList(wtbm, seeSampleDOList);
            saveWarehousingArrangementList(entityDTO.getHyList(), wtbm, TradeType.type.XS.getValue());
        }
        return wtRes;
    }

    private void saveWarehousingArrangementList(List<WarehousingArrangementDTO> hyList, String wtbm, int jylx) {
        if (null != hyList) {
            for (WarehousingArrangementDTO dto : hyList) {
                String dwbm = dto.getDwbm();
                String dwdm = dto.getDwdm();
                String dwmc = dto.getDwmc();
                List<WarehousingArrangementVO> detailList = dto.getDetailList();
                for (WarehousingArrangementVO arrangementVO : detailList) {
                    var entity = JSONObject.parseObject(JSONObject.toJSONString(arrangementVO), WarehousingArrangementDO.class);
                    String pk = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(WarehousingArrangementDO.class), "apbm", "AP", 8);
                    entity.buildInsertData();
                    entity.setApbm(pk);
                    entity.setDwbm(dwbm);
                    entity.setDwdm(dwdm);
                    entity.setDwmc(dwmc);
                    entity.setWtbm(wtbm);
                    entity.initLx(jylx);
                    String dbbm = pk.replace("AP", "BD");
                    entity.setBdbm(dbbm);
                    int insert = warehousingArrangementDao.insertSelective(entity);
                    if (insert <= 0) {
                        throw new RuntimeException("新增失败");
                    }
                }
            }
        }
    }

    public int updateEntryAndExitOrder2(EntryAndExitOrderDTO entityDTO) {
        EntryAndExitOrderVO entryAndExitOrderVO = entityDTO.getEntryAndExitOrderVO();
        EntryAndExitOrderDO mainEntity = JSONObject.parseObject(JSONObject.toJSONString(entryAndExitOrderVO), EntryAndExitOrderDO.class);
        String wtbm = mainEntity.getWtbm();
        String zt = mainEntity.getZt();

        int mainRes = entryAndExitOrderDao.updateByPrimaryKeySelective(mainEntity);
        List<String> editConstants = Arrays.asList(EntryAndExitOrderNodeConstant.DTJ.getValue(), EntryAndExitOrderNodeConstant.DSH.getValue(), EntryAndExitOrderNodeConstant.DGZ.getValue());
        if (editConstants.contains(zt)) {
            var jyfx = entryAndExitOrderVO.getJyfx();
            var goodsDOList = entryAndExitOrderVO.getGoodsDOList();
            goodsDao.deleteByWtbm(wtbm);
            saveGoodsList(wtbm, goodsDOList);

            WarehousingArrangementDO waQuery = new WarehousingArrangementDO();
            waQuery.setWtbm(wtbm);
            if (jyfx.contains(TradeType.CG)) {
                waQuery.setSjlx(TradeType.type.CG.getValue());
                int delete = warehousingArrangementDao.delete(waQuery);
                saveWarehousingArrangementList(entityDTO.getApList(), wtbm, TradeType.type.CG.getValue());
            }
            if (jyfx.contains(TradeType.XS)) {
                var seeSampleDOList = entryAndExitOrderVO.getSeeSampleDOList();
                seeSampleDao.deleteByWtbm(wtbm);
                saveSeeSampleList(wtbm, seeSampleDOList);
                waQuery.setSjlx(TradeType.type.XS.getValue());
                int delete = warehousingArrangementDao.delete(waQuery);
                saveWarehousingArrangementList(entityDTO.getHyList(), wtbm, TradeType.type.XS.getValue());
            }
        }
        return mainRes;
    }

    public void saveGoodsList(String wtbm, List<EntryAndExitOrderGoodsDO> goodsDOList) {
        if (null != goodsDOList) {
            for (EntryAndExitOrderGoodsDO goodsDO : goodsDOList) {
                goodsDO.setWtbm(wtbm);
                String nextSeq = seeSampleDao.getNextSeq();
                goodsDO.setDataId(nextSeq);
                goodsDao.insertSelective(goodsDO);
            }
        }
    }

    public void saveSeeSampleList(String wtbm, List<EntryAndExitOrderSeeSampleDO> list) {
        if (null != list) {
            for (EntryAndExitOrderSeeSampleDO seeSampleDO : list) {
                seeSampleDO.setWtbm(wtbm);
                String nextSeq = seeSampleDao.getNextSeq();
                seeSampleDO.setDataId(nextSeq);
                seeSampleDao.insertSelective(seeSampleDO);
            }
        }
    }

    public int deleteEntryAndExitOrder(String wtbm) {
        int i = entryAndExitOrderDao.deleteByPrimaryKey(wtbm);
        seeSampleDao.deleteByWtbm(wtbm);
        goodsDao.deleteByWtbm(wtbm);
        int delete = warehousingArrangementDao.deleteByWtbm(wtbm);
        return i;
    }


    public void update2NextNode(EntryAndExitOrderDO entity) {
        entryAndExitOrderDao.updateWtsNode(entity);
    }

    /**
     * @param entityDTO
     * @return
     */
    public int updatePrice(EntryAndExitOrderDTO entityDTO) {
        EntryAndExitOrderVO mainEntity = entityDTO.getEntryAndExitOrderVO();
        String apzt = mainEntity.getApzt();
        String orgId = CurrentUtil.getOrgId();
        if ("LS001019".equals(orgId) && EntryAndExitOrderNodeConstant.DGZ.eqVal(apzt)) {
            mainEntity.setApzt(EntryAndExitOrderNodeConstant.YQR.getValue());
            mainEntity.setApztmc(EntryAndExitOrderNodeConstant.YQR.getName());
        }
        int i = entryAndExitOrderDao.updatePriceStatus(mainEntity);
        var jyfx = mainEntity.getJyfx();
        if (i > 0) {
            if (jyfx.contains(TradeType.CG)) {
                var apList = entityDTO.getApList();
                apList.stream().map(WarehousingArrangementDTO::getDetailList).flatMap(Collection::stream).collect(Collectors.toList()).forEach(item -> {
                    warehousingArrangementDao.updatePrice(item.getApbm(), item.getJydj());
                });
            }
            if (jyfx.contains(TradeType.XS)) {
                var hyList = entityDTO.getHyList();
                for (WarehousingArrangementDTO dto : hyList) {
                    for (WarehousingArrangementVO item : dto.getDetailList()) {
                        warehousingArrangementDao.updatePrice(item.getApbm(), item.getJydj());
                    }
                }
            }
        }
        return i;
    }

    /**
     * @param entity
     * @return
     */
    public int updatePrice2NextNode(EntryAndExitOrderVO entity) {
        return entryAndExitOrderDao.updatePriceStatus(entity);
    }

    /**
     * 更新公告状态
     *
     * @param entity
     * @return a
     */
    public JSONObject updateNotice2NextNode(EntryAndExitOrderVO entity) {
        JSONObject res = new JSONObject();

        var wtbm = entity.getWtbm();
        Integer fbzt = entity.getFbzt();
        String fbztmc = entity.getFbztmc();

        String ggbt = entity.getGgbt();
        String ggzw = entity.getGgzw();
        String hwggbt = entity.getHwggbt();
        String hwggzw = entity.getHwggzw();
        int i = 0;
        int ChannelId = 58;
        if (1 == fbzt) {
            log.info("创建津粮网 公告信息 start");
            WcmDocumentObj documentObj2 = WcmDocumentObj.builder()
                    .docStatus(1028)
                    .docHtmlCon(hwggzw)
                    .docTitle(hwggbt)
                    .build();
            WDocument hw = documentObj2.toWDocument(null);
            int hwWcmId2 = DocumentMgr.save(hw);
            log.info("货物公告 docId" + hwWcmId2);
            entity.setWcmId2(String.valueOf(hwWcmId2));

            WcmDocumentObj documentObj = WcmDocumentObj.builder()
                    .docStatus(1028)
                    .docHtmlCon(ggzw)
                    .docTitle(ggbt)
                    .build();
            WDocument gg = documentObj.toWDocument(null);
            int ggWcmId1 = DocumentMgr.save(gg);
            log.info(ggWcmId1);
            log.info("正文公告 docId" + ggWcmId1);
            entity.setWcmId1(String.valueOf(ggWcmId1));

            i = entryAndExitOrderDao.updateNotice2Node(entity);
            res.put("msg", ggWcmId1 + ";" + hwWcmId2);
            log.info("创建津粮网 公告信息 end");
        } else if (2 == fbzt) {
            var exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(wtbm);
            String wcmId1 = exitOrderDO.getWcmId1();
            if (StringUtils.isNotEmpty(wcmId1)) {
                boolean bDeleted1 = DocumentMgr.delete(wcmId1, ChannelId, 0);
                if (bDeleted1) {
                    entity.setWcmId1(null);
                } else {
                    log.info(ggbt + " 已被津粮网锁定，请登录津粮网进行操作");
                    res.put("msg1", ggbt + "  已被津粮网锁定，请登录津粮网进行操作");
                }
            }
            String wcmId2 = exitOrderDO.getWcmId2();
            if (StringUtils.isNotEmpty(wcmId2)) {
                boolean bDeleted2 = DocumentMgr.delete(wcmId2, ChannelId, 0);
                if (bDeleted2) {
                    entity.setWcmId2(null);
                } else {
                    res.put("msg2", hwggbt + " 已被津粮网锁定，请登录津粮网进行操作");
                }
            }
            i = entryAndExitOrderDao.updateNotice2NextNode(wtbm, fbzt, fbztmc);
        } else if (0 == fbzt) {
            i = entryAndExitOrderDao.updateNotice2Node(entity);
        }
        return res;
    }

    public void updateContractByisChange(ContractVO vo) {
        ContractDO contractDO = JSONObject.parseObject(JSONObject.toJSONString(vo), ContractDO.class);
        contractDao.updateByPrimaryKeySelective(contractDO);
    }
}
