package com.unis.transaction.server.entity.base;

import com.trs.web2frame.entity.WDocument;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Optional;

/**
 * @author by PIG
 * 2022/9/20 15
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "WCM document 实体")
public class WcmDocumentObj {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    private String DOCID;
    @ApiModelProperty("栏目id")
    private int channelId = 58;
    @ApiModelProperty("")
    private int documentId = 0;
    @ApiModelProperty("标题")
    private String docTitle;
    @ApiModelProperty("文章内容")
    private String docHtmlCon;
    @ApiModelProperty("文章类型 <br>  20 HTML,10 纯文本,30 链接,40 文件")
    private int docType = 20;
    @ApiModelProperty("所属 未知<br/>" +
            "文字型<br/>" +
            "图片型<br/>" +
            "音频型<br/>" +
            "视频型")
    private String docForm;
    @ApiModelProperty("状态")
    private int docStatus;

    @ApiModelProperty("发稿人")
    private String CrUser;

    public WDocument toWDocument(Integer status) {
        WDocument oDocument = new WDocument();
        oDocument.setFieldValue("ChannelId", 58);
        oDocument.setFieldValue("DocumentId", 0);
        oDocument.setFieldValue("DOCTYPE", 20); // 文档类型
        oDocument.setFieldValue("DocStatus", Optional.ofNullable(status).orElse(this.docStatus)); //
        oDocument.setFieldValue("DOCSTATUS", Optional.ofNullable(status).orElse(this.docStatus)); //
        oDocument.setFieldValue("DOCFORM", 2); // 图片
        oDocument.setFieldValue("DOCLEVEL", 1);

        oDocument.setFieldValue("DOCPEOPLE", this.docTitle);
        oDocument.setFieldValue("DocTitle", this.docTitle);
        oDocument.setFieldValue("DocHtmlCon", this.docHtmlCon);

        oDocument.setFieldValue("DocAuthor", "cbl-author"); //
        oDocument.setFieldValue("DocEditor", "cbl-editor"); //
        oDocument.setFieldValue("operuser", "cbl-operuser"); //
        return oDocument;
    }

}
