package com.unis.transaction.server.entity.creditevaluate;

import com.unis.transaction.server.entity.base.BaseDO;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Author lidiaoquan
 * Description 成交数据维护
 * Date  2019-09-26
 */
@Data
@Table(name="ty_xycjsjwh")
public class TurnoverDataDO extends BaseDO {
	private static final long serialVersionUID = 1L;

	@Id
	private String cjbm;	//成交编码 CJ+8位顺序号

	private String sfbm;	//省份编码

	private String sfmc;	//省份名称

	private String htbm;	//合同编码

	private String hth;	//合同号

	private String bdbm;	//标的编码

	private String bdh;	//标的号

	private String mfcckbm;	//卖方承储库编码

	private String mfcckmc;	//卖方承储库名称

	private String jhckbm;	//交货仓库编码

	private String jhckmc;	//交货仓库名称

	private String chbm;	//仓号编码

	private String chmc;	//仓号名称

	private String scnf;	//生产年份

	private String sflt;	//是否露天  0否 1是

	private String sgdjbm;	//收购等级编码

	private String sgdjmc;	//收购等级名称

	private String hhqydjbm;	//混合扦样等级编码

	private String hhqydjmc;	//混合扦样等级名称

	private BigDecimal cjsl;	//成交数量

	private BigDecimal zcjsl;	//总成交数量

	private String lsxzbm;	//粮食性质编码

	private String lsxzmc;	//粮食性质名称

	private String lspzbm;	//粮食品种编码

	private String lspzmc;	//粮食品种名称

	private BigDecimal qpjg;	//起拍价格

	private BigDecimal cjdj;	//成交单价

	private BigDecimal cjje;	//成交金额


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date cjrq;	//成交日期


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date fhkjzrq;	//付货款截止日期


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date ckjzrq;	//出库截止日期

	private BigDecimal sxf;

	private String cjdwbm;	//成交单位编码

	private String cjdwmc;	//成交单位名称

	private String dzjlx;	//IP地址及类型

	private String jyjbh;	//交易节编号

	private String ztbm;	//状态编码

	private String ztmc;	//状态名称

	private String lyzt;	//履约状态编码

	private String lyztmc;	//履约状态编码

	private BigDecimal hxdf;	//横向得分

	private BigDecimal hxzf;	//横向总得分

	private String cc;	//卖方承储库编码

	private String wtf;	//委托方

	private String sskd;	//所属库点编码

	private String sskdmc;	//所属库点名称

	private String ssqy;	//所属企业编码

	private String ssqymc;	//所属库点名称

	private String sjlx;	//数据类型  0是系统生成 1是客户自己添加维护的

	private String sscc;	//所属场次
	private String jylx;
	private String jyxz;
	private String pjj;

	private String lysl;

	private String lyl;
	private String qysl;
	private String wbqy;
	private String cd;
	private BigDecimal trsl;
}
