package com.unis.transaction.server.entity.creditevaluate;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * Author lgd
 * Description 交易结果及手续费实体
 */
@Data
@Table(name="ty_jyjg")
public class TurnoverEndDO{
	private static final long serialVersionUID = 1L;

	@Id
	private String jgbm;	//结果编码 CJ+8位顺序号

	@ApiModelProperty(value = "场次名称", notes ="")
	private String apcc;

	private String ccbm;


	@ApiModelProperty(value = "委托方", notes ="")
	private String wtfmc;


	@ApiModelProperty(value = "交易性质", notes ="")
	private Integer jyxz;

	@ApiModelProperty(value = "粮食性质", notes ="")
	private String lsxzbm;

	@ApiModelProperty(value = "粮食性质", notes ="")
	private String lsxzmc;

	private String jyxzmc;

	private String jylxmc;


	@ApiModelProperty(value = "品种", notes ="")
	private String pzmc;

	@ApiModelProperty(value = "品种", notes ="")
	private String pzbm;


	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "交割日期", notes ="")
	private Date jgrq;

	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	@ApiModelProperty(value = "交易日期", notes ="")
	private Date jyrq;


	@ApiModelProperty(value = "发布状态 0待发布 1已发布 2清单已撤回", notes ="")
	private String fbzt;


	@ApiModelProperty(value = "发布状态名称", notes ="")
	private String fbztmc;


	@ApiModelProperty(value = "公告标题", notes ="")
	private String title;

	@ApiModelProperty(value = "发布人", notes ="")
	private String fbr;


	@ApiModelProperty(value = "底价", notes ="")
	private String dj;	//仓号编码


	@ApiModelProperty(value = "交易数量", notes ="")
	private String jysl;	//仓号名称


	@ApiModelProperty(value = "成交数量", notes ="")
	private String cjsl;	//生产年份


	@ApiModelProperty(value = "最低成交价", notes ="")
	private String zdcjj;


	@ApiModelProperty(value = "最高成交价", notes ="")
	private String zgcjj;


	@ApiModelProperty(value = "均价", notes ="")
	private String jj;


	@ApiModelProperty(value = "成交率", notes ="")
	private String cjl;


	@ApiModelProperty(value = "发布时间", notes ="")
	private String fbsj;


	@ApiModelProperty(value = "交易类型", notes ="")
	private String jylx;


	@ApiModelProperty(value = "手续费类型", notes ="")
	private String sxflx;


	@ApiModelProperty(value = "手续费率", notes ="")
	private String sxfl;

	@ApiModelProperty(value = "富文本", notes ="")
	private String fwb;

}
