package com.unis.transaction.server.entity.givebackbail;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.server.entity.base.BaseDO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * Author lgd
 * Description 交易申诉
 */
@Data
@Table(name="ty_jycs")
public class ComplainDO extends BaseDO {
    private static final long serialVersionUID = 1L;
    @Id
    private String csbm;
    @ApiModelProperty(value = "交易申诉标题", notes ="", required = false)
    private String title;
    @ApiModelProperty(value = "交易申诉类型，0：粮食数量，1：粮食质量，2：提货时间，3：其他", notes ="", required = false)
    private Integer cslx;
    @ApiModelProperty(value = "交易申诉类型名称", notes ="", required = false)
    private String cslxmc;
    @ApiModelProperty(value = "数据类型，0：交易申诉，1：交易诉求", notes ="", required = false)
    private Integer sjlx;
    @ApiModelProperty(value = "场次", notes ="", required = false)
    private String apcc;
    @ApiModelProperty(value = "场次编码", notes ="", required = false)
    private String ccbm;
    @ApiModelProperty(value = "合同编码", notes ="", required = false)
    private String htbm;
    @ApiModelProperty(value = "合同号", notes ="", required = false)
    private String htbh;
    @ApiModelProperty(value = "粮食性质", notes ="", required = false)
    private String lsxz;
    @ApiModelProperty(value = "品种", notes ="", required = false)
    private String pz;
    @ApiModelProperty(value = "买方", notes ="", required = false)
    private String ccmc;
    @ApiModelProperty(value = "卖方", notes ="", required = false)
    private String sgmc;
    @ApiModelProperty(value = "买方编码", notes ="", required = false)
    private String ccdw;
    @ApiModelProperty(value = "卖方编码", notes ="", required = false)
    private String sgdw;
    @ApiModelProperty(value = "申诉原因", notes ="", required = false)
    private String reason;
    @ApiModelProperty(value = "申诉附件", notes ="", required = false)
    private String csfj;
    @ApiModelProperty(value = "申诉单位", notes ="", required = false)
    private String csdw;
    @ApiModelProperty(value = "申诉单位名称", notes ="", required = false)
    private String csdwmc;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    @ApiModelProperty(value = "申诉日期", notes ="", required = false)
    private Date cssj;
    @ApiModelProperty(value = "申诉状态 0待提交，1已提交，2已处理", notes ="", required = false)
    private String cszt;
    @ApiModelProperty(value = "申诉状态名称", notes ="", required = false)
    private String csztmc;
    @ApiModelProperty(value = "回复人", notes ="", required = false)
    private String hfr;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    @ApiModelProperty(value = "回复日期", notes ="", required = false)
    private Date hfsj;
    @ApiModelProperty(value = "回复类型 0仅申请方 1交易双方 2仅被申诉方", notes ="", required = false)
    private Integer hflx;
    @ApiModelProperty(value = "申诉方答复", notes ="", required = false)
    private String csdf;
    @ApiModelProperty(value = "答复附件", notes ="", required = false)
    private String dffj;
    @ApiModelProperty(value = "被申诉方通知", notes ="", required = false)
    private String bcstz;
    private String bcsdw;
    @ApiModelProperty(value = "被诉求答复时间", notes ="", required = false)
    @DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    private Date bcssj;
    @ApiModelProperty(value = "被诉求方人", notes ="", required = false)
    private String bcsr;
    @ApiModelProperty(value = "被诉求方答复", notes ="", required = false)
    private String bcsdf;
    @ApiModelProperty(value = "被诉求方附件", notes ="", required = false)
    private String bcsfj;
    @ApiModelProperty(value = "通知附件", notes ="", required = false)
    private String tzfj;
    private String bcszt;
}
