/*
 * GiveBackBailLetterDO.java
 * 版权所有 © 2011-2017 北京神舟良实信息技术有限公司
 * Copyright © 2011-2017 All Rights Reserved    京ICP备13013562号
 * 2019-09-20 created by LPH with LAPTOP-IJQ2SDFV
 */
package com.unis.transaction.server.entity.givebackbail;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.server.entity.base.BaseDO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * TY_JYTKWTH
 * @author LPH with LAPTOP-IJQ2SDFV on 2019-09-20 21:04:22
 */
@ApiModel(value = "TY_JYTKWTH:退保证金委托函")
@Data
@Table(name="TY_JYTKWTH")
public class    GiveBackBailLetterDO extends BaseDO {
    @ApiModelProperty(value = "委托函编码#<主键><非空>", notes ="委托函编码")
    @Id
    @Column(name="WTHBM")
    private String wthbm;

    @ApiModelProperty(value = "通知标题", notes ="通知标题")
    @Column(name="TZBT")
    private String tzbt;

    @ApiModelProperty(value = "委托函编号", notes ="委托函编号")
    @Column(name="WTHBH")
    private String wthbh;

    @ApiModelProperty(value = "0销售#<默认值:0>1采购", notes ="0销售")
    @Column(name="WTLX")
    private Integer wtlx;

    @ApiModelProperty(value = "类型名称", notes ="类型名称")
    @Column(name="WTLXMC")
    private String wtlxmc;

    @ApiModelProperty(value = "接收单位", notes ="接收单位")
    @Column(name="JSDW")
    private String jsdw;

    @ApiModelProperty(value = "接收单位", notes ="接收单位")
    @Column(name="JSDWBM")
    private String jsdwbm;

    @ApiModelProperty(value = "接收正文", notes ="接收正文")
    @Column(name="JSZW")
    private String jszw;

    @ApiModelProperty(value = "场次", notes ="场次")
    @Column(name="APCC")
    private String apcc;

    @ApiModelProperty(value = "场次编码", notes ="场次")
    @Column(name="CCBM")
    private String ccbm;

    @ApiModelProperty(value = "合同编号", notes ="场次")
    @Column(name="HTBH")
    private String htbh;

    @ApiModelProperty(value = "合同编码", notes ="场次")
    @Column(name="HTBM")
    private String htbm;

    @ApiModelProperty(value = "编制人", notes ="编制人")
    @Column(name="BZR")
    private String bzr;

    @ApiModelProperty(value = "编制时间", notes ="编制时间")
    @Column(name="BZSJ")
    @DateTimeFormat( pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "PRC")
    private Date bzsj;

    @ApiModelProperty(value = "状态值", notes ="状态值")
    @Column(name="ZT")
    private String zt;

    @ApiModelProperty(value = "状态名称", notes ="状态名称")
    @Column(name="ZTMC")
    private String ztmc;
    @ApiModelProperty(value = "委托方编码", notes ="委托方编码")
    @Column(name="WTFBM")
    private String wtfbm;

    /**
     * null
     * @author LPH with LAPTOP-IJQ2SDFV on 2019-09-20 21:04:22
     */
    public GiveBackBailLetterDO() {
        super();
    }
}