package com.unis.transaction.server.entity.signuppay;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.server.entity.base.BaseDO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Author lidiaoquan
 * Description 交易报名
 * Date  2019-09-20
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Table(name="ty_jybm")
public class TransactionSignUpDO extends BaseDO {
	private static final long serialVersionUID = 1L;

	@Id
	private String jybm;	//交易报名

	private String ccbm;

	private String wtbm;

	private String wtfbm;

	private String bdbm;	//标的编码  BD +8位顺序号

	private String bdh;	//标的号

	private String apcc;	//场次

    @ApiModelProperty(value = "数量（吨）显示委托书中全部数量合计")
    @Column(name = "sl")
	private BigDecimal sl;	//数量

	private String je;	//金额

	private String lspzbm;	//粮食品种

	private String lspzmc;	//粮食品种名称

	private String lsxz;	//粮食性质

	private String lsxzmc;	//粮食性质名称

	private String lslb;	//粮食类别

	private String lslbmc;	//粮食类别名称

	private String dwbm;	//报名单位编码

    @ApiModelProperty("报名单位名称")
    private String dwmc;

    @Column(name = "lxdh")
    @ApiModelProperty("联系电话")
	private String lxdh;

    @ApiModelProperty("交易保证金")
	private String jybzj;

    @ApiModelProperty("履约保证金")
	private String lybzj;

	private String sxfl;	//手续费率 根据粮食性质编码带出


    @ApiModelProperty("报名日期")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date bmrq;

	private String fjid;	//附件id

	private String spr;	//审核人

	private String shzt;	//审核状态

	private String shztmc;	//审核状态名称

	private String shyj;	//审核意见


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date shsj;	//审核时间

	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date gqsj;	//审核时间

	private BigDecimal hkje;	//汇款金额


	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date hksj;	//汇款时间

	private String hkdwbm;	//汇款单位编码

	private String hkdwmc;	//汇款单位名称

	private String hkpz;	//汇款凭证

	private Integer skzt;	//收款状态 0否 1是

	private String hkyj;	//收款状态 0否 1是

	private String skztmc;	//收款状态名称0否 1是

	private String tkzt;	//退款状态

	private String tkztmc;	//退款状态名称

	private String jkje;	//缴款金额

	private String yxbd;	//意向标的

    @Column(name = "lxr")
    @ApiModelProperty("联系人")
	private String lxr;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "交易日期", notes ="")
    private Date jyrq;

    @ApiModelProperty(value = "交易时间", notes ="")
    @Column(name = "jysj")
    private String jysj;

    @ApiModelProperty(value = "交易方向<br/> 0采购 1销售 0,1购销双向")
    @Column(name = "jyfx")
    private String jyfx;

    @ApiModelProperty(value = "交易方向名称<br/> 0采购<br/> 1销售<br/> 0,1购销双向")
    @Column(name = "jyfxmc")
    private String jyfxmc;

    @ApiModelProperty("交易方式<br/>  0竞价  1挂牌 2购销双向")
    private String jyfs;

    @ApiModelProperty("交易方式名称")
    private String jyfsmc;

    @ApiModelProperty(value = "意向数量（吨）")
    @Column(name = "yxsl")
    private BigDecimal yxsl;

    @ApiModelProperty(value = "汇款审核结果")
    private Integer hkshjg;
    @ApiModelProperty(value = "汇款审核时间")
    @Column(name = "hkshsj")
    private Date hkshsj;
    @ApiModelProperty(value = "汇款审核意见")
    private String hkshyj;
    @ApiModelProperty(value = "汇款审核人")
    private String hkshr;

    @ApiModelProperty(value = "交易审核结果")
    private Integer jyshjg;
    @ApiModelProperty(value = "交易审核时间")
    private Date jyshsj;
    @ApiModelProperty(value = "交易审核意见")
    private String jyshyj;
    @ApiModelProperty(value = "交易审核人")
    private String jyshr;


    private String wtbh;

    public static String [] getExcludeField(){
        return new String[]{
                "fjid", "shyj", "hkyj", "hkshyj", "jyshyj", "hkpz"
        };
    }

}
