package com.unis.transaction.server.entity.tradeplan;

import com.unis.transaction.server.entity.base.BaseDO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;

/**
 * Description 合同
 * Date  2019-09-21
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Table(name = "ty_jyht")
public class ContractDO extends BaseDO {
    private static final long serialVersionUID = 1L;
    @Id
    private String htbm;

    private String htbh;

    private String shbh;

    @ApiModelProperty("卖方")
    private String cmmc;

    @ApiModelProperty(value = "卖方单位编码")
    private String cmdw;

    @ApiModelProperty("买方")
    private String sgmc;

    private String sgdw;

    @ApiModelProperty(value = "委托单位       ",notes = "储备粮---发送单位", required = true)
    private String fsdw;

    @ApiModelProperty(value = "承储单位名称", required = true)
    private String cckmc;
    private String cckdm;

    @ApiModelProperty(value = "品种名称")
    private String pzmc;

    private String adress;

    @ApiModelProperty("总成交数量")
    private BigDecimal lssl;

    private Integer jylx;

    private String qddd;

    private String bdh;

    private String bdbm;
    @ApiModelProperty(value = "单价")
    private BigDecimal dj;
    @ApiModelProperty(value = "成交额(元)")
    private BigDecimal je;

    @ApiModelProperty(value = "实际交款额(元)")
    @Column(name = "sjjke")
    private BigDecimal sjjke;

    private String cdkmc;
    @ApiModelProperty(value = "法定代表人")
    private String fddbr;

    @ApiModelProperty(value = "卖方电话")
    private String mtel;
    @ApiModelProperty(value = "收购方、买方电话")
    private String sgtel;
    @ApiModelProperty(value = "委托代理人")
    private String wtdlr;

    private String khyh;
    @ApiModelProperty(value = "银行开户帐号")
    private String khzh;

    private String zh;
    @ApiModelProperty(value = "卖方邮政编码")
    private String yzbm;
    @ApiModelProperty(value = "买方邮政编码")
    private String sgbm;
    @ApiModelProperty(value = "粮食等级")
    private String lsdj;

    private String pdfs;

    //@DateTimeFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty("成交日期")
    private String cjrq;
    @ApiModelProperty(value = "交货仓库")
    private String njhck;
    @ApiModelProperty(value = "卖方承储库")
    private String nmfcck;
    @ApiModelProperty(value = "仓号", required = true)
    private String nch;
    @ApiModelProperty(value = "生产年份", required = true)
    private String nnf;
    @ApiModelProperty(value = "生产年份")
    private String shcnf;
    @ApiModelProperty(value = "是否露天")
    private String nsflt;
    @ApiModelProperty(value = "扦样等级")
    private String nqydj;
    @ApiModelProperty(value = "总成交数量")
    private String nzcjl;
    @ApiModelProperty(value = "出库截止日期")
    private String nckjzrq;
    @ApiModelProperty(value = "仓房编码", required = true)
    private String ncfbm;
    @ApiModelProperty(value = "卖方编码")
    private String nmfbm;
    private String nbz;
    @ApiModelProperty(value = "起拍价")
    private String nqpj;

    @ApiModelProperty(value = "交割日期", required = true)
    @Column(name = "prompt_date")
    private String promptDate;

    @ApiModelProperty(value = "联系人", required = true)
    private String lxr;
    @ApiModelProperty(value = "联系方式", required = true)
    private String lxfs;

    @ApiModelProperty(value = "交易类型<br/> 0采购 1销售 0,1购销双向", required = true)
    private String jyfx;

    @ApiModelProperty(value = "交易方式<br/>  0竞价 1挂牌 2购销双向", required = true)
    private String jyfs;

    @ApiModelProperty(value = "品种编码", required = true)
    @Column(name = "pzbm")
    private String pzbm;

    @ApiModelProperty(value = "起拍单价", required = true)
    private BigDecimal qpdj;
    @ApiModelProperty(value = "成交单价", required = true)
    private BigDecimal cjdj;
    @ApiModelProperty(value = "场次编码", required = true)
    private String ccbm;
    @ApiModelProperty(value = "场次", required = true)
    private String apcc;

    @ApiModelProperty(value = "数据版本 0 老数据 1 新数据", example = "1")
    @Column(name = "data_ver")
    private Integer dataVer;

    @ApiModelProperty(value = "退款状态 0 未退款 1 已退款", example = "0")
    @Column(name = "refund_status")
    private String refund_status;

    @ApiModelProperty(value = "粮食性质", required = true)
    private String lsxz;

    @ApiModelProperty(value = "合同下发结果")
    @Column(name = "sendresult")
    private String sendresult;

    // 是否可更改
    @ApiModelProperty(value = "是否可更改,0否，1是")
    @Column(name = "is_change")
    private String isChange;
}
