package com.unis.transaction.server.entity.tradeplan;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;

@Data
@ApiModel(value = "DcJyHzzb", description = "地储交易汇总表")
public class DcJyHzzb implements Serializable {

    @ApiModelProperty(value = "场次")
    @ExcelProperty(value = "场次")
    private String cc;

    @ApiModelProperty(value = "场次编号")
    @ExcelIgnore
    private String ccbh;

    @ApiModelProperty(value = "交易日期")
    @ExcelProperty(value = "交易日期")
    private String jyrq;

    @ApiModelProperty(value = "委托单位")
    @ExcelProperty(value = "委托单位")
    private String wtf;

    @ApiModelProperty(value = "交易级别")
    @ExcelProperty(value = "交易级别")
    private String jyjb;

    @ApiModelProperty(value = "交易方式")
    @ExcelIgnore
    private String jyfs;

    @ApiModelProperty(value = "交易方式名称")
    @ExcelProperty(value = "交易方式")
    private String jyfsmc;

    @ApiModelProperty(value = "交易类型")
    @ExcelIgnore
    private String jylx;

    @ApiModelProperty(value = "交易类型名称")
    @ExcelProperty(value = "交易类型")
    private String jylxmc;

    @ApiModelProperty(value = "品种")
    @ExcelProperty(value = "品种")
    private String pzmc;

    @ApiModelProperty(value = "品种编号")
    @ExcelIgnore
    private String pzbm;

    @ApiModelProperty(value = "标的数量(吨)")
    @ExcelProperty(value = "标的数量(吨)")
    private String bdsl;

    @ApiModelProperty(value = "合同数量(吨)")
    @ExcelProperty(value = "合同数量(吨)")
    private String htsl;

    @ApiModelProperty(value = "履约数量(吨)")
    @ExcelProperty(value = "履约数量(吨)")
    private String lysl;

    @ApiModelProperty(value = "违约数量(吨)")
    @ExcelProperty(value = "违约数量(吨)")
    private String wysl;

    @ApiModelProperty(value = "合同金额(元)")
    @ExcelProperty(value = "合同金额(元)")
    private String htje;

    @ApiModelProperty(value = "履约金额(元)")
    @ExcelProperty(value = "履约金额(元)")
    private String lyje;

    @ApiModelProperty(value = "手续费金额(元)")
    @ExcelProperty(value = "手续费金额(元)")
    private String sxfje;

    // 年度条件
    @ApiModelProperty(value = "年度条件")
    @ExcelIgnore
    private String nd;

    // 交易日期开始
    @ApiModelProperty(value = "交易日期开始")
    @ExcelIgnore
    @DateTimeFormat(pattern = "yyyy年MM月dd日")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String jyrqStart;

    // 交易日期结束
    @ApiModelProperty(value = "交易日期结束")
    @ExcelIgnore
    @DateTimeFormat(pattern = "yyyy年MM月dd日")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String jyrqEnd;
}
