package com.unis.transaction.server.entity.tradeplan;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.server.entity.base.BaseDO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * Author huyong
 * Description 出入库委托书
 * Date  2019-09-19
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Table(name = "ty_jycrkwt")
@ApiModel(value = "出入库安排")
public class EntryAndExitOrderDO extends BaseDO {
    private static final long serialVersionUID = 1L;

    @Id
    @ApiModelProperty(value = "wt+8位顺序号  编码")
    private String wtbm;

    @ApiModelProperty(value = "交易方向<br/> 0采购 1销售 0,1购销双向")
    @Column(name = "jyfx")
    private String jyfx;

    @ApiModelProperty(value = "交易方向名称<br/> 0采购<br/> 1销售<br/> 0,1购销双向")
    @Column(name = "jyfxmc")
    private String jyfxmc;

    @ApiModelProperty("品种编码")
    private String pzbm;

    @ApiModelProperty("品种名称")
    private String pzmc;

    @ApiModelProperty("委托编号 ")
    private String wtbh;

    @ApiModelProperty("委托方编码")
    private String wtfbm;

    @ApiModelProperty("委托方名称")
    private String wtfmc;

    @ApiModelProperty("交割日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date jgrq;

    @ApiModelProperty("交易日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date jyrq;

    @ApiModelProperty("交易方式<br/>  0竞价  1挂牌 2购销双向")
    private String jyfs;

    @ApiModelProperty("交易方式名称")
    private String jyfsmc;

    @ApiModelProperty("文本内容")
    private String wbnr;

    @ApiModelProperty("1确认 2驳回")
    private Integer sfjs;

    @ApiModelProperty("意见")
    private String yj;

    @ApiModelProperty("状态值")
    private String zt;

    @ApiModelProperty("状态名称")
    private String ztmc;

    @ApiModelProperty("公告标题")
    private String ggbt;

    @ApiModelProperty("公告正文")
    private String ggzw;

    @ApiModelProperty("发布人")
    private String fbr;

    @ApiModelProperty("交易标题")
    private String mxbt;

    @ApiModelProperty("交易正文")
    private String mxzw;

    @ApiModelProperty("交易发布人")
    private String mxfbr;


    @ApiModelProperty("编制时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date bzsj;

    @ApiModelProperty("编制人员")
    private String bzr;

    @ApiModelProperty("发布状态 0 未发布 1已发布 2 发布后撤回")
    private Integer fbzt;

    @ApiModelProperty("发布状态名称 0未发布 1已发布 2发布后撤回")
    private String fbztmc;

    @ApiModelProperty("安排状态")
    private String apzt;

    @ApiModelProperty("安排状态名称")
    private String apztmc;

    @ApiModelProperty("货源表状态")
    @Column(name = "")
    private String hybzt;

    @ApiModelProperty("货源表状态名称")
    @Column(name = "")
    private String hybztmc;

    @ApiModelProperty("货源审核意见")
    @Column(name = "")
    private String hyyj;

    @ApiModelProperty("货源审核结果")
    @Column(name = "")
    private String hyshjg;

    @Transient
    private List<String> zts;

    @Transient
    private Integer page;

    @ApiModelProperty(value = "粮食性质<br/> 1·市储<br/> 2·区储<br/> 3·市自")
    @Column(name = "lsxzbm")
    private String lsxzbm;

    @ApiModelProperty(value = "粮食性质<br/> 市储<br/> 区储<br/> 市自")
    @Column(name = "lsxzmc")
    private String lsxzmc;

    @ApiModelProperty("委托附件")
    @Column(name = "wtfj")
    private String wtfj;

    @ApiModelProperty("承诺附件")
    @Column(name = "")
    private String cnfj;

    @ApiModelProperty(value = "产地", notes = "产地")
    @Column(name = "lscd")
    private String lscd;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty("委托日期")
    @Column(name = "")
    private Date wtrq;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "保质期限first")
    @Column(name = "bzq_first_date")
    private Date bzqFirstDate;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "保质期限last")
    @Column(name = "bzq_last_date")
    private Date bzqLastDate;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "完成时间")
    @Column(name = "wcsj")
    private Date wcsj;

    @ApiModelProperty(value = "购销价差")
    @Column(name = "gxcj")
    private BigDecimal gxcj;

    @ApiModelProperty(value = "报名企业要求")
    @Column(name = "qybmyq")
    private String qybmyq;
    @ApiModelProperty(value = "资质<br/> 1生产 2经营 3应急 4进口", example = "1,2")
    @Column(name = "qyzz")
    private String qyzz;
    @ApiModelProperty(value = "承诺")
    @Column(name = "commitment")
    private String commitment;
    @ApiModelProperty(value = "符合标准")
    @Column(name = "fhbz")
    private String fhbz;
    @ApiModelProperty(value = "检验项目要求")
    @Column(name = "jyxmyq")
    private String jyxmyq;
    @ApiModelProperty(value = "竞价差值")
    @Column(name = "jjcz")
    private BigDecimal jjcz;
    @ApiModelProperty(value = "包装要求")
    @Column(name = "bzyq")
    private String bzyq;
    @ApiModelProperty(value = "交货方式<br/> 1库内价 2汽车车板价")
    @Column(name = "jhfs")
    private String jhfs;
    @ApiModelProperty(value = "计量方式<br/> 1 地磅记录 2 检斤计价 3 其他")
    @Column(name = "jlfs")
    private String jlfs;
    @ApiModelProperty(value = "入库要求<br/> 1第三方报告 2出厂报告")
    @Column(name = "rkyq")
    private String rkyq;
    @ApiModelProperty(value = "第三方报告要求")
    @Column(name = "sfbgyq")
    private String sfbgyq;
    @ApiModelProperty(value = "出厂检验项目")
    @Column(name = "ccjyxm")
    private String ccjyxm;
    @ApiModelProperty(value = "出入库顺序<br/> 1先出后入 2先入后出 3其他")
    @Column(name = "crksx")
    private String crksx;

    @ApiModelProperty("结算方式")
    @Column(name = "jsfs")
    private String jsfs;

    @ApiModelProperty("委托审核人")
    @Column(name = "wtshr")
    private String wtshr;
    @ApiModelProperty("委托审核时间")
    @Column(name = "wtshsj")
    private String wtshsj;
    @ApiModelProperty("委托方盖章")
    @Column(name = "wtfqz")
    private String wtfqz;
    @ApiModelProperty("委托方盖章时间")
    @Column(name = "wtfgzsj")
    private String wtfgzsj;

    @ApiModelProperty("受理人")
    @Column(name = "slr")
    private String slr;
    @ApiModelProperty("受理人意见")
    @Column(name = "slryj")
    private String slryj;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty("受理日期")
    @Column(name = "slrq")
    private Date slrq;

    @ApiModelProperty("审核人")
    @Column(name = "jyzxshr")
    private String jyzxshr;

    @ApiModelProperty("审核人意见")
    @Column(name = "jyzxshryj")
    private String jyzxshryj;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty("审核人日期")
    @Column(name = "jyzxshrq")
    private Date jyzxshrq;

    @ApiModelProperty("货物公告标题")
    @Column(name = "hwggbt")
    private String hwggbt;

    @ApiModelProperty("货物公告正文")
    @Column(name = "hwggzw")
    private String hwggzw;

    @Column(name = "wcm_id1")
    private String wcmId1;
    @Column(name = "wcm_id2")
    private String wcmId2;

    @Column(name = "slrshjg")
    @ApiModelProperty("受理人人审核结果")
    private Integer slrshjg;
    @Column(name = "jyzxshrshjg")
    @ApiModelProperty("交易中心审核人审核结果")
    private Integer jyzxshrshjg;

    @Column(name = "jydjqz")
    private String jydjqz;


    public static String [] getExcludeField(){
        return new String[]{
                "rkyq", "wbnr", "ggzw", "hwggzw", "mxbt", "wtfj", "cnfj",
                "commitment", "jyxmyq", "fhbz", "bzyq", "sfbgyq", "ccjyxm", "jsfs",
                "wtfqz","slryj","jyzxshryj"
        };
    }

}







