package com.unis.transaction.server.entity.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.common.entity.base.BaseDO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "未履约说明函表")
@Table(name = "ty_refund_letter")
public class RefundLetterDO extends BaseDO {

    @Id
    @ApiModelProperty(value = "ID", notes = "")
    private String id;

    @ApiModelProperty(value = "合同编码", notes = "")
    @Column(name = "htbm")
    private String htbm;

    //状态
    @ApiModelProperty(value = "状态")
    @Column(name = "zt")
    private String zt;

    @ApiModelProperty(value = "状态name")
    @Column(name = "zt_name")
    private String ztName;

    //盖章
    @ApiModelProperty(value = "盖章")
    @Column(name = "gz")
    private String gz;

    //签章日期
    @ApiModelProperty(value = "等章日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @Column(name = "gzrq")
    private Date gzrq;

    //盖章人
    @ApiModelProperty(value = "盖章人")
    @Column(name = "gzr")
    private String gzr;

    //盖章人编码
    @ApiModelProperty(value = "盖章人编码")
    @Column(name = "gzrbh")
    private String gzrbh;

    //是否接收
    @ApiModelProperty(value = "是否接收 0:否 1:是")
    @Column(name = "sfjs")
    private Integer sfjs;

    //接收意见
    @ApiModelProperty(value = "接收意见")
    @Column(name = "jsyj")
    private String jsyj;

    //接收人
    @ApiModelProperty(value = "接收人")
    @Column(name = "jsr")
    private String jsr;

    //接收人编号
    @ApiModelProperty(value = "接收人编号")
    @Column(name = "jsrbh")
    private String jsrbh;

    //接收日期
    @ApiModelProperty(value = "接收日期")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @Column(name = "jsrq")
    private Date jsrq;

    @ApiModelProperty(value = "正文")
    @Column(name = "tzzw")
    private String tzzw;

}
