package com.unis.transaction.server.entity.tradeplan;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.server.entity.base.BaseDO;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * Author lgd
 * Description 场次信息
 */
@NoArgsConstructor
@AllArgsConstructor
@Builder
@Data
@EqualsAndHashCode(callSuper = true)
@Table(name="ty_jycc")
public class SiteDO extends BaseDO{
    private static final long serialVersionUID = 1L;

    @Id
    private String ccbm;
    @ApiModelProperty(value = "委托编码", notes ="")
    private String wtbm;
    @ApiModelProperty(value = "安排|货源 编码", notes ="")
    private String apbm;
    @ApiModelProperty(value = "", notes ="")
    private String cccode;
    @ApiModelProperty(value = "场次", notes ="")
    private String apcc;
    @ApiModelProperty(value = "场次状态 0 未发布 1 已发布", notes ="")
    private String cczt;

    @ApiModelProperty(value = "场次编号", notes ="")
    private String ccbh;

    @ApiModelProperty(value = "手续费", notes ="")
    private String sxf;
    @ApiModelProperty(value = "手续费率", notes ="")
    private String sxfl;

    @ApiModelProperty(value = "交易保证金", notes ="")
    private String jybzj;

    @ApiModelProperty(value = "履约保证金", notes ="")
    private String lybzj;

    @ApiModelProperty(value = "数量", notes ="")
    private String sl;

    @ApiModelProperty(value = "手续费类型", notes ="")
    private String sxfType;

    @ApiModelProperty(value = "保证金", notes ="")
    private String bzj;

    @ApiModelProperty(value = "交易性质", notes ="")
    private String jyxz;

    @ApiModelProperty(value = "", notes ="")
    private Integer zt;

    @ApiModelProperty(value = "委托编号", notes ="")
    private String wtbh;

    @ApiModelProperty(value = "", notes ="")
    @Column(name = "marks")
    private String marks;

    @ApiModelProperty(value = "", notes ="")
    private String wczt;

    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "交易日期", notes ="")
    private Date jyrq;

    @ApiModelProperty(value = "交易类型<br/> 0采购 1销售 0,1购销双向")
    @Column(name = "jyfx")
    private String jyfx;

    @ApiModelProperty("交易方式<br/>  0竞价 1挂牌 2购销双向")
    @Column(name = "jyfs")
    private String jyfs;

    @ApiModelProperty(value = "交易时间", notes ="")
    @Column(name = "jysj")
    private String jysj;

    @ApiModelProperty("委托方编码")
    @Column(name = "wtfbm")
    private String wtfbm;

    @ApiModelProperty("委托方名称")
    @Column(name = "wtfmc")
    private String wtfmc;

    public static String [] getExcludeField(){
        return new String[]{
                "marks"
        };
    }
}
