package com.unis.transaction.server.entity.tradeplan;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Classname TyBmkhxxtj
 * @Description 报名客户信息统计
 * @Date 2023/9/11 16:27
 * @Created by rising123sun
 */
@Data
@ApiModel(description = "报名客户信息统计")
public class TyBmkhxxtj {

    // 场次
    @ApiModelProperty(value = "场次")
    @ExcelProperty(value = "场次")
    private String cc;

    // 场次编号
    @ApiModelProperty(value = "场次编号")
    @ExcelProperty(value = "场次编号")
    private String ccbh;

    // 委托单位
    @ApiModelProperty(value = "委托单位")
    @ExcelProperty(value = "委托单位")
    private String wtdw;

    // 品种名称
    @ApiModelProperty(value = "品种")
    @ExcelProperty(value = "品种")
    private String pzmc;

    // 品种编码
    @ApiModelProperty(value = "品种编码")
    @ExcelIgnore
    private String pzbm;

    // 粮食性质
    @ApiModelProperty(value = "粮食性质编码")
    @ExcelIgnore
    private String lsxzbm;

    // 粮食性质名称
    @ApiModelProperty(value = "粮食性质")
    @ExcelProperty(value = "粮食性质")
    private String lsxzmc;

    // 会员名称
    @ApiModelProperty(value = "会员名称")
    @ExcelProperty(value = "会员名称")
    private String hymc;

    // 交易前保证金
    @ApiModelProperty(value = "交易前保证金")
    @ExcelProperty(value = "交易前保证金")
    private String jyqbzj;

    // 交易日期
    @ApiModelProperty(value = "交易日期")
    @ExcelProperty(value = "交易日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String jyrq;

    // 合同号
    @ApiModelProperty(value = "合同号")
    @ExcelProperty(value = "合同号")
    private String hth;

    // 成交情况
    @ApiModelProperty(value = "成交情况")
    @ExcelProperty(value = "成交情况")
    private String cjqk;

    // 交易日期开始
    @ApiModelProperty(value = "交易日期开始")
    @ExcelProperty(value = "交易日期开始")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ExcelIgnore
    private String jyrqStart;

    // 交易日期结束
    @ApiModelProperty(value = "交易日期结束")
    @ExcelProperty(value = "交易日期结束")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ExcelIgnore
    private String jyrqEnd;
}
