package com.unis.transaction.server.entity.tradeplan;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;

@Data
@ApiModel(value = "TyDcsjjl", description = "地储数据记录表")
public class TyDcsjjl implements Serializable {

    @ApiModelProperty(value = "场次")
    @ExcelProperty(value = "场次")
    private String cc;

    @ApiModelProperty(value = "场次编号")
    @ExcelProperty(value = "场次编号")
    private String ccbh;

    @ApiModelProperty(value = "交易日期")
    @ExcelProperty(value = "交易日期")
    private String jyrq;

    @ApiModelProperty(value = "委托单位")
    @ExcelProperty(value = "委托单位")
    private String wtf;

    @ApiModelProperty(value = "交易级别")
    @ExcelProperty(value = "交易级别")
    private String jyjb;

    @ApiModelProperty(value = "交易类型编码")
    @ExcelIgnore
    private String jylx;

    @ApiModelProperty(value = "交易类型名称")
    @ExcelProperty(value = "交易类型")
    private String jylxmc;

    @ApiModelProperty(value = "交易方式编码")
    @ExcelIgnore
    private String jyfs;

    @ApiModelProperty(value = "交易方式名称")
    @ExcelProperty(value = "交易方式")
    private String jyfsmc;

    @ApiModelProperty(value = "品种")
    @ExcelProperty(value = "品种")
    private String pzmc;

    @ApiModelProperty(value = "品种编号")
    @ExcelIgnore
    private String pzbm;

    @ApiModelProperty(value = "标的号")
    @ExcelProperty(value = "标的号")
    private String bdh;

    @ApiModelProperty(value = "合同号")
    @ExcelProperty(value = "合同号")
    private String hth;

    @ApiModelProperty(value = "标的数量(吨)")
    @ExcelProperty(value = "标的数量(吨)")
    private String bdsl;

    @ApiModelProperty(value = "合同数量(吨)")
    @ExcelProperty(value = "合同数量(吨)")
    private String htsl;

    @ApiModelProperty(value = "履约数量(吨)")
    @ExcelProperty(value = "履约数量(吨)")
    private String lysl;

    @ApiModelProperty(value = "违约数量(吨)")
    @ExcelProperty(value = "违约数量(吨)")
    private String wysl;

    @ApiModelProperty(value = "起拍价(元/吨)")
    @ExcelProperty(value = "起拍价(元/吨)")
    private String qpj;

    @ApiModelProperty(value = "成交价(元/吨)")
    @ExcelProperty(value = "成交价(元/吨)")
    private String cjj;

    //todo 以下字段需要根据实际情况修改
    @ApiModelProperty(value = "交易结果")
    @ExcelProperty(value = "交易结果")
    private String jyjg;

    @ApiModelProperty(value = "成交客户")
    @ExcelProperty(value = "成交客户")
    private String cjkh;

    // 报名客户
    @ApiModelProperty(value = "报名客户")
    @ExcelProperty(value = "报名客户")
    private String bmkh;

    @ApiModelProperty(value = "承储单位")
    @ExcelProperty(value = "承储单位")
    private String ccdw;

    @ApiModelProperty(value = "仓号")
    @ExcelProperty(value = "仓号")
    private String ch;

    @ApiModelProperty(value = "合同金额(元)")
    @ExcelProperty(value = "合同金额(元)")
    private String htje;

    @ApiModelProperty(value = "履约金额(元)")
    @ExcelProperty(value = "履约金额(元)")
    private String lyje;

    @ApiModelProperty(value = "委托方手续费率")
    @ExcelProperty(value = "委托方手续费率")
    private String wtfsxfl;

    @ApiModelProperty(value = "客户手续费率")
    @ExcelProperty(value = "客户手续费率")
    private String khsxfl;

    @ApiModelProperty(value = "手续费金额(元)")
    @ExcelProperty(value = "手续费金额(元)")
    private String sxfje;

    @ApiModelProperty(value = "履约保证金(元/吨)")
    @ExcelProperty(value = "履约保证金(元/吨)")
    private String lybzj;

    @ApiModelProperty(value = "交易保证金(元/吨)")
    @ExcelProperty(value = "交易保证金(元/吨)")
    private String jybzj;

    @ApiModelProperty(value = "特殊备注")
    @ExcelProperty(value = "特殊备注")
    private String tsbz;

    @ApiModelProperty(value = "原因")
    @ExcelProperty(value = "原因")
    private String yy;

    // 年度条件
    @ApiModelProperty(value = "年度条件")
    @ExcelIgnore
    private String nd;

    // 交易日期开始
    @ApiModelProperty(value = "交易日期开始")
    @ExcelIgnore
    @DateTimeFormat(pattern = "yyyy年MM月dd日")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String jyrqStart;

    // 交易日期结束
    @ApiModelProperty(value = "交易日期结束")
    @ExcelIgnore
    @DateTimeFormat(pattern = "yyyy年MM月dd日")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String jyrqEnd;

    @ExcelIgnore
    private Dcjybzxx dcjybzxx;
}
