package com.unis.transaction.server.entity.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname TyHtlytxDao
 * @Description 敦促履约提醒
 * @Date 2023/8/2 13:56
 * @Created by rising123sun
 */
@Data
@ApiModel(description = "敦促履约提醒")
public class TyHtlytxDO {

    // id
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "承储企业名称")
    @Column(name = "ccqymc")
    private String ccqymc;

    @ApiModelProperty(value = "承储企业编码")
    @Column(name = "ccqybm")
    private String ccqybm;


    @ApiModelProperty(value = "发起单位")
    @Column(name = "fqdw")
    private String fqdw;

    @ApiModelProperty(value = "发起人")
    @Column(name = "fqr")
    private String fqr;

    @ApiModelProperty(value = "场次")
    @Column(name = "apcc")
    private String apcc;

    @ApiModelProperty(value = "合同号")
    @Column(name = "hth")
    private String hth;

    @ApiModelProperty(value = "计划完成日期")
    @Column(name = "jhwcrq")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jhwcrq;

    @ApiModelProperty(value = "提醒日期/发起时间")
    @Column(name = "txrq")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date txrq;

    @ApiModelProperty(value = "回复时间")
    @Column(name = "hfsj")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date hfsj;

    @ApiModelProperty(value = "承储企业回复")
    @Column(name = "ccqyhf")
    private String ccqyhf;

    @ApiModelProperty(value = "说明")
    @Column(name = "sm")
    private String sm;

    @ApiModelProperty(value = "回复状态,0未回复，1已回复")
    @Column(name = "hfzt")
    private String hfzt;

    @ApiModelProperty(value = "敦促履约函内容")
    @Column(name = "dcllh")
    private String dcllh;

    @ApiModelProperty(value = "敦促履约涵编制人")
    @Column(name = "dclyhbzr")
    private String dclyhbzr;

    @ApiModelProperty(value = "敦促履约涵编制日期")
    @Column(name = "dclyhbzrq")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date dclyhbzrq;

    @ApiModelProperty(value = "组织编码")
    @Column(name = "orgCode")
    private String orgCode;

    @ApiModelProperty(value = "任务名称")
    @Column(name = "rwmc")
    private String rwmc;

    @ApiModelProperty(value = "版本")
    @Column(name = "version")
    private String version;
}
