package com.unis.transaction.server.entity.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname TyHtlytxDclyh
 * @Description 敦促履约函
 * @Date 2023/8/2 13:56
 * @Created by rising123sun
 */
@Data
@Table(name = "ty_htlytx_dclyh")
@ApiModel(description = "敦促履约函")
public class TyHtlytxDclyh {

    @Id
    @ApiModelProperty(value = "id")
    @Column(name = "id")
    private String id;

    @ApiModelProperty(value = "编制人")
    @Column(name = "bzr")
    private String bzr;

    @ApiModelProperty(value = "编制日期")
    @Column(name = "bzrq")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date bzrq;

    @ApiModelProperty(value = "成交单位")
    @Column(name = "cjdw")
    private String cjdw;

    @ApiModelProperty(value = "成交日期")
    @Column(name = "cjrq")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date cjrq;


    @ApiModelProperty(value = "合同号")
    @Column(name = "hth")
    private String hth;

    @ApiModelProperty(value = "截至日期")
    @Column(name = "jzrq")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jzrq;

    @ApiModelProperty(value = "生成日期")
    @Column(name = "scrq")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date scrq;

    @ApiModelProperty(value = "内容")
    @Column(name = "content")
    private String content;
}
