package com.unis.transaction.server.entity.tradeplan;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Classname TyHtlytxDao
 * @Description 敦促履约提醒
 * @Date 2023/8/2 13:56
 * @Created by rising123sun
 */
@Data
@ApiModel(description = "敦促履约提醒")
public class TyHtlytxVO {

    // id
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "承储企业名称")
    private String ccqymc;

    @ApiModelProperty(value = "承储企业编码")
    private String ccqybm;


    @ApiModelProperty(value = "发起单位")
    private String fqdw;

    @ApiModelProperty(value = "发起人")
    private String fqr;

    @ApiModelProperty(value = "场次")
    private String apcc;

    @ApiModelProperty(value = "合同号")
    private String hth;

    @ApiModelProperty(value = "合同编码")
    private String htbm;

    @ApiModelProperty(value = "计划完成日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jhwcrq;

    @ApiModelProperty(value = "提醒日期/发起时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date txrq;

    @ApiModelProperty(value = "回复时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date hfsj;

    @ApiModelProperty(value = "承储企业回复")
    private String ccqyhf;

    @ApiModelProperty(value = "说明")
    private String sm;

    @ApiModelProperty(value = "回复状态,0未回复，1已回复")
    private String hfzt;

    @ApiModelProperty(value = "敦促履约函内容")
    private String dcllh;

    @ApiModelProperty(value = "敦促履约涵编制人")
    private String dclyhbzr;

    @ApiModelProperty(value = "敦促履约涵编制日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date dclyhbzrq;

    @ApiModelProperty(value = "组织编码")
    private String orgCode;

    @ApiModelProperty(value = "任务名称")
    private String rwmc;

    @ApiModelProperty(value = "计划完成时间开始")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String jhwcsjks;

    @ApiModelProperty(value = "计划完成时间结束")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String jhwcsjjs;
}
