package com.unis.transaction.server.entity.tradeplan;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Classname TyJytjbbJyjghz
 * @Description 交易结果汇总表
 * @Date 2023/7/31 08:45
 * @Created by rising123sun
 */
@Data
public class TyJytjbbJyjghz {

    @ApiModelProperty(value = "交易日期")
    private String cjrq;

    @ApiModelProperty(value = "交易日期开始")
    @DateTimeFormat(pattern = "yyyy年MM月dd日")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String cjrqks;

    @ApiModelProperty(value = "交易日期结束")
    @DateTimeFormat(pattern = "yyyy年MM月dd日")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private String cjrqjs;

    // 场次
    @ApiModelProperty(value = "场次")
    private String apcc;

    // 交易方向
    @ApiModelProperty(value = "交易方向<br/> 0采购 1销售 0,1购销双向")
    private String jyfx;

    // 交易方向名称
    @ApiModelProperty(value = "交易方向名称")
    private String jyfxmc;

    // 品种
    @ApiModelProperty(value = "品种")
    private String pzmc;

    @ApiModelProperty(value = "品种编码")
    private String pzbm;

    // 成产年限
    @ApiModelProperty(value = "成产年限")
    private String ccnx;

    // 产地
    @ApiModelProperty(value = "产地")
    private String cd;

    // 成交数量
    @ApiModelProperty(value = "成交数量")
    private String cjsl;

    // 底价
    @ApiModelProperty(value = "底价")
    private String dj;

    // 最低价
    @ApiModelProperty(value = "最低价")
    private String zdcjj;

    // 最高价
    @ApiModelProperty(value = "最高价")
    private String zgcjj;

    // 均价
    @ApiModelProperty(value = "均价")
    private String jj;

    // 交易额
    @ApiModelProperty(value = "交易额")
    private String jye;

    // 委托方编码
    @ApiModelProperty(value = "委托方编码")
    private String wtfbm;
    // 委托方编码
    @ApiModelProperty(value = "标的编码")
    private String bdbm;

}
