package com.unis.transaction.server.entity.tradeplan;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.transaction.server.entity.base.BaseDO;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Author huyong
 * Description 出入库安排
 * Date  2019-09-20
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
@EqualsAndHashCode(callSuper = true)
@Table(name = "ty_jycrkap")
public class WarehousingArrangementDO extends BaseDO {
    private static final long serialVersionUID = 1L;

    @Id
    @ApiModelProperty(value = "AP+8位顺序号  编码", notes = "")
    private String apbm;

    @ApiModelProperty(value = "wt+8位顺序号  编码", notes = "")
    @Column(name = "wtbm")
    private String wtbm;

    @ApiModelProperty(value = "单位编码", notes = "")
    @Column(name = "dwbm")
    private String dwbm;
    @ApiModelProperty(value = "单位编码", notes = "")
    @Column(name = "dwdm")
    private String dwdm;
    @ApiModelProperty(value = "单位名称", notes = "")
    @Column(name = "dwmc")
    private String dwmc;

    @ApiModelProperty(value = "品种编码", notes = "")
    @Column(name = "pzbm")
    private String pzbm;

    @ApiModelProperty(value = "品种名称", notes = "")
    @Column(name = "pzmc")
    private String pzmc;

    @ApiModelProperty(value = "粮食数量", notes = "")
    @Column(name = "lssl")
    private BigDecimal lssl;

    @ApiModelProperty(value = "生产年度", notes = "")
    @Column(name = "scnd")
    private String scnd;
    @ApiModelProperty(value = "是否变更<br/> 0是 1否", notes = "")
    @Column(name = "sfbg")
    private Integer sfbg;

    @ApiModelProperty(value = "储存地点", notes = "仓房")
    @Column(name = "ccdd")
    private String ccdd;

    @ApiModelProperty(value = "容重", notes = "")
    @Column(name = "rz")
    private String rz;
    @ApiModelProperty(value = "水份", notes = "")
    @Column(name = "sf")
    private String sf;
    @ApiModelProperty(value = "杂质", notes = "")
    @Column(name = "zhaz")
    private String zhaz;
    @ApiModelProperty(value = "不完善粒", notes = "")
    @Column(name = "bwsl")
    private String bwsl;
    @ApiModelProperty(value = "色泽气味", notes = "")
    @Column(name = "szqw")
    private String szqw;

    //lgd新加字段start
    @ApiModelProperty(value = "出糙率", notes = "")
    @Column(name = "ccl")
    private String ccl;

    @ApiModelProperty(value = "酸值", notes = "")
    @Column(name = "sz")
    private String sz;
    @ApiModelProperty(value = "过氧化值", notes = "")
    @Column(name = "gyhz")
    private String gyhz;
    @ApiModelProperty(value = "溶剂残留量", notes = "")
    @Column(name = "rjcll")
    private String rjcll;
    @ApiModelProperty(value = "霉变", notes = "")
    @Column(name = "mb")
    private String mb;
    @ApiModelProperty(value = "脂肪酸值", notes = "")
    @Column(name = "zfsz")
    private String zfsz;
    @ApiModelProperty(value = "品尝评分值", notes = "")
    @Column(name = "pcpfz")
    private String pcpfz;
    @ApiModelProperty(value = "黄粒米", notes = "")
    @Column(name = "hlm")
    private String hlm;
    @ApiModelProperty(value = "互混", notes = "")
    @Column(name = "hh")
    private String hh;
    //lgd新加字段end

    @ApiModelProperty(value = "提货期限", notes = "")
    @Column(name = "thqx")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date thqx;
    @ApiModelProperty(value = "1确认 2驳回", notes = "")
    private Integer sfjs;
    @ApiModelProperty(value = "意见", notes = "")
    @Column(name = "yj")
    private String yj;
    @ApiModelProperty(value = "状态值", notes = "")
    @Column(name = "zt")
    private String zt;
    @ApiModelProperty(value = "状态名称", notes = "")
    @Column(name = "ztmc")
    private String ztmc;
    @ApiModelProperty(value = "细则标题", notes = "")
    @Column(name = "xzbt")
    private String xzbt;
    @ApiModelProperty(value = "细则正文", notes = "")
    @Column(name = "xzzw")
    private String xzzw;

    @ApiModelProperty(value = "编制时间", notes = "")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date bzsj;

    @ApiModelProperty(value = "编制人员", notes = "")
    private String bzr;
    @ApiModelProperty(value = "发布状态 0 暂存 1已发布", notes = "")
    private Integer fbzt;

    @ApiModelProperty(value = "发布状态名称 0 暂存 1已发布", notes = "")
    private String fbztmc;

    @ApiModelProperty(value = "常用出库方式  0铁路 1公路  2水路", notes = "")
    private String cyckfs;

    @Column(name = "cknl")
    @ApiModelProperty(value = "出库能力", notes = "")
    private String cknl;

    @ApiModelProperty(value = "是否具备40吨计量能力  0是 1否", notes = "")
    @Column(name = "sfjbnl")
    private Integer sfjbnl;

    @ApiModelProperty(value = "有无铁路专线    0是 1否", notes = "")
    @Column(name = "ywtl")
    private Integer ywtl;

    @ApiModelProperty(value = "是否露天", notes = "")
    @Column(name = "sflt")
    private Integer sflt;

    @ApiModelProperty(value = "距离最近距离", notes = "")
    @Column(name = "jl")
    private String jl;
    @ApiModelProperty(value = "储粮方式", notes = "")
    @Column(name = "clxs")
    private Integer clxs;
    @ApiModelProperty(value = "储粮方式名称", notes = "")
    @Column(name = "clxsmc")
    private String clxsmc;

    @ApiModelProperty(value = "数据类型 0-安排 1-货源", notes = "")
    @Column(name = "sjlx")
    private Integer sjlx;

    @ApiModelProperty(value = "安排数据类型 0-安排数据 1-货源保存", notes = "")
    @Column(name = "aplx")
    private Integer aplx;

    @ApiModelProperty(value = "交易类型<br/> 0采购 1销售", notes = "")
    @Column(name = "jylx")
    private Integer jylx;

    private String wtfmc;

    private String wtfbm;

    @ApiModelProperty(value = "收购等级")
    private String sgdj;

    @ApiModelProperty(value = "产地", notes = "")
    @Column(name = "cd")
    private String cd;

    @ApiModelProperty(value = "仓房编码", notes = "仓房编码")
    private String cfbm;

    @ApiModelProperty(value = "碎米", notes = "")
    @Column(name = "sm")
    private String sm;
    @ApiModelProperty(value = "加工精度", notes = "")
    @Column(name = "jgjd")
    private String jgjd;
    @ApiModelProperty(value = "灰分", notes = "")
    @Column(name = "hf")
    private String hf;


    @JSONField(format = "yyyy-MM-dd")
    @DateTimeFormat( pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    @ApiModelProperty(value = "完成时间", notes = "")
    @Column(name = "wcsj")
    private Date wcsj;

    @ApiModelProperty(value = "入库能力", notes = "")
    @Column(name = "rknl")
    private String rknl;

    @ApiModelProperty(value = "是否空仓<br/>  否 是", notes = "")
    @Column(name = "sfkc")
    private String sfkc;

    @ApiModelProperty(value = "标的分组序号", notes = "")
    @Column(name = "bd_group")
    private String bdGroup;

    @ApiModelProperty("标的号 CG/XS 20220829-001，20220829为交易时间的日期。001为当前唯一编号自增。")
    @Column(name = "bdh")
    private String bdh;

    @ApiModelProperty("标的编码  BD +8位顺序号")
    @Column(name = "bdbm")
    private String bdbm;

    @ApiModelProperty("交易底价")
    @Column(name = "jydj")
    private BigDecimal jydj;

    public static String[] getExcludeField() {
        return new String[]{
                "cyckfs", "fbztmc", "fbzt", "yj",
                "bzr", "xzbt", "xzzw"
        };
    }

    /**
     * @param lx 安排、数据、交易 类型
     */
    public void initLx(int lx){
        this.aplx = lx;
        this.sjlx = lx;
        this.jylx = lx;
    }
}
