/*
 * GiveBackBailLetterService.java
 * 版权所有 © 2011-2017 北京神舟良实信息技术有限公司
 * Copyright © 2011-2017 All Rights Reserved    京ICP备13013562号
 * 2019-09-20 21:04:21 created by lipenghe with LAPTOP-IJQ2SDFV
 */
package com.unis.transaction.server.service;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.givebackbail.GiveBackBailLetterVO;
import com.unis.transaction.server.entity.givebackbail.GiveBackBailLetterDO;

/**
 * TY_JYTKWTH-退保证金委托函
 * @author lipenghe at 2019-09-20 21:04:21
 */
public interface GiveBackBailLetterService {
    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 插入全部字段
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper insertEntityResult(GiveBackBailLetterVO bailLetterVO);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 插入全部字段,可删除部分字段改为选择性插入
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper insertEntitySelectiveResult(GiveBackBailLetterVO bailLetterVO);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 更改状态
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper updateStatusByEntityResult(GiveBackBailLetterVO bailLetterVO, String limit);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体更新单条或者多条数据
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper updateByEntityResult(GiveBackBailLetterVO bailLetterVO, String limit);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体选择性更新
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper updateByEntitySelectiveResult(GiveBackBailLetterVO bailLetterVO, String limit);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体选择性更新,只更新主表,不更新子表
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper updateSingleByEntitySelectiveResult(GiveBackBailLetterVO bailLetterVO, String limit);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体选择性更新
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper updateByEntitySelectiveResult(GiveBackBailLetterDO entity, String limit);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体单条或者批量删除
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper deleteByEntityResult(GiveBackBailLetterVO bailLetterVO, String limit);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体(唯一标示)查询一条数据
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper selectByIdResult(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体(唯一标示)查询一条数据
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper selectByIdResult(GiveBackBailLetterVO bailLetterVO);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体查询分页列表,带限制条件
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper selectPageByEntityResult(int pageNo, int pageSize, GiveBackBailLetterVO bailLetterVO
            , String order);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体查询列表
     * @param entity    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper selectByEntityResult(GiveBackBailLetterDO entity);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体查询列表
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper selectByEntityResult(GiveBackBailLetterVO bailLetterVO);

    /**
     * <TY_JYTKWTH-退保证金委托函>
     * 根据实体查询初始化数据
     * @param bailLetterVO    <退保证金委托函>对象
     * @author lipenghe with LAPTOP-IJQ2SDFV
     */
    ResponseWrapper selectInitDataResult(GiveBackBailLetterVO bailLetterVO);

    ResponseWrapper selectTkdwList();

    ResponseWrapper selectTkdwHtList(String dwbm);
}