package com.unis.transaction.server.service;

import com.unis.common.utils.DateUtil;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import com.unis.transaction.server.dao.EntryAndExitOrderDao;
import com.unis.transaction.server.entity.tradeplan.EntryAndExitOrderDO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * 修改场次手动完成状态
 * Created by admin on 2017/12/4.
 */
@Component
@Slf4j
@Lazy(false)
public class JyccTimer {
    @Autowired
    private TradeMarkService tradeMarkService;
    @Autowired
    private EntryAndExitOrderDao entryAndExitOrderDao;
    @Scheduled(cron = "0 15 0 * * ?")//每天晚上12点05执行
    //@Scheduled(cron = "0 54 15 * * ?")//每天晚上12点05执行
    public  void dowork(){
        String sign= DateUtil.getCurrentStringDate();
        log.info("------手动完成状态开始",sign);
        try {
            execute(sign);
        } catch (Exception e) {
            e.printStackTrace();
        }
        log.info("---手动完成状态结束",sign);

    }

    public void execute(String sign) throws Exception{
        log.info("===================================定时修改手动完成状态开始======================================================================");
        List<SiteVO> list = tradeMarkService.selectContractByZt("未成交");
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        for(SiteVO siteVO:list){
            EntryAndExitOrderDO exitOrderDO = entryAndExitOrderDao.selectByPrimaryKey(siteVO.getWtbm());
            Date dt1 = df.parse(df.format(exitOrderDO.getJyrq()));
            Date dt2 = df.parse(df.format(new Date()));
            if(dt1.getTime() == dt2.getTime()){
                siteVO.setWczt("已成交");
                tradeMarkService.updateStatusCC(siteVO);
            }
        }
        log.info("===================================定时修改手动完成状态结束======================================================================");
    }
}
