package com.unis.transaction.server.service;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.signuppay.TransactionSignUpVO;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import com.unis.transaction.server.entity.signuppay.TransactionSignUpDO;

import java.util.List;

/**
 * 交易报名接口层
 * @author lidiaoquan at 2019-09-20
 */
public interface TransactionSignUpService {

	//交易报名-新增
    public ResponseWrapper insertTransactionSignUp(TransactionSignUpVO vo);

	//交易报名-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateTransactionSignUp(TransactionSignUpVO vo,Integer updateType);

	//交易报名-分页列表
    public ResponseWrapper selectTransactionSignUpPageList(int pageNum, int pageSize, TransactionSignUpVO vo);

	//交易报名-列表全部数据
    public ResponseWrapper selectTransactionSignUpAll(TransactionSignUpVO vo);

	//交易报名--查看--返回单条
    public ResponseWrapper selectTransactionSignUpDetail(TransactionSignUpVO vo);

    //交易报名--列表---场次---新增
    public ResponseWrapper selectSceneList(TransactionSignUpVO vo);

    ResponseWrapper valiTurn(String dwbm);

    List<TransactionSignUpVO> selectTransactionSignUpList();

    ResponseWrapper selectTranPageList(int pageNum, int pageSize, TransactionSignUpVO vo);

    ResponseWrapper selectTransactionSignUp(TransactionSignUpVO vo);

    ResponseWrapper clickTransactionSignUp(String ccbm);

    PageResult<SiteVO> selectClickList(int pageNum, int pageSize, SiteVO vo);

    List<TransactionSignUpDO> listSignUpByCcbm(TransactionSignUpVO vo);
}
