package com.unis.transaction.server.service;

import com.unis.common.utils.DateUtil;
import com.unis.transaction.common.vo.signuppay.TransactionSignUpVO;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;


/**
 * 修改场次过期
 * Created by admin on 2017/12/4.
 */
@Component
@Slf4j
@Lazy(false)
public class VideoTimer {

	@Autowired
	private TransactionSignUpService transactionSignUpService;
	@Autowired
	private TradeMarkService tradeMarkService;

	@Scheduled(cron = "0 5 0 * * ?")//每天晚上12点05执行
	public  void dowork(){
		String sign= DateUtil.getCurrentStringDate();
		log.info("------报名状态轮询开始",sign);
		try {
			execute(sign);
		} catch (Exception e) {
			e.printStackTrace();
		}
		log.info("---报名状态轮询结束",sign);

	}

	public void execute(String sign) throws Exception{
		log.info("===================================定时修改状态轮询开始======================================================================");
		List<TransactionSignUpVO> list = transactionSignUpService.selectTransactionSignUpList();
		DateFormat df = new SimpleDateFormat("yyyy-MM-dd hh:mm");
		for(TransactionSignUpVO transactionSignUpVO:list){
			Date dt1 = df.parse(df.format(transactionSignUpVO.getJyrq()));
			Date dt2 = df.parse(df.format(new Date()));
			if(dt1.getTime() < dt2.getTime()){
				/*transactionSignUpService.insertTimeOver(transactionSignUpVO);*/
				SiteVO siteVO = tradeMarkService.selectDetailCC(transactionSignUpVO.getCcbm());
				siteVO.setZt(0);
				tradeMarkService.updateStatusCC(siteVO);
			}
		}
		log.info("===================================定时修改状态轮询结束======================================================================");
	}
}
