package com.unis.transaction.server.service.impl;

import com.unis.transaction.server.dao.DictDao;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.NumberFormat;


@Service
public class BaseRepository {

	@Autowired
	DictDao mapper;
	
	/**
	 * @param tableName传入数据表名
	 * @param tableFiled传入要获取最大id的字段
	 * @param preStr传入拼接字符的前缀
	 * @param length传入需要在后缀拼接的最大长度
	 * @return
	 */
	public synchronized String selectByTableNameAndAttr(String tableName,String tableFiled,String preStr,int length){
		//根据表名及字段，字段前缀获取最大值
		String sql="select MAX("+tableFiled+") from "+tableName + " where "+tableFiled+" like '%"+preStr+ "%' and length("+tableFiled+")<="+(preStr.length()+length);
        //String sql="select MAX("+tableFiled+") from "+tableName + " where "+tableFiled+" like '"+preStr+ "%' and length("+tableFiled+")<="+(preStr.length()+length);
		String maxCode = mapper.selectTest(sql);
//		Object object = entityManager.createNativeQuery(sql).getSingleResult();
        //获取本字段最大值
//        String maxCode = String.valueOf(object);
//        String maxCode = String.valueOf(object);
        //定义id后缀
        String serialNumberStr = "";
		if (StringUtils.isEmpty(maxCode)||maxCode.length()<(preStr.length()+length)) {
			maxCode = "0000000000000000000";
		}
		int serialNumber = 0;
		int maxSerialNumber = Integer.valueOf(maxCode.substring(maxCode.length() - length, maxCode.length()));
		serialNumber = maxSerialNumber + 1;
		
		NumberFormat nf = NumberFormat.getInstance();
        //设置是否使用分组
        nf.setGroupingUsed(false);
        //设置最大整数位数
        nf.setMaximumIntegerDigits(length);
        //设置最小整数位数   
        nf.setMinimumIntegerDigits(length);
        //输出测试语句
        serialNumberStr = nf.format(serialNumber);
        return new StringBuilder(preStr).append(serialNumberStr).toString();
    }
	
	/**
	 * @param tableName传入数据表名
	 * @param tableFiled传入要获取最大id的字段
	 * @param preStr传入拼接字符的前缀
	 * @param length传入需要在后缀拼接的最大长度
	 * @return
	 */
	public  Integer selectIdByTableNameAndAttr(String tableName,String tableFiled){
		//根据表名及字段，字段前缀获取最大值
		String sql="select MAX("+tableFiled+"+1) from "+tableName ;
		
		
		sql = "SELECT CASE WHEN MAX("+tableFiled+") IS NULL  THEN 1 ELSE MAX("+tableFiled+")+1 END AS "+tableFiled+" FROM "+tableName;
        //String sql="select MAX("+tableFiled+") from "+tableName + " where "+tableFiled+" like '"+preStr+ "%' and length("+tableFiled+")<="+(preStr.length()+length);
//        Object object = entityManager.createNativeQuery(sql).getSingleResult();
        //获取本字段最大值
        String maxCode = mapper.selectTest(sql);;
//        String maxCode = String.valueOf(object);
        
        return Integer.valueOf(maxCode);
    }

	/**
	 * @param tableName传入数据表名
	 * @param tableFiled传入要获取最大id的字段
	 * @param preStr传入拼接字符的前缀
	 * @param length传入需要在后缀拼接的最大长度
	 * @return
	 */
	public  Long selectLongIdByTableNameAndAttr(String tableName,String tableFiled){
		//根据表名及字段，字段前缀获取最大值
		String sql="select MAX("+tableFiled+"+1) from "+tableName ;


		sql = "SELECT CASE WHEN MAX("+tableFiled+") IS NULL  THEN 1 ELSE MAX("+tableFiled+")+1 END AS "+tableFiled+" FROM "+tableName;
		//String sql="select MAX("+tableFiled+") from "+tableName + " where "+tableFiled+" like '"+preStr+ "%' and length("+tableFiled+")<="+(preStr.length()+length);
//		Object object = entityManager.createNativeQuery(sql).getSingleResult();
		//获取本字段最大值
		String maxCode = mapper.selectTest(sql);;;
//		String maxCode = String.valueOf(object);

		return Long.valueOf(maxCode);
	}

	public  void execute(String sql){
		mapper.selectTest(sql);
	}
	
	/**
	 * @param tableName传入数据表名
	 * @param tableFiled传入要获取最大id的字段
	 * @param preStr传入拼接字符的前缀
	 * @param length传入需要在后缀拼接的最大长度
	 * @return
	 */
	public synchronized String selectByTableNameAndAttrAndStatus(String tableName,String tableFiled,String preStr,int length, int status){
		//根据表名及字段，字段前缀获取最大值
		String sql="select MAX("+tableFiled+") from "+tableName + " where status= " + status + " and "+tableFiled+" like '%"+preStr+ "%' and length("+tableFiled+")<="+(preStr.length()+length);
        //String sql="select MAX("+tableFiled+") from "+tableName + " where "+tableFiled+" like '"+preStr+ "%' and length("+tableFiled+")<="+(preStr.length()+length);
		String maxCode = mapper.selectTest(sql);
//		Object object = entityManager.createNativeQuery(sql).getSingleResult();
        //获取本字段最大值
//        String maxCode = String.valueOf(object);
//        String maxCode = String.valueOf(object);
        //定义id后缀
        String serialNumberStr = "";
		if (StringUtils.isEmpty(maxCode)||maxCode.length()<(preStr.length()+length)) {
			maxCode = "0000000000000000000";
		}
		int serialNumber = 0;
		int maxSerialNumber = Integer.valueOf(maxCode.substring(maxCode.length() - length, maxCode.length()));
		serialNumber = maxSerialNumber + 1;
		
		NumberFormat nf = NumberFormat.getInstance();
        //设置是否使用分组
        nf.setGroupingUsed(false);
        //设置最大整数位数
        nf.setMaximumIntegerDigits(length);
        //设置最小整数位数   
        nf.setMinimumIntegerDigits(length);
        //输出测试语句
        serialNumberStr = nf.format(serialNumber);
        return new StringBuilder(preStr).append(serialNumberStr).toString();
    }
}
