package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.givebackbail.ComplainVO;
import com.unis.transaction.server.domain.givebackbail.ComplainDomain;
import com.unis.transaction.server.service.ComplainService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class ComplainServiceImpl implements ComplainService {
    @Autowired
    ComplainDomain complainDomain;
    @Override
    public ResponseWrapper insertComplain(ComplainVO vo) {
        return complainDomain.insertComplain(vo);
    }

    @Override
    public ResponseWrapper updateComplain(ComplainVO vo) {
        return complainDomain.updateComplain(vo);
    }

    @Override
    public ResponseWrapper deleteComplain(ComplainVO vo) {
        return complainDomain.deleteComplain(vo);
    }

    @Override
    public ResponseWrapper selectComplainPageList(int pageNum, int pageSize, ComplainVO vo) {
        Page<ComplainVO> page =  complainDomain.selectComplainPageList(pageNum,pageSize,vo);
        PageResult<ComplainVO> pageResult=new PageResult<>(page);
        return ResponseWrapper.success(pageResult);
    }

    @Override
    public ResponseWrapper selectComplainDetail(ComplainVO vo) {
        return complainDomain.selectComplainDetail(vo);
    }

    @Override
    public ResponseWrapper selectSiteAll() {
        return complainDomain.selectSiteAll();
    }

    @Override
    public ResponseWrapper selectContracts(String ccbm) {
        return complainDomain.selectContracts(ccbm);
    }
}
