package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.creditevaluate.EnterPriseClassSetVO;
import com.unis.transaction.common.vo.creditevaluate.EnterPriseClassVO;
import com.unis.transaction.server.domain.creditevaluate.EnterPriseClassSetDomain;
import com.unis.transaction.server.service.EnterPriseClassSetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 企业分级设置实现层
 * @author lidiaoquan at 2019-09-26
 */
@Component
public class EnterPriseClassSetServiceImpl implements EnterPriseClassSetService{

    @Autowired
    EnterPriseClassSetDomain enterpriseclasssetDomain;

	//企业分级设置-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateEnterPriseClassSet(EnterPriseClassSetVO vo,Integer updateType){
		return enterpriseclasssetDomain.updateEnterPriseClassSet(vo,updateType);
	}
	
	//企业分级设置-分页列表
    public ResponseWrapper selectEnterPriseClassSetPageList(int pageNum, int pageSize, EnterPriseClassSetVO vo){
 		Page<EnterPriseClassSetVO> voPage=enterpriseclasssetDomain.selectEnterPriseClassSetPageList(pageNum,pageSize,vo);
		PageResult<EnterPriseClassSetVO> pageResult=new PageResult<>(voPage); 
        return ResponseWrapper.success(pageResult);  		
    }

	//企业分级设置-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectEnterPriseClassSetAll(EnterPriseClassSetVO vo){
		return enterpriseclasssetDomain.selectEnterPriseClassSetAll(vo);
    }

	//企业分级设置--查看--返回单条
    public ResponseWrapper selectEnterPriseClassSetDetail(EnterPriseClassSetVO vo){
        return enterpriseclasssetDomain.selectEnterPriseClassSetDetail(vo);
    }

	@Override
	public ResponseWrapper insertEnterPriseClassSet(EnterPriseClassVO vo) {
		return enterpriseclasssetDomain.insertEnterPriseClassSet(vo);
	}

}
