package com.unis.transaction.server.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.tradeplan.*;
import com.unis.transaction.server.domain.tradeplan.EntryAndExitOrderDomain;
import com.unis.transaction.server.entity.tradeplan.EntryAndExitOrderDO;
import com.unis.transaction.server.service.EntryAndExitOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 出入库委托书实现层
 *
 * @author huyong at 2019-09-19
 */
@Service
@Transactional
public class EntryAndExitOrderServiceImpl implements EntryAndExitOrderService {

    @Autowired
    EntryAndExitOrderDomain entryandexitorderDomain;

    //出入库委托书-新增
    public void insertEntryAndExitOrder(EntryAndExitOrderVO vo) {
        entryandexitorderDomain.insertEntryAndExitOrder(vo);
    }

    //出入库委托书-修改
    public void updateEntryAndExitOrder(EntryAndExitOrderVO vo) {
        entryandexitorderDomain.updateEntryAndExitOrder(vo);
    }

    //出入库委托书-分页列表
    public PageResult<EntryAndExitOrderVO> selectEntryAndExitOrderPageList(int pageNum, int pageSize, EntryAndExitOrderVO vo) {
        return entryandexitorderDomain.selectEntryAndExitOrderPageList(pageNum, pageSize, vo);
    }

    //出入库委托书-查看--返回单条
    public EntryAndExitOrderVO selectEntryAndExitOrderInfo(EntryAndExitOrderVO vo) {
        return entryandexitorderDomain.selectEntryAndExitOrderInfo(vo);
    }

    //出入库委托书--删除
    public void removeEntryAndExitOrder(String wtbm) {
        entryandexitorderDomain.removeEntryAndExitOrder(wtbm);
    }

    @Override
    public List<EntryAndExitOrderVO> selectEntryAndExitOrder() {
        return entryandexitorderDomain.selectEntryAndExitOrder();
    }

    @Override
    public SiteBacktVO selectEntryAndExitOrderBySite(String id) {
        return entryandexitorderDomain.selectEntryAndExitOrderBySite(id);
    }


    //出入库委托书--查看--通过主键
    public EntryAndExitOrderVO getEntryAndExitOrderDetail(String id) {
        return entryandexitorderDomain.getInfoEntryAndExitOrderDetail(id);
    }

    @Override
    public EntryAndExitOrderDTO getEntryAndExitOrderDTO(String wtbm) {
        return entryandexitorderDomain.getEntryAndExitOrderDTO(wtbm);
    }

    @Override
    public int insertEntryAndExitOrder2(EntryAndExitOrderDTO entityDTO) {
        return entryandexitorderDomain.insertEntryAndExitOrder2(entityDTO);
    }

    @Override
    public int updateEntryAndExitOrder2(EntryAndExitOrderDTO entityDTO) {
        return entryandexitorderDomain.updateEntryAndExitOrder2(entityDTO);
    }

    @Override
    public int deleteEntryAndExitOrder(String wtbm) {
        return entryandexitorderDomain.deleteEntryAndExitOrder(wtbm);
    }

    @Override
    public void update2NextNode(EntryAndExitOrderDO entity) {
        entryandexitorderDomain.update2NextNode(entity);
    }

    @Override
    public int updatePrice(EntryAndExitOrderDTO entityDTO) {
        return entryandexitorderDomain.updatePrice(entityDTO);
    }

    @Override
    public int updatePrice2NextNode(EntryAndExitOrderVO entity) {
        return entryandexitorderDomain.updatePrice2NextNode(entity);
    }

    @Override
    public JSONObject updateNotice2NextNode(EntryAndExitOrderVO entity) {
        return entryandexitorderDomain.updateNotice2NextNode(entity);
    }
}
