package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.flowable.base.PageResult;
import com.unis.transaction.common.vo.signuppay.FeeRateVO;
import com.unis.transaction.server.domain.signuppay.FeeRateDomain;
import com.unis.transaction.server.service.FeeRateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 手续费率维护实现层
 * @author lidiaoquan at 2019-09-19
 */
@Component
public class FeeRateServiceImpl implements FeeRateService{

    @Autowired
    FeeRateDomain feerateDomain;
    
	//手续费率维护-新增
    public ResponseWrapper insertFeeRate(FeeRateVO vo){
		return feerateDomain.insertFeeRate(vo);    
    }

	//手续费率维护-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateFeeRate(FeeRateVO vo,Integer updateType){
		return feerateDomain.updateFeeRate(vo,updateType);
	}
	
	//手续费率维护-分页列表
    public ResponseWrapper selectFeeRatePageList(int pageNum, int pageSize, FeeRateVO vo){
 		Page<FeeRateVO> voPage=feerateDomain.selectFeeRatePageList(pageNum,pageSize,vo);
 		PageResult<FeeRateVO> pageResult=new PageResult<>(voPage);
        return ResponseWrapper.success(pageResult);  
    }

	//手续费率维护-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectFeeRateAll(FeeRateVO vo){
		return feerateDomain.selectFeeRateAll(vo);
    }

	//手续费率维护--查看--返回单条
    public ResponseWrapper selectFeeRateDetail(FeeRateVO vo){
        return feerateDomain.selectFeeRateDetail(vo);
    }

}
