package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.givebackbail.GiveBackVO;
import com.unis.transaction.common.vo.givebackbail.PassBackVO;
import com.unis.transaction.server.domain.givebackbail.GiveBackDomain;
import com.unis.transaction.server.service.GiveBackService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 保证金退款实现层
 * @author lidiaoquan at 2019-09-21
 */
@Component
public class GiveBackServiceImpl implements GiveBackService{

    @Autowired
    GiveBackDomain givebackDomain;
    
	//保证金退款-新增
    public ResponseWrapper insertGiveBack(GiveBackVO vo){
		return givebackDomain.insertGiveBack(vo);    
    }

	//保证金退款-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateGiveBack(GiveBackVO vo,Integer updateType){
		return givebackDomain.updateGiveBack(vo,updateType);
	}
	
	//保证金退款-分页列表
    public ResponseWrapper selectGiveBackPageList(int pageNum, int pageSize, GiveBackVO vo){
 		Page<GiveBackVO> voPage=givebackDomain.selectGiveBackPageList(pageNum,pageSize,vo);
		PageResult<GiveBackVO> pageResult=new PageResult<>(voPage); 
        return ResponseWrapper.success(pageResult);  		
    }

	//保证金退款-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectGiveBackAll(GiveBackVO vo){
		return givebackDomain.selectGiveBackAll(vo);
    }

	//保证金退款--查看--返回单条
    public ResponseWrapper selectGiveBackDetail(GiveBackVO vo){
        return givebackDomain.selectGiveBackDetail(vo);
    }

    @Override
    public List<GiveBackVO> selectGiveBackList() {
        List<GiveBackVO> list=givebackDomain.selectGiveBackList();
        return list;
    }

    @Override
    public void updateGiveEntity(GiveBackVO entity) {
        givebackDomain.updateGiveEntity(entity);
    }

    @Override
    public ResponseWrapper updateGiveBackPass(PassBackVO vo) {
        return givebackDomain.updateGiveBackPass(vo);
    }

    @Override
    public ResponseWrapper selectGiveBackPass(PassBackVO vo) {
        return givebackDomain.selectGiveBackPass(vo);
    }

    @Override
    public ResponseWrapper selectPassBackPageList(int pageNum, int pageSize, PassBackVO vo) {
        Page<PassBackVO> voPage=givebackDomain.selectPassBackPageList(pageNum,pageSize,vo);
        PageResult<PassBackVO> pageResult=new PageResult<>(voPage);
        return ResponseWrapper.success(pageResult);
    }

    @Override
    public ResponseWrapper selectPassBack(GiveBackVO vo) {
        return givebackDomain.selectPassBack(vo);
    }

    @Override
    public ResponseWrapper selectGivePassAll(GiveBackVO vo) {
        return givebackDomain.selectGivePassAll(vo);
    }

    @Override
    public List<GiveBackVO> selectGiveBackCjList(String gqsj) {
        List<GiveBackVO> list=givebackDomain.selectGiveBackCjList(gqsj);
        return list;
    }
    @Override
    public List<GiveBackVO> selectGiveBackByCcbm(String ccbm) {
        List<GiveBackVO> list=givebackDomain.selectGiveBackByCcbm(ccbm);
        return list;
    }

    @Override
    public List<GiveBackVO> selectGiveBackCjLists(String ccbm) {
        List<GiveBackVO> list=givebackDomain.selectGiveBackCjLists(ccbm);
        return list;
    }
}
