package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.givebackbail.NoticeVO;
import com.unis.transaction.server.domain.givebackbail.NoticeDomain;
import com.unis.transaction.server.service.NoticeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class NoticeServiceImpl implements NoticeService {
    @Autowired
    NoticeDomain noticeDomain;
    @Override
    public ResponseWrapper insertNotice(NoticeVO vo) {
        return noticeDomain.insertNotice(vo);
    }

    @Override
    public ResponseWrapper updateNotice(NoticeVO vo) {
        return noticeDomain.updateNotice(vo);
    }

    @Override
    public ResponseWrapper deleteNotice(NoticeVO vo) {
        return noticeDomain.deleteNotice(vo);
    }

    @Override
    public ResponseWrapper selectNoticePageList(int pageNum, int pageSize, NoticeVO vo) {
        Page<NoticeVO> page =  noticeDomain.selectNoticePageList(pageNum,pageSize,vo);
        PageResult<NoticeVO> pageResult=new PageResult<>(page);
        return ResponseWrapper.success(pageResult);
    }

    @Override
    public ResponseWrapper selectNoticeDetail(NoticeVO vo) {
        return noticeDomain.selectNoticeDetail(vo);
    }

    @Override
    public ResponseWrapper selectSiteAllNotice() {
        return noticeDomain.selectSiteAllNotice();
    }

    @Override
    public ResponseWrapper selectContractNotice(String ccbm) {
        return noticeDomain.selectContractNotice(ccbm);
    }

    @Override
    public ResponseWrapper getWtf(NoticeVO vo) {
        return noticeDomain.getWtf(vo);
    }

}
