package com.unis.transaction.server.service.impl;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.tradeplan.RefundLetterVO;
import com.unis.transaction.common.vo.tradeplan.RefundNoticeContractVO;
import com.unis.transaction.common.vo.tradeplan.RefundNoticeQueryVO;
import com.unis.transaction.common.vo.tradeplan.RefundNoticeVO;
import com.unis.transaction.server.domain.tradeplan.RefundNoticeDomain;
import com.unis.transaction.server.service.RefundNoticeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class RefundNoticeServiceImpl implements RefundNoticeService {

    @Autowired
    private RefundNoticeDomain refundNoticeDomain;

    @Override
    public Integer save(RefundNoticeVO vo) {
        return refundNoticeDomain.save(vo);
    }

    @Override
    public ResponseWrapper update(Integer type, RefundNoticeVO vo) {
        return refundNoticeDomain.update(type,vo);
    }

    @Override
    public PageResult<RefundNoticeVO> getPage(Integer pageNum, Integer pageSize, RefundNoticeQueryVO queryVO) {
        return refundNoticeDomain.getPage(pageNum,pageSize,queryVO);
    }

    @Override
    public PageResult<RefundNoticeContractVO> getContractPage(Integer pageNum, Integer pageSize, RefundNoticeQueryVO queryVO) {
        return refundNoticeDomain.getContractPage(pageNum,pageSize,queryVO);
    }

    @Override
    public Integer saveLetter(RefundLetterVO vo) {
        return refundNoticeDomain.saveLetter(vo);
    }

    @Override
    public ResponseWrapper updateLetter(Integer type, RefundLetterVO vo) {
        return refundNoticeDomain.updateLetter(type,vo);
    }

    @Override
    public RefundNoticeVO getInfoByHtbm(String htbm) {
        return refundNoticeDomain.getInfoByHtbm(htbm);
    }
}
