package com.unis.transaction.server.service.impl;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.tradeplan.*;
import com.unis.transaction.server.domain.tradeplan.EntryAndExitOrderDomain;
import com.unis.transaction.server.service.TradeMarkService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 交易标的实现层
 * @author huyong at 2019-09-21
 */
@Service
@Transactional
public class TradeMarkServiceImpl implements TradeMarkService{

    @Autowired
    EntryAndExitOrderDomain entryAndExitOrderDomain;

	//交易标的-新增
    public void insertTradeMark(TradeMarkBackVO vo){
    	entryAndExitOrderDomain.insertTradeMark(vo);
    }

	//交易标的-修改
    public void updateTradeMark(TradeMarkBackVO vo){
    	entryAndExitOrderDomain.updateTradeMark(vo);
	}


	//交易标的-查看--返回单条
	public List<TradeMarkVO> selectTradeMarkInfo(TradeMarkVO vo){

        return entryAndExitOrderDomain.selectTradeMarkInfo(vo);
    }

	//交易标的--删除
    public void deleteTradeMark(String id){

    	entryAndExitOrderDomain.deleteTradeMark(id);
    }


    //交易标的--查看--通过主键
    public TradeMarkBackVO getTradeMarkDetail(String id){

      return entryAndExitOrderDomain.getInfoTradeMarkDetail(id);

    }

	@Override
	public PageResult<SiteVO> selectByWtfbm(int pageNum, int pageSize, SiteVO vo) {
		return entryAndExitOrderDomain.selectByWtfbm(pageNum, pageSize,vo);
	}

	@Override
	public List<WarehousingArrangementVO> exportTradeMark(String apbm) {

		return entryAndExitOrderDomain.exportTradeMark(apbm);
	}

	@Override
	public void insertCC(SiteVO vo) {
		 entryAndExitOrderDomain.insertCC(vo);
	}

	@Override
	public void updateCC(SiteVO vo) {
		entryAndExitOrderDomain.updateCC(vo);
	}

	@Override
	public int selectCode() {
		return entryAndExitOrderDomain.selectCode();
	}

	@Override
	public Boolean valiCode(String ccbm,String cccode) {
		return entryAndExitOrderDomain.valiCode(ccbm,cccode);
	}

	@Override
	public SiteBacktVO selectCC(String id) {
		return entryAndExitOrderDomain.selectCC(id);
	}

	@Override
	public void delCC(String id) {
		entryAndExitOrderDomain.delCC(id);
	}

	@Override
	public PageResult<WarehousingArrangementVO> selectPage(int pageNum, int pageSize, WarehousingArrangementVO vo) {
		return entryAndExitOrderDomain.selectPage(pageNum, pageSize,vo);
	}

	@Override
	public void insertContract(ContractVO vo) {
		entryAndExitOrderDomain.insertContract(vo);
	}

	@Override
	public void updateContract(ContractVO vo) {
		entryAndExitOrderDomain.updateContract(vo);
	}

	@Override
	public ResponseWrapper selectContractDetail(String id) {
		return entryAndExitOrderDomain.selectContractDetail(id);
	}

	@Override
	public PageResult<ContractVO> selectContractPage(int pageNum, int pageSize, ContractVO vo) {
		return entryAndExitOrderDomain.selectContractPage(pageNum,pageSize,vo);
	}

	@Override
	public ResponseWrapper selectContract(String id) {
		return entryAndExitOrderDomain.selectContract(id);
	}

	@Override
	public ResponseWrapper selectTradeMarkAll() {
		return entryAndExitOrderDomain.selectTradeMarkAll();
	}

	@Override
	public ResponseWrapper selectContractList(String id) {
		return entryAndExitOrderDomain.selectContractList(id);
	}

	@Override
	public SiteVO selectDetailCC(String ccbm) {
		return entryAndExitOrderDomain.selectDetailCC(ccbm);
	}

	@Override
	public void updateStatusCC(SiteVO siteVO) {
		entryAndExitOrderDomain.updateStatusCC(siteVO);
	}

	@Override
	public TradeMarkVO selectTradeMarkByBdh(String bdh) {
		return entryAndExitOrderDomain.selectTradeMarkByBdh(bdh);
	}

	@Override
	public void deleteTrade(String ids) {
		entryAndExitOrderDomain.deleteTrade(ids);
	}

	@Override
	public ResponseWrapper selectDWmcList(String id) {
		return entryAndExitOrderDomain.selectDWmcList(id);
	}

	@Override
	public ResponseWrapper selectContractByDwbm(String dwbm,String ccbm) {
		return entryAndExitOrderDomain.selectContractByDwbm(dwbm,ccbm);
	}

	@Override
	public ResponseWrapper selectContracts(String dwbm, String jylx) {
		return entryAndExitOrderDomain.selectContracts(dwbm,jylx);
	}

	@Override
	public ResponseWrapper selectTradeByCcbm(String ccbm) {
		return entryAndExitOrderDomain.selectTradeByCcbm(ccbm);
	}

	@Override
	public ResponseWrapper selectContractAll() {
		return entryAndExitOrderDomain.selectContractAll();
	}
	public ResponseWrapper selectContractAlls(String jylx) {
		return entryAndExitOrderDomain.selectContractAlls(jylx);
	}

	@Override
	public void updateContractByisChange(ContractVO vo) {
		entryAndExitOrderDomain.updateContractByisChange(vo);
	}

	@Override
	public Double getDj(String ccbm) {
		return entryAndExitOrderDomain.getDj(ccbm);
	}

	@Override
	public List<SiteVO> selectContractByZt(String wczt) {
		return entryAndExitOrderDomain.selectContractByZt(wczt);
	}


}
