package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.flowable.base.PageResult;
import com.unis.transaction.common.vo.tradeplan.TradeRuleVO;
import com.unis.transaction.server.domain.tradeplan.TradeRuleDomain;
import com.unis.transaction.server.service.TradeRuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 交易细则实现层
 * @author lidiaoquan at 2019-09-19
 */
@Component
public class TradeRuleServiceImpl implements TradeRuleService{

    @Autowired
    TradeRuleDomain traderuleDomain;
    
	//交易细则-新增
    public ResponseWrapper insertTradeRule(TradeRuleVO vo){
		return traderuleDomain.insertTradeRule(vo);    
    }

	//交易细则-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateTradeRule(TradeRuleVO vo,Integer updateType){
		return traderuleDomain.updateTradeRule(vo,updateType);
	}
	
	//交易细则-分页列表
    public ResponseWrapper selectTradeRulePageList(int pageNum, int pageSize, TradeRuleVO vo){
 		Page<TradeRuleVO> voPage=traderuleDomain.selectTradeRulePageList(pageNum,pageSize,vo);
 		PageResult<TradeRuleVO> pageResult=new PageResult<>(voPage);
        return ResponseWrapper.success(pageResult);  
    }

	//交易细则-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectTradeRuleAll(TradeRuleVO vo){
		return traderuleDomain.selectTradeRuleAll(vo);
    }

	//交易细则--查看--返回单条
    public ResponseWrapper selectTradeRuleDetail(TradeRuleVO vo){
        return traderuleDomain.selectTradeRuleDetail(vo);
    }

}
