package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.vo.flowable.base.PageResult;
import com.unis.transaction.common.vo.signuppay.TransactionSignUpVO;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import com.unis.transaction.server.domain.signuppay.SetDomain;
import com.unis.transaction.server.domain.signuppay.TransactionSignUpDomain;
import com.unis.transaction.server.entity.signuppay.TransactionSignUpDO;
import com.unis.transaction.server.service.TransactionSignUpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 交易报名实现层
 * @author lidiaoquan at 2019-09-20
 */
@Component
public class TransactionSignUpServiceImpl implements TransactionSignUpService{

    @Autowired
    TransactionSignUpDomain transactionsignupDomain;
    @Autowired
    SetDomain setDomain;
	//交易报名-新增
    public ResponseWrapper insertTransactionSignUp(TransactionSignUpVO vo){
		return transactionsignupDomain.insertTransactionSignUp(vo);
    }


    //交易报名-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateTransactionSignUp(TransactionSignUpVO vo,Integer updateType){
		return transactionsignupDomain.updateTransactionSignUp(vo,updateType);
	}

	//交易报名-分页列表
    public ResponseWrapper selectTransactionSignUpPageList(int pageNum, int pageSize, TransactionSignUpVO vo){
        Page<TransactionSignUpVO> voPage=transactionsignupDomain.selectTransactionSignPageList(pageNum,pageSize,vo);
 		//Page<TransactionSignUpVO> voPage=transactionsignupDomain.selectTransactionSignUpPageList(pageNum,pageSize,vo);
		PageResult<TransactionSignUpVO> pageResult=new PageResult<>(voPage);
        return ResponseWrapper.success(pageResult);
    }

	//交易报名-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectTransactionSignUpAll(TransactionSignUpVO vo){
		return transactionsignupDomain.selectTransactionSignUpAll(vo);
    }

	//交易报名--查看--返回单条
    public ResponseWrapper selectTransactionSignUpDetail(TransactionSignUpVO vo){
        return transactionsignupDomain.selectTransactionSignUpDetail(vo);
    }

    //交易报名--列表---场次---新增
    public ResponseWrapper selectSceneList(TransactionSignUpVO vo){
    	return transactionsignupDomain.selectSceneList(vo);
    }

    @Override
    public ResponseWrapper valiTurn(String dwbm) {
        return transactionsignupDomain.valiTurn(dwbm);
    }

    @Override
    public List<TransactionSignUpVO> selectTransactionSignUpList() {
        return transactionsignupDomain.selectTransactionSignUpList();
    }

    @Override
    public ResponseWrapper selectTranPageList(int pageNum, int pageSize, TransactionSignUpVO vo) {
        Page<TransactionSignUpVO> voPage=transactionsignupDomain.selectTranPageList(pageNum,pageSize,vo);
        //Page<TransactionSignUpVO> voPage=transactionsignupDomain.selectTransactionSignUpPageList(pageNum,pageSize,vo);
        PageResult<TransactionSignUpVO> pageResult=new PageResult<>(voPage);
        return ResponseWrapper.success(pageResult);
    }

    @Override
    public ResponseWrapper selectTransactionSignUp(TransactionSignUpVO vo) {
        return ResponseWrapper.success(transactionsignupDomain.selectTransactionSignUp(vo));
    }

    @Override
    public ResponseWrapper clickTransactionSignUp(String ccbm) {
        return setDomain.clickTransactionSignUp(ccbm);
    }

    @Override
    public com.unis.transaction.common.dto.base.PageResult<SiteVO> selectClickList(int pageNum, int pageSize, SiteVO vo) {
        return setDomain.selectClickList(pageNum, pageSize,vo);
    }

    @Override
    public List<TransactionSignUpDO> listSignUpByCcbm(TransactionSignUpVO vo) {
        return transactionsignupDomain.listSignUpByCcbm(vo);
    }
}
