package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.creditevaluate.TurnoverDataVO;
import com.unis.transaction.server.domain.creditevaluate.TurnoverDataDomain;
import com.unis.transaction.server.service.TurnoverDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 成交数据维护实现层
 * @author lidiaoquan at 2019-09-26
 */
@Component
public class TurnoverDataServiceImpl implements TurnoverDataService{

    @Autowired
    TurnoverDataDomain turnoverdataDomain;
    
	//成交数据维护-新增
    public ResponseWrapper insertTurnoverData(TurnoverDataVO vo){
		return turnoverdataDomain.insertTurnoverData(vo);    
    }

	//成交数据维护-修改 注意：updateType非必填项 默认为null 代表业务更新 ，值为1时代表 单表更新
    public ResponseWrapper updateTurnoverData(TurnoverDataVO vo,Integer updateType){
		return turnoverdataDomain.updateTurnoverData(vo,updateType);
	}
	
	//成交数据维护-分页列表
    public ResponseWrapper selectTurnoverDataPageList(int pageNum, int pageSize, TurnoverDataVO vo){
 		Page<TurnoverDataVO> voPage=turnoverdataDomain.selectTurnoverDataPageList(pageNum,pageSize,vo);
		PageResult<TurnoverDataVO> pageResult=new PageResult<>(voPage); 
        return ResponseWrapper.success(pageResult);  		
    }

	//成交数据维护-列表全部数据
	@SuppressWarnings("unchecked")
    public ResponseWrapper selectTurnoverDataAll(TurnoverDataVO vo){
		return turnoverdataDomain.selectTurnoverDataAll(vo);
    }

	//成交数据维护--查看--返回单条
    public ResponseWrapper selectTurnoverDataDetail(TurnoverDataVO vo){
        return turnoverdataDomain.selectTurnoverDataDetail(vo);
    }

    @Override
    public ResponseWrapper insertTurnoverDataImp(TurnoverDataVO vo) {
        return turnoverdataDomain.insertTurnoverDataImp(vo);
    }

    @Override
    public ResponseWrapper selectTurnoverDataImport(TurnoverDataVO vo) {
        return turnoverdataDomain.selectTurnoverDataImport(vo);
    }

}
