package com.unis.transaction.server.service.impl;

import com.github.pagehelper.Page;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.creditevaluate.TurnoverEndVO;
import com.unis.transaction.server.domain.creditevaluate.TurnoverEndDomain;
import com.unis.transaction.server.entity.creditevaluate.TurnoverEndDO;
import com.unis.transaction.server.service.TurnoverEndService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class TurnoverEndServiceImpl implements TurnoverEndService {

    @Autowired
    TurnoverEndDomain turnoverEndDomain;

    @Override
    public ResponseWrapper updateTurnoverEnd(TurnoverEndVO vo) {
        return turnoverEndDomain.updateTurnoverEnd(vo);
    }

    @Override
    public ResponseWrapper selectTurnoverEndPageList(int pageNum, int pageSize, TurnoverEndVO vo) {
        Page<TurnoverEndVO> voPage=turnoverEndDomain.selectTurnoverEndPageList(pageNum,pageSize,vo);
        PageResult<TurnoverEndVO> pageResult=new PageResult<>(voPage);
        return ResponseWrapper.success(pageResult);
    }

    @Override
    public ResponseWrapper selectTurnoverEndDetail(TurnoverEndVO vo) {
        return turnoverEndDomain.selectTurnoverEndDetail(vo);
    }

    @Override
    public TurnoverEndDO selectTurnoverEndByCcbm(String ccbm) {
        return turnoverEndDomain.selectTurnoverEndByCcbm(ccbm);
    }

    @Override
    public int insert(TurnoverEndDO turnoverEndDO) {
         return turnoverEndDomain.insert(turnoverEndDO);
    }

    @Override
    public ResponseWrapper selectTurnoverSxfPageList(int pageNum, int pageSize, TurnoverEndVO vo) {
        Page<TurnoverEndVO> voPage=turnoverEndDomain.selectTurnoverSxfPageList(pageNum,pageSize,vo);
        PageResult<TurnoverEndVO> pageResult=new PageResult<>(voPage);
        return ResponseWrapper.success(pageResult);
    }

    @Override
    public ResponseWrapper selectTurnoverSxfDetail(TurnoverEndVO vo) {
        return turnoverEndDomain.selectTurnoverSxfDetail(vo);
    }
}
