package com.unis.transaction.server.service.impl;

import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.common.dto.base.PageResult;
import com.unis.transaction.common.vo.tradeplan.EntryAndExitOrderInputVO;
import com.unis.transaction.common.vo.tradeplan.WarehousingArrangementVO;
import com.unis.transaction.server.domain.tradeplan.EntryAndExitOrderDomain;
import com.unis.transaction.server.service.WarehousingArrangementService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 出入库安排实现层
 * @author huyong at 2019-09-20
 */
@Service
@Transactional
public class WarehousingArrangementServiceImpl implements WarehousingArrangementService{

    @Autowired
    EntryAndExitOrderDomain entryAndExitOrderDomain;

	//出入库安排-新增
    public void insertWarehousingArrangement(EntryAndExitOrderInputVO vo){
    	entryAndExitOrderDomain.insertWarehousingArrangement(vo);
    }

	//出入库安排-修改
    public void updateWarehousingArrangement(EntryAndExitOrderInputVO vo,Integer sjlx){
    	entryAndExitOrderDomain.updateWarehousingArrangement(vo,sjlx);
	}


	  //出入库安排-分页列表
    public PageResult<WarehousingArrangementVO> selectWarehousingArrangementPageList(int pageNum, int pageSize,
	  WarehousingArrangementVO vo){

	  return entryAndExitOrderDomain.selectWarehousingArrangementPageList(pageNum,pageSize,vo); }

	//出入库安排-查看--返回多条
	public EntryAndExitOrderInputVO selectWarehousingArrangementInfo(WarehousingArrangementVO vo){

        return entryAndExitOrderDomain.selectWarehousingArrangementInfo(vo);
    }

	@Override
	public List<WarehousingArrangementVO> selectWareDetail(WarehousingArrangementVO vo) {
		return entryAndExitOrderDomain.selectWareDetail(vo);
	}


	//出入库安排--删除
    public void deleteWarehousingArrangement(String id){

    	entryAndExitOrderDomain.deleteWarehousingArrangement(id);
    }


    //出入库安排--查看--通过主键
    public WarehousingArrangementVO getWarehousingArrangementDetail(String id){

      return entryAndExitOrderDomain.getInfoWarehousingArrangementDetail(id);

    }

	@Override
	public Integer updateWarehousingArrangement(WarehousingArrangementVO vo) {
		return entryAndExitOrderDomain.updateWarehousingArrangement(vo);
	}

	@Override
	public ResponseWrapper selectwarehousingArrangementByWtbm(String id) {
		return entryAndExitOrderDomain.selectwarehousingArrangementByWtbm(id);
	}


}
