package com.unis.transaction.server.service;

import com.unis.common.utils.DateUtil;
import com.unis.transaction.common.utils.EntityUtil;
import com.unis.transaction.common.vo.tradeplan.SiteVO;
import com.unis.transaction.server.dao.PassBackDao;
import com.unis.transaction.server.dao.SiteDao;
import com.unis.transaction.server.dao.TradeMarkDao;
import com.unis.transaction.server.dao.TransactionSignUpDao;
import com.unis.transaction.server.entity.creditevaluate.TurnoverEndDO;
import com.unis.transaction.server.entity.tradeplan.SiteDO;
import com.unis.transaction.server.entity.tradeplan.TradeMarkDO;
import com.unis.transaction.server.service.impl.BaseRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
@Slf4j
@Lazy(false)
public class testTimer {


    @Autowired
    private TransactionSignUpDao transactionSignUpDao;
    @Autowired
    private TradeMarkDao tradeMarkDao;
    @Autowired
    private PassBackDao passBackDao;
    @Autowired
    private SiteDao siteDao;
    @Autowired
    BaseRepository baseMapper;
    @Autowired
    private TradeMarkService tradeMarkService;
    @Autowired
    private GiveBackService giveBackService;

    @Autowired
    private EntryAndExitOrderService entryAndExitOrderService;

    //@Scheduled(cron = "0 30 0 * * ?")//每天晚上12点05执行
    //@Scheduled(cron = "0 0/2 * * * ?")
    public  void dowork(){
        String sign= DateUtil.getCurrentStringDate();
        log.info("------未成交状态轮询开始",sign);
        try {
            execute(sign);
        } catch (Exception e) {
            e.printStackTrace();
        }
        log.info("---未成交状态轮询结束",sign);

    }

    public void execute(String sign) throws Exception{
        TurnoverEndDO turnoverEndDO = new TurnoverEndDO();
        String pk= baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(TurnoverEndDO.class)
                ,"jgbm", "JG", 8);
        turnoverEndDO.setJgbm(pk);
        SiteDO siteDO = siteDao.selectByPrimaryKey("CC00000007");
        Double dj = tradeMarkService.getDj(siteDO.getCcbm());
        //turnoverEndDO.setDj(dj);
        //交易数量
        turnoverEndDO.setJysl(siteDO.getSl());
        //成交数量  所有合同的成交数量
        List<TradeMarkDO> tradeMarkDOS = tradeMarkDao.selectListByCcbm(siteDO.getCcbm());
        List<String> bdjh = new ArrayList<>();
        for(TradeMarkDO tradeMarkDO:tradeMarkDOS){
            bdjh.add(tradeMarkDO.getBdbm());
        }
        SiteVO siteVO = new SiteVO();
        siteVO.setHtList(bdjh);
        String cjsl = tradeMarkDao.getCjsl(siteVO);
        //最低和最高成交价 合同里面的价格
        System.out.println(cjsl);
    }
}
