package com.unis.transaction.server.service.user;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Lists;

import com.unis.common.utils.JsonUtils;
import com.unis.common.utils.ResponseWrapper;
import com.unis.transaction.client.UserClient;
import com.unis.transaction.common.vo.CompanyBarn;
import com.unis.transaction.common.vo.flowable.UserVO;
import com.unis.transaction.server.entity.tradeplan.ReceiverCollectionVO;
import lombok.Getter;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author huyong
 * @ClassName: UserService
 * @Description: 用户中心
 * @date 2019年9月12日
 */
@Component
@Log4j2
public class UserService {

//    @Getter
//    @Value("${ccqygz}")
//    private String ccqygz;
//    @Getter
//    @Value("${lhjhgl}")
//    private String lhjhgl;
//    @Getter
//    @Value("${ywbqz}")
//    private String ywbqz;
//
//    @Getter
//    @Value("${cwjscw}")
//    private String cwjscw;
//    @Getter
//    @Value("${cwjsyw}")
//    private String cwjsyw;
//
//    @Value("${cwbqz}")
//    private String cwbqz;
//
//    @Getter
//    @Value("${kcyggl}")
//    private String kcyggl;
//
//    @Getter
//    @Value("${bgbqz}")
//    private String bgbqz;
//
//    @Getter
//    @Value("${rkysbg}")
//    private String rkysbg;
//
//    @Getter
//    @Value("${dcyk}")
//    private String dcyk;
//
//    @Getter
//    @Value("${ckysyw}")
//    private String ckysyw;
//
    @Autowired
    private UserClient userClient;
////    @Autowired
////    private BaseServerClient baseServerClient;
//
//    @Getter
//    @Value("${zong-he-ji-hua-bu-pu-tong}")
//    private String zongHeJiHuaBuPuTong;
//    @Getter
//    @Value("${zong-he-ji-hua-bu-bu-zhang}")
//    private String zongHeJiHuaBuBuZhang;
//    @Getter
//    @Value("${cang-chu-pu-tong}")
//    private String cangChuPuTong;
//    @Getter
//    @Value("${cang-chu-bu-zhang}")
//    private String cangChuBuZhang;
//    @Getter
//    @Value("${cang-chu2-pu-tong}")
//    private String cangChu2PuTong;
//    @Getter
//    @Value("${cang-chu2-bu-zhang}")
//    private String cangChu2BuZhang;
//    @Getter
//    @Value("${cai-wu-bu-pu-tong}")
//    private String caiWuBuPuTong;
//    @Getter
//    @Value("${cai-wu-bu-bu-zhang}")
//    private String caiWuBuBuZhang;
//    @Getter
//    @Value("${ye-wu-zhu-guan-jing-li}")
//    private String yeWuZhuGuanJingLi;
//    @Getter
//    @Value("${cai-wu-zhu-guan-jing-li}")
//    private String caiWuZhuGuanJingLi;
//    @Getter
//    @Value("${gong-si-jing-li}")
//    private String gongSiJingLi;

//    public String getQydgzry() {
//        return ccqygz;
//    }
    /**
     * @param @param  roleId
     * @param @return 参数
     * @return String 返回类型
     * @throws
     * @Title: getUserIdByRole
     * @Description: 根据角色获取人员code字符串
     */
    public String getUserIdByRole(String roleId) {
        ResponseWrapper wapper = userClient.getUserByRole(Arrays.asList(roleId));
        Object data = wapper.getData();
        List<UserVO> userVOs = new ArrayList<>();
        if (data != null) {
            //List<UserVO> userVOs = JSONObject.parseArray(JSONObject.toJSONString(data), UserVO.class);
            JSONArray objArr = JSON.parseArray(JsonUtils.serialize(data));
            if (!ObjectUtils.isEmpty(objArr)) {
                objArr.forEach(jsonObj -> {
                    JSONObject obj = (JSONObject) jsonObj;
                    UserVO userVO  = new UserVO();
                    userVO.setId(obj.getString("userCode"));
                    userVO.setUserName(obj.getString("userName"));
                    userVOs.add(userVO);
                });
            }
            if (userVOs != null) {
                StringBuilder codes = new StringBuilder();
                for(UserVO userVO:userVOs){
                    codes.append(userVO.getId()).append(",");
                }
                if(codes.length()>0){
                    codes = new StringBuilder(codes.substring(0, codes.length() - 1));
                }
                return codes.toString();
            }
        }
        return null;
    }


    /**
     * @param c      对象
     * @param roleId void
     * @Author lidiaoquan
     * @version V1.0
     * @Description 根据角色给用户 添加 待办发送用户集合 (根据角色/部门/库点) 注意：T 中有字段userList
     * @Date 2020年3月19日 上午10:40:40
     */
    public List<ReceiverCollectionVO> addUserList(Object c, String roleId, String orgCode) {
        ResponseWrapper result = userClient.getUserByRole(Arrays.asList(new String[]{roleId}));
        Object resultObj = result.getData();
        List<ReceiverCollectionVO> userList = Lists.newArrayList();
        if (result.isSuccess() && !ObjectUtils.isEmpty(resultObj)) {
            JSONArray objArr = JSON.parseArray(JsonUtils.serialize(resultObj));
            if (!ObjectUtils.isEmpty(objArr)) {
                objArr.forEach(jsonObj -> {
                    JSONObject obj = (JSONObject) jsonObj;
                    String org = obj.getString("orgCode");
                    if(orgCode!=null){
                       if(orgCode.equals(org)){
                           ReceiverCollectionVO vo = new ReceiverCollectionVO();
                           vo.setUserId(obj.getString("userCode"));
                           vo.setUserName(obj.getString("userName"));
                           userList.add(vo);
                       }
                    }else{
                        ReceiverCollectionVO vo = new ReceiverCollectionVO();
                        vo.setUserId(obj.getString("userCode"));
                        vo.setUserName(obj.getString("userName"));
                        userList.add(vo);
                    }
                });
            }
        }

        try {
            if (c != null) {
                Field f = c.getClass().getDeclaredField("userList");
                f.setAccessible(true);
                f.set(c, userList);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return userList;
    }

    /**
     *
     * @param  roleIds 角色id集合
     * @param orgCode 组织代码
     * @return 用户集合
     */
    public List<ReceiverCollectionVO> listUser(List<String> roleIds, String orgCode) {
        ResponseWrapper wrapper = userClient.getUserByRole(roleIds);
        if (wrapper.isSuccess()) {
            Object data = wrapper.getData();
            List<JSONObject> objArr = JSON.parseArray(JsonUtils.serialize(data)).toJavaList(JSONObject.class);
            if (!ObjectUtils.isEmpty(objArr)) {
                if (orgCode != null) {
                    return objArr.stream().filter(item -> orgCode.equals(item.getString("orgCode")))
                            .map(jsonObj -> new ReceiverCollectionVO(jsonObj.getString("userName"), jsonObj.getString("userCode")))
                            .distinct()
                            .collect(Collectors.toList());
                }else {
                    return objArr.stream()
                            .map(jsonObj -> new ReceiverCollectionVO(jsonObj.getString("userName"), jsonObj.getString("userCode")))
                            .distinct()
                            .collect(Collectors.toList());
                }
            }
        } else {
            log.error("获取角色包含人员失败");
        }
        return new ArrayList<>();
    }

//    public CompanyBarn getCompanyByCode(String tyshxydm) {
//        ResponseWrapper companyByQydm = baseServerClient.company(tyshxydm);
//        Object data = companyByQydm.getData();
//        if (data != null) {
//            return JSONObject.parseObject(JsonUtils.serialize(data), CompanyBarn.class);
//        }
//        return null;
//    }

//    public List<ReceiverCollectionVO> listUserByResourceCode(String resourceCode) {
//        return listUserByResourceCode(resourceCode, null);
//    }

//    public List<ReceiverCollectionVO> listUserByResourceCode(String resourceCode, List<String> orgCodes) {
//        ResponseWrapper wrapper = userClient.listUserByResourceCode(resourceCode);
//        if (wrapper.isSuccess()) {
//            Object data = wrapper.getData();
//            if (data != null) {
//                List<JSONObject> objArr = JSON.parseArray(JsonUtils.serialize(data)).toJavaList(JSONObject.class);
//                if (null == orgCodes) {
//                    return objArr.stream()
//                            .map(jsonObj -> new ReceiverCollectionVO(jsonObj.getString("userName"), jsonObj.getString("userCode")))
//                            .distinct()
//                            .collect(Collectors.toList());
//                }else {
//                    return objArr.stream().filter(item -> orgCodes.contains(item.getString("orgCode")))
//                            .map(jsonObj -> new ReceiverCollectionVO(jsonObj.getString("userName"), jsonObj.getString("userCode")))
//                            .distinct()
//                            .collect(Collectors.toList());
//                }
//            }
//
//        }else {
//            log.error(wrapper.getMsg());
//        }
//        return null;
//    }
}
