//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.unis.transaction.common.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Iterator;
import java.util.Map;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpStatus;

public class HttpRequestUtil {
    private static final Logger log = LoggerFactory.getLogger(HttpRequestUtil.class);
    private static Logger logger = LoggerFactory.getLogger(HttpRequestUtil.class);

    public HttpRequestUtil() {
    }

    public static String sendGet(String url, String param) {
        StringBuffer sb = null;
        sb = new StringBuffer();
        BufferedReader in = null;
        URL realUrl = null;
        HttpURLConnection conn = null;
        String line = null;
        String urlNameString = null;
        if (param != null && param.length() > 0) {
            urlNameString = url + "?" + param;
        } else {
            urlNameString = url;
        }

        String res = null;

        try {
            realUrl = new URL(urlNameString);
            conn = (HttpURLConnection)realUrl.openConnection();
            conn.setRequestProperty("accept", "*/*");
            conn.setRequestProperty("connection", "Keep-Alive");
            conn.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            conn.setRequestProperty("Content-Type", "text/html;charset=utf-8");
            conn.setUseCaches(false);
            conn.connect();
            int responseCode = conn.getResponseCode();
            if (responseCode == HttpStatus.OK.value()) {
                in = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));

                while((line = in.readLine()) != null) {
                    sb.append(line);
                }

                res = sb.toString();
            } else {
                log.error("code:{}   request:{}   参数:{}   响应错误:{}", new Object[]{responseCode, url, param, conn.getResponseMessage()});
            }
        } catch (IOException var18) {
            log.error("request:{}   参数:{}   发送请求异常:{}", new Object[]{url, param, var18.getMessage()});
        } finally {
            conn.disconnect();
            log.debug("request:{}   res:{}", url, res);

            try {
                if (in != null) {
                    in.close();
                }
            } catch (IOException var17) {
                log.error(var17.getMessage());
            }

        }

        return res;
    }

    public static String sendJSON(String url, String jsonStr) {
        PrintWriter out = null;
        BufferedReader in = null;
        URL realUrl = null;
        HttpURLConnection conn = null;
        String line = null;
        StringBuffer sb = null;
        sb = new StringBuffer();
        String res = null;

        try {
            realUrl = new URL(url);
            conn = (HttpURLConnection)realUrl.openConnection();
            conn.setRequestProperty("accept", "*/*");
            conn.setRequestProperty("connection", "Keep-Alive");
            conn.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            conn.setRequestProperty("Content-Type", "text/html;charset=utf-8");
            conn.setUseCaches(false);
            conn.setDoOutput(true);
            conn.setDoInput(true);
            out = new PrintWriter(new OutputStreamWriter(conn.getOutputStream(), "UTF-8"));
            out.write(jsonStr);
            out.flush();
            int responseCode = conn.getResponseCode();
            if (responseCode == HttpStatus.OK.value()) {
                in = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));

                while((line = in.readLine()) != null) {
                    sb.append(line);
                }

                res = sb.toString();
            } else {
                log.error("code:{}   request:{}   参数:{}   响应错误:{}", new Object[]{responseCode, url, jsonStr, conn.getResponseMessage()});
            }
        } catch (Exception var18) {
            log.error("request:{}   参数:{}   发送请求异常:{}", new Object[]{url, jsonStr, var18});
        } finally {
            log.debug("request:{}   res:{}", url, res);

            try {
                if (out != null) {
                    out.close();
                }

                if (in != null) {
                    in.close();
                }
            } catch (IOException var17) {
                var17.printStackTrace();
            }

        }

        return res;
    }

    public static String doFormPost(String url, Map<String, Object> params) {
        URL u = null;
        HttpURLConnection con = null;
        StringBuffer sb = new StringBuffer();
        if (params != null) {
            Iterator var5 = params.entrySet().iterator();

            while(var5.hasNext()) {
                Map.Entry<String, Object> e = (Map.Entry)var5.next();
                sb.append((String)e.getKey());
                sb.append("=");
                sb.append(e.getValue());
                sb.append("&");
            }

            sb.substring(0, sb.length() - 1);
        }

        System.out.println("send_url:" + url);
        System.out.println("send_data:" + sb.toString());

        try {
            u = new URL(url);
            con = (HttpURLConnection)u.openConnection();
            con.setRequestMethod("POST");
            con.setDoOutput(true);
            con.setDoInput(true);
            con.setUseCaches(false);
            con.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
            OutputStreamWriter osw = new OutputStreamWriter(con.getOutputStream(), "UTF-8");
            osw.write(sb.toString());
            osw.flush();
            osw.close();
        } catch (Exception var11) {
            var11.printStackTrace();
        } finally {
            if (con != null) {
                con.disconnect();
            }

        }

        StringBuffer buffer = new StringBuffer();

        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(con.getInputStream(), "UTF-8"));

            String temp;
            while((temp = br.readLine()) != null) {
                buffer.append(temp);
                buffer.append("\n");
            }
        } catch (Exception var13) {
            var13.printStackTrace();
        }

        return buffer.toString();
    }
}
